namespace eval bondfluid {

    global ProgramName

    # Tdyn settings
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_alemesh
    variable show_naval
    variable edit_units [IsVarOnTdynDefaults edit_units 0]

    # Selected boundary name
    variable Boundary_Name
    variable Boundary_Type

    # List of available Body Questions in Mat File.
    variable FluidBody_Questions

    # List of available Contact Questions in Mat File.
    variable Contact_Questions

    # List of available Free Surface Questions in Mat File.
    variable FreeSurface_Questions

    # List of auxiliar Questions in Prb File.
    variable Auxiliar_Questions

    # Working Namespace Variables
    # Auxiliar Questions
    variable Geometry_Units
    variable Boundary_Angle_Units
    variable Boundary_Force_Units
    variable Boundary_Moment_Units
    variable Boundary_Velocity_Units
    variable Boundary_Kenr_Units
    variable Boundary_ELen_Units
    # Body Questions
    variable Yplus
    variable Delta
    variable Delta_Units
    variable Cw
    variable Roughness
    variable Roughness_Units
    variable FTau_Field
    variable Kenr_Field
    variable Elen_Field
    variable VelX_Field
    variable VelY_Field
    variable VelZ_Field
    variable VelN_Field
    variable Sharp_Angle
    variable Fix_Angle
    variable SternC_Angle
    variable Heat_Flux
    variable Heat_Flux_Units
    variable Reactive_Heat_Flux
    variable Reactive_Heat_Flux_Units
    variable Species_Properties
    variable Spc_Units
    variable Variables_Properties
    variable URV_Units
    variable Body_Mass
    variable Body_Mass_Auto
    variable Body_Mass_Units
    variable Centre_of_Gravity_X
    variable Centre_of_Gravity_Y
    variable Centre_of_Gravity_Z
    variable Radius_of_Gyration_X
    variable Radius_of_Gyration_Y
    variable Radius_of_Gyration_Z
    variable Displacement_OX
    variable Displacement_Value_OX
    variable Displacement_OY
    variable Displacement_Value_OY
    variable Displacement_OZ
    variable Displacement_Value_OZ
    variable Rotation_OX
    variable Rotation_Value_OX
    variable Rotation_OY
    variable Rotation_Value_OY
    variable Rotation_OZ
    variable Rotation_Value_OZ
    variable Springs
    variable KD_Units
    variable KR_Units
    # Contact Questions
    variable Thermal_Resistance
    variable Thermal_Resistance_Units
    variable Switch
    variable Species_Properties
    variable Resistance_Spc_Units
    variable Variables_Properties
    variable Resistance_Phi_Units
    # Free Surface Questions
    variable Time_Integration
    variable Length
    variable Length_units
    variable Damping_length
    variable Damping_factor
    variable Time_factor
    variable Step_factor
    variable Advect_Stabilisation
    variable StabTau_MinRatio
    variable Control_Level
    variable CrossWind_Diffusion
    variable Maximum_Value
    variable Minimum_Value
    variable tv_Time_Integration
    variable tv_Length
    variable tv_Length_units
    variable tv_Damping_length
    variable tv_Damping_factor
    variable tv_Time_factor
    variable tv_Step_factor
    variable tv_Advect_Stabilisation
    variable tv_StabTau_MinRatio
    variable tv_Control_Level
    variable tv_CrossWind_Diffusion
    variable tv_Maximum_Value
    variable tv_Minimum_Value
    variable fsa_Advect_Stabilisation
    variable fsa_StabTau_MinRatio
    variable fsa_Control_Level
    variable fsa_CrossWind_Diffusion
    variable fsa_Maximum_Value
    variable fsa_Minimum_Value

    # Advect variables
    variable Species_Names
    variable Species_Values
    variable Species_UValues
    variable Species_Valnames
    variable Species_UValnames
    variable spcdelerrwarn 0
    variable spcdellasterrwarn 0
    variable spcnlastsel -1
    variable snlist
    variable sname

    # URSolver variables
    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_UValues
    variable URVariables_Valnames
    variable URVariables_UValnames
    variable ursdelerrwarn 0
    variable ursdellasterrwarn 0
    variable ursnlastsel -1
    variable ursnlist
    variable ursname

    # Alemesh Questions
    variable Springs_Values
    switch $ProgramName {
	"Tdyn2D" {
	    variable Springs_Valnames \
		    [list \
		    [list "KD " KD func 1 ""] \
		    [list "KR " KR func 1 ""] \
		    [list "Fix X " Fix_X func 1 ""] \
		    [list "Fix Y " Fix_Y func 1 ""] \
		    [list "End X " End_X func 1 ""] \
		    [list "End Y " End_Y func 1 ""] \
		    ]
	}
	"Tdyn3D" {
	    variable Springs_Valnames \
		    [list \
		    [list "KD " KD func 1 ""] \
		    [list "KR " KR func 1 ""] \
		    [list "Fix X " Fix_X func 1 ""] \
		    [list "Fix Y " Fix_Y func 1 ""] \
		    [list "Fix Z " Fix_Z func 1 ""] \
		    [list "End X " End_X func 1 ""] \
		    [list "End Y " End_Y func 1 ""] \
		    [list "End Z " End_Z func 1 ""] \
		    ]
	}
    }

    # Function Editor variables lists
    switch $ProgramName {
	"Tdyn2D" {
	    variable ransol_ff \
		[ list \
		    {bondfluid::FTau_Field} {FTau Field} \
		    {bondfluid::Kenr_Field} {KEnr Field} \
		    {bondfluid::Elen_Field} {ELen Field} \
		    {bondfluid::VelX_Field} {VelX Field} \
		    {bondfluid::VelY_Field} {VelY Field} \
		    {bondfluid::VelN_Field} {VelN Field} \
		    ]
	}
	"Tdyn3D" {
	    variable ransol_ff \
		[ list \
		    {bondfluid::FTau_Field} {FTau Field} \
		    {bondfluid::Kenr_Field} {KEnr Field} \
		    {bondfluid::Elen_Field} {ELen Field} \
		    {bondfluid::VelX_Field} {VelX Field} \
		    {bondfluid::VelY_Field} {VelY Field} \
		    {bondfluid::VelZ_Field} {VelZ Field} \
		    {bondfluid::VelN_Field} {VelN Field} \
		    ]
	}
    }
    variable heatrans_ff \
	    [ list \
	    {bondfluid::Heat_Flux} {Heat Flux} \
	    {bondfluid::Reactive_Heat_Flux} {Reactive Heat Flux} \
	    ]
    variable heatcont_ff \
	    [ list \
	    {bondfluid::Thermal_Resistance} {Thermal Resistance} \
	    ]
    variable advect_ff \
	    [ list \
	    {bondfluid::Flux_Spc} {Flux Spc} \
	    {bondfluid::Reactive_Flux_Spc} {Reactive Flux Spc} \
	    ]
    variable ursolver_ff \
	    [ list \
	    {bondfluid::Flux_Phi} {Flux Phi} \
	    {bondfluid::Reactive_Flux_Phi} {Reactive Flux Phi} \
	    ]
    switch $ProgramName {
	"Tdyn2D" {
	    variable alemesh_ff \
		    [ list \
		    {bondfluid::Centre_of_Gravity_X} {Centre of Gravity X} \
		    {bondfluid::Centre_of_Gravity_Y} {Centre of Gravity Y} \
		    {bondfluid::Displacement_Value_OX} {Displacement Value OX} \
		    {bondfluid::Displacement_Value_OY} {Displacement Value OY} \
		    {bondfluid::Rotation_Value_OZ} {Rotation Value OZ} \
		    {bondfluid::EForce_OX} {External Force OX} \
		    {bondfluid::EForce_OY} {External Force OY} \
		    {bondfluid::EMoment_OZ} {External Moment OZ} \
		    ]
	}
	"Tdyn3D" {
	    variable alemesh_ff \
		    [ list \
		    {bondfluid::Centre_of_Gravity_X} {Centre of Gravity X} \
		    {bondfluid::Centre_of_Gravity_Y} {Centre of Gravity Y} \
		    {bondfluid::Centre_of_Gravity_Z} {Centre of Gravity Z} \
		    {bondfluid::Displacement_Value_OX} {Displacement Value OX} \
		    {bondfluid::Displacement_Value_OY} {Displacement Value OY} \
		    {bondfluid::Displacement_Value_OZ} {Displacement Value OZ} \
		    {bondfluid::Rotation_Value_OX} {Rotation Value OX} \
		    {bondfluid::Rotation_Value_OY} {Rotation Value OY} \
		    {bondfluid::Rotation_Value_OZ} {Rotation Value OZ} \
		    {bondfluid::EForce_OX} {External Force OX} \
		    {bondfluid::EForce_OY} {External Force OY} \
		    {bondfluid::EForce_OZ} {External Force OZ} \
		    {bondfluid::EMoment_OX} {External Moment OX} \
		    {bondfluid::EMoment_OY} {External Moment OY} \
		    {bondfluid::EMoment_OZ} {External Moment OZ} \
		    ]
	}
    }
    variable ff_variables "x y z nx ny nz t it rand dt e pi vx vy vz pr tm\
	    vt v_ tau wc ds ke ep om kt pk dn bt sp# ph#"
    variable example_ff_variables "x y z nx ny nz t it rand dt exp(1)\
	    pi vx vy vz pr tm vt v_ tau wc ds ke ep om kt pk dn bt sp#"
    variable ff_operators "+ - * / ^ mod div rmod rdiv max min Dx() Dy() Dz()\
	    ~ < <= > >= = != & |"
    variable predefined_ff [list $ff_variables $example_ff_variables $ff_operators]
}



################################################################################
#
#   Initialize Fluid Boundary Window
#
################################################################################

proc bondfluid::init { BASE selmatname } {

    global ProgramName

    # Tdyn settings
    variable show_ransol [IsVarOnTdynDefaults show_ransol 1]
    variable show_heatrans [IsVarOnTdynDefaults show_heatrans 1]
    variable show_advect [IsVarOnTdynDefaults show_advect 1]
    variable show_ursolver [IsVarOnTdynDefaults show_ursolver 1]
    variable show_alemesh [IsVarOnTdynDefaults show_alemesh 1]
    variable show_naval [IsVarOnTdynDefaults show_naval 1]
    variable edit_units

    # Selected Boundary Name
    variable Boundary_Name $selmatname
    variable Boundary_Type

    # Read Boundary Type from values list
    set Boundary_Type [lindex [TUI_getmatvalueslist $Boundary_Name] 0]

    # Variables Lists
    variable FluidBody_Questions
    variable Contact_Questions
    variable FreeSurface_Questions
    variable Auxiliar_Questions

    # Working Namespace Variables
    # Auxiliar Questions
    variable Geometry_Units
    variable Boundary_Angle_Units
    variable Boundary_Force_Units
    variable Boundary_Moment_Units
    variable Boundary_Velocity_Units
    variable Boundary_Kenr_Units
    variable Boundary_ELen_Units
    # Body Questions
    variable Yplus
    variable Delta
    variable Delta_Units
    variable Cw
    variable Roughness
    variable Roughness_Units
    variable FTau_Field
    variable Kenr_Field
    variable Elen_Field
    variable VelX_Field
    variable VelY_Field
    variable VelZ_Field
    variable VelN_Field
    variable Sharp_Angle
    variable Fix_Angle
    variable SternC_Angle
    variable Heat_Flux
    variable Heat_Flux_Units
    variable Reactive_Heat_Flux
    variable Reactive_Heat_Flux_Units
    variable Species_Properties
    variable Spc_Units
    variable Variables_Properties
    variable URV_Units
    variable Body_Mass
    variable Body_Mass_Auto
    variable Body_Mass_Units
    variable Centre_of_Gravity_X
    variable Centre_of_Gravity_Y
    variable Centre_of_Gravity_Z
    variable Radius_of_Gyration_X
    variable Radius_of_Gyration_Y
    variable Radius_of_Gyration_Z
    variable Displacement_OX
    variable Displacement_Value_OX
    variable Displacement_OY
    variable Displacement_Value_OY
    variable Displacement_OZ
    variable Displacement_Value_OZ
    variable Rotation_OX
    variable Rotation_Value_OX
    variable Rotation_OY
    variable Rotation_Value_OY
    variable Rotation_OZ
    variable Rotation_Value_OZ
    variable Springs
    variable KD_Units
    variable KR_Units
    # Free Surface Questions
    variable Time_Integration
    variable Length
    variable Length_units
    variable Damping_length
    variable Damping_factor
    variable Time_factor
    variable Step_factor
    variable Advect_Stabilisation
    variable StabTau_MinRatio
    variable Control_Level
    variable CrossWind_Diffusion
    variable Maximum_Value
    variable Minimum_Value
    variable tv_Time_Integration
    variable tv_Length
    variable tv_Length_units
    variable tv_Damping_length
    variable tv_Damping_factor
    variable tv_Time_factor
    variable tv_Step_factor
    variable tv_Advect_Stabilisation
    variable tv_StabTau_MinRatio
    variable tv_Control_Level
    variable tv_CrossWind_Diffusion
    variable tv_Maximum_Value
    variable tv_Minimum_Value
    variable fsa_Advect_Stabilisation
    variable fsa_StabTau_MinRatio
    variable fsa_Control_Level
    variable fsa_CrossWind_Diffusion
    variable fsa_Maximum_Value
    variable fsa_Minimum_Value

    # Contact Questions
    variable Thermal_Resistance
    variable Thermal_Resistance_Units
    variable Switch
    variable Species_Properties
    variable Resistance_Spc_Units
    variable Variables_Properties
    variable Resistance_Phi_Units

    # Advect variables
    variable Species_Names
    variable Species_Values
    variable Species_UValues
    variable Species_Valnames
    variable Species_UValnames
    variable spcdelerrwarn 0
    variable spcdellasterrwarn 0
    variable spcnlastsel -1
    variable snlist
    variable sname

    # URSolver variables
    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_UValues
    variable URVariables_Valnames
    variable URVariables_UValnames
    variable ursdelerrwarn 0
    variable ursdellasterrwarn 0
    variable ursnlastsel -1
    variable ursnlist
    variable ursname

    # Function Editor Variables
    variable ransol_ff
    variable heatrans_ff
    variable heatcont_ff
    variable alemesh_ff
    variable ff_variables
    variable example_ff_variables
    variable ff_operators
    variable predefined_ff

    # Alemesh Questions
    variable Springs_Values

    # Depending on Boundary Type, configure pages
    switch $Boundary_Type {
	"Fluid_Body" {
	    set Species_Valnames \
		    [list \
		    [list "[= {Flux Spc}] " Flux_Spc func 1 ""] \
		    [list "[= {Reactive Flux Spc}] " Reactive_Flux_Spc func 1 ""] \
		    ]
	    set Species_UValnames \
		    [list \
		    [list "[= {Flux Spc Units}]" Flux_Spc_Units unit 1 concentration] \
		    [list "[= {Reactive Flux Spc Units}]" Reactive_Flux_Spc_Units unit 1 concentration] \
		    ]
	    set URVariables_Valnames \
		    [list \
		    [list "[= {Flux Phi}] " Flux_Phi func 1 ""] \
		    [list "[= {Reactive Flux Phi}] " Reactive_Flux_Phi func 1 ""] \
		    ]
	    set URVariables_UValnames \
		    [list \
		    [list "[= {Flux Phi Units}]" Flux_Phi_Units unit 1 concentration] \
		    [list "[= {Reactive Flux Phi Units}]" Reactive_Flux_Phi_Units unit 1 concentration] \
		    ]
	    switch $ProgramName {
		"Tdyn2D" {
		    set FluidBody_Questions [list \
		            [list SWITCH integer 0 ransol] \
		            [list BoundType string 0 ransol] \
		            [list Yplus integer 1 ransol] \
		            [list Delta float 1 ransol] \
		            [list Delta_Units unit 0 ransol] \
		            [list Cw float 1 ransol] \
		            [list Roughness float 1 ransol] \
		            [list Roughness_Units unit 0 ransol] \
		            [list FTau_Field func 1 ransol] \
		            [list Kenr_Field func 1 ransol] \
		            [list Elen_Field func 1 ransol] \
		            [list VelX_Field func 1 ransol] \
		            [list VelY_Field func 1 ransol] \
		            [list VelN_Field func 1 ransol] \
		            [list Sharp_Angle float 1 ransol] \
		            [list Fix_Angle float 1 ransol] \
		            [list SternC_Angle float 1 ransol] \
		            [list Heat_Flux func 1 heatrans] \
		            [list Heat_Flux_Units unit 0 heatrans] \
		            [list Reactive_Heat_Flux func 1 heatrans] \
		            [list Reactive_Heat_Flux_Units unit 0 heatrans] \
		            [list Species_Properties string 0 advect] \
		            [list Spc_Units string 0 advect] \
		            [list Variables_Properties string 0 ursolver] \
		            [list URV_Units string 0 ursolver] \
		            [list Body_Mass float 1 alemesh] \
		            [list Body_Mass_Auto onoff 1 alemesh] \
		            [list Body_Mass_Units unit 0 alemesh] \
		            [list Centre_of_Gravity_X func 1 alemesh] \
		            [list Centre_of_Gravity_Y func 1 alemesh] \
		            [list Radius_of_Gyration_Z float 1 alemesh] \
		            [list Displacement_OX string 0 alemesh] \
		            [list Displacement_Value_OX func 0 alemesh] \
		            [list Displacement_OY string 0 alemesh] \
		            [list Displacement_Value_OY func 0 alemesh] \
		            [list Rotation_OZ string 0 alemesh] \
		            [list Rotation_Value_OZ func 0 alemesh] \
		            [list EForce_OX func 0 alemesh] \
		            [list EForce_OY func 0 alemesh] \
		            [list EMoment_OZ func 0 alemesh] \
		            [list Springs string 0 alemesh] \
		            [list KD_Units unit 0 alemesh] \
		            [list KR_Units unit 0 alemesh] \
		            ]
		}
		"Tdyn3D"  {
		    set FluidBody_Questions [list \
		            [list SWITCH integer 0 ransol] \
		            [list BoundType string 0 ransol] \
		            [list Yplus integer 1 ransol] \
		            [list Delta float 1 ransol] \
		            [list Delta_Units unit 0 ransol] \
		            [list Cw float 1 ransol] \
		            [list Roughness float 1 ransol] \
		            [list Roughness_Units unit 0 ransol] \
		            [list FTau_Field func 1 ransol] \
		            [list Kenr_Field func 1 ransol] \
		            [list Elen_Field func 1 ransol] \
		            [list VelX_Field func 1 ransol] \
		            [list VelY_Field func 1 ransol] \
		            [list VelZ_Field func 1 ransol] \
		            [list VelN_Field func 1 ransol] \
		            [list Sharp_Angle float 1 ransol] \
		            [list Fix_Angle float 1 ransol] \
		            [list SternC_Angle float 1 ransol] \
		            [list Heat_Flux func 1 heatrans] \
		            [list Heat_Flux_Units unit 0 heatrans] \
		            [list Reactive_Heat_Flux func 1 heatrans] \
		            [list Reactive_Heat_Flux_Units unit 0 heatrans] \
		            [list Species_Properties string 0 advect] \
		            [list Spc_Units string 0 advect] \
		            [list Variables_Properties string 0 ursolver] \
		            [list URV_Units string 0 ursolver] \
		            [list Body_Mass float 1 alemesh] \
		            [list Body_Mass_Auto onoff 1 alemesh] \
		            [list Body_Mass_Units unit 0 alemesh] \
		            [list Centre_of_Gravity_X func 1 alemesh] \
		            [list Centre_of_Gravity_Y func 1 alemesh] \
		            [list Centre_of_Gravity_Z func 1 alemesh] \
		            [list Radius_of_Gyration_X float 1 alemesh] \
		            [list Radius_of_Gyration_Y float 1 alemesh] \
		            [list Radius_of_Gyration_Z float 1 alemesh] \
		            [list Displacement_OX string 0 alemesh] \
		            [list Displacement_Value_OX func 0 alemesh] \
		            [list Displacement_OY string 0 alemesh] \
		            [list Displacement_Value_OY func 0 alemesh] \
		            [list Displacement_OZ string 0 alemesh] \
		            [list Displacement_Value_OZ func 0 alemesh] \
		            [list Rotation_OX string 0 alemesh] \
		            [list Rotation_Value_OX func 0 alemesh] \
		            [list Rotation_OY string 0 alemesh] \
		            [list Rotation_Value_OY func 0 alemesh] \
		            [list Rotation_OZ string 0 alemesh] \
		            [list Rotation_Value_OZ func 0 alemesh] \
		            [list EForce_OX func 0 alemesh] \
		            [list EForce_OY func 0 alemesh] \
		            [list EForce_OZ func 0 alemesh] \
		            [list EMoment_OX func 0 alemesh] \
		            [list EMoment_OY func 0 alemesh] \
		            [list EMoment_OZ func 0 alemesh] \
		            [list Springs string 0 alemesh] \
		            [list KD_Units unit 0 alemesh] \
		            [list KR_Units unit 0 alemesh] \
		            ]
		}
	    }
	}
	"Interf" {
	    set Species_Valnames ""
	    set Species_UValnames ""
	    set URVariables_Valnames ""
	    set URVariables_UValnames ""
	    set Contact_Questions [list \
		    [list Thermal_Resistance float 1 heatrans] \
		    [list Thermal_Resistance_Units unit 0 heatrans] \
		    [list Thermal_OnOff string 0 heatrans] \
		]
	}
	"FreeS" {
	    set Species_Valnames ""
	    set Species_UValnames ""
	    set URVariables_Valnames ""
	    set URVariables_UValnames ""
	    set FreeSurface_Questions [list \
		    [list Time_Integration string 0 "" basic] \
		    [list Length float 1 "" basic] \
		    [list Length_units unit 1 "" basic] \
		    [list Damping_length float 1 "" basic] \
		    [list Damping_factor float 1 "" basic] \
		    [list Advanced onoff 0 "" basic] \
		    [list Time_factor float 1 "" advanced] \
		    [list Step_factor float 1 "" advanced] \
		    [list Advect_Stabilisation string 0 "" advanced] \
		    [list StabTau_MinRatio float 1 "" advanced] \
		    [list Control_Level integer 1 "" advanced] \
		    [list CrossWind_Diffusion onoff 1 "" advanced] \
		    [list Maximum_Value float 1 "" advanced] \
		    [list Minimum_Value float 1 "" advanced] \
		    ]
	}
    }

    # Auxiliar data variables
    set Auxiliar_Questions [list \
	    [list Geometry_Units unit 0 ""] \
	    [list Boundary_Angle_Units unit 0 ""] \
	    [list Boundary_Force_Units unit 0 ""] \
	    [list Boundary_Moment_Units unit 0 ""] \
	    [list Boundary_Velocity_Units unit 0 ""] \
	    [list Boundary_Kenr_Units unit 0 ""] \
	    [list Boundary_ELen_Units unit 0 ""] \
    ]

    # Read values of selected material
    bondfluid::getvalues

    #####  HELP Text variables #####
    set help_btn_func "[= {Custom Function Editor}].\n\
	    [= {Edit a function and transfer it automatically to a field}].\n\
	    [= {You can also RIGHT-CLICK a field, to open the Function Editor}]."

    #####  HELP Text variables - BODY TYPE #####
    # RANSOL Fields
    set help_BoundType \
	    "[= {Law of the Wall boundary Type}].\n[= "Next boundary conditions (in momentum equation) are available:\n\tCw_U2Wall: Wall stress is calculated by Cw*U^2\n\tITTC_Wall: Wall stress are corrected, taking into account the ITTC57 friction line\n\tNone_Wall: No conditions\n\tRoughWall: Law of the Wall with Roughness efect and y(delta) prescribed\n\tDeltaWall: Reichardt Law of the Wall with y(delta) prescribed\n\tYplusWall: Reichardt Law of the Wall with y+(yplus) prescribed\n\tInvisWall: Null Normal Velocity\n\tV_fixWall: Null Velocity\n\tV_fixBound: Velocity is defined by the user\n\tVnfixBound: Normal velocity is defined by the user (rest of the velocity components are null)\n\tUser_Wall: Boundary conditions may defined by the user\n\tOutF_Bound: Simulate an outlet boundary"]"
    set help_Yplus \
	    "[= {Nondimensional distance to the wall}]"
    set help_Delta \
	    "[= {Distance to the wall}]"
    set help_Cw \
	    "[= {Constant of the Cw_U2 or ITTC friction lines}]"
    set help_Roughness \
	    "[= {Roughness or characteristic length of the wall}].\n[= {It is used to calculate boundary conditions on the wall}].\n[= {This value shouldn't be less that 0.0001 times the average element size of the body}]."
    set help_Roughness_Units \
	    "[= {Units of the roughness of the wall}]."
    set help_FTau_Field \
	    "[= {Field of Friction Velocity (stress = density x ftau^2) at the wall}]."
    set help_Kenr_Field \
	    "[= {Field of Eddy Kinetic Energy at the wall}]."
    set help_Elen_Field \
	    "[= {Field of Turbulent Length Scale at the wall}]."
    set help_VelX_Field \
	    "[= {Field of X component of the velocity on the boundary}]."
    set help_VelY_Field \
	    "[= {Field of Y component of the velocity on the boundary}]."
    set help_VelZ_Field \
	    "[= {Field of Z component of the velocity on the boundary}]."
    set help_VelN_Field \
	    "[= {Field of normal component of the velocity on the boundary}]."
    set help_Sharp_Angle \
	    "[= {Maximum angle to apply (automatically) Kutta-Jukowsky condition (recommended 20o)}]"
    set help_Fix_Angle \
	    "[= {Maximum angle to fix (automatically) the velocity (recommended 100o)}]"
    set help_SternC_Angle \
	    "[= {Maximum angle between velocity and hull in the floating line}].\n[= {It is used to control the stern flow conditions (recommended 60)}]"
    switch $ProgramName {
	"Tdyn2D" {
	    set help_Centre_of_Gravity \
		    "[= {Insert the X, Y coordinate of Center of Gravity in geometry units}]."
	}
	"Tdyn3D" {
	    set help_Centre_of_Gravity \
		    "[= {Insert the X, Y, Z coordinate of Center of Gravity in geometry units}]."
	}
    }
    # HEATRANS Fields
    set help_Heat_Flux \
	    "[= {Heat flux through the boundary}]. [= {Positive values are taken as heating flow}].\n[= {It may be a function or a constant (i.e. a 10+200*(5-tm), see Function editor in the bottom-right corner of the window)}].\n[= {Units are defined in Problem Data>UNITS>General Units window}]."
    set help_Heat_Flux_Units \
	    "[= {Heat flux units used in the definition of the heat transfer problem}]."
    set help_Reactive_Heat_Flux \
	    "[= {Reactive heat flux through the boundary}]. [= {Positive values are taken as heating flow}].\n[= {It may be a function or a constant (i.e. a 1.2e-4*tm^3, see Function editor in the bottom-right corner of the window)}].\n[= {Units are defined in Problem Data>UNITS>General Units window}]."
    set help_Reactive_Heat_Flux_Units \
	    "[= {Reactive heat flux units used in the definition of the heat transfer problem}]."
    # ADVECT Fields
    set help_Species_Properties \
	    "[= {Flux_Spc: Species flux through the boundary}]. [= "Positive values are taken as entering flow\n Reactive_Flux_Spc: Reactive species flux through the boundary"]."
    set help_Advect "[= {ADVECT module data}].\n\
	    [= {Select species from the list and edit their properties}].\n\
	    [= {New species may be created or deleted in Material window}]"
    # URSOLVER Fields
    set help_Variables_Properties \
	    "[= {Flux_Phi: Variables flux through the boundary}].\n[= {Positive values are taken as entering flow}].\n[= {Reactive_Flux_Phi: Reactive variables flux through the boundary}]."
    set help_Ursolver "[= {ADVECT module data}].\n\
	    [= {Select species from the list and edit their properties}].\n\
	    [= {New species may be created or deleted in Material window}]."
    
    # ALEMESH Fields
    set help_Body_Mass \
	    "[= {Enter the body mass}]."
    set help_Body_Mass_Auto \
	    "[= {Mark to automatically calcule the mass of the body based on initial static equilibrium}]."
    set help_Body_Mass_Units \
	    "[= {Enter the units for body mass}]."
    switch $ProgramName {
	"Tdyn2D" {
	    set help_Centre_of_Gravity \
		    "[= {Insert the X, Y coordinate of Center of Gravity in geometry units}]."
	    set help_Radius_of_Gyration \
		    "[= {Radius of Gyration on OZ}]"
	    set help_Displacement \
		    "[= {Allows translation parallel to OX, OY}]"
	    set help_Rotation \
		    "[= {Allows planar rotation perpendicular to OZ}]"
	    set help_EForce \
		    "[= {External forces (X, Y components) acting on the COG of the body}]"
	    set help_EMoment \
		    "[= {External moments (Z component) acting on the COG of the body}]"
	}
	"Tdyn3D" {
	    set help_Centre_of_Gravity \
		    "[= {Insert the X, Y, Z coordinate of Center of Gravity in geometry units}]."
	    set help_Radius_of_Gyration \
		    "[= {Radius of Gyration on OX OY OZ}]"
	    set help_Displacement \
		    "[= {Allows translation parallel to OX, OY, OZ}]"
	    set help_Rotation \
		    "[= {Allows planar rotation perpendicular to OX OY OZ}]"
	    set help_EForce \
		    "[= {External forces (X, Y, Z components) acting on the COG of the body}]"
	    set help_EMoment \
		    "[= {External moments (X, Y, Z components) acting on the COG of the body}]"
	}
    }
    set help_Geometry_Units \
	    "[= {Geometry units may be defined in Data>Units window}]."
    set help_Boundary_Angle \
	    "[= {Boundary angle units may be defined in Data>Units data}]."
    set help_Force_Units \
	    "[= {Force units may be defined in Data>Units>General window}]."
    set help_Moment_Units \
	    "[= {Moment units may be defined in Data>Units>General window}]."
    set help_Velocity_Units \
	    "[= {Velocity units may be defined in Data>Units>General window}]."
    set help_Kenr_Units \
	    "[= {Eddy Kinetic Energy units may be defined in Data>Units>General window}]."
    set help_ELen_Units \
	    "[= {Eddy Length units may be defined in Data>Units>General window}]."
    set help_Springs \
	    "[= {Spring links}]. [= {Give the spring constants (displacement-KD and rotation-KR) and the origin (fixed) and end of the spring}].\n[= {Units are given in Data>Problem_Data>UNITS>General_Units option}]."
    set help_KD_Units \
	    "[= {Force per length units used for defining spring constants}]."
    set help_KR_Units \
	    "[= {Force per angle units used for defining spring constants}]."

    # Free Surface Fields
    set help_Time_Integration "[= {Scheme to be used in the time integration of the free surface equation}]."
    set help_Length "[= {Characteristic length of the free surface problem}]"
    set help_Length_units "[= {Units for the characteristic length of the free surface problem}]"
    set help_Damping_length "[= {Damping length (Damping_length X Length) to be used in this free surface}]"
    set help_Damping_factor "[= {Damping factor to be used in this free surface}]"

    #####  HELP Text variables - CONTACT TYPE #####
    # HEATRANS Fields
    set help_Thermal_Resistance \
	    "[= {Thermal_Resistance: Resistance flux through the boundary (resulting flux is equal to the inverse of resistance multiplied by temperature increment)}]."
    # ADVECT Fields
    set help_Species_Properties \
	    "[= {Resistance_Spc: Resistance flux through the boundary (resulting flux is equal to resistance multiplied by Spc increment)}]."
    # URSOLVER Fields
    set help_Variables_Properties \
	    "[= {Resistance_Phi: Resistance flux through the boundary (resulting flux is equal to resistance multiplied by Phi increment)}]."

    # Main Notebook pages GRID
    set pages [NoteBook $BASE.pages -arcradius 0]
    if { $show_ransol == 1 } {
	set page1 [$pages insert 0 page1 -text "[= {RANSOL}]"]
	set fpage1 [$pages getframe page1]
    }
    if { $show_heatrans == 1 } {
	set page2 [$pages insert 1 page2 -text "[= {HEATRANS}]"]
	set fpage2 [$pages getframe page2]
    }
    if { $show_advect == 1 } {
	set page3 [$pages insert 2 page3 -text "[= {ADVECT}]"]
	set fpage3 [$pages getframe page3]
    }
    if { $show_ursolver == 1 } {
	set page4 [$pages insert 3 page4 -text "[= {URSOLVER}]"]
	set fpage4 [$pages getframe page4]
    }
    if { $show_alemesh == 1 || $show_ransol == 1} {
	set page5 [$pages insert 4 page5 -text "[= {ALEMESH}]"]
	set fpage5 [$pages getframe page5]
    }
    if { $show_naval == 1 } {
	set page6 [$pages insert 5 page6 -text "[= {NAVAL}]"]
	set fpage6 [$pages getframe page6]
    }
    if { $show_ransol == 1 } {
	$pages raise page1
    } elseif { $show_heatrans == 1 } {
	$pages raise page2
    } elseif { $show_advect == 1 } {
	$pages raise page3
    } elseif { $show_ursolver == 1 } {
	$pages raise page4
    } elseif { $show_alemesh == 1 } {
	$pages raise page5
    } elseif { $show_naval == 1 } {
	$pages raise page6
    } else {
	WarnWin "[= {Wrong Tdyn preferences found}].\n[= {Cannot generate data window}]."
	return
    }

    # GRIDS PAGES
    grid $pages -row 1 -column 0 -sticky nwes -pady 5
    if { $show_ransol == 1 } {
	grid columnconf $fpage1 15 -weight 1
	grid rowconf $fpage1 30 -weight 1
    }
    if { $show_heatrans == 1 } {
	grid columnconf $fpage2 10 -weight 1
	grid rowconf $fpage2 10 -weight 1
    }
    if { $show_advect == 1 } {
	grid columnconf $fpage3 1 -weight 1
	grid rowconf $fpage3 1 -weight 1
    }
    if { $show_ursolver == 1 } {
	grid columnconf $fpage4 1 -weight 1
	grid rowconf $fpage4 1 -weight 1
    }
    if { $show_alemesh == 1 } {
	grid columnconf $fpage5 30 -weight 1
	grid rowconf $fpage5 30 -weight 1
    }
    if { $show_naval == 1 } {
	grid columnconf $fpage6 10 -weight 1
	grid rowconf $fpage6 6 -weight 1
    }

    if { $Boundary_Type == "Fluid_Body" } {

	#--------------------------- FLUID BODY  ---------------------------#
	if { $show_naval == 1 } {
	    $pages delete page6
	}
	if { $show_ransol == 1 } {

	#--------------------------- PAGE RANSOL ---------------------------#

	    # Combo boxes Units definitions
	    lappend vals_BoundType "InvisWall" "DeltaWall" "RoughWall" "YplusWall" \
		    "Cw U2Wall" "ITTC Wall" "V fixWall" "V fixBound" "VnfixBound" \
		    "User Wall" "None Wall" "OutFBound"
	    lappend vals_Delta_Units "m" "dm" "cm" "mm" "in" "pica" "ft" "yd" "Nmi"
	    lappend vals_Roughness_Units "um" "m" "dm" "cm" "mm" "in" "pica" "ft" "yd" "Nmi"
	    lappend vals_Angle_Units "\u2070" "rad"

	    # Invisible size label
	    set sizelabel [label $fpage1.l_sizelabel \
		    -text "                                   " -bd 0 ]

	    # Bound Type
	    set l_BoundType [Label $fpage1.l_boundtype -text "[= {Boundary Type}] " -helptext $help_BoundType]
	    set e_BoundType [ComboBox $fpage1.e_boundtype -values $vals_BoundType \
		    -editable false -width [TUI_getcbxsize 11 $vals_BoundType] \
		    -textvariable bondfluid::BoundType \
		    -modifycmd "bondfluid::managedependencies $fpage1 $fpage1.e_boundtype BoundType \"\""]

	    # Yplus
	    set l_Yplus [Label $fpage1.l_yplus -text "[= {Yplus}] " -helptext $help_Yplus]
	    set e_Yplus [entry $fpage1.e_yplus -textvariable bondfluid::Yplus]
	    
	    # Delta
	    set l_Delta [Label $fpage1.l_delta -text "[= {Delta}] " -helptext $help_Delta]
	    set e_Delta [entry $fpage1.e_delta -textvariable bondfluid::Delta]
	    set e_Delta_Units [ComboBox $fpage1.e_delta_units -values $vals_Delta_Units \
		    -editable $edit_units -width [TUI_getcbxsize 11 $vals_Delta_Units] \
		    -textvariable bondfluid::Delta_Units]
	    
	    # Cw
	    set l_Cw [Label $fpage1.l_cw -text "[= {Cw}] " -helptext $help_Cw]
	    set e_Cw [entry $fpage1.e_cw -textvariable bondfluid::Cw]
	    
	    # Roughness
	    set l_Roughness [Label $fpage1.l_roughness -text "[= {Roughness}] " -helptext $help_Roughness]
	    set e_Roughness [entry $fpage1.e_roughness -textvariable bondfluid::Roughness]
	    set e_Roughness_Units [ComboBox $fpage1.e_roughness_units -values $vals_Roughness_Units \
		    -editable $edit_units -width [TUI_getcbxsize 11 $vals_Roughness_Units] \
		    -textvariable bondfluid::Roughness_Units]
	    
	    # FTau Field
	    set l_FTau_Field [Label $fpage1.l_ftau -text "[= {FTau Field}] " -helptext $help_FTau_Field]
	    set e_FTau_Field [entry $fpage1.e_ftau -textvariable bondfluid::FTau_Field]
	    set l_FTau_Units [Label $fpage1.l_ftau_units -text ${bondfluid::Boundary_Velocity_Units} \
		    -helptext $help_Velocity_Units]
	    
	    # Kenr Field
	    set l_Kenr_Field [Label $fpage1.l_kenr -text "[= {KEnr Field}] " -helptext $help_Kenr_Field]
	    set e_Kenr_Field [entry $fpage1.e_kenr -textvariable bondfluid::Kenr_Field]
	    set l_Kenr_Units [Label $fpage1.l_kenr_units -text ${bondfluid::Boundary_Kenr_Units} \
		    -helptext $help_Kenr_Units]

	    # ELen Field
	    set l_Elen_Field [Label $fpage1.l_elen -text "[= {ELen Field}] " -helptext $help_Elen_Field]
	    set e_Elen_Field [entry $fpage1.e_elen -textvariable bondfluid::Elen_Field]
	    set l_ELen_Units [Label $fpage1.l_elen_units -text ${bondfluid::Boundary_ELen_Units} \
		    -helptext $help_ELen_Units]

	    # VelX Field
	    set l_VelX_Field [Label $fpage1.l_velx -text "[= {VelX Field}] " -helptext $help_VelX_Field]
	    set e_VelX_Field [entry $fpage1.e_velx -textvariable bondfluid::VelX_Field]
	    set l_VelX_Units [Label $fpage1.l_velx_units -text ${bondfluid::Boundary_Velocity_Units} \
		    -helptext $help_Velocity_Units]

	    # VelY Field
	    set l_VelY_Field [Label $fpage1.l_vely -text "[= {VelY Field}] " -helptext $help_VelY_Field]
	    set e_VelY_Field [entry $fpage1.e_vely -textvariable bondfluid::VelY_Field]
	    set l_VelY_Units [Label $fpage1.l_vely_units -text ${bondfluid::Boundary_Velocity_Units} \
		    -helptext $help_Velocity_Units]

	    # VelZ Field
	    set l_VelZ_Field [Label $fpage1.l_velz -text "[= {VelZ Field}] " -helptext $help_VelZ_Field]
	    set e_VelZ_Field [entry $fpage1.e_velz -textvariable bondfluid::VelZ_Field]
	    set l_VelZ_Units [Label $fpage1.l_velz_units -text ${bondfluid::Boundary_Velocity_Units} \
		    -helptext $help_Velocity_Units]
	    
	    # VelN Field
	    set l_VelN_Field [Label $fpage1.l_veln -text "[= {VelN Field}] " -helptext $help_VelN_Field]
	    set e_VelN_Field [entry $fpage1.e_veln -textvariable bondfluid::VelN_Field]
	    set l_VelN_Units [Label $fpage1.l_veln_units -text ${bondfluid::Boundary_Velocity_Units} \
		    -helptext $help_Velocity_Units]

	    # Sharp_Angle
	    set l_Sharp_Angle [Label $fpage1.l_sharpangle -text "[= {Sharp Angle}] " -helptext $help_Sharp_Angle]
	    set e_Sharp_Angle [entry $fpage1.e_sharpangle -textvariable bondfluid::Sharp_Angle]
	    set l_Sharp_Units [Label $fpage1.l_sharp_units -text ${bondfluid::Boundary_Angle_Units} \
		    -helptext $help_Boundary_Angle]
	    
	    # Fix_Angle
	    set l_Fix_Angle [Label $fpage1.l_fixangle -text "[= {Fix Angle}] " -helptext $help_Fix_Angle]
	    set e_Fix_Angle [entry $fpage1.e_fixangle -textvariable bondfluid::Fix_Angle]
	    set l_Fix_Units [Label $fpage1.l_fix_units -text ${bondfluid::Boundary_Angle_Units} \
		    -helptext $help_Boundary_Angle]
	    
	    # SternC_Angle
	    set show_sternc [IsVarOnTdynDefaults show_naval 1]
	    if { $show_sternc == 1 } {
		set l_SternC_Angle [Label $fpage1.l_sterncangle -text "[= {SternC Angle}] " -helptext $help_SternC_Angle]
		set e_SternC_Angle [entry $fpage1.e_sterncangle -textvariable bondfluid::SternC_Angle]
		set l_SternC_Units [Label $fpage1.l_sternc_units -text ${bondfluid::Boundary_Angle_Units} \
		        -helptext $help_Boundary_Angle]
	    }
	    # Buttons frame
	    set btn_frame [frame $fpage1.btn_frame]
	    # Function Editor Button
	    set btn_functions [Button $btn_frame.btn_func -justify left -underline 0 \
		    -command "FEditor::init $BASE \"$predefined_ff\" \"\" \"[= {SELECT FIELD}]\" \"\" \"\$bondfluid::ransol_ff\" \"\"" \
		    -image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]
	    
	    # GRIDS
	    # SizeLabel
	    grid $sizelabel -row 0 -column 0 -sticky en
	    grid $l_BoundType -row 1 -column 0 -pady 2 -sticky en
	    grid $e_BoundType -row 1 -column 1 -pady 1 -sticky wn
	    grid $l_Yplus -row 2 -column 0 -pady 2 -sticky en
	    grid $e_Yplus -row 2 -column 1 -pady 1 -sticky wn
	    grid $l_Delta -row 3 -column 0 -pady 2 -sticky en
	    grid $e_Delta -row 3 -column 1 -pady 1 -sticky wn
	    grid $e_Delta_Units -row 3 -column 2 -padx 7 -pady 1 -sticky wn
	    grid $l_Cw -row 4 -column 0 -pady 2 -sticky en
	    grid $e_Cw -row 4 -column 1 -pady 1 -sticky wn
	    grid $l_Roughness -row 5 -column 0 -pady 2 -sticky en
	    grid $e_Roughness -row 5 -column 1 -pady 1 -sticky wn
	    grid $e_Roughness_Units -row 5 -column 2 -padx 7 -pady 1 -sticky wn
	    grid $l_FTau_Field -row 6 -column 0 -pady 2 -sticky en
	    grid $e_FTau_Field -row 6 -column 1 -pady 1 -sticky wn
	    grid $l_FTau_Units -row 6 -column 2 -padx 7 -pady 1 -sticky wn
	    grid $l_Kenr_Field -row 7 -column 0 -pady 2 -sticky en
	    grid $e_Kenr_Field -row 7 -column 1 -pady 1 -sticky wn
	    grid $l_Kenr_Units -row 7 -column 2 -padx 7 -pady 1 -sticky wn
	    grid $l_Elen_Field -row 8 -column 0 -pady 2 -sticky en
	    grid $e_Elen_Field -row 8 -column 1 -pady 1 -sticky wn
	    grid $l_ELen_Units -row 8 -column 2 -padx 7 -pady 1 -sticky wn
	    grid $l_VelX_Field -row 9 -column 0 -pady 2 -sticky en
	    grid $e_VelX_Field -row 9 -column 1 -pady 1 -sticky wn
	    grid $l_VelX_Units -row 9 -column 2 -padx 7 -pady 1 -sticky wn
	    grid $l_VelY_Field -row 10 -column 0 -pady 2 -sticky en
	    grid $e_VelY_Field -row 10 -column 1 -pady 1 -sticky wn
	    grid $l_VelY_Units -row 10 -column 2 -padx 7 -pady 1 -sticky wn
	    if { $ProgramName == "Tdyn3D" } {
		grid $l_VelZ_Field -row 11 -column 0 -pady 2 -sticky en
		grid $e_VelZ_Field -row 11 -column 1 -pady 1 -sticky wn
		grid $l_VelZ_Units -row 11 -column 2 -padx 7 -pady 1 -sticky wn
	    }
	    grid $l_VelN_Field -row 12 -column 0 -pady 2 -sticky en
	    grid $e_VelN_Field -row 12 -column 1 -pady 1 -sticky wn
	    grid $l_VelN_Units -row 12 -column 2 -padx 7 -pady 1 -sticky wn
	    grid $l_Sharp_Angle -row 13 -column 0 -pady 2 -sticky en
	    grid $e_Sharp_Angle -row 13 -column 1 -pady 1 -sticky wn
	    grid $l_Sharp_Units -row 13 -column 2 -padx 7 -pady 1 -sticky wn
	    grid $l_Fix_Angle -row 14 -column 0 -pady 2 -sticky en
	    grid $e_Fix_Angle -row 14 -column 1 -pady 1 -sticky wn
	    grid $l_Fix_Units -row 14 -column 2 -padx 7 -pady 1 -sticky wn
	    if { $show_sternc == 1 } {
		grid $l_SternC_Angle -row 15 -column 0 -pady 2 -sticky en
		grid $e_SternC_Angle -row 15 -column 1 -pady 1 -sticky wn
		grid $l_SternC_Units -row 15 -column 2 -padx 7 -pady 1 -sticky wn
	    }
	    # Function Editor Button
	    grid $btn_frame -row 16 -column 1 -columnspan 2 -sticky wn
	    grid $btn_functions -row 0 -column 0 -sticky en -padx 1 -pady 5
	    
	    # Right Click menus
	    bind $e_FTau_Field <ButtonPress-3> "bondfluid::popupmenu $BASE bondfluid::FTau_Field \"[= {FTau Field}]\" \"\" 1 %X %Y"
	    bind $e_Kenr_Field <ButtonPress-3> "bondfluid::popupmenu $BASE bondfluid::Kenr_Field \"[= {Kenr Field}]\" \"\" 1 %X %Y"
	    bind $e_Elen_Field <ButtonPress-3> "bondfluid::popupmenu $BASE bondfluid::Elen_Field \"[= {ELen Field}]\" \"\" 1 %X %Y"
	    bind $e_VelX_Field <ButtonPress-3> "bondfluid::popupmenu $BASE bondfluid::VelX_Field \"[= {VelX Field}]\" \"\" 1 %X %Y"
	    bind $e_VelY_Field <ButtonPress-3> "bondfluid::popupmenu $BASE bondfluid::VelY_Field \"[= {VelY Field}]\" \"\" 1 %X %Y"
	    bind $e_VelZ_Field <ButtonPress-3> "bondfluid::popupmenu $BASE bondfluid::VelZ_Field \"[= {VelZ Field}]\" \"\" 1 %X %Y"
	    bind $e_VelN_Field <ButtonPress-3> "bondfluid::popupmenu $BASE bondfluid::VelN_Field \"[= {VelN Field}]\" \"\" 1 %X %Y"
	    # Initial dependencies set
	    bondfluid::managedependencies $fpage1 $fpage1.e_boundtype BoundType ""
	}

	if { $show_heatrans == 1 } {
	    
	    #--------------------------- PAGE HEATRANS ---------------------------#
	    
	    # Combo boxes Units definitions
	    lappend vals_Heat_Flux_Units "Kcal/h.m\u00b2" "KW/m\u00b2" \
		"cal/h.m\u00b2" "W/m\u00b2" "cal/s.m\u00b2" "btu/h.in\u00b2" \
		"btu/s.in\u00b2" "btu/h.ft\u00b2"
	    lappend vals_Reactive_Heat_Flux_Units "Kcal/h.m\u00b2.\u2070C" \
		"KW/m\u00b2.\u2070C" "cal/hour.m\u00b2.\u2070C" "W/m\u00b2.\u2070C" \
		"cal/s.m\u00b2.\u2070C" "btu/h.in\u00b2.\u2070F" \
		"btu/s.in\u00b2.\u2070F" "btu/h.ft\u00b2.\u2070F"
	    
	    # Invisible label to keep size
	    set sizelabel [label $fpage2.l_sizelabel \
		    -text "                                   " -bd 0 ]
	    
	    # Heat Flux
	    set l_Heat_Flux [Label $fpage2.l_heat_flux -text "[= {Heat Flux}] " -helptext $help_Heat_Flux]
	    set e_Heat_Flux [entry $fpage2.e_heat_flux -textvariable bondfluid::Heat_Flux]
	    set e_Heat_Flux_Units [ComboBox $fpage2.e_Heat_Flux_units -values $vals_Heat_Flux_Units \
		    -editable $edit_units -width [TUI_getcbxsize 11 $vals_Heat_Flux_Units] \
		    -textvariable bondfluid::Heat_Flux_Units]
	    
	    # Reactive Heat Flux
	    set l_Reactive_Heat_Flux [Label $fpage2.l_reactive_heat_flux \
		    -text "[= {Reactive Heat Flux}] " -helptext $help_Reactive_Heat_Flux]
	    set e_Reactive_Heat_Flux [entry $fpage2.e_reactive_heat_flux \
		    -textvariable bondfluid::Reactive_Heat_Flux]
	    set e_Reactive_Heat_Flux_Units [ComboBox $fpage2.e_Reactive_Heat_Flux_units \
		    -values $vals_Reactive_Heat_Flux_Units \
		    -editable $edit_units -width [TUI_getcbxsize 11 $vals_Reactive_Heat_Flux_Units] \
		    -textvariable bondfluid::Reactive_Heat_Flux_Units]
	    
	    # Buttons frame
	    set btn_frame [frame $fpage2.btn_frame]
	    # Function Editor Button
	    set btn_functions [Button $btn_frame.btn_func -justify left -underline 0 \
		    -command "FEditor::init $BASE \"$predefined_ff\" \"\" \"[= {SELECT FIELD}]\" \"\" \"\$bondfluid::heatrans_ff\" \"\"" \
		    -image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]
	    
	    # GRIDS
	    # SizeLabel
	    grid $sizelabel -row 0 -column 0 -sticky en
	    grid $l_Heat_Flux -row 1 -column 0 -pady 2 -sticky en
	    grid $e_Heat_Flux -row 1 -column 1 -pady 1 -sticky wn
	    grid $e_Heat_Flux_Units -row 1 -column 2 -padx 7 -pady 1 -sticky wn
	    grid $l_Reactive_Heat_Flux -row 2 -column 0 -pady 2 -sticky en
	    grid $e_Reactive_Heat_Flux -row 2 -column 1 -pady 1 -sticky wn
	    grid $e_Reactive_Heat_Flux_Units -row 2 -column 2 -padx 7 -pady 1 -sticky wn
	    # Function Editor Button
	    grid $btn_frame -row 9 -column 1 -columnspan 2 -sticky wn
	    grid $btn_functions -row 0 -column 0 -sticky en -padx 1 -pady 5
	    
	    # Right Click menus
	    bind $e_Heat_Flux <ButtonPress-3> "bondfluid::popupmenu $BASE bondfluid::Heat_Flux \"[= {Heat Flux}]\" \"\" 1 %X %Y"
	    bind $e_Reactive_Heat_Flux <ButtonPress-3> "bondfluid::popupmenu $BASE bondfluid::Reactive_Heat_Flux \"[= {Reactive Heat Flux}]\" \"\" 1 %X %Y"
	}

	if { $show_advect == 1 } {
	    
	    #--------------------------- PAGE ADVECT ---------------------------#
	    
	    # Title Frame Species List
	    set tfr_spclist [TitleFrame $fpage3.tfr_spclist -relief ridge -bd 3\
		    -text "[= {Defined Species}]" -side left ]
	    set frame_spclist [$tfr_spclist getframe]
	    
	    # Paned window
	    set pw [PanedWindow $frame_spclist.pw]
	    set pane1 [$pw add -weight 1]
	    set pane2 [$pw add -weight 5]
	    
	    # Species Names in scrolled window
	    set spc_scrw [ScrolledWindow $pane1.spc_scrw -scrollbar both]
	    set snlist [listbox $spc_scrw.snlist -selectbackground lightblue -selectforeground black \
		    -selectborderwidth 1 -selectmode extended -height 5 -bg white -width 10]
	    $spc_scrw setwidget $snlist
	    
	    # Selected Specie values frame
	    set svlist [frame $pane2.svlist -relief flat]
	    
	    # Buttons frame
	    set btn_frame [frame $svlist.btn_frame]
	    # Function Editor Button
	    set btn_functions [Button $btn_frame.btn_func -justify left -underline 0 \
		    -command "FEditor::init $BASE \"$predefined_ff\" \"\" \"[= {SELECT FIELD}]\" \"\" \"\$bondfluid::advect_ff\" \"\"" \
		    -image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]
	    
	    # GRIDS
	    # Title Frame
	    grid $tfr_spclist -row 1 -column 0 -columnspan 5 -sticky wnes
	    grid $pw -row 0 -column 0 -sticky wnes
	    grid $spc_scrw -row 0 -column 0 -sticky wnes
	    # Rows and columns configuration
	    grid rowconf $pane1 0 -weight 1
	    grid columnconf $pane1 0 -weight 1
	    grid rowconf $pane2 1 -weight 1
	    grid columnconf $pane2 0 -weight 1
	    grid columnconf $frame_spclist 0 -weight 1
	    grid rowconf $frame_spclist 0 -weight 1
	    grid rowconf $svlist 10 -weight 1
	    # Function Editor Button
	    grid $btn_frame -row 9 -column 1 -columnspan 2 -sticky wn
	    grid $btn_functions -row 0 -column 0 -sticky en -padx 1 -pady 5
	    
	    GidHelpRecursive $tfr_spclist $help_Advect
	    
	    # BINDS 
	    bind $snlist <<ListboxSelect>> ";
		bondfluid::valsavespecie $snlist \"last\" \"advect\"; 
		bondfluid::displayspecievalues $snlist \"advect\";
		bondfluid::displayspeciesnames $snlist \"advect\";
		"
	    bind $snlist <ButtonPress-3> "+bondfluid::popupmenu $snlist \"\" \"\" \"\" 2 %X %Y"
	    
	    # Insert Species Names to listbox
	    bondfluid::displayspeciesnames $snlist "advect"
	    # Selecting first Specie
	    bondfluid::updatespcselection $snlist 0 "advect"
	    # Create Species Values widgets
	    bondfluid::makespecie $snlist $svlist "advect"
	    # Put specie values into entries
	    bondfluid::displayspecievalues $snlist "advect"  
	}

	if { $show_ursolver == 1 } {
	    
	    #--------------------------- PAGE URSOLVER ---------------------------#
	    
	    # Title Frame Species List
	    set tfr_spclist [TitleFrame $fpage4.tfr_spclist -relief ridge -bd 3\
		    -text "[= {Defined Variables}]" -side left ]
	    set frame_spclist [$tfr_spclist getframe]
	    
	    # Paned window
	    set upw [PanedWindow $frame_spclist.pw]
	    set upane1 [$upw add -weight 1]
	    set upane2 [$upw add -weight 5]
	    
	    # Variables Names in scrolled window
	    set ursv_scrw [ScrolledWindow $upane1.ursv_scrw -scrollbar both]
	    set ursnlist [listbox $ursv_scrw.ursnlist -selectbackground lightblue -selectforeground black \
		    -selectborderwidth 1 -selectmode extended -height 5 -bg white -width 10]
	    $ursv_scrw setwidget $ursnlist
	    
	    # Selected Specie values frame
	    set ursvlist [frame $upane2.ursvlist -relief flat]
	    
	    # Buttons frame
	    set btn_frame [frame $ursvlist.btn_frame]
	    # Function Editor Button
	    set btn_functions [Button $btn_frame.btn_func -justify left -underline 0 \
		    -command "FEditor::init $BASE \"$predefined_ff\" \"\" \"[= {SELECT FIELD}]\" \"\" \"\$bondfluid::ursolver_ff\" \"\"" \
		    -image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]
	    
	    # GRIDS
	    # Title Frame
	    grid $tfr_spclist -row 1 -column 0 -columnspan 5 -sticky wnes
	    grid $upw -row 0 -column 0 -sticky wnes
	    grid $ursv_scrw -row 0 -column 0 -sticky wnes
	    # Rows and columns configuration
	    grid rowconf $upane1 0 -weight 1
	    grid columnconf $upane1 0 -weight 1
	    grid rowconf $upane2 1 -weight 1
	    grid columnconf $upane2 0 -weight 1
	    grid columnconf $frame_spclist 0 -weight 1
	    grid rowconf $frame_spclist 0 -weight 1
	    grid rowconf $ursvlist 10 -weight 1
	    # Function Editor Button
	    grid $btn_frame -row 9 -column 1 -columnspan 2 -sticky wn
	    grid $btn_functions -row 0 -column 0 -sticky en -padx 1 -pady 5
	    
	    # BINDS 
	    bind $ursnlist <<ListboxSelect>> ";
		bondfluid::valsavespecie $ursnlist \"last\" \"ursolver\"; 
		bondfluid::displayspecievalues $ursnlist \"ursolver\";
		bondfluid::displayspeciesnames $ursnlist \"ursolver\";
		"
	    bind $ursnlist <ButtonPress-3> "+bondfluid::popupmenu $ursnlist \"\" \"\" \"\" 2 %X %Y"
	    
	    # GidHelpRecursive $tfr_spclist $help_URSolver
	    
	    # Insert Species Names to listbox
	    bondfluid::displayspeciesnames $ursnlist "ursolver"
	    # Selecting first Specie
	    bondfluid::updatespcselection $ursnlist 0 "ursolver"
	    # Create Species Values widgets
	    bondfluid::makespecie $ursnlist $ursvlist "ursolver"
	    # Put specie values into entries
	    bondfluid::displayspecievalues $ursnlist "ursolver"
	}

    #--------------------------- PAGE ALEMESH ---------------------------#

	if { $show_alemesh == 1 || $show_ransol == 1} {
	    
	    # Combo boxes Units definitions
	    lappend vals_Body_Mass_Units "Kg" "g" "qui" "lb" "ton" "oz" "amu"
	    lappend vals_Radii_of_Gyration_Units "m" "dm" "cm" "mm" "in" "pica" "ft" "yd" "Nmi"
	    lappend vals_KD_Units "N/m" "KN/m" "KN/cm" "KN/mm" "N/mm"
	    lappend vals_KR_Units "N/\u2070" "N/rad" "KN/\u2070" "KN/rad"
	    
	    set cbxsizes [TUI_getcbxsize 11 $vals_KD_Units]
	    set cbxsizes [TUI_getcbxsize $cbxsizes $vals_KR_Units]
	    
	    # Invisible label to keep size
	    set sizelabel [label $fpage5.l_sizelabel \
		    -text "                                   " -bd 0 ]
	    
	    # Body Mass
	    set l_Body_Mass [Label $fpage5.l_body_mass -text "[= {Body Mass}] " -helptext $help_Body_Mass]
	    set f_bdm [frame $fpage5.f_bdm -relief flat]
	    set e_Body_Mass [entry $f_bdm.e_body_mass -textvariable bondfluid::Body_Mass -width 16]
	    set e_Body_Mass_Units [ComboBox $f_bdm.e_body_mass_units -values $vals_Body_Mass_Units \
		    -editable $edit_units -width $cbxsizes -textvariable bondfluid::Body_Mass_Units]
	    set c_Body_Mass_Auto [checkbutton $f_bdm.c_auto_mass -variable bondfluid::Body_Mass_Auto \
		    -command "bondfluid::LinkProblem $f_bdm \${bondfluid::Body_Mass_Auto}"]
	    
	    # Centre of Gravity
	    switch $ProgramName {
		"Tdyn2D" {
		    set ltext_cog "[= {Centre of Gravity (X Y)}] "
		}
		"Tdyn3D" {
		    set ltext_cog "[= {Centre of Gravity (X Y Z)}] "
		} 
	    }
	    set l_Centre_of_Gravity [Label $fpage5.l_cog -text $ltext_cog \
		    -helptext $help_Centre_of_Gravity]
	    set f_cog [frame $fpage5.f_cog -relief flat]
	    switch $ProgramName {
		"Tdyn2D" {
		    set e_Centre_of_Gravity_X [entry $f_cog.e_cog_x -width 9 \
		            -textvariable bondfluid::Centre_of_Gravity_X]
		    set e_Centre_of_Gravity_Y [entry $f_cog.e_cog_y -width 9 \
		            -textvariable bondfluid::Centre_of_Gravity_Y]
		}
		"Tdyn3D" {
		    set e_Centre_of_Gravity_X [entry $f_cog.e_cog_x -width 7 \
		            -textvariable bondfluid::Centre_of_Gravity_X]
		    set e_Centre_of_Gravity_Y [entry $f_cog.e_cog_y -width 7 \
		            -textvariable bondfluid::Centre_of_Gravity_Y]
		    set e_Centre_of_Gravity_Z [entry $f_cog.e_cog_z -width 7 \
		            -textvariable bondfluid::Centre_of_Gravity_Z]
		}
	    }
	    set l_Centre_of_Gravity_Units [Label $f_cog.e_cog_u \
		    -text $Geometry_Units -helptext $help_Geometry_Units]
	    
	    # Buttons frame
	    set btn_frame [frame $fpage5.btn_frame]
	    
	    # Function Editor Button
	    set btn_functions [Button $btn_frame.btn_func -justify left -underline 0 \
		    -command "FEditor::init $BASE \"$predefined_ff\" \"\" \"[= {SELECT FIELD}]\" \"\" \"\$bondfluid::alemesh_ff\" \"\"" \
		    -image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]
	    
	    # GRIDS (Common entries)
	    set alr 0
	    grid $sizelabel -row $alr -column 0 -sticky en
	    # Body Mass
	    incr alr
	    grid $l_Body_Mass -row $alr -column 0 -pady 2 -sticky en
	    grid $f_bdm -row $alr -column 1 -sticky wn
	    grid $e_Body_Mass -row 0 -column 0 -pady 1 -sticky en
	    grid $c_Body_Mass_Auto -row 0 -column 1 -pady 1 -sticky en
	    grid $e_Body_Mass_Units -row 0 -column 2 -padx 7 -pady 1 -sticky wn
	    # Centre of Gravity
	    incr alr
	    grid $l_Centre_of_Gravity -row $alr -column 0 -pady 2 -sticky en
	    grid $f_cog -row $alr -column 1 -sticky wn
	    switch $ProgramName {
		"Tdyn2D" {
		    grid $e_Centre_of_Gravity_X -row 0 -column 0 -pady 1 -sticky en
		    grid $e_Centre_of_Gravity_Y -row 0 -column 1 -padx 7 -pady 1 -sticky en
		    grid $l_Centre_of_Gravity_Units -row 0 -column 2 -padx 1 -pady 1 -sticky wn
		}
		"Tdyn3D" {
		    grid $e_Centre_of_Gravity_X -row 0 -column 0 -pady 1 -sticky en
		    grid $e_Centre_of_Gravity_Y -row 0 -column 1 -pady 1 -sticky en
		    grid $e_Centre_of_Gravity_Z -row 0 -column 2 -pady 1 -sticky en
		    grid $l_Centre_of_Gravity_Units -row 0 -column 3 -padx 11 -pady 1 -sticky wn
		}
	    }
	    bondfluid::LinkProblem $f_bdm ${bondfluid::Body_Mass_Auto}
	    GidHelp $c_Body_Mass_Auto $help_Body_Mass_Auto

	} 
	if { $show_alemesh == 1 } {

	    # Radius of Gyration
	    switch $ProgramName {
		"Tdyn2D" {
		    set rog_ldes "[= {Radius of Gyration (Z)}] "
		}
		"Tdyn3D" {
		    set rog_ldes "[= {Radii of Gyration (X Y Z)}] "
		}
	    }
	    set l_Radius_of_Gyration [Label $fpage5.l_radius_of_gyration \
		    -text $rog_ldes -helptext $help_Radius_of_Gyration]
	    set f_rog [frame $fpage5.f_rog -relief flat]
	    switch $ProgramName {
		"Tdyn2D" {
		    set e_Radius_of_Gyration_Z [entry $f_rog.e_radius_of_gyration_z \
		            -textvariable bondfluid::Radius_of_Gyration_Z]
		}
		"Tdyn3D" {
		    set e_Radius_of_Gyration_X [entry $f_rog.e_radius_of_gyration_x \
		            -textvariable bondfluid::Radius_of_Gyration_X -width 7]
		    set e_Radius_of_Gyration_Y [entry $f_rog.e_radius_of_gyration_y \
		            -textvariable bondfluid::Radius_of_Gyration_Y -width 7]
		    set e_Radius_of_Gyration_Z [entry $f_rog.e_radius_of_gyration_z \
		            -textvariable bondfluid::Radius_of_Gyration_Z -width 7]
		}
	    }
	    set e_Radii_of_Gyration_Units [Label $f_rog.e_radii_of_gyration_units \
		    -text $Geometry_Units -helptext $help_Geometry_Units]
	    
	    # Displacement Options
	    set vals_Displacement ""
	    lappend vals_Displacement "Free" "None" "Fixed" "Field"
	    
	    set f_Displacement [frame $fpage5.f_Displacement -relief flat]
	    set e_Displacement_OX [ComboBox $f_Displacement.e_displx -values $vals_Displacement \
		    -editable false -width 4 -textvariable bondfluid::Displacement_OX -takefocus 1 \
		    -modifycmd "bondfluid::managedependencies $fpage5.f_Displacement_Values $f_Displacement.e_displx displx $BASE"]
	    set e_Displacement_OY [ComboBox $f_Displacement.e_disply -values $vals_Displacement \
		    -editable false -width 4 -textvariable bondfluid::Displacement_OY -takefocus 1 \
		    -modifycmd "bondfluid::managedependencies $fpage5.f_Displacement_Values $f_Displacement.e_disply disply $BASE"]
	    if { $ProgramName == "Tdyn3D"} {
		set l_Displacement [Label $fpage5.l_Displacement -text "[= {Displacement Options (X Y Z)}] " -helptext $help_Displacement]
		set e_Displacement_OZ [ComboBox $f_Displacement.e_displz -values $vals_Displacement \
		        -editable false -width 4 -textvariable bondfluid::Displacement_OZ -takefocus 1 \
		        -modifycmd "bondfluid::managedependencies $fpage5.f_Displacement_Values $f_Displacement.e_displz displz $BASE"]
	    } else {
		set l_Displacement [Label $fpage5.l_Displacement -text "[= {Displacement Options (X Y)}] " -helptext $help_Displacement]
	    }
	    
	    # Displacement Values
	    set l_Displacement_Values [Label $fpage5.l_Displacement_Values -text "[= {Displacement Values}] "]
	    set f_Displacement_Values [frame $fpage5.f_Displacement_Values -relief flat]
	    set e_Displacement_Value_OX [entry $f_Displacement_Values.e_displvx -width 7 \
		    -textvariable bondfluid::Displacement_Value_OX -takefocus 1 -disabledbackground lightgrey]
	    set e_Displacement_Value_OY [entry $f_Displacement_Values.e_displvy -width 7 \
		    -textvariable bondfluid::Displacement_Value_OY -takefocus 1 -disabledbackground lightgrey]
	    if { $ProgramName == "Tdyn3D"} {
		set e_Displacement_Value_OZ [entry $f_Displacement_Values.e_displvz -width 7 \
		        -textvariable bondfluid::Displacement_Value_OZ -takefocus 1 -disabledbackground lightgrey]
	    }
	    set e_Displacement_Value_Units [Label $f_Displacement_Values.e_displacement_value_units \
		    -text $Geometry_Units -helptext $help_Geometry_Units]
	    
	    # Rotation Options
	    set vals_Rotation ""
	    lappend vals_Rotation  "Free" "None" "Fixed"
	    set f_Rotation [frame $fpage5.f_rotation -relief flat]
	    if { $ProgramName == "Tdyn3D"} {
		set l_Rotation [Label $fpage5.l_Rotation -text "[= {Rotation Options (X Y Z)}] " -helptext $help_Rotation]
		set e_Rotation_OX [ComboBox $f_Rotation.e_rotx -values $vals_Rotation \
		        -editable false -width 4 -textvariable bondfluid::Rotation_OX -takefocus 1 \
		        -modifycmd "bondfluid::managedependencies $fpage5.f_Rotation_Values $f_Rotation.e_rotx rotx $BASE"]
		set e_Rotation_OY [ComboBox $f_Rotation.e_roty -values $vals_Rotation \
		        -editable false -width 4 -textvariable bondfluid::Rotation_OY -takefocus 1 \
		        -modifycmd "bondfluid::managedependencies $fpage5.f_Rotation_Values $f_Rotation.e_roty roty $BASE"]
	    } else {
		set l_Rotation [Label $fpage5.l_Rotation -text "[= {Rotation Options (Z)}] " -helptext $help_Rotation]
	    }
	    set e_Rotation_OZ [ComboBox $f_Rotation.e_rotz -values $vals_Rotation \
		    -editable false -width 4 -textvariable bondfluid::Rotation_OZ -takefocus 1 \
		    -modifycmd "bondfluid::managedependencies $fpage5.f_Rotation_Values $f_Rotation.e_rotz rotz $BASE"]
	    
	    # Rotation Values
	    set l_Rotation_Values [Label $fpage5.l_Rotation_Values -text "[= {Rotation Values}] "]
	    set f_Rotation_Values [frame $fpage5.f_Rotation_Values -relief flat]
	    if { $ProgramName == "Tdyn3D"} {
		set e_Rotation_Value_OX [entry $f_Rotation_Values.e_rotvx -width 7 \
		        -textvariable bondfluid::Rotation_Value_OX -takefocus 1 -disabledbackground lightgrey]
		set e_Rotation_Value_OY [entry $f_Rotation_Values.e_rotvy -width 7 \
		        -textvariable bondfluid::Rotation_Value_OY -takefocus 1 -disabledbackground lightgrey]
	    }
	    set e_Rotation_Value_OZ [entry $f_Rotation_Values.e_rotvz -width 7 \
		    -textvariable bondfluid::Rotation_Value_OZ -takefocus 1 -disabledbackground lightgrey]
	    set e_Rotation_Value_Units [Label $f_Rotation_Values.e_rotation_value_units \
		    -text $Boundary_Angle_Units -helptext $help_Boundary_Angle]

	    # External Forces Values
	    set l_EForce_Values [Label $fpage5.l_EForce_Values -text "[= {External Forces}] " -helptext $help_EForce]
	    set f_EForce_Values [frame $fpage5.f_EForce_Values -relief flat]
	    set e_EForce_Value_OX [entry $f_EForce_Values.e_displvx -width 7 \
		    -textvariable bondfluid::EForce_OX -takefocus 1 -disabledbackground lightgrey]
	    set e_EForce_Value_OY [entry $f_EForce_Values.e_displvy -width 7 \
		    -textvariable bondfluid::EForce_OY -takefocus 1 -disabledbackground lightgrey]
	    if { $ProgramName == "Tdyn3D"} {
		set e_EForce_Value_OZ [entry $f_EForce_Values.e_displvz -width 7 \
		        -textvariable bondfluid::EForce_OZ -takefocus 1 -disabledbackground lightgrey]
	    }
	    set e_EForce_Value_Units [Label $f_EForce_Values.e_eforce_units \
		    -text $Boundary_Force_Units -helptext $help_Force_Units]

	    # External Moments Values
	    set l_EMoment_Values [Label $fpage5.l_EMoment_Values -text "[= {External Moments}] " -helptext $help_EMoment]
	    set f_EMoment_Values [frame $fpage5.f_EMoment_Values -relief flat]
	    if { $ProgramName == "Tdyn3D"} {
		set e_EMoment_Value_OX [entry $f_EMoment_Values.e_rotvx -width 7 \
		        -textvariable bondfluid::EMoment_OX -takefocus 1 -disabledbackground lightgrey]
		set e_EMoment_Value_OY [entry $f_EMoment_Values.e_rotvy -width 7 \
		        -textvariable bondfluid::EMoment_OY -takefocus 1 -disabledbackground lightgrey]
	    }
	    set e_EMoment_Value_OZ [entry $f_EMoment_Values.e_rotvz -width 7 \
		    -textvariable bondfluid::EMoment_OZ -takefocus 1 -disabledbackground lightgrey]
	    set e_EMoment_Value_Units [Label $f_EMoment_Values.e_emoment_units \
		    -text $Boundary_Moment_Units -helptext $help_Moment_Units]

	    # Springs
	    if { 0 } {
	    switch $ProgramName {
		"Tdyn2D" {
		    set columns [list \
		            0 KD left \
		            0 KR left \
		            0 FixX left \
		            0 FixY left \
		            0 EndX left \
		            0 EndY left]
		}
		"Tdyn3D" {
		    set columns [list \
		            0 KD left \
		            0 KR left \
		            0 FixX left \
		            0 FixY left \
		            0 FixZ left \
		            0 EndX left \
		            0 EndY left \
		            0 EndZ left]
		}
	    }
	    
	    # Springs
	    set tbl_height [llength $Springs_Values]
	    if { $tbl_height > 7 } {
		set tbl_height 7
	    } elseif { $tbl_height < 4 } {
		set tbl_height 4
	    }
	    set l_Springs [Label $fpage5.l_springs -text "[= {Springs}] " -helptext $help_Springs]
	    set f_Springs [frame $fpage5.f_springs -relief flat]
	    set scr_Springs [ScrolledWindow $f_Springs.springs_scrw -scrollbar vertical -auto none]
	    set tbl_Springs [tablelist::tablelist $scr_Springs.tbl_springs -columns $columns \
		    -listvariable bondfluid::Springs_Values -selectmode extended -stretch all \
		    -takefocus 1 -height $tbl_height]
	    for { set i 0 } { $i < [llength [lindex $Springs_Values 0]] } { incr i } {
		$tbl_Springs columnconfigure $i -editable 1
	    }
	    $scr_Springs setwidget $tbl_Springs
	    
	    # Buttons PLUS MINUS - under the Species Names listbox
	    set btnbox [ButtonBox $f_Springs.btnbox -spacing 0 -padx 1 -pady 1 -homogeneous 0]
	    $btnbox add -image $buttons::ibtn_plus -width 20 -height 20 \
		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 \
		-padx 4 -pady 1 -helptext "[= {Add a row}]" \
		-command "bondfluid::addspring"
	    $btnbox add -image $buttons::ibtn_minus -width 20 -height 20 \
		-highlightthickness 1 -takefocus 0 -relief link -borderwidth 1 \
		-padx 4 -pady 1 -helptext "[= {Delete a row}]" \
		-command "bondfluid::removespring \[$tbl_Springs curselection\]"
	    
	    # KD Units
	    set l_KD_Units [Label $fpage5.l_KD_Units -text "[= {KD Units}] " -helptext $help_KD_Units]
	    set e_KD_Units [ComboBox $fpage5.e_kd_units -values $vals_KD_Units \
		    -editable $edit_units -width $cbxsizes -textvariable bondfluid::KD_Units]
	    
	    # KR Units
	    set l_KR_Units [Label $fpage5.l_KR_Units -text "[= {KR Units}] " -helptext $help_KR_Units]
	    set e_KR_Units [ComboBox $fpage5.e_kr_units -values $vals_KR_Units \
		    -editable $edit_units -width $cbxsizes -textvariable bondfluid::KR_Units]
	    }
	    
	    # Gridding
	    incr alr
	    grid $l_Radius_of_Gyration -row $alr -column 0 -pady 2 -sticky en
	    grid $f_rog -row $alr -column 1 -sticky wn
	    switch $ProgramName {
		"Tdyn2D" {
		    grid $e_Radius_of_Gyration_Z -row 0 -column 0 -pady 1 -sticky en
		    grid $e_Radii_of_Gyration_Units -row 0 -column 1 -padx 7 -pady 1 -sticky wn
		}
		"Tdyn3D" {
		    grid $e_Radius_of_Gyration_X -row 0 -column 0 -pady 1 -sticky en
		    grid $e_Radius_of_Gyration_Y -row 0 -column 1 -pady 1 -sticky en
		    grid $e_Radius_of_Gyration_Z -row 0 -column 2 -pady 1 -sticky en
		    grid $e_Radii_of_Gyration_Units -row 0 -column 3 -padx 11 -pady 1 -sticky wn
		}
	    }
	    
	    # Displacement
	    incr alr
	    grid $l_Displacement -row $alr -column 0 -pady 2 -sticky en
	    grid $f_Displacement -row $alr -column 1 -pady 2 -sticky wn
	    grid $e_Displacement_OX -row 0 -column 0 -sticky wn
	    grid $e_Displacement_OY -row 0 -column 1 -sticky wn
	    if { $ProgramName == "Tdyn3D"} {
		grid $e_Displacement_OZ -row 0 -column 2 -sticky wn
	    }
	    grid columnconf $f_Displacement 3 -weight 1
	    
	    incr alr
	    grid $l_Displacement_Values -row $alr -column 0 -pady 2 -sticky en
	    grid $f_Displacement_Values -row $alr -column 1 -pady 2 -sticky wn
	    grid $e_Displacement_Value_OX -row 0 -column 0 -sticky wn
	    grid $e_Displacement_Value_OY -row 0 -column 1 -sticky wn
	    if { $ProgramName == "Tdyn3D" } {
		grid $e_Displacement_Value_OZ -row 0 -column 2 -sticky wn
	    }
	    grid $e_Displacement_Value_Units -row 0 -column 3 -padx 10 -pady 1 -sticky wn
	    
	    # Rotation
	    incr alr
	    grid $l_Rotation -row $alr -column 0 -pady 2 -sticky en
	    grid $f_Rotation -row $alr -column 1 -pady 2 -sticky wn
	    if { $ProgramName == "Tdyn3D" } {
		grid $e_Rotation_OX -row 0 -column 0 -pady 1 -sticky wn
		grid $e_Rotation_OY -row 0 -column 1 -pady 1 -sticky wn
	    }
	    grid $e_Rotation_OZ -row 0 -column 2 -pady 1 -sticky wn
	    grid columnconf $f_Rotation 3 -weight 1
	    
	    incr alr
	    grid $l_Rotation_Values -row $alr -column 0 -pady 2 -sticky en
	    grid $f_Rotation_Values -row $alr -column 1 -pady 2 -sticky wn
	    if { $ProgramName == "Tdyn3D" } {
		grid $e_Rotation_Value_OX -row 0 -column 0 -sticky wn
		grid $e_Rotation_Value_OY -row 0 -column 1 -sticky wn
	    }   
	    grid $e_Rotation_Value_OZ -row 0 -column 2 -sticky wn
	    grid $e_Rotation_Value_Units -row 0 -column 3 -padx 10 -pady 1 -sticky wn
	    
	    # External Forces
	    incr alr
	    grid $l_EForce_Values -row $alr -column 0 -pady 2 -sticky en
	    grid $f_EForce_Values -row $alr -column 1 -pady 2 -sticky wn
	    grid $e_EForce_Value_OX -row 0 -column 0 -sticky wn
	    grid $e_EForce_Value_OY -row 0 -column 1 -sticky wn
	    if { $ProgramName == "Tdyn3D" } {
		grid $e_EForce_Value_OZ -row 0 -column 2 -sticky wn
	    }
	    grid $e_EForce_Value_Units -row 0 -column 3 -padx 10 -pady 1 -sticky wn

	    # External Moment
	    incr alr
	    grid $l_EMoment_Values -row $alr -column 0 -pady 2 -sticky en
	    grid $f_EMoment_Values -row $alr -column 1 -pady 2 -sticky wn
	    if { $ProgramName == "Tdyn3D" } {
		grid $e_EMoment_Value_OX -row 0 -column 0 -sticky wn
		grid $e_EMoment_Value_OY -row 0 -column 1 -sticky wn
	    }   
	    grid $e_EMoment_Value_OZ -row 0 -column 2 -sticky wn
	    grid $e_EMoment_Value_Units -row 0 -column 3 -padx 10 -pady 1 -sticky wn

	    # Springs
	    if { 0 } {
	    incr alr
	    grid $l_Springs -row $alr -column 0 -pady 2 -sticky en
	    grid $f_Springs -row $alr -column 1 -columnspan 2 -pady 2 -sticky wnes
	    grid $scr_Springs -row 0 -column 0 -sticky wnes
	    grid $btnbox -row 1 -column 0 -sticky wn
	    grid rowconf $f_Springs 0 -weight 1
	    grid columnconf $f_Springs 0 -weight 1
	    grid rowconf $scr_Springs 0 -weight 1
	    grid columnconf $scr_Springs 0 -weight 1
	    
	    grid rowconf $fpage5 $alr -weight 1
	    grid columnconf $fpage5 1 -weight 1
	    
	    # KD Units
	    incr alr
	    grid $l_KD_Units -row $alr -column 0 -pady 2 -sticky en
	    grid $e_KD_Units -row $alr -column 1 -padx 7 -pady 1 -sticky wn
	    
	    # KR Units
	    incr alr
	    grid $l_KR_Units -row $alr -column 0 -pady 2 -sticky en
	    grid $e_KR_Units -row $alr -column 1 -padx 7 -pady 1 -sticky wn
	    }

	    # Dependencies
	    bondfluid::managedependencies $fpage5.f_Displacement_Values $f_Displacement.e_displx displx $BASE
	    bondfluid::managedependencies $fpage5.f_Displacement_Values $f_Displacement.e_disply disply $BASE
	    bondfluid::managedependencies $fpage5.f_Rotation_Values $f_Rotation.e_rotz rotz $BASE
	    if { $ProgramName == "Tdyn3D" } {
		bondfluid::managedependencies $fpage5.f_Displacement_Values $f_Displacement.e_displz displz $BASE
		bondfluid::managedependencies $fpage5.f_Rotation_Values $f_Rotation.e_rotx rotx $BASE
		bondfluid::managedependencies $fpage5.f_Rotation_Values $f_Rotation.e_roty roty $BASE
	    }

	    # Right Click menus
	    bind $e_EForce_Value_OX <ButtonPress-3> \
		"bondfluid::popupmenu $BASE bondfluid::EForce_OX \"[= {External Force X}]\" \"\" 1 %X %Y"
	    bind $e_EForce_Value_OY <ButtonPress-3> \
		"bondfluid::popupmenu $BASE bondfluid::EForce_OY \"[= {External Force Y}]\" \"\" 1 %X %Y"
	    bind $e_EMoment_Value_OZ <ButtonPress-3> \
		"bondfluid::popupmenu $BASE bondfluid::EMoment_OZ \"[= {External Moment Z}]\" \"\" 1 %X %Y"
	    if { $ProgramName == "Tdyn3D" } {
		bind $e_EForce_Value_OZ <ButtonPress-3> \
		    "bondfluid::popupmenu $BASE bondfluid::EForce_OZ \"[= {External Force Z}]\" \"\" 1 %X %Y"
		bind $e_EMoment_Value_OX <ButtonPress-3> \
		    "bondfluid::popupmenu $BASE bondfluid::EMoment_OX \"[= {External Moment X}]\" \"\" 1 %X %Y"
		bind $e_EMoment_Value_OY <ButtonPress-3> \
		    "bondfluid::popupmenu $BASE bondfluid::EMoment_OY \"[= {External Moment Y}]\" \"\" 1 %X %Y"
	    }
	}
	
	if { $show_alemesh == 1 || $show_ransol == 1} {
	    
	    # Gridding
	    # Buttons frame
	    incr alr
	    grid $btn_frame -row $alr -column 1 -columnspan 2 -sticky wn
	    # Function Editor Button
	    grid $btn_functions -row 0 -column 0 -sticky en -padx 1 -pady 5
	    
	    # Right Click menus
	    bind $e_Centre_of_Gravity_X <ButtonPress-3> \
		"bondfluid::popupmenu $BASE bondfluid::Centre_of_Gravity_X \"[= {Centre of Gravity X}]\" \"\" 1 %X %Y"
	    bind $e_Centre_of_Gravity_Y <ButtonPress-3> \
		"bondfluid::popupmenu $BASE bondfluid::Centre_of_Gravity_Y \"[= {Centre of Gravity Y}]\" \"\" 1 %X %Y"
	    if { $ProgramName == "Tdyn3D" } {
		bind $e_Centre_of_Gravity_Z <ButtonPress-3> \
		    "bondfluid::popupmenu $BASE bondfluid::Centre_of_Gravity_Z \"[= {Centre of Gravity Z}]\" \"\" 1 %X %Y"
	    }
	    if { $show_alemesh != 1 } {
		switch $ProgramName {
		    "Tdyn2D" {
		        variable alemesh_ff \
		            [ list \
		                {bondfluid::Centre_of_Gravity_X} [= {Centre of Gravity X}] \
		                {bondfluid::Centre_of_Gravity_Y} [= {Centre of Gravity Y}] \
		                ]
		    }
		    "Tdyn3D" {
		        variable alemesh_ff \
		            [ list \
		                {bondfluid::Centre_of_Gravity_X} [= {Centre of Gravity X}] \
		                {bondfluid::Centre_of_Gravity_Y} [= {Centre of Gravity Y}] \
		                {bondfluid::Centre_of_Gravity_Z} [= {Centre of Gravity Z}] \
		                ]
		    }
		}
	    }
	}
    }
    
    if { $Boundary_Type == "Interf" } {
	
	#--------------------------- CONTACT BOUNDARY ---------------------------#
	
	# Combo boxes Units definitions
	lappend vals_Thermal_Resistance_Units "Kcal/h.m\u00b2.\u2070C" "KW/m\u00b2.\u2070C"\
	    "cal/h.m\u00b2.\u2070C" "W/m\u00b2.\u2070C" "cal/s.m\u00b2.\u2070C" \
	"btu/h.in\u00b2.\u2070F" "btu/h.ft\u00b2.\u2070F" "btu/s.ft\u00b2.\u2070F"
		    
	# Invisible label to keep size
	set sizelabel [label $fpage2.l_sizelabel \
		-text "                                   " -bd 0 ]
	
	# Thermal Resistance
	set l_Thermal_Resistance [Label $fpage2.l_thermal_resistance \
		-text "[= {Thermal Resistance}] " -helptext $help_Thermal_Resistance]
	set e_Thermal_Resistance [entry $fpage2.e_thermal_resistance \
		-textvariable bondfluid::Thermal_Resistance]
	
	# Thermal Resistance Units
	set e_Thermal_Resistance_Units [ComboBox $fpage2.e_thermal_resistance_units \
		-values $vals_Thermal_Resistance_Units \
		-editable $edit_units -width [TUI_getcbxsize 11 $vals_Thermal_Resistance_Units] \
		-textvariable bondfluid::Thermal_Resistance_Units]
	
	# SWITCH
	set b_Switch [checkbutton $fpage2.switch -offvalue "Off" -onvalue "On" \
		-variable bondfluid::Thermal_OnOff -takefocus 1 -indicatoron 1 -text ""\
		-state disabled]
	
	# Buttons frame
	set btn_frame [frame $fpage2.btn_frame]
	# Function Editor Button
	set btn_functions [Button $btn_frame.btn_func -justify left -underline 0 \
		-command "FEditor::init $BASE \"$predefined_ff\" \"\" \"[= {SELECT FIELD}]\" \"\" \"\$bondfluid::heatcont_ff\" \"\"" \
		-image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]
	
	# GRIDS
	# SizeLabel
	grid $sizelabel -row 0 -column 0 -sticky en
	grid $l_Thermal_Resistance -row 1 -column 0 -pady 2 -sticky en
	grid $e_Thermal_Resistance -row 1 -column 1 -pady 1 -sticky wn
	grid $b_Switch -row 1 -column 3 -sticky wn
	grid $e_Thermal_Resistance_Units -row 1 -column 4 -pady 1 -sticky wn
	# Function Editor Button
	grid $btn_frame -row 9 -column 1 -columnspan 2 -sticky wn
	grid $btn_functions -row 0 -column 0 -sticky en -padx 1 -pady 5
	
	
	# Right Click menus
	bind $e_Thermal_Resistance <ButtonPress-3> "bondfluid::popupmenu $BASE bondfluid::Thermal_Resistance \"[= {Thermal Resistance}]\" \"\" 1 %X %Y"
    }


    if { $Boundary_Type == "FreeS" } {
	
	#---------------------- FREE SURFACE (ONLY ONE PAGE) -----------------------#
	if { $show_ransol == 1 } {
	    $pages delete page1
	}
	if { $show_heatrans == 1 } {
	    $pages delete page2
	}
	if { $show_advect == 1 } {
	    $pages delete page3
	}
	if { $show_ursolver == 1 } {
	    $pages delete page4
	}
	if { $show_alemesh == 1 || $show_ransol == 1 } {
	    $pages delete page5
	}
	$pages raise page6

	# More Button help
	set help_btn_more "[= {Show Advanced Data}]."
	
	# Combo boxes definitions
	lappend vals_Time_Integration "[= {Adams Bashforth 2}]" "[= {Stabilised FIC}]" "[= {Backward Euler}]"\
	    "[= {Forward Euler}]" "[= {Crank Nicolson}]"
	lappend vals_Length_units "m" "dm" "cm" "mm" "in" "pica" "ft" "yd" "A" "Nmi"
	
#        catch {
#            destroy $BASE.fsfr
#        }
#        set fsfr [frame $BASE.fsfr -relief flat]
	set fsfr $fpage6

	# Invisible label to keep size
	set sizelabel [label $fsfr.l_sizelabel \
		-text "                                   " -bd 0 ]
	
	# Time Integration
	set l_Time_Integration [Label $fsfr.l_timeintegration -text "[= {Time Integration}] "\
		-helptext $help_Time_Integration]
	set e_Time_Integration [ComboBox $fsfr.e_timeintegration -values $vals_Time_Integration \
		-editable false -width [TUI_getcbxsize 11 $vals_Time_Integration] \
		-textvariable bondfluid::Time_Integration]
	
	# Length
	set l_Length [Label $fsfr.l_length -text "[= {Length}] " -helptext $help_Length]
	set e_Length [entry $fsfr.e_length -textvariable bondfluid::Length]
	set e_Length_units [ComboBox $fsfr.e_length_units -values $vals_Length_units \
		-editable $edit_units -width [TUI_getcbxsize 11 $vals_Length_units] \
		-textvariable bondfluid::Length_units]
	
	# Damping Length
	set l_Damping_length [Label $fsfr.l_dumping_length -text "[= {Damping Length}] "\
		-helptext $help_Damping_length]
	set e_Damping_length [entry $fsfr.e_dumping_length -textvariable bondfluid::Damping_length]
	
	# Damping Factor
	set l_Damping_factor [Label $fsfr.l_dumping_factor -text "[= {Damping Factor}] "\
		-helptext $help_Damping_factor]
	set e_Damping_factor [entry $fsfr.e_dumping_factor -textvariable bondfluid::Damping_factor]
	
	# More button
	set btn_more [Button $fsfr.btn_adv -underline 0 -helptext $help_btn_more \
		-command "bondfluid::freesurfadvanced $BASE" \
		-text "[= {More}]..." -takefocus 1]
	
	# GRIDS
	# SizeLabel
#        grid $fsfr -row 1 -column 0 -sticky nwes -pady 5
#        grid columnconf $fsfr 10 -weight 1
#        grid rowconf $fsfr 10 -weight 1
	grid $sizelabel -row 0 -column 0 -sticky en
	grid $l_Time_Integration -row 1 -column 0 -pady 2 -sticky en
	grid $e_Time_Integration -row 1 -column 1 -pady 1 -sticky wn
	grid $l_Length -row 2 -column 0 -pady 2 -sticky en
	grid $e_Length -row 2 -column 1 -pady 1 -sticky wn
	grid $e_Length_units -row 2 -column 2 -padx 7 -pady 1 -sticky wn
	grid $l_Damping_length -row 3 -column 0 -pady 2 -sticky en
	grid $e_Damping_length -row 3 -column 1 -pady 1 -sticky wn
	grid $l_Damping_factor -row 4 -column 0 -pady 2 -sticky en
	grid $e_Damping_factor -row 4 -column 1 -pady 1 -sticky wn
	grid $btn_more -row 5 -column 1 -pady 5 -sticky wn
	
    }
    
    if { [info exists snlist] == 1 && [info exists ursnlist] == 1 } {
	$pages bindtabs <Button-1> "bondfluid::selectpage $snlist $ursnlist"
    } elseif { [info exists snlist] == 1 && [info exists ursnlist] != 1 } {
	$pages bindtabs <Button-1> "bondfluid::selectpage $snlist \"\""
    } elseif { [info exists snlist] != 1 && [info exists ursnlist] == 1 } {
	$pages bindtabs <Button-1> "bondfluid::selectpage \"\" $ursnlist"
    }
}

proc bondfluid::LinkProblem { frame value } {
    if { $value=="Yes" || $value==1 } { 
	$frame.e_body_mass configure -state disabled
	$frame.e_body_mass_units configure -state disabled
    } else {
	$frame.e_body_mass configure -state normal
	$frame.e_body_mass_units configure -state normal
    }
}

# Manage dependencies in this window
proc bondfluid::managedependencies { parent manpath man tag } {

    global ProgramName

    variable show_naval
    variable alemesh_ff

    switch $man {
	"BoundType" { 
	    variable BoundType
	    set showlist ""
	    set hidelist ""
	    lappend showlist \
		    $parent.l_sharpangle \
		    $parent.e_sharpangle \
		    $parent.l_sharp_units \
		    $parent.l_fixangle \
		    $parent.e_fixangle \
		    $parent.l_fix_units
	    if { $show_naval == 1 } {
		lappend showlist \
		        $parent.l_sterncangle \
		        $parent.e_sterncangle \
		        $parent.l_sternc_units
	    }
	    switch $BoundType {
		"InvisWall" {
		    lappend hidelist \
		            $parent.l_yplus \
		            $parent.e_yplus \
		            $parent.l_delta \
		            $parent.e_delta \
		            $parent.e_delta_units \
		            $parent.l_cw \
		            $parent.e_cw \
		            $parent.l_roughness \
		            $parent.e_roughness \
		            $parent.e_roughness_units \
		            $parent.l_ftau \
		            $parent.e_ftau \
		            $parent.l_ftau_units \
		            $parent.l_kenr \
		            $parent.e_kenr \
		            $parent.l_kenr_units \
		            $parent.l_elen \
		            $parent.e_elen \
		            $parent.l_elen_units \
		            $parent.l_velx \
		            $parent.e_velx \
		            $parent.l_velx_units \
		            $parent.l_vely \
		            $parent.e_vely \
		            $parent.l_vely_units \
		            $parent.l_velz \
		            $parent.e_velz \
		            $parent.l_velz_units \
		            $parent.l_veln \
		            $parent.e_veln \
		            $parent.l_veln_units
		}
		"DeltaWall" { 
		    lappend showlist \
		            $parent.l_delta \
		            $parent.e_delta \
		            $parent.e_delta_units

		    lappend hidelist \
		            $parent.l_yplus \
		            $parent.e_yplus \
		            $parent.l_cw \
		            $parent.e_cw \
		            $parent.l_roughness \
		            $parent.e_roughness \
		            $parent.e_roughness_units \
		            $parent.l_ftau \
		            $parent.e_ftau \
		            $parent.l_ftau_units \
		            $parent.l_kenr \
		            $parent.e_kenr \
		            $parent.l_kenr_units \
		            $parent.l_elen \
		            $parent.e_elen \
		            $parent.l_elen_units \
		            $parent.l_velx \
		            $parent.e_velx \
		            $parent.l_velx_units \
		            $parent.l_vely \
		            $parent.e_vely \
		            $parent.l_vely_units \
		            $parent.l_velz \
		            $parent.e_velz \
		            $parent.l_velz_units \
		            $parent.l_veln \
		            $parent.e_veln \
		            $parent.l_veln_units
		}
		"RoughWall" { 
		    lappend showlist \
		            $parent.l_roughness \
		            $parent.e_roughness \
		            $parent.e_roughness_units

		    lappend hidelist \
		            $parent.l_yplus \
		            $parent.e_yplus \
		            $parent.l_delta \
		            $parent.e_delta \
		            $parent.e_delta_units \
		            $parent.l_cw \
		            $parent.e_cw \
		            $parent.l_ftau \
		            $parent.e_ftau \
		            $parent.l_ftau_units \
		            $parent.l_kenr \
		            $parent.e_kenr \
		            $parent.l_kenr_units \
		            $parent.l_elen \
		            $parent.e_elen \
		            $parent.l_elen_units \
		            $parent.l_velx \
		            $parent.e_velx \
		            $parent.l_velx_units \
		            $parent.l_vely \
		            $parent.e_vely \
		            $parent.l_vely_units \
		            $parent.l_velz \
		            $parent.e_velz \
		            $parent.l_velz_units \
		            $parent.l_veln \
		            $parent.e_veln \
		            $parent.l_veln_units
		}
		"YplusWall" {
		    lappend showlist \
		            $parent.l_yplus \
		            $parent.e_yplus

		    lappend hidelist \
		            $parent.l_delta \
		            $parent.e_delta \
		            $parent.e_delta_units \
		            $parent.l_cw \
		            $parent.e_cw \
		            $parent.l_roughness \
		            $parent.e_roughness \
		            $parent.e_roughness_units \
		            $parent.l_ftau \
		            $parent.e_ftau \
		            $parent.l_ftau_units \
		            $parent.l_kenr \
		            $parent.e_kenr \
		            $parent.l_kenr_units \
		            $parent.l_elen \
		            $parent.e_elen \
		            $parent.l_elen_units \
		            $parent.l_velx \
		            $parent.e_velx \
		            $parent.l_velx_units \
		            $parent.l_vely \
		            $parent.e_vely \
		            $parent.l_vely_units \
		            $parent.l_velz \
		            $parent.e_velz \
		            $parent.l_velz_units \
		            $parent.l_veln \
		            $parent.e_veln \
		            $parent.l_veln_units
		}
		"Cw U2Wall" {
		    lappend showlist \
		            $parent.l_cw \
		            $parent.e_cw

		    lappend hidelist \
		            $parent.l_yplus \
		            $parent.e_yplus \
		            $parent.l_delta \
		            $parent.e_delta \
		            $parent.e_delta_units \
		            $parent.l_roughness \
		            $parent.e_roughness \
		            $parent.e_roughness_units \
		            $parent.l_ftau \
		            $parent.e_ftau \
		            $parent.l_ftau_units \
		            $parent.l_kenr \
		            $parent.e_kenr \
		            $parent.l_kenr_units \
		            $parent.l_elen \
		            $parent.e_elen \
		            $parent.l_elen_units \
		            $parent.l_velx \
		            $parent.e_velx \
		            $parent.l_velx_units \
		            $parent.l_vely \
		            $parent.e_vely \
		            $parent.l_vely_units \
		            $parent.l_velz \
		            $parent.e_velz \
		            $parent.l_velz_units \
		            $parent.l_veln \
		            $parent.e_veln \
		            $parent.l_veln_units           
		}
		"ITTC Wall" {
		    lappend showlist \
		            $parent.l_yplus \
		            $parent.e_yplus \
		            $parent.l_cw \
		            $parent.e_cw

		    lappend hidelist \
		            $parent.l_delta \
		            $parent.e_delta \
		            $parent.e_delta_units \
		            $parent.l_roughness \
		            $parent.e_roughness \
		            $parent.e_roughness_units \
		            $parent.l_ftau \
		            $parent.e_ftau \
		            $parent.l_ftau_units \
		            $parent.l_kenr \
		            $parent.e_kenr \
		            $parent.l_kenr_units \
		            $parent.l_elen \
		            $parent.e_elen \
		            $parent.l_elen_units \
		            $parent.l_velx \
		            $parent.e_velx \
		            $parent.l_velx_units \
		            $parent.l_vely \
		            $parent.e_vely \
		            $parent.l_vely_units \
		            $parent.l_velz \
		            $parent.e_velz \
		            $parent.l_velz_units \
		            $parent.l_veln \
		            $parent.e_veln \
		            $parent.l_veln_units   
		}
		"V fixWall" {
		    lappend hidelist \
		            $parent.l_yplus \
		            $parent.e_yplus \
		            $parent.l_delta \
		            $parent.e_delta \
		            $parent.e_delta_units \
		            $parent.l_cw \
		            $parent.e_cw \
		            $parent.l_roughness \
		            $parent.e_roughness \
		            $parent.e_roughness_units \
		            $parent.l_ftau \
		            $parent.e_ftau \
		            $parent.l_ftau_units \
		            $parent.l_kenr \
		            $parent.e_kenr \
		            $parent.l_kenr_units \
		            $parent.l_elen \
		            $parent.e_elen \
		            $parent.l_elen_units \
		            $parent.l_velx \
		            $parent.e_velx \
		            $parent.l_velx_units \
		            $parent.l_vely \
		            $parent.e_vely \
		            $parent.l_vely_units \
		            $parent.l_velz \
		            $parent.e_velz \
		            $parent.l_velz_units \
		            $parent.l_veln \
		            $parent.e_veln \
		            $parent.l_veln_units   
		}
		"User Wall" {
		    lappend showlist \
		            $parent.l_ftau \
		            $parent.e_ftau \
		            $parent.l_ftau_units \
		            $parent.l_kenr \
		            $parent.e_kenr \
		            $parent.l_kenr_units \
		            $parent.l_elen \
		            $parent.e_elen \
		            $parent.l_elen_units

		    lappend hidelist \
		            $parent.l_yplus \
		            $parent.e_yplus \
		            $parent.l_delta \
		            $parent.e_delta \
		            $parent.e_delta_units \
		            $parent.l_cw \
		            $parent.e_cw \
		            $parent.l_roughness \
		            $parent.e_roughness \
		            $parent.e_roughness_units \
		            $parent.l_velx \
		            $parent.e_velx \
		            $parent.l_velx_units \
		            $parent.l_vely \
		            $parent.e_vely \
		            $parent.l_vely_units \
		            $parent.l_velz \
		            $parent.e_velz \
		            $parent.l_velz_units \
		            $parent.l_veln \
		            $parent.e_veln \
		            $parent.l_veln_units 
		}
		"V fixBound" {
		    lappend showlist \
		            $parent.l_velx \
		            $parent.e_velx \
		            $parent.l_velx_units \
		            $parent.l_vely \
		            $parent.e_vely \
		            $parent.l_vely_units
		    if { $ProgramName == "Tdyn3D" } {
		        lappend showlist \
		            $parent.l_velz \
		            $parent.e_velz \
		            $parent.l_velz_units
		    }

		    lappend hidelist \
		            $parent.l_yplus \
		            $parent.e_yplus \
		            $parent.l_delta \
		            $parent.e_delta \
		            $parent.e_delta_units \
		            $parent.l_cw \
		            $parent.e_cw \
		            $parent.l_roughness \
		            $parent.e_roughness \
		            $parent.e_roughness_units \
		            $parent.l_ftau \
		            $parent.e_ftau \
		            $parent.l_ftau_units \
		            $parent.l_kenr \
		            $parent.e_kenr \
		            $parent.l_kenr_units \
		            $parent.l_elen \
		            $parent.e_elen \
		            $parent.l_elen_units \
		            $parent.l_veln \
		            $parent.e_veln \
		            $parent.l_veln_units
		}
		"VnfixBound" {
		    lappend showlist \
		            $parent.l_veln \
		            $parent.e_veln \
		            $parent.l_veln_units

		    lappend hidelist \
		            $parent.l_yplus \
		            $parent.e_yplus \
		            $parent.l_delta \
		            $parent.e_delta \
		            $parent.e_delta_units \
		            $parent.l_cw \
		            $parent.e_cw \
		            $parent.l_roughness \
		            $parent.e_roughness \
		            $parent.e_roughness_units \
		            $parent.l_ftau \
		            $parent.e_ftau \
		            $parent.l_ftau_units \
		            $parent.l_kenr \
		            $parent.e_kenr \
		            $parent.l_kenr_units \
		            $parent.l_elen \
		            $parent.e_elen \
		            $parent.l_elen_units \
		            $parent.l_velx \
		            $parent.e_velx \
		            $parent.l_velx_units \
		            $parent.l_vely \
		            $parent.e_vely \
		            $parent.l_vely_units \
		            $parent.l_velz \
		            $parent.e_velz \
		            $parent.l_velz_units
		}
		"None Wall" {
		    lappend hidelist \
		            $parent.l_yplus \
		            $parent.e_yplus \
		            $parent.l_delta \
		            $parent.e_delta \
		            $parent.e_delta_units \
		            $parent.l_cw \
		            $parent.e_cw \
		            $parent.l_roughness \
		            $parent.e_roughness \
		            $parent.e_roughness_units \
		            $parent.l_ftau \
		            $parent.e_ftau \
		            $parent.l_ftau_units \
		            $parent.l_kenr \
		            $parent.e_kenr \
		            $parent.l_kenr_units \
		            $parent.l_elen \
		            $parent.e_elen \
		            $parent.l_elen_units \
		            $parent.l_velx \
		            $parent.e_velx \
		            $parent.l_velx_units \
		            $parent.l_vely \
		            $parent.e_vely \
		            $parent.l_vely_units \
		            $parent.l_velz \
		            $parent.e_velz \
		            $parent.l_velz_units \
		            $parent.l_veln \
		            $parent.e_veln \
		            $parent.l_veln_units
		}
		"OutFBound" {
		    lappend hidelist \
		            $parent.l_yplus \
		            $parent.e_yplus \
		            $parent.l_delta \
		            $parent.e_delta \
		            $parent.e_delta_units \
		            $parent.l_cw \
		            $parent.e_cw \
		            $parent.l_roughness \
		            $parent.e_roughness \
		            $parent.e_roughness_units \
		            $parent.l_ftau \
		            $parent.e_ftau \
		            $parent.l_ftau_units \
		            $parent.e_kenr \
		            $parent.l_kenr_units \
		            $parent.l_elen \
		            $parent.e_elen \
		            $parent.l_elen_units \
		            $parent.l_velx \
		            $parent.e_velx \
		            $parent.l_velx_units \
		            $parent.l_vely \
		            $parent.e_vely \
		            $parent.l_vely_units \
		            $parent.l_velz \
		            $parent.e_velz \
		            $parent.l_velz_units \
		            $parent.l_veln \
		            $parent.e_veln \
		            $parent.l_veln_units
		}
	    }
	    if { [llength $hidelist] > 0 } {
		HideShow 0 $hidelist
	    }
	    if { [llength $showlist] > 0 } {
		HideShow 1 $showlist
	    }
	}
	"displx" {
	    if { [$manpath getvalue] != 1 } {
		bind $parent.e_displvx <ButtonPress-3> \
		        "bondfluid::popupmenu $tag bondfluid::Displacement_Value_OX \"[= {Displacement Value OX}]\" \"\" 1 %X %Y"
		$parent.e_displvx configure -state normal
		if { [lsearch -exact $alemesh_ff "bondfluid::Displacement_Value_OX"] == -1 } {
		    set alemesh_ff [linsert $alemesh_ff end "bondfluid::Displacement_Value_OX" "[= {Displacement Value OX}]"]
		}
	    } else {
		bind $parent.e_displvx <ButtonPress-3> ""
		$parent.e_displvx configure -state disabled
		set pos [lsearch -exact $alemesh_ff "bondfluid::Displacement_Value_OX"]
		if { $pos != -1 } {
		    set alemesh_ff [lreplace $alemesh_ff $pos [expr $pos + 1]]
		}
	    }
	}
	"disply" {
	    if { [$manpath getvalue] != 1 } {
		bind $parent.e_displvy <ButtonPress-3> \
		        "bondfluid::popupmenu $tag bondfluid::Displacement_Value_OY \"[= {Displacement Value OY}]\" \"\" 1 %X %Y"
		$parent.e_displvy configure -state normal
		if { [lsearch -exact $alemesh_ff "bondfluid::Displacement_Value_OY"] == -1 } {
		    set alemesh_ff [linsert $alemesh_ff end "bondfluid::Displacement_Value_OY" "[= {Displacement Value OY}]"]
		}
	    } else {
		bind $parent.e_displvy <ButtonPress-3> ""
		$parent.e_displvy configure -state disabled
		set pos [lsearch -exact $alemesh_ff "bondfluid::Displacement_Value_OY"]
		if { $pos != -1 } {
		    set alemesh_ff [lreplace $alemesh_ff $pos [expr $pos + 1]]
		}
	    }
	}
	"displz" {
	    if { [$manpath getvalue] != 1 } {
		bind $parent.e_displvz <ButtonPress-3> \
		        "bondfluid::popupmenu $tag bondfluid::Displacement_Value_OZ \"[= {Displacement Value OZ}]\" \"\" 1 %X %Y"
		$parent.e_displvz configure -state normal
		if { [lsearch -exact $alemesh_ff "bondfluid::Displacement_Value_OZ"] == -1 } {
		    set alemesh_ff [linsert $alemesh_ff end "bondfluid::Displacement_Value_OZ" "[= {Displacement Value OZ}]"]
		}
	    } else {
		bind $parent.e_displvz <ButtonPress-3> ""
		$parent.e_displvz configure -state disabled
		set pos [lsearch -exact $alemesh_ff "bondfluid::Displacement_Value_OZ"]
		if { $pos != -1 } {
		    set alemesh_ff [lreplace $alemesh_ff $pos [expr $pos + 1]]
		}
	    }
	}
	"rotx" {
	    if { [$manpath getvalue] != 1 } {
		bind $parent.e_rotvx <ButtonPress-3> \
		        "bondfluid::popupmenu $tag bondfluid::Rotation_Value_OX \"[= {Rotation Value OX}]\" \"\" 1 %X %Y"
		$parent.e_rotvx configure -state normal
		if { [lsearch -exact $alemesh_ff "bondfluid::Rotation_Value_OX"] == -1 } {
		    set alemesh_ff [linsert $alemesh_ff end "bondfluid::Rotation_Value_OX" "[= {Rotation Value OX}]"]
		}
	    } else {
		bind $parent.e_rotvx <ButtonPress-3> ""
		$parent.e_rotvx configure -state disabled
		set pos [lsearch -exact $alemesh_ff "bondfluid::Rotation_Value_OX"]
		if { $pos != -1 } {
		    set alemesh_ff [lreplace $alemesh_ff $pos [expr $pos + 1]]
		}
	    }
	}
	"roty" {
	    if { [$manpath getvalue] != 1 } {
		bind $parent.e_rotvy <ButtonPress-3> \
		        "bondfluid::popupmenu $tag bondfluid::Rotation_Value_OY \"[= {Rotation Value OY}]\" \"\" 1 %X %Y"
		$parent.e_rotvy configure -state normal
		if { [lsearch -exact $alemesh_ff "bondfluid::Rotation_Value_OY"] == -1 } {
		    set alemesh_ff [linsert $alemesh_ff end "bondfluid::Rotation_Value_OY" "[= {Rotation Value OY}]"]
		}
	    } else {
		bind $parent.e_rotvy <ButtonPress-3> ""
		$parent.e_rotvy configure -state disabled
		set pos [lsearch -exact $alemesh_ff "bondfluid::Rotation_Value_OY"]
		if { $pos != -1 } {
		    set alemesh_ff [lreplace $alemesh_ff $pos [expr $pos + 1]]
		}
	    }
	}
	"rotz" {
	    if { [$manpath getvalue] != 1 } {
		bind $parent.e_rotvz <ButtonPress-3> \
		        "bondfluid::popupmenu $tag bondfluid::Rotation_Value_OZ \"[= {Rotation Value OZ}]\" \"\" 1 %X %Y"
		$parent.e_rotvz configure -state normal
		if { [lsearch -exact $alemesh_ff "bondfluid::Rotation_Value_OZ"] == -1 } {
		    set alemesh_ff [linsert $alemesh_ff end "bondfluid::Rotation_Value_OZ" "[= {Rotation Value OZ}]"]
		}
	    } else {
		bind $parent.e_rotvz <ButtonPress-3> ""
		$parent.e_rotvz configure -state disabled
		set pos [lsearch -exact $alemesh_ff "bondfluid::Rotation_Value_OZ"]
		if { $pos != -1 } {
		    set alemesh_ff [lreplace $alemesh_ff $pos [expr $pos + 1]]
		}
	    }
	}
    }
}



# Free Surface Advanced Data Window
proc bondfluid::freesurfadvanced { parent } {

    variable FreeSurface_Questions
    foreach item $FreeSurface_Questions {
	variable [lindex $item 0]
	if { [lindex $item 4] == "advanced" } {
	    set itt [lindex $item 0]
	    set var "fsa_"
	    append var $itt
	    variable $var
	    set $var [eval set nothing $$itt]
	}
    }

    #####  HELP Text variables #####
    set help_Time_factor "[= {Time Increment security factor to be used in the explicit integration of this free surface}]."
    set help_Step_factor "[= {Time step ratio between free surface and fluid solver}]. [= {It is possible to accelerate convergence by increasing this ratio, but may cause unstability in the integration scheme}].\n[= {If chosen Time_Increment is too high, reduce this value to achieve convergence}].\n[= {Note that solutions with Step_factor != 1 are only valid in the free surface steady state}]."
    set help_Advect_Stabilisation "[= {Scheme to be used in the stabilisation of the advective terms: Standard (2nd_Order) or Improved (4th order)}]."
    set help_StabTau_MinRatio "[= {Minimum admissible ratio (tau/dt) for the stabilisation parameter tau}]."
    set help_Control_Level "[= {Level of free surface stabilisation control (0 means Off)}]. [= {If unstabilities are found in the wave elevation field, reduce Time_Increment or increase this value}].\n[= {Note that too high values may cause over-diffusive results}]."
    set help_CrossWind_Diffusion "[= {Additional diffusion to stabilise the scheme}]."
    set help_Maximum_Value "[= {Maximum limit of the wave elevation}]"
    set help_Minimum_Value "[= {Minimum limit of the wave elevation}]"

    # Combo boxes values
    lappend vals_Advect_Stabilisation "4th Order" "2nd Order" "Auto"
    lappend vals_Control_Level "0" "1" "2" "3" "4" "5"

    set w $parent.fsadvdat
    InitWindow $w "[= {Advanced Free Surface Data}]" PreTdynFreeSAdvDatWindowGeom ""
    set closecmd "bondfluid::freesurfadvancedcheckclose $w 1 1 1"
    wm protocol $w WM_DELETE_WINDOW "$closecmd"

    set frame [frame $w.f -relief flat]

    # Invisible label to keep size
    set sizelabel [label $frame.l_sizelabel \
	    -text "                                   " -bd 0 ]

    # Time Factor
    set l_Time_factor [Label $frame.l_timefactor -text "[= {Time Factor}] " \
	    -helptext $help_Time_factor]
    set e_Time_factor [entry $frame.e_timefactor -textvariable bondfluid::fsa_Time_factor]

    # Step Factor
    set l_Step_factor [Label $frame.l_stepfactor -text "[= {Step Factor}] " \
	    -helptext $help_Step_factor]
    set e_Step_factor [entry $frame.e_stepfactor -textvariable bondfluid::fsa_Step_factor]

    # Advect Stabilisation
    set l_Advect_Stabilisation [Label $frame.l_advstabil -text "[= {Advect Stabilisation}] " -helptext $help_Advect_Stabilisation]
    set e_Advect_Stabilisation [ComboBox $frame.e_advstabil -values $vals_Advect_Stabilisation \
	    -editable false -width [TUI_getcbxsize 11 $vals_Advect_Stabilisation] \
	    -textvariable bondfluid::fsa_Advect_Stabilisation]

    # StabTau MinRatio
    set l_StabTau_MinRatio [Label $frame.l_stbtminrat -text "[= {StabTau MinRatio}] " \
	    -helptext $help_StabTau_MinRatio]
    set e_StabTau_MinRatio [entry $frame.e_stbtminrat -textvariable bondfluid::fsa_StabTau_MinRatio]

    # Control Level
    set l_Control_Level [Label $frame.l_ctrllevel -text "[= {Control Level}] " -helptext $help_Control_Level]
    set e_Control_Level [ComboBox $frame.e_ctrllevel -values $vals_Control_Level \
	    -editable false -width [TUI_getcbxsize 11 $vals_Control_Level] \
	    -textvariable bondfluid::fsa_Control_Level]

    # CrossWind Diffusion
    set l_CrossWind_Diffusion [Label $frame.l_crwdiffus -text "[= {CrossWind Diffusion}] " -helptext $help_CrossWind_Diffusion]
    set e_CrossWind_Diffusion [checkbutton $frame.e_crwdiffus -offvalue "Off" -onvalue "On" \
	    -variable bondfluid::fsa_CrossWind_Diffusion -takefocus 1 -indicatoron 1]

    # Maximum Value
    set l_Maximum_Value [Label $frame.l_maxvalue -text "[= {Maximum Value}] " \
	    -helptext $help_Maximum_Value]
    set e_Maximum_Value [entry $frame.e_maxvalue -textvariable bondfluid::fsa_Maximum_Value]

    # Minimum Value
    set l_Minimum_Value [Label $frame.l_minvalue -text "[= {Minimum Value}] " \
	    -helptext $help_Minimum_Value]
    set e_Minimum_Value [entry $frame.e_minvalue -textvariable bondfluid::fsa_Minimum_Value]

    # Buttons Frame
    set bf [frame $w.bf -relief raised -takefocus 1]

    # Accept button
    set btn_accept [button $bf.btn_accept -text "[= {Accept Data}]" -underline 0 -relief raised \
	    -bd 1 -highlightthickness 1 -bg lightblue -takefocus 1 \
	    -command "bondfluid::freesurfadvancedcheckclose $w 1 0 0"]

    # Close button
    set btn_close [button $bf.btn_close -text "[= {Close}]" -underline 0 -relief raised \
	    -bd 1 -highlightthickness 1 -bg lightblue -takefocus 1 \
	    -command "$closecmd"]


    # GRIDS
    # SizeLabel
    grid $frame -row 0 -column 0 -padx 7 -sticky wn
    grid $sizelabel -row 0 -column 0 -sticky en
    set row 1
    foreach item $FreeSurface_Questions {
	if { [lindex $item 4] == "advanced" } {
	    set itt [lindex $item 0]
	    set lvar "l_$itt"
	    set evar "e_$itt"
	    grid [eval set temp $$lvar] -row $row -column 0 -sticky en -pady 2
	    grid [eval set temp $$evar] -row $row -column 1 -sticky wn -pady 2 -padx 5
	    set help "help_$itt"
	    if { [info exist $help] } {
		GidHelp [eval set temp $$lvar] [eval set temp $$help]
		GidHelp [eval set temp $$evar] [eval set temp $$help]
	    }
	    incr row
	}
    }
    grid $bf -row 1 -column 0 -sticky ne -padx 10 -pady 7
    grid $btn_accept -row 0 -column 0 -sticky e -pady 1
    grid $btn_close -row 0 -column 1 -sticky e -pady 1

    grid rowconf $w 3 -weight 1
    grid columnconf $w 1 -weight 1

    # BINDS
    bind $w <Escape> "tkButtonInvoke $btn_close"
    bind $w <Alt-c> "tkButtonInvoke $btn_close"
    bind $w <Alt-a> "tkButtonInvoke $btn_accept"

    focus $w

    return 1
}


proc bondfluid::freesurfadvancedcheckclose { win {dumpit 1} {askdump 1} {close 1} } {

    variable FreeSurface_Questions

    set valueschange 0
    set usr_err ""
    set num_usr_err 0

    # Checking Free Surface Advanced Data
    # If no errors are detected and parameter dumpit == 1, data will be copied 
    # to Free Surface variables.
    foreach item $FreeSurface_Questions {
	if { [lindex $item 4] == "advanced" } {
	    set exitt [lindex $item 0]
	    variable $exitt
	    set itt "fsa_$exitt"
	    variable $itt
	    if { [eval set nothing $$exitt] != [eval set nothing $$itt] } {
		set valueschange 1
		if { [lindex $item 3] == 1} {
		    set errcheck [TUI_valuecheck [DWSpace2Under [eval set nothing $$itt]] \
		            [lindex $item 2] 0 ""]
		    if { $errcheck != "ok"} {
		        incr num_usr_err
		        append usr_err "$num_usr_err. " [DWUnder2Space $exitt] ": $errcheck\n"
		    }
		}
	    }
	}
    }

    if { $valueschange == 1 } {
	if { $askdump == 0 } {
	    set answer 0
	} else {
	    set answer [tk_dialogRAM $win "[= {Free Surface Advanced Data}]" \
		    "[= {Free Surface Advenced Data has changed}].\n[= {Do you want to save changes?}]" question 0 Yes No]
	}

	if { $answer == 0 && $dumpit == 1} {
	    set wtsave 1
	    if { $num_usr_err > 0 } {
		if { $num_usr_err > 1 } {
		    set err_display "[= {The following %s errors were found in the data input} $num_usr_err]:\n"
		} else {
		    set err_display "[= {The following error was found in the data input}]:\n"
		}
		append err_display $usr_err
		WarnWin $err_display
		set close 0
	    } else {
		bondfluid::freesurfaceadvdatdump
		FloatMessage $win.flm "[= {Free Surface Advenced Data was saved}]."
	    }
	}
    } else {
	if { $dumpit == 1 } {
	    FloatMessage $win.flm "[= {No changes need to be saved}]."
	}
    }

    if { $close == 1 } {
	destroy $win
    } else {
	focus $win
	if { $num_usr_err == 0 } {
	    return $valueschange
	} else {
	    if { $wtsave == 1 } {
		return "dataerror"
	    } else {
		return "nosave.dataerror"
	    }
	}
    }
}

proc bondfluid::freesurfaceadvdatdump { } {

    variable Boundary_Name
    variable Boundary_Type
    variable FreeSurface_Questions

    set Vallist [list $Boundary_Type]
    foreach item $FreeSurface_Questions {
	set itt [lindex $item 0]
	variable $itt
	set tv_var bondfluid::tv_$itt
	set fsa_var bondfluid::fsa_$itt
	if { [lindex $item 4] == "advanced" } {
	    eval set value $$fsa_var
	    eval set $itt $$fsa_var
	} else {
	    eval set value $$tv_var
	    eval set $tv_var $$itt
	}
	if { [lindex $item 1] == "unit" } {
	    set value [TUI_formatunits Unicode2Nums $value 1]
	}
	lappend Vallist $value
    }

    TUI_setnewmatvalues $Boundary_Name $Vallist

    return 1
}



# Ading and removing rows in Springs tablelist
proc bondfluid::addspring { } {

    variable Springs_Values

    lappend Springs_Values [lindex $Springs_Values end]

    return 1
}



proc bondfluid::removespring { sel } {

    variable Springs_Values

    if { $sel == "" } {
	WarnWin "[= {Please select a row(s) to be deleted}]."
    } else {
	if { [llength $sel] < [llength $Springs_Values] } {
	    set i 0
	    set temp ""
	    while { $i < [llength $Springs_Values] } {
		if { [lsearch $sel $i] == -1 } {
		    lappend temp [lindex $Springs_Values $i]
		}
		incr i
	    }
	    set Springs_Values $temp
	} else {
	    WarnWin "[= {There must be at least one Spring left}]."
	}
    }

    return 1
}

proc bondfluid::selectpage { snlist ursnlist {pg ""} } {

    variable spcnlastsel
    variable ursnlastsel

    set nlist ""

    if { $pg == "page3" } {
	set type "advect"
	set nlist $snlist
	set setsel $spcnlastsel
	set leavenlist $ursnlist
    } elseif { $pg == "page4" } {
	set type "ursolver"
	set nlist $ursnlist
	set setsel $ursnlastsel
	set leavenlist $snlist
    }

    if { [string length $nlist] > 0 && ( $type == "advect" || $type == "ursolver") } {
	bondfluid::valsavespecie $leavenlist "" $type
	bondfluid::updatespcselection $nlist $setsel $type
	bondfluid::displayspecievalues $nlist $type
    }

    return 1
}



################################################################################
#
#   Species Manipulation
#   The following functions are used to manipulate the ADVECT Species Data
#   as well as the URSolver Variables Data.
#
################################################################################

proc bondfluid::makespecie { nlist vlist type } {

    # Tdyn Settings
    variable edit_units

    variable Boundary_Type

    # Advect Variables
    variable Species_Values
    variable Species_UValues
    variable Species_Names
    variable Species_Valnames
    variable Species_UValnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    for { set i 0 } { $i < [llength $Species_UValnames] } { incr i } {
	set tvar [lindex [lindex $Species_UValnames $i] 1]
	variable $tvar
    }
    variable spcnlastsel
    variable sname
    # URSolver Variables
    variable URVariables_Values
    variable URVariables_UValues
    variable URVariables_Names
    variable URVariables_Valnames
    variable URVariables_UValnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    for { set i 0 } { $i < [llength $URVariables_UValnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_UValnames $i] 1]
	variable $tvar
    }
    variable ursnlastsel
    variable ursname

    # Combo boxes Units definitions
    # ADVECT
    lappend units_Flux_Spc_Units "C.m/s" "mC.m/s"
    lappend units_Reactive_Flux_Spc_Units "m/s" "cm/s"
    lappend units_Res_Spc_Units "m/s" "cm/s"
    # URSOLVER
    lappend units_Flux_Phi_Units "U/m\u00b2.s" "cU/m\u00b2.s"
    lappend units_Reactive_Flux_Phi_Units "1/m\u00b2.s" "1/cm\u00b2.s"
    lappend units_Res_Phi_Units "1/m\u00b2.s" "1/cm\u00b2.s"

    # Grid Values Frame
    grid $vlist -row 0 -column 0 -sticky wnes -padx 10

    switch $type {
	"advect" {
	    # Specie Name
	    set l_sname [Label $vlist.l_sname -text "  [= {Species Name}]:"]
	    set e_sname [Entry $vlist.e_sname -width 21 -textvariable bondfluid::sname \
		    -editable 0 -background [$vlist cget -background] -relief flat]
	}
	"ursolver" {
	    # Variable Name
	    set l_sname [Label $vlist.l_vname -text "[= {Variable Name}]:"]
	    set e_sname [Entry $vlist.e_vname -width 21 -textvariable bondfluid::ursname \
		    -editable 0 -background [$vlist cget -background] -relief flat]
	}
    }

    # GRIDS
    # Label
    grid $l_sname -row 0 -column 0 -sticky en -pady 5
    # Entry
    grid $e_sname -row 0 -column 1 -columnspan 2 -sticky wn -pady 5

    # BINDS
    bind $e_sname <Return> ";
    bondfluid::valsavespecie $nlist \"actual\" \"$type\";
    bondfluid::displayspeciesnames $nlist \"$type\";
    "
    bind $e_sname <ButtonPress-3> "+bondfluid::popupmenu $vlist \"\" \"\" \"\" 2 %X %Y"

    switch $type {
	"advect" {
	    set type_Valnames $Species_Valnames
	    set type_UValnames $Species_UValnames
	    set cbmove 1
	}
	"ursolver" {
	    set type_Valnames $URVariables_Valnames
	    set type_UValnames $URVariables_UValnames
	    set cbmove 1
	}
    }

    # Creating widgets
    for { set i 0 } { $i < [llength $type_Valnames] } { incr i } {
	set tvar [lindex [lindex $type_Valnames $i] 1]
	set tname [lindex [lindex $type_Valnames $i] 0]
	# Defining a Label
	set lvar l_$tvar
	set $lvar [Label $vlist.$lvar -text $tname]
	# Defining an Entry
	set evar e_$tvar
	set $evar [entry $vlist.$evar -width 11 -textvariable bondfluid::$tvar]

	# GRIDS
	# Label
	grid [eval set temp $$lvar] -row [expr $i+1] -column 0 -sticky en -pady 1
	# Entry
	grid [eval set temp $$evar] -row [expr $i+1] -column 1 -sticky wn -pady 1

	# BINDS
	bind [eval set temp $$evar] <Return> ";
	bondfluid::valsavespecie $nlist \"actual\" \"$type\";
	bondfluid::displayspeciesnames $nlist \"$type\";
	"
	bind [eval set temp $$evar] <ButtonPress-3> "+bondfluid::popupmenu $vlist bondfluid::$tvar \"$tname\" \"\" 1 %X %Y"
    }
    for { set i 0 } { $i < [llength $type_UValnames] } { incr i } {
	set tuvar [lindex [lindex $type_UValnames $i] 1]
	set cuvar "units_"
	append cuvar [lindex [lindex $type_UValnames $i] 1]
	# Defining Units Combobox
	set cvar c_$tuvar
	set $cvar [ComboBox $vlist.$cvar -values [eval set temp $$cuvar] \
		-editable $edit_units -width 7 -textvariable bondfluid::$tuvar -takefocus 1]

	# GRIDS
	# Units Combo
	grid [eval set temp $$cvar] -row [expr $i+$cbmove] -column 2 -sticky wn -padx 2
    }

    grid columnconf $vlist 3 -weight 1

    return 1
}

proc bondfluid::displayspecievalues { nlist type } {

    # Advect Variables
    variable Species_Values
    variable Species_UValues
    variable Species_Names
    variable Species_Valnames
    variable Species_UValnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    for { set i 0 } { $i < [llength $Species_UValnames] } { incr i } {
	set tvar [lindex [lindex $Species_UValnames $i] 1]
	variable $tvar
    }
    variable spcnlastsel
    variable sname
    # URSolver Variables
    variable URVariables_Values
    variable URVariables_UValues
    variable URVariables_Names
    variable URVariables_Valnames
    variable URVariables_UValnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    for { set i 0 } { $i < [llength $URVariables_UValnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_UValnames $i] 1]
	variable $tvar
    }
    variable ursnlastsel
    variable ursname

    if { [lindex [$nlist curselection] 0] > -1 } {
	set sel [lindex [$nlist curselection] 0]
    } else {
	bondfluid::updatespcselection $nlist 0 $type
	set sel [lindex [$nlist curselection] 0]
    }

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	    set type_Values $Species_Values
	    set type_Valnames $Species_Valnames
	    set type_UValnames $Species_UValnames
	    set type_UValues $Species_UValues
	    set vartype_name "sname"
	    set vartype_lastsel "spcnlastsel"
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	    set type_Values $URVariables_Values
	    set type_Valnames $URVariables_Valnames
	    set type_UValues $URVariables_UValues
	    set type_UValnames $URVariables_UValnames
	    set vartype_name "ursname"
	    set vartype_lastsel "ursnlastsel"
	}
    }

    # Display Specie / Variable name and set last selection
    set $vartype_name [lindex $type_Names $sel]
    set $vartype_lastsel $sel

    set currvals [lindex $type_Values $sel]
    for { set i 0 } { $i < [llength $type_Valnames] } { incr i } {
	# Entries Values
	set tvar [lindex [lindex $type_Valnames $i] 1]
	set $tvar [lindex $currvals $i]
    }
    set currvals [lindex $type_UValues $sel]
    for { set i 0 } { $i < [llength $type_UValnames] } { incr i } {
	# Combo boxes Units values
	set tvar [lindex [lindex $type_UValnames $i] 1]
	set $tvar [lindex $currvals $i]
    }

    return 1
}

proc bondfluid::displayspeciesnames { nlist type } {

    variable Species_Names
    variable URVariables_Names

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	}
    }

    if { [lindex [$nlist curselection] 0] > -1 } {
	set savesel [lindex [$nlist curselection] 0]
    } else {
	set savesel ""
    }
    set p 0
    $nlist delete 0 end
    foreach n $type_Names {
	$nlist insert $p $n
	incr p
    }

    if { $savesel > -1 } {
	$nlist selection clear 0 end
	$nlist selection set $savesel $savesel
    }

    return 1
}

proc bondfluid::updatespcselection { nlist setsel type } {

    variable Species_Names
    variable URVariables_Names
    variable spcnlastsel
    variable ursnlastsel
    variable sname
    variable ursname

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	}
    }

    if { $setsel < 0 || $setsel > [expr [llength $type_Names] -1] } {
	set setsel "end"
    }

    $nlist selection clear 0 end
    $nlist selection set $setsel $setsel

    switch $type {
	"advect" {
	    set spcnlastsel $setsel
	    set sname [lindex $type_Names $setsel]
	}
	"ursolver" {
	    set ursnlastsel $setsel
	    set ursname [lindex $type_Names $setsel]
	}
    }

    return 1
}

proc bondfluid::valsavespecie { nlist sel type } {

    # Advect Variables
    variable Species_Values
    variable Species_UValues
    variable Species_Names
    variable Species_Valnames
    variable Species_UValnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    for { set i 0 } { $i < [llength $Species_UValnames] } { incr i } {
	set tvar [lindex [lindex $Species_UValnames $i] 1]
	variable $tvar
    }
    variable spcnlastsel
    variable sname
    # URSolver Variables
    variable URVariables_Values
    variable URVariables_UValues
    variable URVariables_Names
    variable URVariables_Valnames
    variable URVariables_UValnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    for { set i 0 } { $i < [llength $URVariables_UValnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_UValnames $i] 1]
	variable $tvar
    }
    variable ursnlastsel
    variable ursname

    if { $sel == "actual" && [string length [$nlist curselection]] > 0 } {
	set sel [lindex [$nlist curselection] 0]
    } else {
	switch $type {
	    "advect" {
		set sel $spcnlastsel
	    }
	    "ursolver" {
		set sel $ursnlastsel
	    }
	}
    }

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	    set vartype_Names "Species_Names"
	    set type_Values $Species_Values
	    set vartype_Values "Species_Values"
	    set type_Valnames $Species_Valnames
	    set type_UValnames $Species_UValnames
	    set type_UValues $Species_UValues
	    set vartype_UValues "Species_UValues"
	    set type_name $sname
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	    set vartype_Names "URVariables_Names"
	    set type_Values $URVariables_Values
	    set vartype_Values "URVariables_Values"
	    set type_Valnames $URVariables_Valnames
	    set type_UValnames $URVariables_UValnames
	    set type_UValues $URVariables_UValues
	    set vartype_UValues "URVariables_UValues"
	    set type_name $ursname
	}
    }

    if { $sel > -1 && !($sel > [expr [llength $type_Values] -1]) } {

	# Saving Specie / UR Variable Name
	set $vartype_Names [lreplace $type_Names $sel $sel [string trim [DWSpace2Under $type_name]]]

	# Saving Specie / UR Variable values
	set newvals ""
	for { set i 0 } { $i < [llength $type_Valnames] } { incr i } {
	    set tvar [lindex [lindex $type_Valnames $i] 1]
	    set type [lindex [lindex $type_Valnames $i] 2]
	    lappend newvals [TUI_cleanvalue [eval set temp $$tvar] $type]
	    #if { [lindex [lindex $type_Valnames $i] 2] == "func" } {
	    #    lappend newvals [TdynCleanString [eval set temp $$tvar]]
	    #} else {
	    #    lappend newvals [DWSpace2Under [eval set temp $$tvar]]
	    #}
	}
	set $vartype_Values [lreplace $type_Values $sel $sel $newvals]
	# Saving Specie / UR Variable Units values
	set newvals ""
	for { set i 0 } { $i < [llength $type_UValnames] } { incr i } {
	    set tvar [lindex [lindex $type_UValnames $i] 1]
	    lappend newvals [TUI_cleanvalue [eval set temp $$tvar] units]
	    #regsub -all { } [eval set temp $$tvar] {} ttv
	    #lappend newvals $ttv
	}
	set $vartype_UValues [lreplace $type_UValues $sel $sel $newvals]
    }

    return 1
}



################################################################################
#
#   PopUp Menus
#
################################################################################

proc bondfluid::popupmenu { parent {field ""} {fieldname ""} tags content x y } {

    variable predefined_ff

    catch { 
	destroy $parent.menu
    }

    set menu [menu $parent.menu -type normal]

    switch $content {
	1 {
	    if { [string length $field] > 0 } {
		eval set fval $$field
	    }
	    $menu add command -label "[= {Define Function}]" \
		    -command "FEditor::init $parent \"$predefined_ff\" $field [list $fieldname] [list $fval] \"\" \"\""
	}
    }
    
    tk_popup $menu $x $y

    return 1
}



################################################################################
#
#   GiD Values Manipulation - GET Values, TSAVE and DUMP Values
#   - GETVALUES reads GiD values and puts them to the variables
#   - CHECKCLOSE goes through all variables and checks for changes. If changes 
#     are found, asks the user SAVE YES or NO. If YES, runs DUMP procedure.
#     This procedure also checks the temporal space of Initial Conditions.
#   - TICSAVE saves values from Initial Conditions entries to temporal variables
#     from where in case of accept saving it saves the values tom GiD memory.
#   - DUMP saves values of entries to GiD memory and in case of initial condition
#
################################################################################

proc bondfluid::getvalues { } {

    global ProgramName

    # Tdyn settings
    set show_ransol $bondfluid::show_ransol
    set show_heatrans $bondfluid::show_heatrans
    set show_advect $bondfluid::show_advect
    set show_ursolver $bondfluid::show_ursolver
    set show_alemesh $bondfluid::show_alemesh
    set show_naval $bondfluid::show_naval

    variable FluidBody_Questions
    variable Contact_Questions
    variable FreeSurface_Questions
    variable Auxiliar_Questions

    variable Boundary_Name
    variable Boundary_Type
    variable ValList

    variable Species_Names
    variable Species_Values
    variable Species_UValues
    variable Species_Valnames
    variable Species_UValnames

    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_UValues
    variable URVariables_Valnames
    variable URVariables_UValnames

    variable Springs_Values
    variable Springs_Valnames
    
    # Read all boundary values
    set ValList [.central.s info materials $Boundary_Name]

    # Depending on Boundary Type, configure script
    switch $Boundary_Type {
	"Fluid_Body" {
#            set show_ransol 1
#            set show_heatrans 1
#            set show_advect 1
#            set show_ursolver 1
#            set show_alemesh 1
	    set show_naval 0
	}
	"Interf" {
	    set show_ransol 0
#            set show_heatrans 1
	    set show_advect 0
	    set show_ursolver 0
	    set show_alemesh 0
	    set show_naval 0
	}
	"FreeS" {
	    set show_ransol 0
	    set show_heatrans 0
	    set show_advect 0
	    set show_ursolver 0
	    set show_alemesh 0
	}
    }

    # Index of values started from 1 and not from 0 because the 
    # first values is number of questions.
    set i 0
    switch $Boundary_Type {
	"Fluid_Body" {
	    foreach item $FluidBody_Questions {
		set itt [lindex $item 0]
		variable $itt
		set tv [TUI_getfieldvalue $itt $ValList]
		if { [lindex $item 1] == "unit" } {
		    set tv [TUI_formatunits Nums2Unicode $tv 0]
		}
		if { $itt == "BoundType" } {
		    set tv [DWUnder2Space $tv]
		}
		set $itt $tv
		incr i
	    }
	}
	"Interf" {
	    foreach item $Contact_Questions {
		set itt [lindex $item 0]
		variable $itt
		set tv [TUI_getfieldvalue $itt $ValList]
		if { [lindex $item 1] == "unit" } {
		    set tv [TUI_formatunits Nums2Unicode $tv 0]
		}
		set $itt $tv
		incr i
	    }
	}
	"FreeS" {
	    foreach item $FreeSurface_Questions {
		set itt [lindex $item 0]
		variable $itt
		set tv [TUI_getfieldvalue $itt $ValList]
		if { [lindex $item 1] == "unit" } {
		    set tv [TUI_formatunits Nums2Unicode $tv 0]
		}
		if { $itt == "Time_Integration" || $itt == "Advect_Stabilisation" } {
		    set tv [DWUnder2Space $tv]
		}
		set $itt $tv
		if { [lindex $item 4] == "advanced" } {
		    variable fsa_$itt $tv
		} else {
		    variable tv_$itt $tv
		}
		incr i
	    }
	}
    }

    # Read auxiliar data (from Prb file)
    set gendata [.central.s info gendata]
    foreach item $Auxiliar_Questions {
	set itt [lindex $item 0]
	if { [lindex $item 1] == "unit" } {
	    # Format units
	    variable $itt [TUI_formatunits Nums2Unicode \
		    [DWUnder2Space [join [lindex $gendata [expr [lsearch -regexp $gendata \
		    [eval set nothing ^${itt}(\$|\#CB)]] + 1]]]] 0]
	} else {
	    # Normal assign
	    variable $itt [join [lindex $gendata [expr [lsearch -regexp $gendata \
		    [eval set nothing ^${itt}(\$|\#CB)]] + 1]]]
	}
    }

    if { $show_advect == 1 } {
	# Read Species Names from Problem Data
	set temp [join [lindex [.central.s info gendata] \
		[expr [lsearch [.central.s info gendata] "Species_Names:(SpecieName)"] + 1]]]
	set Species_Names [lreplace $temp 0 1]

	# Species Lists formating
	switch $Boundary_Type {
	    "Fluid_Body" {
		set Species_Values [TUI_formatspeciesvalues String2List $Species_Valnames $Species_Properties]
		set Species_UValues [TUI_formatspeciesvalues String2List $Species_UValnames $Spc_Units]
	    }
	    "Interf" {
		set Species_Values [TUI_formatspeciesvalues String2List $Species_Valnames $Species_Properties]
		set Species_UValues [TUI_formatspeciesvalues String2List $Species_UValnames $Resistance_Spc_Units]
	    }
	}

	# Format Species Units Lists for Mat File Format
	set ltemp ""
	foreach litem $Species_UValues {
	    set temp ""
	    foreach item $litem {
		lappend temp [TUI_formatunits Nums2Unicode $item 1]
	    }
	    lappend ltemp [string trim $temp]
	}
	set Species_UValues $ltemp
    }

    if { $show_ursolver == 1 } {
	# Read URSolver Variables Names from Problem Data
	set temp [join [lindex [.central.s info gendata] \
		[expr [lsearch [.central.s info gendata] "URVariables_Names:(VariableName)"] + 1]]]
	set URVariables_Names [lreplace $temp 0 1]

	# URVariables Lists formating
	switch $Boundary_Type {
	    "Fluid_Body" {
		set URVariables_Values [TUI_formatspeciesvalues String2List $URVariables_Valnames $Variables_Properties]
		set URVariables_UValues [TUI_formatspeciesvalues String2List $URVariables_UValnames $URV_Units]
	    }
	    "Interf" {
		set URVariables_Values [TUI_formatspeciesvalues String2List $URVariables_Valnames $Variables_Properties]
		set URVariables_UValues [TUI_formatspeciesvalues String2List $URVariables_UValnames $Resistance_Phi_Units]
	    }
	}

	# Format URVariables Units Lists for Mat File Format
	set ltemp ""
	foreach litem $URVariables_UValues {
	    set temp ""
	    foreach item $litem {
		lappend temp [TUI_formatunits Nums2Unicode $item 1]
	    }
	    lappend ltemp [string trim $temp]
	}
	set URVariables_UValues $ltemp
    }

    if { $show_alemesh == 1 } {
	# Format Alemesh Springs matrix to Values List
	set Springs_Values [TUI_formatspeciesvalues String2List $Springs_Valnames $Springs]
    }

    return 1
}

proc bondfluid::checkclose { win {dumpit 1} {askdump 1} {close 1} } {

    # Tdyn settings
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_alemesh

    variable Boundary_Name
    variable Boundary_Type
    variable ValList

    variable FluidBody_Questions
    variable Contact_Questions
    variable FreeSurface_Questions

    variable Species_Valnames
    variable Species_UValnames
    variable Species_UValues
    variable Species_Names
    variable Species_Values
    variable snlist

    variable URVariables_Valnames
    variable URVariables_UValnames
    variable URVariables_UValues
    variable URVariables_Names
    variable URVariables_Values
    variable ursnlist

    variable Springs_Values
    variable Springs_Valnames

    switch $Boundary_Type {
	"Fluid_Body" {
	    set check_ransol $show_ransol
	    set check_heatrans $show_heatrans
	    set check_advect $show_advect
	    set check_ursolver $show_ursolver
	    set check_alemesh $show_alemesh
	    set run_Questions $FluidBody_Questions
	}
	"Interf" {
	    set check_ransol 0
	    set check_heatrans $show_heatrans
	    set check_advect $show_advect
	    set check_ursolver $show_ursolver
	    set check_alemesh 0
	    set run_Questions $Contact_Questions
	}
	"FreeS" {
	    set check_ransol 0
	    set check_heatrans 0
	    set check_advect 0
	    set check_ursolver 0
	    set check_alemesh 0
	    set run_Questions $FreeSurface_Questions
	}
    }

    foreach item $run_Questions {
	set itt [lindex $item 0]
	variable $itt
	if { [lindex $item 1] == "unit" } {
	    set $itt [TUI_formatunits Unicode2Nums [eval set nothing $$itt] 1]
	}
	if { $itt == "BoundType" || $itt == "Time_Integration" || $itt == "Advect_Stabilisation" } { 
	    set $itt [DWSpace2Under [eval set temp $$itt]]
	}
	#if { [lindex $item 1] == "func" } {
	#    regsub -all { } [eval set nothing $$itt] {} $itt
	#}
    }

    if { $Boundary_Type == "Fluid_Body" } {
	set adv_propvar "Species_Properties"
	set adv_unitvar "Spc_Units"
	set urv_propvar "Variables_Properties"
	set urv_unitvar "URV_Units"
    } elseif { $Boundary_Type == "Interf" } {
	set adv_propvar "Species_Properties"
	set adv_unitvar "Resistance_Spc_Units"
	set urv_propvar "Variables_Properties"
	set urv_unitvar "Resistance_Phi_Units"
    }

    if { $check_advect == 1 } {

	bondfluid::valsavespecie $snlist "actual" "advect"

	set ltemp ""
	foreach litem $Species_UValues {
	    set temp ""
	    foreach item $litem {
		lappend temp [TUI_formatunits Unicode2Nums $item 1]
	    }
	    lappend ltemp [string trim $temp]
	}
	set Species_UValues $ltemp

	set $adv_propvar [TUI_formatspeciesvalues List2String $Species_Valnames $Species_Values]
	set $adv_unitvar [TUI_formatspeciesvalues List2String $Species_UValnames $Species_UValues]
    }

    if { $check_ursolver == 1 } {

	bondfluid::valsavespecie $ursnlist "actual" "ursolver"

	set ltemp ""
	foreach litem $URVariables_UValues {
	    set temp ""
	    foreach item $litem {
		lappend temp [TUI_formatunits Unicode2Nums $item 1]
	    }
	    lappend ltemp [string trim $temp]
	}
	set URVariables_UValues $ltemp

	set $urv_propvar [TUI_formatspeciesvalues List2String $URVariables_Valnames $URVariables_Values]
	set $urv_unitvar [TUI_formatspeciesvalues List2String $URVariables_UValnames $URVariables_UValues]
    }

    if { $check_alemesh == 1 } {

	set Springs [TUI_formatspeciesvalues List2String $Springs_Valnames $Springs_Values]

    }

    set pv [TUI_getmatvalueslist $Boundary_Name]

    set valueschange 0
    set wtsave 0
    set vi 1
    set usr_err ""
    set num_usr_err 0
    set uerrpg_ran 0
    set uerrpg_htr 0
    set uerrpg_adv 0
    set uerrpg_urs 0
    set uerrpg_alm 0

    foreach item $run_Questions {
	set itt [lindex $item 0]
	set $itt [string trim [eval set nothing $$itt]]
	eval set cv $$itt
	set pos [lsearch -regexp $ValList [eval set nothing ^${itt}(\$|\#CB|\:)]]
	if { $pos != -1 } {
	    #set tv [join [lindex $ValList [expr $pos + 1]]]
	    set tv [lindex $ValList [expr $pos + 1]]
	    if { ![TUI_comparelists $cv $tv] } {
		set valueschange 1
		if { $itt == "Species_Properties" && $check_advect == 1 } {
		    set spc_pos 0
		    foreach item $Species_Values {
		        set tspn [lindex $Species_Names $spc_pos]
		        incr spc_pos
		        set valnamepos 0
		        foreach itt $item {
		            set valname [lindex $Species_Valnames $valnamepos]
		            incr valnamepos
		            if { [lindex $valname 3] == 1 } {
		                set errcheck [TUI_valuecheck $itt [lindex $valname 2] 0 [lindex $valname 4]]
		            } else {
		                set errcheck "ok"
		            }
		            if { $errcheck != "ok"} {
		                incr num_usr_err
		                if { $uerrpg_adv != 1 } {
		                    append usr_err "\n[= {ADVECT page}]\n"
		                    set uerrpg_adv 1
		                }
		                append usr_err "$num_usr_err. " "$tspn; " [lindex $valname 0] ": $errcheck\n"
		            }
		        }
		    }
		} elseif { $itt == "Variables_Properties" && $check_ursolver == 1 } {
		    set spc_pos 0
		    foreach item $URVariables_Values {
		        set tspn [lindex $URVariables_Names $spc_pos]
		        incr spc_pos
		        set valnamepos 0
		        foreach itt $item {
		            set valname [lindex $URVariables_Valnames $valnamepos]
		            incr valnamepos
		            if { [lindex $valname 3] == 1 } {
		                set errcheck [TUI_valuecheck $itt [lindex $valname 2] 0  [lindex $valname 4]]
		            } else {
		                set errcheck "ok"
		            }
		            if { $errcheck != "ok"} {
		                incr num_usr_err
		                if { $uerrpg_urs != 1 } {
		                    append usr_err "\n[= {URSOLVER page}]\n"
		                    set uerrpg_urs 1
		                }
		                append usr_err "$num_usr_err. " "$tspn; " [lindex $valname 0] ": $errcheck\n"
		            }
		        }
		    }
		} elseif { $itt == "Springs" && $check_alemesh == 1 } {
		    if { [TUI_getmatfieldvalue $Boundary_Name "Springs"] != $Springs } {
		        set spc_pos 0
		        foreach item $Springs_Values {
		            set tspn "Row $spc_pos"
		            incr spc_pos
		            set valnamepos 0
		            foreach itt $item {
		                set valname [lindex $Springs_Valnames $valnamepos]
		                incr valnamepos
		                if { [lindex $valname 3] == 1 } {
		                    set errcheck [TUI_valuecheck $itt [lindex $valname 2] 0  [lindex $valname 4]]
		                } else {
		                    set errcheck "ok"
		                }
		                if { $errcheck != "ok"} {
		                    incr num_usr_err
		                    if { $uerrpg_urs != 1 } {
		                        append usr_err "\n[= {ALEMESH page}]\n"
		                        set uerrpg_alm 1
		                    }
		                    append usr_err "$num_usr_err. " "$tspn; " [lindex $valname 0] ": $errcheck\n"
		                }
		            }
		        }
		    }
		} else {
		    if { [lindex $item 2] == 1 } {
		        set errcheck [TUI_valuecheck [eval set nothing $$itt] [lindex $item 1] 0 [lindex $item 4]]
		    } else {
		        set errcheck "ok"
		    }
		    if { $errcheck != "ok" && [lindex $item 2] == 1} {
		        incr num_usr_err
		        switch "[lindex $item 3]" {
		            "ransol" {
		                if { $uerrpg_ran != 1 } {
		                    append usr_err "\n[= {RANSOL page}]\n"
		                    set uerrpg_ran 1
		                }
		            }
		            "heatrans" {
		                if { $uerrpg_htr != 1 } {
		                    append usr_err "\n[= {HEATRANS page}]\n"
		                    set uerrpg_htr 1
		                }
		            }
		        }
		        append usr_err "$num_usr_err. " [DWUnder2Space $itt] ": $errcheck\n"
		    }
		}
	    }
	}
	incr vi
    }

    # Values are formated back to unicode so that they are not seen 
    # in MAT File format in fields while asking if changes shouldbe saved.
    foreach item $run_Questions {
	set itt [lindex $item 0]
	if { [lindex $item 1] == "unit" } {
	    set $itt [TUI_formatunits Nums2Unicode [eval set nothing $$itt] 1]
	}
	if { $itt == "BoundType" || $itt == "Time_Integration" || $itt == "Advect_Stabilisation" } { 
	    set $itt [DWUnder2Space [eval set temp $$itt]]
	}
    }
    if { [info exists Species_UValues] } {
	set ltemp ""
	foreach litem $Species_UValues {
	    set temp ""
	    foreach item $litem {
		lappend temp [TUI_formatunits Nums2Unicode $item 1]
	    }
	    lappend ltemp [string trim $temp]
	}
	set Species_UValues $ltemp
    }
    if { [info exists URVariables_UValues] } {
	set ltemp ""
	foreach litem $URVariables_UValues {
	    set temp ""
	    foreach item $litem {
		lappend temp [TUI_formatunits Nums2Unicode $item 1]
	    }
	    lappend ltemp [string trim $temp]
	}
	set URVariables_UValues $ltemp
    }
    # And now everything ends ...
    if { $valueschange == 1 } {
	if { $askdump == 0 } {
	    set answer 0
	} else {
	    set answer [tk_dialogRAM $win "[= {Boundary}]: '$Boundary_Name'" \
		    "[= {Boundary data has changed}].\n[= {Do you want to save changes?}]" question 0 Yes No]
	}

	if { $answer == 0 && $dumpit == 1} {
	    set wtsave 1
	    if { $num_usr_err > 0 } {
		if { $num_usr_err > 1 } {
		    set err_display "[= {The following %s errors were found in the data input} $num_usr_err]:\n"
		} else {
		    set err_display "[= {The following error was found in the data input}]:\n"
		}
		append err_display $usr_err
		WarnWin $err_display
		set close 0
	    } else {
		bondfluid::dump
	    }
	}
    }

    if { $close == 1 } {
	destroy $win
	return $valueschange
    } else {
	if { $num_usr_err == 0 } {
	    return $valueschange
	} else {
	    if { $wtsave == 1 } {
		return "dataerror"
	    } else {
		return "nosave.dataerror"
	    }
	}
    }

}

# Updates material data to file
proc bondfluid::dump { } {

    variable show_advect
    variable show_ursolver

    variable Boundary_Name
    variable Boundary_Type
    variable ValList

    variable FluidBody_Questions
    variable Contact_Questions
    variable FreeSurface_Questions

    variable Species_Names
    variable URVariables_Names

    variable Species_Rebuild
    variable URVariables_Rebuild

    switch $Boundary_Type {
	"Fluid_Body" {
	    set run_Questions $FluidBody_Questions
	}
	"Interf" {
	    set run_Questions $Contact_Questions
	}
	"FreeS" {
	    set run_Questions $FreeSurface_Questions
	}
    }

    foreach item $run_Questions {
	set itt [lindex $item 0]
	variable $itt
	if { [lindex $item 1] == "unit" } {
	    set $itt [TUI_formatunits Unicode2Nums [eval set nothing $$itt] 1]
	}
	if { $itt == "BoundType" || $itt == "Time_Integration" || $itt == "Advect_Stabilisation" } { 
	    set $itt [DWSpace2Under [eval set temp $$itt]]
	}
    }

    # Replacing values in ValList
    foreach item $run_Questions {
	set itt [lindex $item 0]
	set pos [lsearch -regexp $ValList [eval set nothing ^${itt}(\$|\#CB|\:)]]
	if { $pos != -1 } {
	    set pos [expr $pos + 1]
	    set ValList [lreplace $ValList $pos $pos [eval set nothing $$itt]]
	}
    }

    # Saving values in GID Data
    #TUI_setnewmatvalues $Boundary_Name [string trim [bondfluid::getcurrentvalset]]
    bondfluid::setnewmatvalues $Boundary_Name

    if { $Boundary_Type == "FreeS" } {
	foreach item $FreeSurface_Questions {
	    set itt [lindex $item 0]
	    if { [lindex $item 4] != "advanced" } {
		set tv_var tv_$itt
		eval set $tv_var $$itt
	    }
	}
    }

    foreach item $run_Questions {
	set itt [lindex $item 0]
	if { [lindex $item 1] == "unit" } {
	    set $itt [TUI_formatunits Nums2Unicode [eval set nothing $$itt] 1]
	}
	if { $itt == "BoundType" || $itt == "Time_Integration" || $itt == "Advect_Stabilisation" } { 
	    set $itt [DWUnder2Space [eval set temp $$itt]]
	}
    }

    # Actualizamos la variable de control de cambios en GiD
    GIDModifiedFileFlag Set
    return 1
}

proc bondfluid::setnewmatvalues { material } {
    variable ValList

    set vals [lrange $ValList 1 end]
    set justvals ""
    foreach {q v} $vals {
	lappend justvals $v
    }
    GiD_ModifyData materials $material $justvals
}

proc bondfluid::getcurrentvalset { } {

    variable ValList

    set vals [lrange $ValList 1 end]
    set JVL ""
    foreach {q v} $vals {
	append JVL $v " "
    }

    return $JVL
}