namespace eval initdatwin {

    global ProgramName

    # Tdyn settings
    variable show_ursolver [IsVarOnTdynDefaults show_ursolver 1]
    variable show_ransol [IsVarOnTdynDefaults show_ransol 1]
    variable show_heatrans [IsVarOnTdynDefaults show_heatrans 1]
    variable show_advect [IsVarOnTdynDefaults show_advect 1]
    variable show_vof [IsVarOnTdynDefaults show_vof 1]

    # RANSOL
    switch $ProgramName {
	"Tdyn2D" {
	    variable Ransol_Initdata [list \
		    [list Initial_Pressure "Initial_Pressure" func 1] \
		    [list Pressure_FuncCond "Pressure_FuncCond" func 1] \
		    [list Initial_VelocityX "Initial_VelocityX" func 1] \
		    [list VelocityX_FuncCond "VelocityX_FuncCond" func 1] \
		    [list Initial_VelocityY "Initial_VelocityY" func 1] \
		    [list VelocityY_FuncCond "VelocityY_FuncCond" func 1] \
		    [list Initial_EddyKEner "Initial_EddyKEner" func 1] \
		    [list Initial_EddyLength "Initial_EddyLength" func 1] \
		    ]
	}
	"Tdyn3D" {
	    variable Ransol_Initdata [list \
		    [list Initial_Pressure "Initial_Pressure" func 1] \
		    [list Pressure_FuncCond "Pressure_FuncCond" func 1] \
		    [list Initial_VelocityX "Initial_VelocityX" func 1] \
		    [list VelocityX_FuncCond "VelocityX_FuncCond" func 1] \
		    [list Initial_VelocityY "Initial_VelocityY" func 1] \
		    [list VelocityY_FuncCond "VelocityY_FuncCond" func 1] \
		    [list Initial_VelocityZ "Initial_VelocityZ" func 1] \
		    [list VelocityZ_FuncCond "VelocityZ_FuncCond" func 1] \
		    [list Initial_EddyKEner "Initial_EddyKEner" func 1] \
		    [list Initial_EddyLength "Initial_EddyLength" func 1] \
		    ]
	}
    }
    foreach item $Ransol_Initdata {
	variable [lindex $item 0]
    }
    variable Ransol_UnitsRead [list \
	    [list Boundary_Velocity_Units "Boundary_Velocity_Units#CB#"] \
	    [list Boundary_Pressure_Units "Boundary_Pressure_Units#CB#"] \
	    [list Boundary_Kenr_Units "Boundary_Kenr_Units#CB#"] \
	    [list Boundary_ELen_Units "Boundary_ELen_Units#CB#"] \
    ]
    foreach item $Ransol_UnitsRead {
	variable [lindex $item 0]
    }
    
    # HEATRANS
    variable Heatrans_Initdata [list \
	    [list Initial_Temperature "Initial_Temperature" func 1] \
	    [list Temperature_FuncCond "Temperature_FuncCond" func 1] \
	    ]
    foreach item $Heatrans_Initdata {
	variable [lindex $item 0]
    }
    variable Heatrans_UnitsRead [list \
	    [list Boundary_Temperature_Units "Boundary_Temperature_Units#CB#"] \
    ]
    foreach item $Heatrans_UnitsRead {
	variable [lindex $item 0]
    }

    # ADVECT
    variable Advect_Initdata
    variable Species_Names
    variable Species_Values
    variable Species_Valnames \
	    [list \
	    [list "Initial Concentration" ADVECT_Initial_Concentration func 1] \
	    [list "Species FuncCond" ADVECT_Species_FuncCond func 1] \
	    ]
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set advect_var [lindex [lindex $Species_Valnames $i] 1]
	variable $advect_var
    }
    # Advect Species support variables
    variable spcdelerrwarn 0
    variable spcdellasterrwarn 0
    variable spcnlastsel -1
    variable snlist
    variable sname
    variable spcinitialtit
    variable spccondittit

    # URSOLVER
    variable URSolver_Initdata
    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_Valnames \
	    [list \
	    [list "Initial Variable" URSOLVER_Initial_Variable func 1] \
	    [list "Variable FuncCond" URSOLVER_Variable_FuncCond func 1] \
	    ]
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set ursolver_var [lindex [lindex $URVariables_Valnames $i] 1]
	variable $ursolver_var
    }
    # URSolver support variables
    variable ursdelerrwarn 0
    variable ursdellasterrwarn 0
    variable ursnlastsel -1
    variable ursnlist
    variable ursname
    variable ursinitialtit
    variable urscondittit

    # VOFLUID
    variable VOFluid_Initdata [list \
	    [list Initial_VOFluid "Initial VOFluid" func 1] \
	    [list VOFluid_FuncCond "VOFluid FuncCond" func 1] \
	    ]
    foreach item $VOFluid_Initdata {
	variable [lindex $item 0]
    }

    # Function Editor variables
    switch $ProgramName {
	"Tdyn2D" {
	    variable ransolinit_ff \
		    [ list \
		    {initdatwin::Initial_Pressure} {Initial Pressure} \
		    {initdatwin::Pressure_FuncCond} {Pressure FuncCond} \
		    {initdatwin::Initial_VelocityX} {Initial VelocityX} \
		    {initdatwin::VelocityX_FuncCond} {VelocityX FuncCond} \
		    {initdatwin::Initial_VelocityY} {Initial VelocityY} \
		    {initdatwin::VelocityY_FuncCond} {VelocityY FuncCond} \
		    {initdatwin::Initial_EddyKEner} {Initial EddyKEner} \
		    {initdatwin::Initial_EddyLength} {Initial EddyLength} \
		    ]
	}
	"Tdyn3D" {
	    variable ransolinit_ff \
		    [ list \
		    {initdatwin::Initial_Pressure} {Initial Pressure} \
		    {initdatwin::Pressure_FuncCond} {Pressure FuncCond} \
		    {initdatwin::Initial_VelocityX} {Initial VelocityX} \
		    {initdatwin::VelocityX_FuncCond} {VelocityX FuncCond} \
		    {initdatwin::Initial_VelocityY} {Initial VelocityY} \
		    {initdatwin::VelocityY_FuncCond} {VelocityY FuncCond} \
		    {initdatwin::Initial_VelocityZ} {Initial VelocityZ} \
		    {initdatwin::VelocityZ_FuncCond} {VelocityZ FuncCond} \
		    {initdatwin::Initial_EddyKEner} {Initial EddyKEner} \
		    {initdatwin::Initial_EddyLength} {Initial EddyLength} \
		    ]
	}
    }
    variable heatransinit_ff \
	    [ list \
	    {initdatwin::Initial_Temperature} {Initial Temperature} \
	    {initdatwin::Temperature_FuncCond} {Temperature FuncCond} \
	    ]
    variable advectinit_ff \
	    [ list \
	    {initdatwin::ADVECT_Initial_Concentration} {Initial Concentration} \
	    {initdatwin::ADVECT_Species_FuncCond} {Species FuncCond} \
	    ]
    variable ursolverinit_ff \
	    [ list \
	    {initdatwin::URSOLVER_Initial_Variable} {Initial Variable} \
	    {initdatwin::URSOLVER_Variable_FuncCond} {Variable FuncCond} \
	    ]
    variable vofluidinit_ff \
	    [ list \
	    {initdatwin::Initial_VOFluid} {Initial VOFluid} \
	    {initdatwin::VOFluid_FuncCond} {VOFluid FuncCond} \
	    ]
    variable initcond_variables "x y z nx ny nz t it rand dt e pi vx vy vz pr tm\
	    vt v_ tau wc ds ke ep om kt pk dn bt sp#"
    variable example_initcond_variables "x y z nx ny nz t it rand dt exp(1)\
	    pi vx vy vz pr tm vt v_ tau wc ds ke ep om kt pk dn bt sp#"
    variable initcond_operators "+ - * / ^ mod div rmod rdiv max min Dx() Dy() Dz()\
	    ~ < <= > >= = != & |"
    variable predefined_ff [list $initcond_variables $example_initcond_variables $initcond_operators]
}



proc initdatwin::init { parent {show "all"} {tags ""} } {

    global ProgramName

    # Tdyn settings
    variable show_ursolver
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_vof

    variable Species_Names
    variable snlist
    variable URVariables_Names
    variable ursnlist

    set tiw $parent.tiw

    if { [TUI_closeotherwindows $tiw 1] != 1 } {
	# Cannot close other data window
	return
    }

    InitWindow $tiw [= {Tdyn Initial and Conditional Data}] PreTdynInitialDataWindowGeom ""

    set closecmd "initdatwin::checkclose $tiw 1 1 1"
    set acceptcmd "initdatwin::checkclose $tiw 1 0 0"
    wm protocol $tiw WM_DELETE_WINDOW "$closecmd"

    # Reading values from Problem Data
    initdatwin::getvalues

    # Top frame
    set topf [frame $tiw.f -bg lightblue]
    # Image
    set l_icon [label $topf.l_icon -image [imagefromtdyn initial.gif] -bg lightblue]
    grid $topf -row 0 -column 0 -sticky nwe
    grid $l_icon -row 0 -column 0 -sticky nw
    grid columnconf $topf 1 -weight 1

    # Main Notebook
    set pages [NoteBook $tiw.pages -homogeneous 1 -arcradius 0]
    grid $pages -row 1 -column 0 -sticky nwes -pady 5

    grid columnconf $tiw 0 -weight 1
    grid rowconf $tiw 1 -weight 1

    set pnum 0
    set firstpage ""

    # Ransol Page
    if { $show_ransol == 1 } {
	incr pnum
	set pvar "pg_ransol"
	if { [string length $firstpage] < 1 } { 
	    set firstpage $pvar
	}
	set fpvar "fpg_ransol"
	set $pvar [$pages insert $pnum $pvar -text [= {RANSOL}]]
	set $fpvar [$pages getframe $pvar]
#        grid columnconf $fpg_ransol 0 -weight 1
#        grid rowconf $fpg_ransol 0 -weight 1
	initdatwin::ransol $pg_ransol $tags
    }

    # Heatrans Page
    if { $show_heatrans == 1 } {
	incr pnum
	set pvar "pg_heatrans"
	if { [string length $firstpage] < 1 } { 
	    set firstpage $pvar
	}
	set fpvar "fpg_heatrans"
	set $pvar [$pages insert $pnum $pvar -text [= {HEATRANS}]]
	set $fpvar [$pages getframe $pvar]
#        grid columnconf $fpg_heatrans 0 -weight 1
#        grid rowconf $fpg_heatrans 0 -weight 1
	initdatwin::heatrans $pg_heatrans $tags
    }

    # Advect Page
    if { $show_advect == 1 } {
	  incr pnum
	  set pvar "pg_advect"
	  if { [string length $firstpage] < 1 } { 
	      set firstpage $pvar
	  }
	  set fpvar "fpg_advect"
	  set $pvar [$pages insert $pnum $pvar -text [= {ADVECT}]]
	  set $fpvar [$pages getframe $pvar]
#          grid columnconf $fpg_advect 0 -weight 1
#          grid rowconf $fpg_advect 0 -weight 1
	  initdatwin::advect $pg_advect $tags
    }

    # URSolver Page
    if { $show_ursolver == 1 } {
	  incr pnum
	  set pvar "pg_ursolver"
	  if { [string length $firstpage] < 1 } { 
	      set firstpage $pvar
	  }
	  set fpvar "fpg_ursolver"
	  set $pvar [$pages insert $pnum $pvar -text [= {URSOLVER}]]
	  set $fpvar [$pages getframe $pvar]
#          grid columnconf $fpg_ursolver 0 -weight 1
#          grid rowconf $fpg_ursolver 0 -weight 1
	  initdatwin::ursolver $pg_ursolver $tags
    }

    # VOFluid Page
    if { $show_vof == 1 } {
	incr pnum
	set pvar "pg_vofluid"
	if { [string length $firstpage] < 1 } { 
	    set firstpage $pvar
	}
	set fpvar "fpg_vofluid"
	set $pvar [$pages insert $pnum $pvar -text [= {VOFLUID}]]
	set $fpvar [$pages getframe $pvar]
#        grid columnconf $fpg_vofluid 0 -weight 1
#        grid rowconf $fpg_vofluid 0 -weight 1
	initdatwin::vofluid $pg_vofluid $tags
    }

    if { $show == "all" } {
	$pages raise $firstpage
    } elseif { $show_ransol == 1 && $show == "ransol" } {
	$pages raise pg_ransol
    } elseif { $show_heatrans == 1 && $show == "heatrans" } {
	$pages raise pg_heatrans
    } elseif { $show_advect == 1 && $show == "advect" } {
	$pages raise pg_advect
    } elseif { $show_ursolver == 1 && $show == "ursolver" } {
	$pages raise pg_ursolver
    } elseif { $show_vofluid == 1 && $show == "vofluid" } {
	$pages raise pg_vofluid
    } else {
	$pages raise $firstpage
    }

    # Buttons frame
    set bf [frame $tiw.bf -relief raised -takefocus 1]
    # Accept button
    set btn_accept [button $bf.btn_accept -text [= {Accept Data}] -underline 0 -width 10 \
	     -relief raised -bd 1 -highlightthickness 1 -takefocus 1 \
	    -command "$acceptcmd"]
    # Cancel button
    set btn_close [button $bf.btn_close -text [= {Close}] -underline 0 -width 10 \
	    -relief raised -bd 1 -highlightthickness 1 -takefocus 1 \
	    -command "$closecmd"]

    # GRIDS
    grid $bf -row 2 -column 0 -sticky news
    grid $btn_accept -row 0 -column 0 -sticky ew -padx 5 -pady 5
    grid $btn_close -row 0 -column 1 -sticky ew -padx 5 -pady 5

    # BINDS
    bind $tiw <Escape> "tkButtonInvoke $btn_close"
    $pages bindtabs <Button-1> "initdatwin::selectpage"
    bind $tiw <Alt-KeyPress-a> "tkButtonInvoke $btn_accept"
    bind $tiw <Alt-KeyPress-c> "tkButtonInvoke $btn_close"

    # Selecting Specie / Variable
    if { $show == "advect" || $show == "ursolver" || $firstpage == "pg_advect" || $firstpage == "pg_ursolver" } {
	  if { $show == "advect" || $firstpage == "pg_advect" } {
	      set type_Names $Species_Names
	      set type_nlist $snlist
	      set type "advect"
	  } elseif { $show == "ursolver" || $firstpage == "pg_ursolver" } {
	      set type_Names $URVariables_Names
	      set type_nlist $ursnlist
	      set type "ursolver"
	  }

	  if { $tags > -1 && $tags <= [llength $type_Names] } {
	      set setsel $tags
	  } else {
	      set setsel 0
	  }
	  initdatwin::updatespcselection $type_nlist $setsel $type
	  initdatwin::displayspecievalues $type_nlist $type
    }

    $pages compute_size

    focus $tiw

    return 1
}



proc initdatwin::selectpage { page } {
    
    variable spcnlastsel
    variable ursnlastsel
    variable snlist
    variable ursnlist

    switch $page {
	"pg_advect" {
	    initdatwin::valsavespecie $snlist "" "advect"
	    initdatwin::updatespcselection $snlist $spcnlastsel "advect"
	    initdatwin::displayspecievalues $snlist "advect"
	}
	"pg_ursolver" {
	    initdatwin::valsavespecie $ursnlist "" "ursolver"
	    initdatwin::updatespcselection $ursnlist $ursnlastsel "ursolver"
	    initdatwin::displayspecievalues $ursnlist "ursolver"
	}
    }

    return 1
}



################################################################################
#
#   Ransol
#
################################################################################

proc initdatwin::ransol { page tags } {

    global ProgramName

    # Ransol variables
    variable Ransol_Initdata
    foreach item $Ransol_Initdata {
	variable [lindex $item 0]
    }
    variable Ransol_UnitsRead
    foreach item $Ransol_UnitsRead {
	variable [lindex $item 0]
    }
    variable predefined_ff
    variable ransolinit_ff

    #####  HELP Text variables #####
    set help_Initial_Pressure \
	    "[= {Field of Pressure (for initial and transient boundary conditions)}].\n[= {Units given in Problem_Data (book UNITS)}].\n[= {May be a constant or a function.}]"
    set help_Pressure_FuncCond \
	    "[= {Function used to update boundary conditions where conditional condition is applied}].\n[= {If the value given by the function is > 0, boundary condition is applied}].\n[= {If < 0 no boundary condition is applied. If = 0, nothing is done.}]"
    set help_Initial_VelocityX \
	    "[= {Field of OX velocity component (for initial and transient boundary conditions)}].\n[= {Units given in Problem_Data (book UNITS)}].\n[= {May be a constant or a function.}]"
    set help_VelocityX_FuncCond \
	    "[= {Function used to update boundary conditions where conditional condition is applied}].\n[= {If the value given by the function is > 0 , boundary condition is applied}].\n[= {If < 0 no boundary condition is applied. If = 0, nothing is done.}]"
    set help_Initial_VelocityY \
	    "[= {Field of OY velocity component (for initial and transient boundary conditions)}].\n[= {Units given in Problem_Data (book UNITS)}].\n[= {May be a constant or a function.}]"
    set help_VelocityY_FuncCond \
	    "[= {Function used to update boundary conditions where conditional condition is applied}].\n[= {If the value given by the function is > 0 , boundary condition is applied}].\n[= {If < 0 no boundary condition is applied. If = 0, nothing is done.}]"
    set help_Initial_VelocityZ \
	    "[= {Field of OZ velocity component (for initial and transient boundary conditions)}].\n[= {Units given in Problem_Data (book UNITS)}].\n[= {May be a constant or a function.}]"
    set help_VelocityZ_FuncCond \
	    "[= {Function used to update boundary conditions where conditional condition is applied. If the value given by the function is > 0 , boundary condition is applied. If < 0 no boundary condition is applied. If = 0, nothing is done.}]"
    set help_Initial_EddyKEner \
	    "[= {Field of kinetic energy (for initial and transient boundary conditions)}].\n[= {Units given in Problem_Data (book UNITS)}].\n[= {May be a constant or a function.}]"
    set help_Initial_EddyLength \
	    "[= {Field of eddy length (for initial and transient boundary conditions)}].\n[= {Units given in Problem_Data (book UNITS)}].\n[= {May be a constant or a function.}]"
    set help_btn_func "[= {Custom Function Editor}].\n[= {Edit a function and transfer it automatically to a field}].\n[= {You can also RIGHT-CLICK a field to open the Function Editor}]."

    set help_Initial \
	    "[= {Insert function defining initial field (initial conditions) of the variables}].\n[= {These functions can also be used to define variable (even transient) boundary conditions}].\n[= {See Fix_Field type boundary conditions}]."
    set help_Conditional \
	    "[= {Insert function defining how to apply 'Conditional Boundary Conditions'}].\n[= {These conditions are only applied when the given functions takes values > 0}]."

    # Title Frame Initial Data
    set tfr_iniransol [TitleFrame $page.i -relief ridge -bd 3\
	    -text [= {Initial & Field Data}] -side left ]
    set iframe [$tfr_iniransol getframe]
    GidHelp $tfr_iniransol $help_Initial

    # Initial Pressure
    set l_Initial_Pressure [Label $iframe.l_initpress -text "[= {Pressure Field}] " \
	    -helptext $help_Initial_Pressure]
    set e_Initial_Pressure [entry $iframe.e_initpres -textvariable initdatwin::Initial_Pressure]
    set l_Boundary_Pressure_Units [Label $iframe.l_bondpressunt -text "$Boundary_Pressure_Units"]

    # Initial Velocity X
    set l_Initial_VelocityX [Label $iframe.l_initvelx -text "[= {Velocity X Field}] " \
	    -helptext $help_Initial_VelocityX]
    set e_Initial_VelocityX [entry $iframe.e_initvelx -textvariable initdatwin::Initial_VelocityX]
    set l_Boundary_Velocity_UnitsX [Label $iframe.l_bondveluntx -text "$Boundary_Velocity_Units"]

    # Initial Velocity Y
    set l_Initial_VelocityY [Label $iframe.l_initvely -text "[= {Velocity Y Field}] " \
	    -helptext $help_Initial_VelocityY]
    set e_Initial_VelocityY [entry $iframe.e_initvely -textvariable initdatwin::Initial_VelocityY]
    set l_Boundary_Velocity_UnitsY [Label $iframe.l_bondvelunty -text "$Boundary_Velocity_Units"]

    # Title Frame Initial Data
    set tfr_cndransol [TitleFrame $page.c -relief ridge -bd 3\
	    -text [= {Conditional Data}] -side left ]
    set cframe [$tfr_cndransol getframe]
    GidHelp $tfr_cndransol $help_Conditional

    # Pressure FuncCond
    set l_Pressure_FuncCond [Label $cframe.l_pressfunccond -text "[= {Pressure FuncCond}] " \
	    -helptext $help_Pressure_FuncCond]
    set e_Pressure_FuncCond [entry $cframe.e_pressfunccond -textvariable initdatwin::Pressure_FuncCond]

    # Velocity X FuncCond
    set l_VelocityX_FuncCond [Label $cframe.l_velxfunccond -text "[= {Velocity X FuncCond}] " \
	    -helptext $help_VelocityX_FuncCond]
    set e_VelocityX_FuncCond [entry $cframe.e_velxfunccond -textvariable initdatwin::VelocityX_FuncCond]

    # Velocity Y FuncCond
    set l_VelocityY_FuncCond [Label $cframe.l_velyfunccond -text "[= {Velocity Y FuncCond}] " \
	    -helptext $help_VelocityY_FuncCond]
    set e_VelocityY_FuncCond [entry $cframe.e_velyfunccond -textvariable initdatwin::VelocityY_FuncCond]

    if { $ProgramName == "Tdyn3D" } {
	# Initial Velocity Z
	set l_Initial_VelocityZ [Label $iframe.l_initvelz -text "[= {Velocity Z Field}] " \
		-helptext $help_Initial_VelocityZ]
	set e_Initial_VelocityZ [entry $iframe.e_initvelz -textvariable initdatwin::Initial_VelocityZ]
	set l_Boundary_Velocity_UnitsZ [Label $iframe.l_bondveluntz -text "$Boundary_Velocity_Units"]

	# Velocity Z FuncCond
	set l_VelocityZ_FuncCond [Label $cframe.l_velzfunccond -text "[= {Velocity Z FuncCond}] " \
		-helptext $help_VelocityZ_FuncCond]
	set e_VelocityZ_FuncCond [entry $cframe.e_velzfunccond -textvariable initdatwin::VelocityZ_FuncCond]
    }

    # Initial EddyKEner
    set l_Initial_EddyKEner [Label $iframe.l_initeddyken -text "[= {EddyKEner Field}] " \
	    -helptext $help_Initial_EddyKEner]
    set e_Initial_EddyKEner [entry $iframe.e_initeddyken -textvariable initdatwin::Initial_EddyKEner]
    set l_Boundary_Kenr_Units [Label $iframe.l_bondkenrunt -text "$Boundary_Kenr_Units"]

    # Initial EddyLength
    set l_Initial_EddyLength [Label $iframe.l_initeddylen -text "[= {EddyLength Field}] " \
	    -helptext $help_Initial_EddyLength]
    set e_Initial_EddyLength [entry $iframe.e_initeddylen -textvariable initdatwin::Initial_EddyLength]
    set l_Boundary_ELen_Units [Label $iframe.l_bondelenunt -text "$Boundary_ELen_Units"]

    # Buttons frame
    set btn_frame [frame $page.btn_frame]

    # Function Editor Button
    set btn_functions [Button $btn_frame.btn_func -underline 0 \
	    -command "FEditor::init $page \"$predefined_ff\" \"\" \"SELECT FIELD\" \"\" \"$ransolinit_ff\" \"\"" \
	    -image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]

    # GRIDS
    grid $tfr_iniransol -row 0 -column 0 -sticky wne -pady 3
    grid $tfr_cndransol -row 1 -column 0 -sticky wne -pady 3
    grid $l_Initial_Pressure -row 0 -column 0 -sticky wn -pady 2
    grid $e_Initial_Pressure -row 0 -column 1 -sticky wn -pady 2
    grid $l_Boundary_Pressure_Units -row 0 -column 2 -sticky wn -pady 2 -padx 3
    grid $l_Initial_VelocityX -row 1 -column 0 -sticky wn -pady 2
    grid $e_Initial_VelocityX -row 1 -column 1 -sticky wn -pady 2
    grid $l_Boundary_Velocity_UnitsX -row 1 -column 2 -sticky wn -pady 2 -padx 3
    grid $l_Initial_VelocityY -row 2 -column 0 -sticky wn -pady 2
    grid $e_Initial_VelocityY -row 2 -column 1 -sticky wn -pady 2
    grid $l_Boundary_Velocity_UnitsY -row 2 -column 2 -sticky wn -pady 2 -padx 3
    grid $l_Pressure_FuncCond -row 0 -column 0 -sticky wn -pady 2
    grid $e_Pressure_FuncCond -row 0 -column 1 -sticky wn -pady 2
    grid $l_VelocityX_FuncCond -row 1 -column 0 -sticky wn -pady 2
    grid $e_VelocityX_FuncCond -row 1 -column 1 -sticky wn -pady 2
    grid $l_VelocityY_FuncCond -row 2 -column 0 -sticky wn -pady 2
    grid $e_VelocityY_FuncCond -row 2 -column 1 -sticky wn -pady 2
    set row 3
    if { $ProgramName == "Tdyn3D" } {
	grid $l_Initial_VelocityZ -row $row -column 0 -sticky wn -pady 2
	grid $e_Initial_VelocityZ -row $row -column 1 -sticky wn -pady 2
	grid $l_Boundary_Velocity_UnitsZ -row $row -column 2 -sticky wn -pady 2 -padx 3
	grid $l_VelocityZ_FuncCond -row $row -column 0 -sticky wn -pady 2
	grid $e_VelocityZ_FuncCond -row $row -column 1 -sticky wn -pady 2
	incr row
    }
    grid $l_Initial_EddyKEner -row $row -column 0 -sticky wn -pady 2
    grid $e_Initial_EddyKEner -row $row -column 1 -sticky wn -pady 2
    grid $l_Boundary_Kenr_Units -row $row -column 2 -sticky wn -pady 2 -padx 3
    incr row
    grid $l_Initial_EddyLength -row $row -column 0 -sticky wn -pady 2
    grid $e_Initial_EddyLength -row $row -column 1 -sticky wn -pady 2
    grid $l_Boundary_ELen_Units -row $row -column 2 -sticky wn -pady 2 -padx 3

    # Buttons frame
    grid $btn_frame -row 2 -column 0 -sticky ne
    # Function Editor Button
    grid $btn_functions -row 0 -column 0 -sticky en -pady 2 -padx 1

    grid columnconfigure $page 0 -weight 1
    grid rowconfigure $page 2 -weight 1

    # BINDS
    foreach item $Ransol_Initdata {
	set itt [lindex $item 0]
	set itn [DWUnder2Space [lindex $item 1]]
	set ename "e_$itt"
	bind [eval set temp $$ename] <ButtonPress-3> "+initdatwin::popupmenu $page initdatwin::$itt \"$itn\" \"\" 1 %X %Y"
    }
}

################################################################################
#
#   Heatrans
#
################################################################################

proc initdatwin::heatrans { page tags } {

    # Heatrans variables
    variable Heatrans_Initdata
    foreach item $Heatrans_Initdata {
	variable [lindex $item 0]
    }
    variable Heatrans_UnitsRead
    foreach item $Heatrans_UnitsRead {
	variable [lindex $item 0]
    }

    variable predefined_ff
    variable heatransinit_ff

    #####  HELP Text variables #####
    set help_Initial_Temperature \
	    "[= {Field of temperature (for initial and transient boundary conditions)}].\n[= {Units given in Problem_Data (book UNITS)}].\n[= {May be a constant or a function.}]"
    set help_Temperature_FuncCond \
	    "[= {Function used to update boundary conditions where conditional condition is applied. If the value given by the function is > 0 , boundary condition is applied. If < 0 no boundary condition is applied. If = 0, nothing is done.}]"

    set help_btn_func "[= {Custom Function Editor}].\n[= {Edit a function and transfer it automatically to a field}].\n[= {You can also RIGHT-CLICK a field to open the Function Editor}]."
    set help_Initial \
	    "[= {Insert function defining initial field (initial conditions) of the variables}].\n[= {These functions can also be used to define variable (even transient) boundary conditions}].\n[= {See Fix_Field type boundary conditions}]."
    set help_Conditional \
	    "[= {Insert function defining how to apply 'Conditional Boundary Conditions'}].\n[= {These conditions are only applied when the given functions takes values > 0}]."

    # Title Frame Initial Data
    set tfr_iniheatrans [TitleFrame $page.i -relief ridge -bd 3\
	    -text [= {Initial & Field Data}] -side left ]
    set iframe [$tfr_iniheatrans getframe]
    GidHelp $tfr_iniheatrans $help_Initial

    # Initial Temperature
    set l_Initial_Temperature [Label $iframe.l_inittemp -text "[= {Temperature Field}] " \
	    -helptext $help_Initial_Temperature]
    set e_Initial_Temperature [entry $iframe.e_inittemp -textvariable initdatwin::Initial_Temperature]
    set l_Boundary_Temperature_Units [Label $iframe.l_bondtempunt -text "$Boundary_Temperature_Units"]

    # Title Frame Initial Data
    set tfr_cndheatrans [TitleFrame $page.c -relief ridge -bd 3\
	    -text [= {Conditional Data}] -side left ]
    set cframe [$tfr_cndheatrans getframe]
    GidHelp $tfr_cndheatrans $help_Conditional

    # Temperature FuncCond
    set l_Temperature_FuncCond [Label $cframe.l_tempfunccond -text "[= {Temperature FuncCond}] " \
	    -helptext $help_Temperature_FuncCond]
    set e_Temperature_FuncCond [entry $cframe.e_tempfunccond -textvariable initdatwin::Temperature_FuncCond]

    # Buttons frame
    set btn_frame [frame $page.btn_frame]

    # Function Editor Button
    set btn_functions [Button $btn_frame.btn_func -underline 0 \
	    -command "FEditor::init $page \"$predefined_ff\" \"\" \"SELECT FIELD\" \"\" \"$heatransinit_ff\" \"\"" \
	    -image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]

    # GRIDS
    grid $tfr_iniheatrans -row 0 -column 0 -sticky wne -pady 3
    grid $tfr_cndheatrans -row 1 -column 0 -sticky wne -pady 3
    grid $l_Initial_Temperature -row 0 -column 0 -sticky en -pady 2
    grid $e_Initial_Temperature -row 0 -column 1 -sticky wn -pady 2
    grid $l_Boundary_Temperature_Units -row 0 -column 2 -sticky wn -pady 2 -padx 3
    grid $l_Temperature_FuncCond -row 0 -column 0 -sticky en -pady 2
    grid $e_Temperature_FuncCond -row 0 -column 1 -sticky wn -pady 2

    # Buttons frame
    grid $btn_frame -row 2 -column 0 -sticky en
    # Function Editor Button
    grid $btn_functions -row 0 -column 0 -sticky wn -pady 2 -padx 1

    grid columnconfigure $page 0 -weight 1
    grid rowconfigure $page 2 -weight 1

    # BINDS
    foreach item $Heatrans_Initdata {
	set itt [lindex $item 0]
	set itn [DWUnder2Space [lindex $item 1]]
	set ename "e_$itt"
	bind [eval set temp $$ename] <ButtonPress-3> "+initdatwin::popupmenu $page initdatwin::$itt \"$itn\" \"\" 1 %X %Y"
    }
}

################################################################################
#
#   Advect
#
################################################################################

proc initdatwin::advect { page tags } {

    # Advect variables
    variable Species_Names
    variable Species_Values
    variable Species_Valnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    # Advect Species support variables
    variable spcdelerrwarn 0
    variable spcdellasterrwarn 0
    variable spcnlastsel -1
    variable snlist
    variable sname

    variable predefined_ff
    variable advectinit_ff

    set help_btn_func "[= {Custom Function Editor}].\n[= {Edit a function and transfer it automatically to a field}].\n[= {You can also RIGHT-CLICK a field to open the Function Editor}]."

    set frame [frame $page.f -relief flat]

    # Paned window
    set pw [PanedWindow $frame.pw]
    set pane1 [$pw add -weight 1]
    set pane2 [$pw add -weight 1]

    # Species Names in scrolled window
    set spc_scrw [ScrolledWindow $pane1.spc_scrw -scrollbar both]
    set scrw_frm [$spc_scrw getframe]
    set snlist [listbox $spc_scrw.snlist -selectbackground lightblue -selectforeground black \
		-selectborderwidth 1 -selectmode extended -height 5 -bg white -width 10]
    $spc_scrw setwidget $snlist

    # Selected Specie values frame
    set svlist [frame $pane2.svlist -relief flat]

    # GRIDS
    grid $frame -row 0 -column 0 -sticky wnes
    grid $pw -row 0 -column 0 -sticky wnes
    grid $spc_scrw -row 0 -column 0 -sticky wnes
    grid columnconf $page 0 -weight 1
    grid rowconf $page 0 -weight 1
    grid columnconf $frame 0 -weight 1
    grid rowconf $frame 0 -weight 1
    grid columnconf $pw 0 -weight 1
    grid rowconf $pw 0 -weight 1
    grid columnconf $pane1 0 -weight 1
    grid rowconf $pane1 0 -weight 1
    grid columnconf $pane2 0 -weight 1
    grid rowconf $pane2 0 -weight 1
#    grid columnconf $spc_scrw 0 -weight 1
#    grid rowconf $spc_scrw 0 -weight 1
    grid columnconf $snlist 0 -weight 1
    grid rowconf $snlist 0 -weight 1

    # BINDS 
    bind $snlist <<ListboxSelect>> ";
    initdatwin::valsavespecie $snlist \"last\" \"advect\"; 
    initdatwin::displayspecievalues $snlist \"advect\";
    initdatwin::displayspeciesnames $snlist \"advect\";
    "
    bind $snlist <ButtonPress-3> "+initdatwin::popupmenu $snlist \"\" \"\" \"\" 2 %X %Y"

    # Insert Species Names to listbox
    initdatwin::displayspeciesnames $snlist "advect"
    # Create Species Values widgets
    initdatwin::makespecie $snlist $svlist "advect"
    # Put specie values into entries
    initdatwin::displayspecievalues $snlist "advect"

    # Buttons frame
    set btn_frame [frame $svlist.btn_frame]

    # Function Editor Button
    set btn_functions [Button $btn_frame.btn_func -underline 0 \
	    -command "FEditor::init $page \"$predefined_ff\" \"\" \"SELECT FIELD\" \"\" \"$advectinit_ff\" \"\"" \
	    -image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]

    # Buttons frame
    grid $btn_frame -row [expr [llength $Species_Valnames] + 1] -column 1 -sticky en
    # Function Editor Button
    grid $btn_functions -row 0 -column 0 -sticky wn -pady 2 -padx 1
}

################################################################################
#
#   URSolver
#
################################################################################

proc initdatwin::ursolver { page tags } {

    # URSolver Species variables
    variable URSolver_Initdata
    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_UValues
    # URSolver Species variables
    variable URVariables_Valnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    # URSolver Species support variables
    variable ursdelerrwarn 0
    variable ursdellasterrwarn 0
    variable ursnlastsel -1
    variable ursnlist
    variable ursname

    variable predefined_ff
    variable ursolverinit_ff

    set help_btn_func "[= {Custom Function Editor}].\n[= {Edit a function and transfer it automatically to a field}].\n[= {You can also RIGHT-CLICK a field to open the Function Editor}]."

    set frame [frame $page.f -relief flat]

    # Paned window
    set upw [PanedWindow $frame.pw]
    set upane1 [$upw add -weight 1]
    set upane2 [$upw add -weight 1]

    # Variables Names in scrolled window
    set ursv_scrw [ScrolledWindow $upane1.ursv_scrw -scrollbar both]
    set ursnlist [listbox $ursv_scrw.ursnlist -selectbackground lightblue -selectforeground black \
	    -selectborderwidth 1 -selectmode extended -height 5 -bg white -width 10]
    $ursv_scrw setwidget $ursnlist

    # Selected Specie values frame
    set ursvlist [frame $upane2.ursvlist -relief flat]

    # GRIDS
    grid $frame -row 0 -column 0 -sticky wnes
    grid $upw -row 0 -column 0 -sticky wnes
    grid $ursv_scrw -row 0 -column 0 -sticky wnes
    grid columnconf $page 0 -weight 1
    grid rowconf $page 0 -weight 1
    grid columnconf $frame 0 -weight 1
    grid rowconf $frame 0 -weight 1
    grid columnconf $upw 0 -weight 1
    grid rowconf $upw 0 -weight 1
    grid rowconf $upane1 0 -weight 1
    grid columnconf $upane1 0 -weight 1
    grid rowconf $upane2 0 -weight 1
    grid columnconf $upane2 0 -weight 1
#    grid columnconf $ursv_scrw 0 -weight 1
#    grid rowconf $ursv_scrw 0 -weight 1
    grid columnconf $ursnlist 0 -weight 1
    grid rowconf $ursnlist 0 -weight 1

    # BINDS 
    bind $ursnlist <<ListboxSelect>> ";
    initdatwin::valsavespecie $ursnlist \"last\" \"ursolver\"; 
    initdatwin::displayspecievalues $ursnlist \"ursolver\";
    initdatwin::displayspeciesnames $ursnlist \"ursolver\";
    "
    bind $ursnlist <ButtonPress-3> "+initdatwin::popupmenu $ursnlist \"\" \"\" \"\" 2 %X %Y"

    # Insert Species Names to listbox
    initdatwin::displayspeciesnames $ursnlist "ursolver"
    # Selecting first Specie
    if { $tags > -1 && $tags <= [llength $URVariables_Names] } {
	set setsel $tags
    } else {
	set setsel 0
    }
    initdatwin::updatespcselection $ursnlist $setsel "ursolver"
    # Create Species Values widgets
    initdatwin::makespecie $ursnlist $ursvlist "ursolver"
    # Put specie values into entries
    initdatwin::displayspecievalues $ursnlist "ursolver"

    # Buttons frame
    set btn_frame [frame $ursvlist.btn_frame]

    # Function Editor Button
    set btn_functions [Button $btn_frame.btn_func -underline 0 \
	    -command "FEditor::init $page \"$predefined_ff\" \"\" \"SELECT FIELD\" \"\" \"$ursolverinit_ff\" \"\"" \
	    -image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]

    # Buttons frame
    grid $btn_frame -row [expr [llength $URVariables_Valnames] + 1] -column 1 -sticky en
    # Function Editor Button
    grid $btn_functions -row 0 -column 0 -sticky wn -pady 2 -padx 1
}

################################################################################
#
#   VOFluid
#
################################################################################

proc initdatwin::vofluid { page tags } {

    # VOFluid variables
    variable VOFluid_Initdata
    foreach item $VOFluid_Initdata {
	variable [lindex $item 0]
    }

    variable predefined_ff
    variable vofluidinit_ff

    #####  HELP Text variables #####
    set help_Initial_VOFluid \
	    "[= {Field of Volume of Fluid (for initial and transient boundary conditions)}].\n[= {May be a constant or a function.}]"
    set help_VOFluid_FuncCond \
	    "[= {Function used to update boundary conditions where conditional condition is applied. If the value given by the function is > 0 , boundary condition is applied. If < 0 no boundary condition is applied. If = 0, nothing is done.}]"

    set help_btn_func "[= {Custom Function Editor}].\n[= {Edit a function and transfer it automatically to a field}].\n[= {You can also RIGHT-CLICK a field to open the Function Editor}]."
    set help_Initial \
	    "[= {Insert function defining initial field (initial conditions) of the vof}].\n[= {These functions can also be used to define variable (even transient) boundary conditions}].\n[= {See Fix_Field type boundary conditions}]."
    set help_Conditional \
	    "[= {Insert function defining how to apply 'Conditional Boundary Conditions'}].\n[= {These conditions are only applied when the given functions takes values > 0}]."

    # Title Frame Initial Data
    set tfr_inivofluid [TitleFrame $page.i -relief ridge -bd 3\
	    -text [= {Initial & Field Data}] -side left ]
    set iframe [$tfr_inivofluid getframe]
    GidHelp $tfr_inivofluid $help_Initial

    # Initial VOFluid
    set l_Initial_VOFluid [Label $iframe.l_initvof -text "[= {VOFluid Field}] " \
	    -helptext $help_Initial_VOFluid]
    set e_Initial_VOFluid [entry $iframe.e_initvof -textvariable initdatwin::Initial_VOFluid]

    # Title Frame Initial Data
    set tfr_cndvofluid [TitleFrame $page.c -relief ridge -bd 3\
	    -text [= {Conditional Data}] -side left ]
    set cframe [$tfr_cndvofluid getframe]
    GidHelp $tfr_cndvofluid $help_Conditional

    # VOFluid FuncCond
    set l_VOFluid_FuncCond [Label $cframe.l_voffunccond -text "[= {VOFluid FuncCond}] " \
	    -helptext $help_VOFluid_FuncCond]
    set e_VOFluid_FuncCond [entry $cframe.e_voffunccond -textvariable initdatwin::VOFluid_FuncCond]

    # Buttons frame
    set btn_frame [frame $page.btn_frame]

    # Function Editor Button
    set btn_functions [Button $btn_frame.btn_func -underline 0 \
	    -command "FEditor::init $page \"$predefined_ff\" \"\" \"SELECT FIELD\" \"\" \"$vofluidinit_ff\" \"\"" \
	    -image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]

    # GRIDS
    grid $tfr_inivofluid -row 0 -column 0 -sticky wne -pady 3
    grid $tfr_cndvofluid -row 1 -column 0 -sticky wne -pady 3
    grid $l_Initial_VOFluid -row 0 -column 0 -sticky en -pady 2
    grid $e_Initial_VOFluid -row 0 -column 1 -sticky wn -pady 2
    grid $l_VOFluid_FuncCond -row 0 -column 0 -sticky en -pady 2
    grid $e_VOFluid_FuncCond -row 0 -column 1 -sticky wn -pady 2

    # Buttons frame
    grid $btn_frame -row 2 -column 0 -sticky en
    # Function Editor Button
    grid $btn_functions -row 0 -column 0 -sticky wn -pady 2 -padx 1

    grid columnconfigure $page 0 -weight 1
    grid rowconfigure $page 2 -weight 1

    # BINDS
    foreach item $VOFluid_Initdata {
	set itt [lindex $item 0]
	set itn [DWUnder2Space [lindex $item 1]]
	set ename "e_$itt"
	bind [eval set temp $$ename] <ButtonPress-3> "+initdatwin::popupmenu $page initdatwin::$itt \"$itn\" \"\" 1 %X %Y"
    }
}

################################################################################
#
#   Species Manipulation
#   The following functions are used to manipulate the ADVECT Initial Data
#   as well as the URSolver Initial Data.
#
################################################################################

proc initdatwin::makespecie { nlist vlist type } {

    # Advect Variables
    variable Species_Values
    variable Species_Names
    variable Species_Valnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    variable spcnlastsel
    variable sname
    variable spcselected

    # URSolver Variables
    variable URVariables_Values
    variable URVariables_Names
    variable URVariables_Valnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    variable ursnlastsel
    variable ursname
    variable ursselected

    # Grid Values Frame
    grid $vlist -row 0 -column 0 -sticky wnes -padx 15

    switch $type {
	"advect" {
	    # Specie Name
	    set l_sname [Label $vlist.l_sname -text "[= {Species Name}]: "]
	    set e_sname [Entry $vlist.e_sname -textvariable initdatwin::sname \
		    -editable 0 -background [$vlist cget -background] -relief flat]
       }
	"ursolver" {
	    # Variable Name
	    set l_sname [Label $vlist.l_vname -text "[= {Variable Name}]: "]
	    set e_sname [Entry $vlist.e_vname -textvariable initdatwin::ursname \
		    -editable 0 -background [$vlist cget -background] -relief flat]
	}
    }

    # GRIDS
    # Label
    grid $l_sname -row 0 -column 0 -sticky en -pady 5
    # Entry
    grid $e_sname -row 0 -column 1 -sticky wn -pady 5

    # BINDS
    bind $e_sname <Return> ";
    initdatwin::valsavespecie $nlist \"actual\" \"$type\";
    initdatwin::displayspeciesnames $nlist \"$type\";
    "
    bind $e_sname <ButtonPress-3> "+initdatwin::popupmenu $vlist \"\" \"\" \"\" 2 %X %Y"

    set help_Initial \
	    "[= {Insert function defining initial field (initial conditions) of the variables}].\n[= {These functions can also be used to define variable (even transient) boundary conditions}].\n[= {See Fix_Field type boundary conditions}]."
    set help_Conditional \
	    "[= {Insert function defining how to apply 'Conditional Boundary Conditions'}].\n[= {These conditions are only applied when the given functions takes values > 0}]."

    switch $type {
	"advect" {
	    set type_Valnames $Species_Valnames
	}
	"ursolver" {
	    set type_Valnames $URVariables_Valnames
	}
    }

    # Title Frame Initial Data
    set tfr_ini [TitleFrame $vlist.i -relief ridge -bd 3\
	    -text [= {Initial & Field Data}] -side left]
    set iframe [$tfr_ini getframe]
    GidHelp $tfr_ini $help_Initial
    # Title Frame Conditional Data
    set tfr_cnd [TitleFrame $vlist.c -relief ridge -bd 3\
	    -text [= {Conditional Data}] -side left ]
    set cframe [$tfr_cnd getframe]
    GidHelp $tfr_cnd $help_Conditional

    # GRID Title Frames
    grid $tfr_ini -row 1 -column 0 -sticky swne -pady 3 -columnspan 2
    grid $tfr_cnd -row 2 -column 0 -sticky swne -pady 3 -columnspan 2
 
    grid columnconf $vlist {0 1} -weight 1
    grid rowconf $vlist 10 -weight 1

    # Creating widgets
    set inirow 0
    set cndrow 0
    for { set i 0 } { $i < [llength $type_Valnames] } { incr i } {
	set tvar [lindex [lindex $type_Valnames $i] 1]
	set tname [lindex [lindex $type_Valnames $i] 0]
	if { [string match "Initial*" $tname] } {
	    set myframe $iframe
	    set myrow $inirow
	    incr inirow
	    set tname "[string range $tname 8 end] Field "
	} else {
	    set myframe $cframe
	    set myrow $cndrow
	    incr cndrow
	    set tname "$tname "
	}
	# Defining a Label
	set lvar l_$tvar
	set $lvar [Label $myframe.$lvar -text $tname]
	# Defining an Entry
	set evar e_$tvar
	set $evar [entry $myframe.$evar -width 11 -textvariable initdatwin::$tvar]

	# GRIDS
	# Label
	grid [eval set temp $$lvar] -row $myrow -column 0 -sticky wn -pady 1
	# Entry
	grid [eval set temp $$evar] -row $myrow -column 1 -sticky wn -pady 1

	# BINDS
	bind [eval set temp $$evar] <Return> ";
	initdatwin::valsavespecie $nlist \"actual\" \"$type\";
	initdatwin::displayspeciesnames $nlist \"$type\";
	"
	bind [eval set temp $$evar] <ButtonPress-3> "+initdatwin::popupmenu $vlist initdatwin::$tvar \"$tname\" \"\" 1 %X %Y"
    }

    return 1
}

proc initdatwin::displayspecievalues { nlist type } {

    # Advect Variables
    variable Species_Values
    variable Species_Names
    variable Species_Valnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    variable spcnlastsel
    variable sname
    # URSolver Variables
    variable URVariables_Values
    variable URVariables_Names
    variable URVariables_Valnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    variable ursnlastsel
    variable ursname

    if { [lindex [$nlist curselection] 0] > -1 } {
	set sel [lindex [$nlist curselection] 0]
    } else {
	initdatwin::updatespcselection $nlist 0 $type
	set sel [lindex [$nlist curselection] 0]
    }

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	    set type_Values $Species_Values
	    set type_Valnames $Species_Valnames
	    set vartype_name "sname"
	    set vartype_lastsel "spcnlastsel"
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	    set type_Values $URVariables_Values
	    set type_Valnames $URVariables_Valnames
	    set vartype_name "ursname"
	    set vartype_lastsel "ursnlastsel"
	}
    }

    # Display Specie / Variable name and set last selection
    set $vartype_name [DWUnder2Space [lindex $type_Names $sel]]
    set $vartype_lastsel $sel

    set currvals [lindex $type_Values $sel]
    for { set i 0 } { $i < [llength $type_Valnames] } { incr i } {
	# Entries Values
	set tvar [lindex [lindex $type_Valnames $i] 1]
	set $tvar [lindex $currvals $i]
    }

    return 1
}

proc initdatwin::displayspeciesnames { nlist type } {

    variable Species_Names
    variable URVariables_Names

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	}
    }

    if { [lindex [$nlist curselection] 0] > -1 } {
	set savesel [lindex [$nlist curselection] 0]
    } else {
	set savesel ""
    }
    set p 0
    $nlist delete 0 end
    foreach n $type_Names {
	$nlist insert $p $n
	incr p
    }

    if { $savesel > -1 } {
	$nlist selection clear 0 end
	$nlist selection set $savesel $savesel
    }

    return 1
}

proc initdatwin::updatespcselection { nlist setsel type } {

    variable Species_Names
    variable URVariables_Names
    variable spcnlastsel
    variable ursnlastsel
    variable sname
    variable ursname

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	}
    }

    if { $setsel < 0 || $setsel > [expr [llength $type_Names] -1] } {
	set setsel "end"
    }

    $nlist selection clear 0 end
    $nlist selection set $setsel $setsel

    switch $type {
	"advect" {
	    set spcnlastsel $setsel
	    set sname [lindex $type_Names $setsel]
	}
	"ursolver" {
	    set ursnlastsel $setsel
	    set ursname [lindex $type_Names $setsel]
	}
    }

    return 1
}

proc initdatwin::valsavespecie { nlist sel type } {

    # Advect Variables
    variable Species_Values
    variable Species_Names
    variable Species_Valnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    variable spcnlastsel
    variable sname
    # URSolver Variables
    variable URVariables_Values
    variable URVariables_Names
    variable URVariables_Valnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    variable ursnlastsel
    variable ursname

    if { $sel == "actual" && [string length [$nlist curselection]] > 0 } {
	set sel [lindex [$nlist curselection] 0]
    } else {
	switch $type {
	    "advect" {
		set sel $spcnlastsel
	    }
	    "ursolver" {
		set sel $ursnlastsel
	    }
	}
    }

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	    set vartype_Names "Species_Names"
	    set type_Values $Species_Values
	    set vartype_Values "Species_Values"
	    set type_Valnames $Species_Valnames
	    set type_name $sname
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	    set vartype_Names "URVariables_Names"
	    set type_Values $URVariables_Values
	    set vartype_Values "URVariables_Values"
	    set type_Valnames $URVariables_Valnames
	    set type_name $ursname
	}
    }

    if { $sel > -1 && !($sel > [expr [llength $type_Values] -1]) } {

	# Saving Specie / UR Variable Name
	set $vartype_Names [lreplace $type_Names $sel $sel [string trim [DWSpace2Under $type_name]]]
	
	# Saving Specie / UR Variable values
	set newvals ""
	for { set i 0 } { $i < [llength $type_Valnames] } { incr i } {
	    set tvar [lindex [lindex $type_Valnames $i] 1]
	    set type [lindex [lindex $type_Valnames $i] 2]
	    lappend newvals [TUI_cleanvalue [eval set temp $$tvar] $type]
	    #if { [lindex [lindex $type_Valnames $i] 2] == "func" } {
	    #    lappend newvals [TdynCleanString [eval set temp $$tvar]]
	    #} else {
	    #    lappend newvals [DWSpace2Under [eval set temp $$tvar]]
	    #}
	}
	set $vartype_Values [lreplace $type_Values $sel $sel $newvals]
    }

    return 1
}

proc initdatwin::formatvalues { way } {

    # ADVECT Variables
    variable Advect_Initdata
    variable Species_Names
    variable Species_Values
    variable Species_Valnames
    # URSolver Variables
    variable URSolver_Initdata
    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_Valnames

    switch $way {
	"saving" {
	    # ADVECT Species values
	    set Advect_Initdata [TUI_formatspeciesvalues List2String $Species_Valnames $Species_Values]
	    #set tn [expr [llength $Species_Valnames] * [llength $Species_Values]]
	    #set Advect_Initdata "#N# $tn"
	    #foreach sv $Species_Values {
	    #    foreach svv $sv {
	    #        append Advect_Initdata " " [string trim $svv]
	    #    }
	    #}
	    #set Advect_Initdata [string trim $Advect_Initdata]
	    # URSOLVER Species values
	    set URSolver_Initdata [TUI_formatspeciesvalues List2String $URVariables_Valnames $URVariables_Values]
	    #set tn [expr [llength $URVariables_Valnames] * [llength $URVariables_Values]]
	    #set URSolver_Initdata "#N# $tn"
	    #foreach sv $URVariables_Values {
	    #    foreach svv $sv {
	    #        append URSolver_Initdata " " [string trim $svv]
	    #    }
	    #}
	    #set URSolver_Initdata [string trim $URSolver_Initdata]
	}
	"retrieving" {
	    # ADVECT Species values
	    set Species_Values [TUI_formatspeciesvalues String2List $Species_Valnames $Advect_Initdata]
	    #set valstr [lreplace $Advect_Initdata 0 1]
	    #set Species_Values ""
	    #for { set i 0 } { $i < [expr [llength $valstr] / [llength $Species_Valnames]] } { incr i } {
	    #    set aa [lrange $valstr [expr $i * [llength $Species_Valnames]] \
	    #            [expr [expr ($i+1) * [llength $Species_Valnames]] -1]]
	    #    lappend Species_Values $aa
	    #}
	    # URSOLVER Species values
	    set URVariables_Values [TUI_formatspeciesvalues String2List $URVariables_Valnames $URSolver_Initdata]
	    #set valstr [lreplace $URSolver_Initdata 0 1]
	    #set URVariables_Values ""
	    #for { set i 0 } { $i < [expr [llength $valstr] / [llength $URVariables_Valnames]] } { incr i } {
	    #    set aa [lrange $valstr [expr $i * [llength $URVariables_Valnames]] \
	    #            [expr [expr ($i+1) * [llength $URVariables_Valnames]] -1]]
	    #    lappend URVariables_Values $aa
	    #}
	}
    }
}



################################################################################
#
#   PopUp Menus
#
################################################################################

proc initdatwin::popupmenu { parent {field ""} {fieldname ""} tags content x y } {

    variable predefined_ff
    variable Species_List
    variable Species_Columns

    catch {
	destroy $parent.menu
    }

    set menu [menu $parent.menu -type normal]

    switch $content {
	1 {
#              $menu add command -label [= {Help}] -command initdatwin::definehelptagshere-stillmissing
	      if { [string length $field] > 0 } {
		  eval set fval $$field
	      }
	    $menu add command -label [= {Define Function}] \
		    -command "FEditor::init $parent \"$predefined_ff\" $field [list $fieldname] [list $fval] \"\" \"\""
	}
    }
    
    tk_popup $menu $x $y

    return 1
}

proc initdatwin::getvalues { } {

    # Ransol variables
    variable Ransol_Initdata
    foreach item $Ransol_Initdata {
	variable [lindex $item 0]
    }
    variable Ransol_UnitsRead
    foreach item $Ransol_UnitsRead {
	variable [lindex $item 0]
    }
    # Heatrans variables
    variable Heatrans_Initdata
    foreach item $Heatrans_Initdata {
	variable [lindex $item 0]
    }
    variable Heatrans_UnitsRead
    foreach item $Heatrans_UnitsRead {
	variable [lindex $item 0]
    }
    # Advect variables
    variable Species_Names
    variable Species_Values
    variable Advect_Initdata
    # URSolver variables
    variable URVariables_Names
    variable URSolver_Initdata
    # VOFluid variables
    variable VOFluid_Initdata
    foreach item $VOFluid_Initdata {
	variable [lindex $item 0]
    }

    set gendata [.central.s info gendata]

    # Ransol
    foreach item $Ransol_Initdata {
	set itt [lindex $item 0]
#        set $itt [DWUnder2Space "[lindex $gendata [expr [lsearch -regexp $gendata \
#                    [eval set nothing ^${itt}(\$|\#CB)]] + 1]]"]
	set $itt [TUI_readsinglefield gendata $itt]
    }
    foreach item $Ransol_UnitsRead {
	set itt [lindex $item 0]
	set nitt [lindex $item 1]
	set $itt [TUI_formatunits Nums2Unicode \
		    [DWUnder2Space [join [lindex $gendata [expr [lsearch -regexp $gendata \
		                        [eval set nothing ^${itt}(\$|\#CB)]] + 1]]]] 0]
    }

    # Heatrans
    foreach item $Heatrans_Initdata {
	set itt [lindex $item 0]
#        set $itt [DWUnder2Space "[lindex $gendata [expr [lsearch -regexp $gendata \
#                    [eval set nothing ^${itt}(\$|\#CB)]] + 1]]"]
	set $itt [TUI_readsinglefield gendata $itt] 
    }
    foreach item $Heatrans_UnitsRead {
	set itt [lindex $item 0]
	set nitt [lindex $item 1]
	set $itt [TUI_formatunits Nums2Unicode \
		    [DWUnder2Space [join [lindex $gendata [expr [lsearch -regexp $gendata \
		                        [eval set nothing ^${itt}(\$|\#CB)]] + 1]]]] 0]
    }

    # Advect
    # Read Species Names from Problem Data
    set temp "[lindex $gendata [expr [lsearch -regexp $gendata "Species_Names"] + 1]]"
    set Species_Names [TUI_formatlistvalues String2List $temp]
    # Read existing ADVECT Initial Data
    set temp "[lindex $gendata [expr [lsearch -regexp $gendata "Advect_Initdata"] + 1]]"
    set Advect_Initdata $temp

    # URSolver
    # Read URSolver Variables Names from Problem Data
    set temp "[lindex $gendata [expr [lsearch -regexp $gendata "URVariables_Names"] + 1]]"
    set URVariables_Names [TUI_formatlistvalues String2List $temp] 
    # Read existing URSolver Initial Data
    set temp "[lindex $gendata [expr [lsearch -regexp $gendata "URSolver_Initdata"] + 1]]"
    set URSolver_Initdata $temp

    # VOFluid
    foreach item $VOFluid_Initdata {
	set itt [lindex $item 0]
	set $itt [TUI_readsinglefield gendata $itt] 
    }

    initdatwin::formatvalues retrieving
}

proc initdatwin::checkclose { win {dumpit 1} {askdump 1} {close 1} } {
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver

    # Ransol variables
    variable Ransol_Initdata
    foreach item $Ransol_Initdata {
	variable [lindex $item 0]
    }
    # Heatrans variables
    variable Heatrans_Initdata
    foreach item $Heatrans_Initdata {
	variable [lindex $item 0]
    }
    # Advect variables
    variable Advect_Initdata
    variable Species_Names
    variable Species_Values
    variable Species_Valnames
    variable snlist
    # URSolver variables
    variable URSolver_Initdata
    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_Valnames
    variable ursnlist
    # Heatrans variables
    variable VOFluid_Initdata
    foreach item $VOFluid_Initdata {
	variable [lindex $item 0]
    }

    # Last unsaved changes of Species Values - save them
    if { $show_advect == 1 } {
	initdatwin::valsavespecie $snlist "actual" "advect"
    }

    if { $show_ursolver == 1 } {
	initdatwin::valsavespecie $ursnlist "actual" "ursolver"
    }

    initdatwin::formatvalues "saving"

    set gendata [.central.s info gendata]
    set valueschange 0
    set wtsave 0
    set usr_err ""
    set num_usr_err 0
    set uerrpg_ran 0
    set uerrpg_htr 0
    set uerrpg_adv 0
    set uerrpg_urs 0

    # Checking RANSOL values
    foreach item $Ransol_Initdata {
	set itt [lindex $item 0]
	set temp [TUI_readsinglefield gendata $itt]
	if { $temp != [eval set nothing $$itt] } {
	    set valueschange 1
	    set errcheck [TUI_valuecheck [eval set nothing $$itt] [lindex $item 2] 0 [lindex $item 4]]
	    if { $errcheck != "ok" && [lindex $item 3] == 1} {
		incr num_usr_err
		if { $uerrpg_ran != 1 } {
		    append usr_err "\n[= {RANSOL PAGE}]\n"
		    set uerrpg_ran 1
		}
		append usr_err "$num_usr_err. " [DWUnder2Space $itt] ": $errcheck\n"
	    }
	}
    }

    # Checking HEATRANS values
    foreach item $Heatrans_Initdata {
	set itt [lindex $item 0]
	set temp [TUI_readsinglefield gendata $itt]    
	if { $temp != [eval set nothing $$itt] } {
	    set valueschange 1
	    set errcheck [TUI_valuecheck [eval set nothing $$itt] [lindex $item 2] 0 [lindex $item 4]]
	    if { $errcheck != "ok" && [lindex $item 3] == 1} {
		incr num_usr_err
		if { $uerrpg_htr != 1 } {
		    append usr_err "\n[= {HEATRANS PAGE}]\n"
		    set uerrpg_htr 1
		}
		append usr_err "$num_usr_err. " [DWUnder2Space $itt] ": $errcheck\n"
	    }
	}
    }

    # Checking ADVECT values
    set temp "[lindex $gendata [expr [lsearch -regexp $gendata "Advect_Initdata"] + 1]]"

    if { ![TUI_comparelists $temp $Advect_Initdata] } {
	set valueschange 1
	set spc_pos 0
	foreach item $Species_Values {
	    set tspn [lindex $Species_Names $spc_pos]
	    incr spc_pos
	    set valnamepos 0
	    foreach itt $item {
		set valname [lindex $Species_Valnames $valnamepos]
		incr valnamepos
		set errcheck [TUI_valuecheck $itt [lindex $valname 2] 0 [lindex $item 4]]
		if { $errcheck != "ok" && [lindex $valname 3] == 1} {
		    incr num_usr_err
		    if { $uerrpg_adv != 1 } {
		        append usr_err "\n[= {ADVECT PAGE}]\n"
		        set uerrpg_adv 1
		    }
		    append usr_err "$num_usr_err. " "$tspn; " [lindex $valname 0] ": $errcheck\n"
		}
	    }
	}
    }

    # Checking URSOLVER values
    set temp "[lindex $gendata [expr [lsearch -regexp $gendata "URSolver_Initdata"] + 1]]"

    if { ![TUI_comparelists $temp $URSolver_Initdata] } {
	set valueschange 1
	set spc_pos 0
	foreach item $URVariables_Values {
	    set tspn [lindex $URVariables_Names $spc_pos]
	    incr spc_pos
	    set valnamepos 0
	    foreach itt $item {
		set valname [lindex $URVariables_Valnames $valnamepos]
		incr valnamepos
		set errcheck [TUI_valuecheck $itt [lindex $valname 2] 0 [lindex $item 4]]
		if { $errcheck != "ok" && [lindex $valname 3] == 1} {
		    incr num_usr_err
		    if { $uerrpg_urs != 1 } {
		        append usr_err "\n[= {URSOLVER PAGE}]\n"
		        set uerrpg_urs 1
		    }
		    append usr_err "$num_usr_err. " "$tspn; " [lindex $valname 0] ": $errcheck\n"
		}
	    }
	}
    }

    # Checking VOFLUID values
    foreach item $VOFluid_Initdata {
	set itt [lindex $item 0]
	set temp [TUI_readsinglefield gendata $itt]    
	if { $temp != [eval set nothing $$itt] } {
	    set valueschange 1
	    set errcheck [TUI_valuecheck [eval set nothing $$itt] [lindex $item 2] 0 [lindex $item 4]]
	    if { $errcheck != "ok" && [lindex $item 3] == 1} {
		incr num_usr_err
		if { $uerrpg_htr != 1 } {
		    append usr_err "\n[= {VOFLUID PAGE}]\n"
		    set uerrpg_htr 1
		}
		append usr_err "$num_usr_err. " [DWUnder2Space $itt] ": $errcheck\n"
	    }
	}
    }

    if { $valueschange == 1 } {
	if { $askdump == 0 } {
	    set answer 0
	} else {
	    set answer [tk_dialogRAM $win [= {Tdyn Initial Data}] \
		    [= {Initial data has changed}].\n[= {Do you want to save changes?}] question 0 Yes No]
	}

	if { $answer == 0 && $dumpit == 1} {
	    set wtsave 1
	    if { $num_usr_err > 0 } {
		if { $num_usr_err > 1 } {
		    set err_display [= {The following %s error} $num_usr_err]
		    append err_display "[= {(s) were found in the data input}]:\n"
		} else {
		    set err_display "[= {The following error was found in the data input}]:\n"
		}
		append err_display $usr_err
		WarnWin $err_display
		set close 0
	    } else {
		initdatwin::dump
		FloatMessage $win.flm "[= {Initial Data was saved}]."
	    }
	}
    } else {
	if { $dumpit == 1 } {
	    FloatMessage $win.flm "[= {No changes need to be saved}]."
	}
    }

    if { $close == 1 } {
	destroy $win
	return $valueschange
    } else {
	if { $num_usr_err == 0 } {
	    return $valueschange
	} else {
	    if { $wtsave == 1 } {
		return "dataerror"
	    } else {
		return "nosave.dataerror"
	    }
	}
    }
}

proc initdatwin::dump { } {

    variable Ransol_Initdata
    variable Heatrans_Initdata
    variable Advect_Initdata
    variable URSolver_Initdata
    variable VOFluid_Initdata

    TUI_dumpsinglefields initdatwin $Ransol_Initdata ProblemData

    TUI_dumpsinglefields initdatwin $Heatrans_Initdata ProblemData

    GiD_AccessValue set gendata "Advect_Initdata:" $Advect_Initdata

    GiD_AccessValue set gendata "URSolver_Initdata:" $URSolver_Initdata

    TUI_dumpsinglefields initdatwin $VOFluid_Initdata ProblemData

    # Actualizamos la variable de control de cambios en GiD
    GIDModifiedFileFlag Set
}
