namespace eval prbdatwin {

    global ProgramName
    global tkPriv tcl_platform

    # Tdyn settings
    variable show_fluid [IsVarOnTdynDefaults show_fluid 1]
    variable show_solid [IsVarOnTdynDefaults show_solid 1]
    variable show_ransol [IsVarOnTdynDefaults show_ransol 1]
    variable show_heatrans [IsVarOnTdynDefaults show_heatrans 1]
    variable show_advect [IsVarOnTdynDefaults show_advect 1]
    variable show_ursolver [IsVarOnTdynDefaults show_ursolver 1]
    variable show_alemesh [IsVarOnTdynDefaults show_alemesh 1]
    variable show_naval [IsVarOnTdynDefaults show_naval 1]
    variable show_ramsolid [IsVarOnTdynDefaults show_ramsolid 1]
    variable show_vof [IsVarOnTdynDefaults show_vof 1]
    variable edit_units [IsVarOnTdynDefaults edit_units 0]
   
    switch $ProgramName {
	"Tdyn2D" {
	    variable Problem_Prbdata [list \
		    [list Solve_Fluid "Solve Fluid" yesno 1] \
		    [list Solve_FluidFlow_in_Fluid "Solve FluidFlow in Fluid" yesno 1] \
		    [list Solve_Compressibility_in_Fluid "Solve Compressibility in Fluid" yesno 1] \
		    [list Solve_Temperature_in_Fluid "Solve Temperature in Fluid" yesno 1] \
		    [list Solve_SpeciesConcentration_in_Fluid "SolveSpecies Concentration in Fluid" yesno 1] \
		    [list Solve_PhiProblems_in_Fluid "Solve PhiProblems in Fluid" yesno 1] \
		    [list Solve_VolumeOfFluid_in_Fluid "Solve VolumeOfFluid in Fluid" yesno 1] \
		    [list Solve_MeshDeformation_in_Fluid "Solve MeshDeformation in Fluid" yesno 1] \
		    [list Solve_Solid "Solve Solid" yesno 1] \
		    [list Solve_FluidFlow_in_Solid "Solve FluidFlow in Solid" yesno 1] \
		    [list Solve_Temperature_in_Solid "Solve Temperature in Solid" yesno 1] \
		    [list Solve_SpeciesConcentration_in_Solid "Solve SpeciesConcentration in Solid" yesno 1] \
		    [list Solve_PhiProblems_in_Solid "Solve PhiProblems in Solid" yesno 1] \
		    [list Solve_MeshDeformation_in_Solid "Solve MeshDeformation in Solid" yesno 1] \
		    ]
	}
	"Tdyn3D" {
	    variable Problem_Prbdata [list \
		    [list Solve_Fluid "Solve Fluid" yesno 1] \
		    [list Solve_FluidFlow_in_Fluid "Solve FluidFlow in Fluid" yesno 1] \
		    [list Solve_Compressibility_in_Fluid "Solve Compressibility in Fluid" yesno 1] \
		    [list Solve_Temperature_in_Fluid "Solve Temperature in Fluid" yesno 1] \
		    [list Solve_Transpiration_in_Fluid "Solve Transpiration in Fluid" yesno 1] \
		    [list Solve_SpeciesConcentration_in_Fluid "SolveSpecies Concentration in Fluid" yesno 1] \
		    [list Solve_PhiProblems_in_Fluid "Solve PhiProblems in Fluid" yesno 1] \
		    [list Solve_VolumeOfFluid_in_Fluid "Solve VolumeOfFluid in Fluid" yesno 1] \
		    [list Solve_MeshDeformation_in_Fluid "Solve MeshDeformation in Fluid" yesno 1] \
		    [list Solve_Solid "Solve Solid" yesno 1] \
		    [list Solve_FluidFlow_in_Solid "Solve FluidFlow in Solid" yesno 1] \
		    [list Solve_Temperature_in_Solid "Solve Temperature in Solid" yesno 1] \
		    [list Solve_SpeciesConcentration_in_Solid "Solve SpeciesConcentration in Solid" yesno 1] \
		    [list Solve_PhiProblems_in_Solid "Solve PhiProblems in Solid" yesno 1] \
		    [list Solve_MeshDeformation_in_Solid "Solve MeshDeformation in Solid" yesno 1] \
		    [list Solve_StructuralProblem_in_Solid "Solve_StructuralProblem_in_Solid" yesno 1] \
		    ]
	}
    }
    foreach item $Problem_Prbdata {
	variable [lindex $item 0]
    }
    # ANALYSIS
    variable Analysis_Prbdata [list \
	    [list Number_of_Steps "Number of Steps" integer 1] \
	    [list Time_increment "Time increment" func 1] \
	    [list Max_Iterations "Max Iterations" integer 1] \
	    [list Initial_Steps "Initial Steps" integer 1] \
	    [list Start_Up_Control "Start Up Control" string 1] \
	    [list Restart "Restart" string 1] \
	    ]
    foreach item $Analysis_Prbdata {
	variable [lindex $item 0]
    }
    variable Analysis_Unitsdata [list \
	    [list Time_increment_Units "Time_increment_Units#CB#"] \
    ]
    foreach item $Analysis_Unitsdata {
	variable [lindex $item 0]
    }
    # RESULTS
    variable Results_Prbdata [list \
	    [list Output_Step "Output Step" integer 1 outfr] \
	    [list Output_Start "Output Start" integer 1 outfr] \
	    [list Results_File "Results File" string 1 outfr] \
	    [list Initial_Data "Initial Data" onoff 1 ransol] \
	    [list Velocity "Velocity" onoff 1 ransol] \
	    [list Velocity_Stress_Tensor "Velocity Stress Tensor" onoff 1 ransol] \
	    [list Pressure "Pressure" onoff 1 ransol] \
	    [list Pressure_Gradient "Pressure Gradient" onoff 1 ransol] \
	    [list Total_Pressure "Total Pressure" onoff 1 ransol] \
	    [list Temperature "Temperature" onoff 1 heatrans] \
	    [list Temperature_Gradient "Temperature Gradient" onoff 1 heatrans] \
	    [list Heat_Flux "Heat Flux" onoff 1 heatrans] \
	    [list Solid_Density "Solid Density" onoff 1 heatrans] \
	    [list Species_Concentration "Species Concentration" onoff 1 advect] \
	    [list Wave_Elevation "Wave Elevation" onoff 1 naval] \
	    [list Wave_Elevation_Vector "Wave Elevation Vector" onoff 1 naval] \
	    [list Density "Density" onoff 1 ransol] \
	    [list Viscosity "Viscosity" onoff 1 ransol] \
	    [list Compressibility_factor "Compressibility factor" onoff 1 ransol] \
	    [list Wall_Law_Traction "Wall Law Traction" onoff 1 ransol] \
	    [list Tau_Parameter "Tau Parameter" onoff 1 ransol] \
	    [list Vorticity "Vorticity" onoff 1 ransol] \
	    [list Eddy_Viscosity "Eddy Viscosity" onoff 1 ransol] \
	    [list EddyKin_Energy "EddyKin Energy" onoff 1 ransol] \
	    [list Epsilon "Epsilon" onoff 1 ransol] \
	    [list Omega "Omega" onoff 1 ransol] \
	    [list Tau_Eddy "Tau Eddy" onoff 1 ransol] \
	    [list Mesh_Deformation "Mesh Deformation" onoff 1 alemesh] \
	    [list Eulerian_Velocity "ALE Velocity" onoff 1 alemesh] \
	    [list Real_Velocity "Real Velocity" onoff 1 ransol] \
	    [list VariableResult "VariableResult" onoff 1 ursolver] \
	    [list UserDefinedF1 "UserDefinedF1" onoff 1 ursolver] \
	    [list FluidFunction1 "FluidFunction1" func 1 ursolver] \
	    [list FluidFunction1_Name "FluidFunction1 Name" string 1 ursolver] \
	    [list UserDefinedF2 "UserDefinedF2" onoff 1 ursolver] \
	    [list FluidFunction2 "FluidFunction2" func 1 ursolver] \
	    [list FluidFunction2_Name "FluidFunction2 Name" string 1 ursolver] \
	    [list UserDefinedF3 "UserDefinedF3" onoff 1 ursolver] \
	    [list FluidFunction3 "FluidFunction3" func 1 ursolver] \
	    [list FluidFunction3_Name "FluidFunction3 Name" string 1 ursolver] \
	    [list UserDefinedS1 "UserDefinedS1" onoff 1 ursolver] \
	    [list SolidFunction1 "SolidFunction1" func 1 ursolver] \
	    [list SolidFunction1_Name "SolidFunction1 Name" string 1 ursolver] \
	    [list UserDefinedS2 "UserDefinedS2" onoff 1 ursolver] \
	    [list SolidFunction2 "SolidFunction2" func 1 ursolver] \
	    [list SolidFunction2_Name "SolidFunction2 Name" string 1 ursolver] \
	    [list UserDefinedS3 "UserDefinedS3" onoff 1 ursolver] \
	    [list SolidFunction3 "SolidFunction3" func 1 ursolver] \
	    [list SolidFunction3_Name "SolidFunction3 Name" string 1 ursolver] \
	    ]
    foreach item $Results_Prbdata {
	variable [lindex $item 0]
    }
    # FLUID SOLVER
    variable Fluid_Solver [list \
	    [list FTime_Integration "FTime_Integration#CB#" string 0] \
	    [list StabTauV_MinRatio "StabTauV_MinRatio" float 1] \
	    [list StabTauP_MinRatio "StabTauP_MinRatio" float 1] \
	    [list FSolver_NonSymmetric "FSolver_NonSymmetric#CB#" string 0] \
	    [list NS1_Kdim "NS1_Kdim" float 0] \
	    [list NS1_Tolerance "NS1_Tolerance" float 1] \
	    [list NS1_MaxIter "NS1_MaxIter" float 1] \
	    [list NS1_Preconditioner "NS1_Preconditioner#CB#" string 0] \
	    [list FSolver_Symmetric "FSolver_Symmetric#CB#" string 0] \
	    [list NS2_Kdim "NS2_Kdim" float 0] \
	    [list NS2_Tolerance "NS2_Tolerance" float 1] \
	    [list NS2_MaxIter "NS2_MaxIter" float 1] \
	    [list NS2_Preconditioner "NS2_Preconditioner#CB#" string 0] \
	    [list Advection_Norm "Advection_Norm" float 1] \
	    [list FLUIDSOLVER_Steady_State_Norm "FLUIDSOLVER_Steady_State_Norm" float 1] \
	    [list FLUIDSOLVER_Increment_Control "FLUIDSOLVER_Increment_Control#CB#" posfloat 1] \
	    ]
    foreach item $Fluid_Solver {
	variable [lindex $item 0]
    }

    # SOLID SOLVER
    variable Solid_Solver [list \
	    [list STime_Integration "STime_Integration#CB#" string 0] \
	    [list SSolver_Symmetric "SSolver_Symmetric#CB#" string 0] \
	    [list S_Kdim "S_Kdim" float 1] \
	    [list S_Tolerance "S_Tolerance" float 1] \
	    [list S_MaxIter "S_MaxIter" float 1] \
	    [list S_Preconditioner "S_Preconditioner#CB#" string 0] \
	    [list SOLIDSOLVER_Steady_State_Norm "SOLIDSOLVER_Steady_State_Norm" float 1] \
	    [list SOLIDSOLVER_Increment_Control "SOLIDSOLVER_Increment_Control#CB#" posfloat 1] \
	    [list Solver_type "Ramsolid Solver type" string 1] \
	    [list Solver_tolerance "Ramsolid Solver tolerance" float 1] \
	    [list Solver_tolerance_minimum "Ramsolid Solver tolerance minimum" float 1] \
	    [list Solver_max_iterations "Ramsolid Solver max iterations" integer 1] \
	    ]
    foreach item $Solid_Solver {
	variable [lindex $item 0]
    }
 
    # OTHER
    switch $ProgramName {
	"Tdyn2D" {
	    variable Other_Data [list \
		    [list Float_By_Density "Floatability by Density" yesno 0] \
		    [list Use_Total_Pressure "Use Total Pressure" yesno 0] \
		    [list Give_Pressure_Origin "Give Pressure Origin" yesno 0] \
		    [list Pressure_Origin_OX "Pressure Origin OX" float 1] \
		    [list Pressure_Origin_OY "Pressure Origin OY" float 1] \
		    [list Xplane_Symmetry_in_Fluid "Xplane Symmetry in Fluid" yesno 1] \
		    [list Xplane_Symmetry_Position "Xplane Symmetry Position" string 0] \
		    [list Yplane_Symmetry_in_Fluid "Yplane Symmetry in Fluid" yesno 0] \
		    [list Yplane_Symmetry_Position "Yplane Symmetry Position" string 0] \
		    [list RefineMesh "Refine Mesh Type" string 0] \
		    [list Wall_Law_Type "Wall Law Type" string 0] \
		    [list Wall_Law_VFor "Wall Law VFor" string 0] \
		    [list UserIntegralF1 "UserIntegralF1" func 1] \
		    [list UserIntegralF2 "UserIntegralF2" func 1] \
		    [list UserIntegralF3 "UserIntegralF3" func 1] \
		    [list UserIntegralS1 "UserIntegralS1" func 1] \
		    [list UserIntegralS2 "UserIntegralS2" func 1] \
		    [list UserIntegralS3 "UserIntegralS3" func 1] \
		    [list Velocities_List "Velocities List" string 0] \
		    [list Additional_Steps "Additional Steps" string 0] \
		    [list Execution_Arguments "Execution_arguments" string 0] \
	    ]
	} 
	"Tdyn3D" {
	    variable Other_Data [list \
		    [list Float_By_Density "Floatability by Density" yesno 0] \
		    [list Use_Total_Pressure "Use Total Pressure" yesno 0] \
		    [list Give_Pressure_Origin "Give Pressure Origin" yesno 0] \
		    [list Pressure_Origin_OX "Pressure Origin OX" float 1] \
		    [list Pressure_Origin_OY "Pressure Origin OY" float 1] \
		    [list Pressure_Origin_OZ "Pressure Origin OZ" float 1] \
		    [list Xplane_Symmetry_in_Fluid "Xplane Symmetry in Fluid" yesno 0] \
		    [list Xplane_Symmetry_Position "Xplane Symmetry Position" string 0] \
		    [list Yplane_Symmetry_in_Fluid "Yplane Symmetry in Fluid" yesno 0] \
		    [list Yplane_Symmetry_Position "Yplane Symmetry Position" string 0] \
		    [list Zplane_Symmetry_in_Fluid "Zplane Symmetry in Fluid" yesno 0] \
		    [list Zplane_Symmetry_Position "Zplane Symmetry Position" string 0] \
		    [list RefineMesh "Refine Mesh Type" string 0] \
		    [list Wall_Law_Type "Wall Law Type" string 0] \
		    [list Wall_Law_VFor "Wall Law VFor" string 0] \
		    [list UserIntegralF1 "UserIntegralF1" func 1] \
		    [list UserIntegralF2 "UserIntegralF2" func 1] \
		    [list UserIntegralF3 "UserIntegralF3" func 1] \
		    [list UserIntegralS1 "UserIntegralS1" func 1] \
		    [list UserIntegralS2 "UserIntegralS2" func 1] \
		    [list UserIntegralS3 "UserIntegralS3" func 1] \
		    [list Velocities_List "Velocities List" string 0] \
		    [list Additional_Steps "Additional Steps" string 0] \
		    [list Execution_Arguments "Execution_arguments" string 0] \
	    ]
	} 
    }
    foreach item $Other_Data {
	variable [lindex $item 0]
    }
    variable Other_Unitsdata [list \
	    [list Geometry_Units "Geometry_Units"] \
    ]
    foreach item $Other_Unitsdata {
	variable [lindex $item 0]
    }
    # Function Editor variables
    variable analysis_ff [list {prbdatwin::Time_increment} {Time Increment}]
    variable results_ursolver_ff [list \
	    {prbdatwin::FluidFunction1} {Fluid Function #1} \
	    {prbdatwin::FluidFunction2} {Fluid Function #2} \
	    {prbdatwin::FluidFunction3} {Fluid Function #3} \
	    {prbdatwin::SolidFunction1} {Solid Function #1} \
	    {prbdatwin::SolidFunction2} {Solid Function #2} \
	    {prbdatwin::SolidFunction3} {Solid Function #3} \
	    ]
    variable results_fursolver_ff [list \
	    {prbdatwin::FluidFunction1} {Fluid Function #1} \
	    {prbdatwin::FluidFunction2} {Fluid Function #2} \
	    {prbdatwin::FluidFunction3} {Fluid Function #3} \
	    ]
    variable results_sursolver_ff [list \
	    {prbdatwin::SolidFunction1} {Solid Function #1} \
	    {prbdatwin::SolidFunction2} {Solid Function #2} \
	    {prbdatwin::SolidFunction3} {Solid Function #3} \
	    ]
    variable other_ff [list \
	    {prbdatwin::UserIntegralF1} {Fluid user integral #1} \
	    {prbdatwin::UserIntegralF2} {Fluid user integral #2} \
	    {prbdatwin::UserIntegralF3} {Fluid user integral #3} \
	    {prbdatwin::UserIntegralS1} {Solid user integral #1} \
	    {prbdatwin::UserIntegralS2} {Solid user integral #2} \
	    {prbdatwin::UserIntegralS3} {Solid user integral #3} \
	    ]
    variable fluid_variables_anl "t it rand dt exp(1) pi"
    variable example_fluid_variables_anl "t it rand dt exp(1) pi"
    variable fluid_operators_anl "+ - * / ^ mod div rmod rdiv max min \
	    ~ < <= > >= = != & |"
    variable predefined_anl_ff [list $fluid_variables_anl $example_fluid_variables_anl $fluid_operators_anl]

    variable fluid_variables "x y z nx ny nz t it rand dt exp(1) pi vx vy vz pr tm\
	    vt v_ tau wc ds ke ep om kt pk dn bt sp# ph#"
    variable example_fluid_variables "x y z nx ny nz t it rand dt exp(1)\
	    pi vx vy vz pr tm vt v_ tau wc ds ke ep om kt pk dn bt sp#"
    variable fluid_operators "+ - * / ^ mod div rmod rdiv max min Dx() Dy() Dz()\
	    ~ < <= > >= = != & |"
    variable predefined_ff [list $fluid_variables $example_fluid_variables $fluid_operators]
}

proc prbdatwin::init { parent {show "all"} {tags ""} } {

    global ProgramName
    global tkPriv tcl_platform

    # Tdyn settings
    variable show_fluid
    variable show_solid
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_alemesh
    variable show_naval
    variable edit_units

    variable Species_Names
    variable snlist
    variable URVariables_Names
    variable ursnlist

    set prb $parent.prb

    if { [TUI_closeotherwindows $prb 1] == 1 } {

	InitWindow $prb [= {Tdyn Problem and Solver Data}] PreTdynProblemDataWindowGeom ""

	set closecmd "prbdatwin::checkclose $prb 1 1 1"
	set acceptcmd "prbdatwin::checkclose $prb 1 0 0"
	wm protocol $prb WM_DELETE_WINDOW "$closecmd"

	# Reading values from Problem Data
	prbdatwin::getvalues

	# Top frame
	set topf [frame $prb.f -bg lightblue]
	# Image
	set l_icon [label $topf.l_icon -image [imagefromtdyn prdata.gif] -bg lightblue]
	grid $topf -row 0 -column 0 -sticky nwe
	grid $l_icon -row 0 -column 0 -sticky nw
	grid columnconf $topf 1 -weight 1

	# Main Notebook
	set pages [NoteBook $prb.pages -homogeneous 1 -arcradius 0]
	grid $pages -row 1 -column 0 -sticky nwes -pady 5
	grid columnconf $prb 0 -weight 1
	grid rowconf $prb 1 -weight 1
	
	set pnum 0
	# Problem data page
	set pg_problem [$pages insert $pnum pg_problem -text [= {PROBLEM}]]
	$pages raise pg_problem
	prbdatwin::problem_data $pg_problem $tags
	grid columnconfigure $pg_problem 0 -weight 1
	grid rowconfigure $pg_problem 10 -weight 1
	incr pnum      

	# Analysis data page
	set pg_analysis [$pages insert $pnum pg_analysis -text [= {ANALYSIS}]]
	prbdatwin::analysis_data $pg_analysis $tags
	grid columnconfigure $pg_analysis 0 -weight 1
	grid rowconfigure $pg_analysis 10 -weight 1
	incr pnum

	# Results data page
	set pg_results [$pages insert $pnum pg_results -text [= {RESULTS}]]
	prbdatwin::results_data $pg_results $tags
	grid columnconfigure $pg_results 0 -weight 1
#        grid rowconfigure $pg_results 10 -weight 1
	incr pnum

	# Fluid Solver Page
	if { $show_fluid == 1 } {
	    incr pnum
	    set pvar "pg_fluid_solver"
	    set fpvar "fpg_fluid_solver"
	    set $pvar [$pages insert $pnum $pvar -text [= {FLUID SOLVER}]]
	    set $fpvar [$pages getframe $pvar]
	    grid columnconf $fpg_fluid_solver 0 -weight 1
	    grid rowconf $fpg_fluid_solver 10 -weight 1
	    prbdatwin::fluid_solver $pg_fluid_solver $tags
	}
	
	# Solid Solver Page
	if { $show_solid == 1 } {
	    incr pnum
	    set pvar "pg_solid_solver"
	    set fpvar "fpg_solid_solver"
	    set $pvar [$pages insert $pnum $pvar -text [= {SOLID SOLVER}]]
	    set $fpvar [$pages getframe $pvar]
	    grid columnconf $fpg_solid_solver 0 -weight 1
	    grid rowconf $fpg_solid_solver 10 -weight 1
	    prbdatwin::solid_solver $pg_solid_solver $tags
	}

	# Other data page 
	if { $show_ransol == 1 && $show_ursolver == 1 } {
	    set pg_other [$pages insert $pnum pg_other -text [= {OTHER}]]
	    prbdatwin::other_data $pg_other $tags
	    grid columnconfigure $pg_other 0 -weight 1
	    #        grid rowconfigure $pg_other 10 -weight 1
	    incr pnum
	}

	# Buttons frame
	set bf [frame $prb.bf -relief raised -takefocus 1]
	# Accept button
	set btn_accept [button $bf.btn_accept -text [= {Accept Data}] -underline 0 \
		-width 10 -relief raised -bd 1 -highlightthickness 1 -takefocus 1 \
		-command "$acceptcmd"]
	# Close button
	set btn_close [button $bf.btn_close -text [= {Close}] -underline 0 -width 10 \
		-relief raised -bd 1 -highlightthickness 1 -takefocus 1 \
		-command "$closecmd"]

	# GRIDS
	grid $bf -row 2 -column 0 -sticky news
	grid $btn_accept -row 0 -column 1 -sticky ew -padx 5 -pady 5
	grid $btn_close -row 0 -column 2 -sticky ew -padx 5 -pady 5

	# BINDS
	bind $prb <Escape> "tkButtonInvoke $btn_close"
	bind $prb <Alt-c> "tkButtonInvoke $btn_close"
	bind $prb <Alt-a> "tkButtonInvoke $btn_accept"

	$pages compute_size

	focus $prb

	return 1
    }
}

################################################################################
#
#   Problem data
#
################################################################################

proc prbdatwin::problem_data { page tags } {
 
    # Tdyn settings
    variable show_fluid
    variable show_solid
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_alemesh
    variable show_naval 
    variable show_ramsolid
    variable show_vof

    if { $show_fluid == 1 } {
	# Title Frame Fluid
	set tfr_fluid [TitleFrame $page.f -relief ridge -bd 3\
		-text "Fluid Problems" -side left ]
	set fframe [$tfr_fluid getframe]
	GidHelp $tfr_fluid [= {Select problems to be solved in Fluid domain}]
	grid $tfr_fluid -row 0 -column 0 -sticky nwe -pady 5
	
	# Fluid Fields
	set irow 0
	set chk1 [checkbutton $fframe.chk1 -text [= {Solve Fluid }] \
		-variable prbdatwin::Solve_Fluid -offvalue "No" -onvalue "Yes" \
		-command "prbdatwin::LinkProblem $fframe \$prbdatwin::Solve_Fluid"]
	grid $chk1 -row [incr irow] -column 0 -sticky nw
	if { $show_ransol == 1 } {
	    set chk2 [checkbutton $fframe.chk2 -text [= {Solve Fluid Flow }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_FluidFlow_in_Fluid]
	    grid $chk2 -row [incr irow] -column 0 -padx 10 -sticky nw
	    set chk8 [checkbutton $fframe.chk8 -text [= {Solve Fluid Compressibility}] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_Compressibility_in_Fluid]
	    grid $chk8 -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	if { $show_heatrans == 1 } {
	    set chk3 [checkbutton $fframe.chk3 -text [= {Solve Temperature }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_Temperature_in_Fluid]
	    grid $chk3 -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	if { $show_advect == 1 } {
	    set chk4 [checkbutton $fframe.chk4 -text [= {Solve Species Concentration }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_SpeciesConcentration_in_Fluid]
	    grid $chk4 -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	if { $show_ursolver == 1 } {
	    set chk5 [checkbutton $fframe.chk5 -text [= {Solve Phi Problems }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_PhiProblems_in_Fluid]
	    grid $chk5 -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	if { $show_vof == 1 } {
	    set chk5b [checkbutton $fframe.chk5b -text [= {Solve VolumeOfFluid Problems }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_VolumeOfFluid_in_Fluid]
	    grid $chk5b -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	if { $show_alemesh == 1 } {
	    set chk6 [checkbutton $fframe.chk6 -text [= {Solve Mesh Deformation }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_MeshDeformation_in_Fluid]
	    grid $chk6 -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	if { $show_naval == 1 } {
	    set chk7 [checkbutton $fframe.chk7 -text [= {Solve Transpiration }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_Transpiration_in_Fluid]
	    grid $chk7 -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	# By default options
	LinkProblem $fframe $prbdatwin::Solve_Fluid
	
	grid columnconfigure $fframe 10 -weight 1
    }
    if { $show_solid == 1 } {
	# Title Frame Solid
	set tfr_solid [TitleFrame $page.s -relief ridge -bd 3\
		-text [= {Solid Problems}] -side left ]
	set sframe [$tfr_solid getframe]
	GidHelp $tfr_solid [= {Select problems to be solved in Solid domain}]
	grid $tfr_solid -row 1 -column 0 -sticky nwe -pady 5
	
	# Solid Fields
	set irow 0
	set chk1 [checkbutton $sframe.chk1 -text [= {Solve Solid }] \
		-variable prbdatwin::Solve_Solid -offvalue "No" -onvalue "Yes" \
		-command "prbdatwin::LinkProblem $sframe \$prbdatwin::Solve_Solid"]
	grid $chk1 -row [incr irow] -column 0 -sticky nw
	if { $show_ransol == 1 } {
	    set chk2 [checkbutton $sframe.chk2 -text [= {Solve Fluid Flow }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_FluidFlow_in_Solid]
	    grid $chk2 -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	if { $show_heatrans == 1 } {
	    set chk3 [checkbutton $sframe.chk3 -text [= {Solve Temperature }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_Temperature_in_Solid]
	    grid $chk3 -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	if { $show_advect == 1 } {
	    set chk4 [checkbutton $sframe.chk4 -text [= {Solve Species Concentration }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_SpeciesConcentration_in_Solid]
	    grid $chk4 -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	if { $show_ursolver == 1 } {
	    set chk5 [checkbutton $sframe.chk5 -text [= {Solve Phi Problems }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_PhiProblems_in_Solid]
	    grid $chk5 -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	if { $show_alemesh == 1 } {
	    set chk6 [checkbutton $sframe.chk6 -text [= {Solve Mesh Deformation }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_MeshDeformation_in_Solid]
	    grid $chk6 -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	if { $show_ramsolid == 1 } {
	    set chk7 [checkbutton $sframe.chk7 -text [= {Solve Structural Problem }] \
		    -offvalue "No" -onvalue "Yes" \
		    -variable prbdatwin::Solve_StructuralProblem_in_Solid]
	    grid $chk7 -row [incr irow] -column 0 -padx 10 -sticky nw
	}
	# By default options
	if { $show_fluid == 0 } {
	    if { $prbdatwin::Solve_Fluid == "Yes" || $prbdatwin::Solve_FluidFlow_in_Fluid  == "Yes" } {
		WarnWin [= {Solve Fluid problem is switched off}]
	    }
	    set prbdatwin::Solve_Fluid "No"
	    set prbdatwin::Solve_FluidFlow_in_Fluid "No"
	}
	LinkProblem $sframe $prbdatwin::Solve_Solid
	
	grid columnconfigure $sframe 10 -weight 1
    }
}

proc prbdatwin::LinkProblem { frame value } {
    set chklist [list chk2 chk3 chk4 chk5 chk5b chk6 chk7 chk8]
    if { $value=="No" } {
	foreach chki $chklist {
	    if { [winfo exists $frame.$chki] } {
		$frame.$chki deselect 
		$frame.$chki configure -state disabled
	    }
	}
    } else {
	foreach chki $chklist {
	    if { [winfo exists $frame.$chki] } {
		$frame.$chki configure -state active
	    }
	}
    }
}


################################################################################
#
#   Analysis data
#
################################################################################

proc prbdatwin::analysis_data { page tags } {

    # Tdyn Settings
    variable edit_units

    variable predefined_anl_ff
    variable analysis_ff

    variable Analysis_Prbdata
    foreach item $Analysis_Prbdata {
	variable [lindex $item 0]
    }
    variable Analysis_Unitsdata
    foreach item $Analysis_Unitsdata {
	variable [lindex $item 0]
    }
    #####  HELP Text variables #####
    set help_Number_of_Steps \
	"[= {Number of steps of the simulation}].\n[= {Total physical time will be Number_of_Steps X Time_increment}]."
    set help_Time_increment \
	"[= {Time increment per time step}].\n[= {Recommended value dt = CL/V \
	    (being L a characteristic length and 0.1 < C < 0.01)}].\n[= {May be a constant or a funtion of time ( i.e. interpolate(#0.0,0.1,1.0,0.2#t)}]"
    set help_Max_Iterations \
	"[= {Maximum number of iterations of the non linear loop (recommended values for\
	    fully implicit schemes are between 3 to 10, if 1 is selected, fractional step method is used)}]."
    set help_Initial_Steps \
	"[= {During first 'Initial_Steps' steps some controls are carried out}]."
    set help_Start_Up_Control \
	"[= {If selected, during first 'Initial Steps' steps the start up process is smoothed}].\n\
	[= {This can be done by creating an acceleration on the flow (Speed) or by gradually incrementing the time step size}]."
    set help_Restart \
	"[= {If marked Yes the restart file is used to define the initial data}].\n[= {The Restart file taken is 'ProblemName.flavia.rst'}]"
    set help_btn_func \
	"[= {Custom Function Editor}].\n[= {Edit a function and transfer it automatically to a field}].\n[= {You can also RIGHT-CLICK a field to open the Function Editor}]."

    lappend vals_Time_increment_Units "s" "cs" "ms"
    lappend vals_Start_Up_Control "None" "Time" "Speed" "Both"
    lappend vals_Restart "Off" "On"

    # Title Frame
    set tframe [TitleFrame $page.f -relief ridge -text [= {Analysis Parameters}]]
    set frame [$tframe getframe]
    # Number of Steps
    set l_Number_of_Steps [Label $frame.l_nos \
	    -text [= {Number of Steps }] -helptext $help_Number_of_Steps]
    set e_Number_of_Steps [entry $frame.e_nos -textvariable prbdatwin::Number_of_Steps]
    # Time Increment
    set l_Time_increment [Label $frame.l_tin \
	    -text [= {Time increment }] -helptext $help_Time_increment]
    set e_Time_increment [entry $frame.e_tin -textvariable prbdatwin::Time_increment]
    set e_Time_increment_Units [ComboBox $frame.e_timu -values $vals_Time_increment_Units \
	    -editable $edit_units -width [TDYN_getcbxsize 5 $vals_Time_increment_Units 0] \
	    -textvariable prbdatwin::Time_increment_Units]
    # Max Iterations
    set l_Max_Iterations [Label $frame.l_mit \
	    -text [= {Max Iterations }] -helptext $help_Max_Iterations]
    set e_Max_Iterations [entry $frame.e_mit -textvariable prbdatwin::Max_Iterations]
    # Initial Steps
    set l_Initial_Steps [Label $frame.l_ist \
	    -text [= {Initial Steps }] -helptext $help_Initial_Steps]
    set e_Initial_Steps [entry $frame.e_ist -textvariable prbdatwin::Initial_Steps]
    # Start Up Control
    set l_Start_Up_Control [Label $frame.l_str \
	    -text [= {Start-up control }] -helptext $help_Start_Up_Control]
    set e_Start_Up_Control [ComboBox $frame.e_str -values $vals_Start_Up_Control \
	    -editable false -width [TDYN_getcbxsize 10 $vals_Start_Up_Control] \
	    -textvariable prbdatwin::Start_Up_Control -takefocus 1]
    # Restart
    set l_Restart [Label $frame.l_res \
	    -text [= {Restart }] -helptext $help_Restart]
    set e_Restart [ComboBox $frame.e_res -values $vals_Restart \
	    -editable false -width [TDYN_getcbxsize 10 $vals_Restart] \
	    -textvariable prbdatwin::Restart -takefocus 1]
    
    # Buttons frame
    set bf [frame $frame.bf -relief raised -takefocus 1]
    # Editor button
    set btn_functions [Button $bf.btn_func -underline 0 \
	    -command "FEditor::init $page \"$predefined_anl_ff\" \"\" \"SELECT FIELD\" \"\" \"$analysis_ff\" \"\"" \
	    -image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]
    GidHelp $btn_functions $help_btn_func
    
    # GRIDS
    grid $tframe -row 0 -column 0 -sticky ewn

    set row 0
    foreach item $Analysis_Prbdata {
	set itt [lindex $item 0]
	set lvar "l_$itt"
	set evar "e_$itt"
	grid [eval set temp $$lvar] -row $row -column 0 -sticky en -pady 2
	grid [eval set temp $$evar] -row $row -column 1 -sticky wn -pady 2
	set units ${evar}_Units
	if { [info exist $units] } {
	    grid [eval set temp $$units] -row $row -column 2 -sticky en -pady 2
	}
	set help "help_$itt"
	if { [info exist $help] } {
	    GidHelp [eval set temp $$lvar] [eval set temp $$help]
	    GidHelp [eval set temp $$evar] [eval set temp $$help]
	}
	incr row
    }
    
    grid $bf -row $row -column 1 -sticky nw
    grid $btn_functions -row 0 -column 0 -sticky nw -pady 3 -padx 2
    bind $e_Time_increment <ButtonPress-3> \
	"prbdatwin::popupmenu $page prbdatwin::Time_increment \"Time_increment\" \"\" 1 %X %Y"
}

################################################################################
#
#   Results data
#
################################################################################

proc prbdatwin::results_data { page tags } {
 
    # Tdyn settings
    variable show_fluid
    variable show_solid
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_alemesh
    variable show_naval

    variable predefined_ff
    variable results_ursolver_ff
    variable results_fursolver_ff
    variable results_sursolver_ff

    variable Results_Prbdata
    foreach item $Results_Prbdata {
	variable [lindex $item 0]
    }

    set help_Output_Step \
	    "[= {Each Output_Step time steps the results will be written}]."
    set help_Output_Start \
	    "[= {The results will be written each 'Output_Step' time steps after 'Output_Start' steps}]."
    set help_Results_File \
	    "[= {Type of the results file (binary, ascii or ascii compressed)}].\n[= {Binary type should be selected when large results file is expected}]."
    set help_btn_func \
	"[= {Custom Function Editor}].\n[= {Edit a function and transfer it automatically to a field}].\n[= {You can also RIGHT-CLICK a field to open the Function Editor}]."

#    lappend vals_Results_File "Binary" "Ascii" "AsciiZipped"
    lappend vals_Results_File "Binary" "Ascii"

    # Title Frame
    set tframe [TitleFrame $page.f -relief ridge -text [= {Results data}]]
    set frame [$tframe getframe]
    # OutPut Step
    set l_Output_Step [Label $frame.l_ostep \
	    -text [= {Output Step }] -helptext $help_Output_Step]
    set e_Output_Step [entry $frame.e_ostep -textvariable prbdatwin::Output_Step]
    # OutPut Start
    set l_Output_Start [Label $frame.l_ostart \
	    -text [= {Output Start }] -helptext $help_Output_Start]
    set e_Output_Start [entry $frame.e_ostart -textvariable prbdatwin::Output_Start]
    # Results File
    set l_Results_File [Label $frame.l_rfile \
	    -text [= {Results File }] -helptext $help_Results_File]
    set e_Results_File [ComboBox $frame.e_rfile -values $vals_Results_File \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Results_File] \
	    -textvariable prbdatwin::Results_File]
    # Gridding
    grid $l_Output_Step -row 0 -column 0 -sticky en -pady 2
    grid $e_Output_Step -row 0 -column 1 -sticky wn -pady 2
    grid $l_Output_Start -row 1 -column 0 -sticky en -pady 2
    grid $e_Output_Start -row 1 -column 1 -sticky wn -pady 2
    grid $l_Results_File -row 2 -column 0 -sticky en -pady 2
    grid $e_Results_File -row 2 -column 1 -sticky wn -pady 2
    grid $tframe -row 0 -column 0 -sticky ewn

    # Scrollable Frame
    set scrwindow [ScrolledWindow $page.g -relief ridge -bd 2]
    set scrframe [ScrollableFrame $scrwindow.f]
    $scrwindow setwidget $scrframe
    set sframe [$scrframe getframe]
    grid $scrwindow -row 1 -column 0 -sticky ewsn -pady 4
    grid rowconfigure $page 1 -weight 1

    if { $show_ransol == 1 } {
	# Title Frame RANSOL
	set tframe [TitleFrame $sframe.ransol -relief ridge -text [= {RANSOL Results}]]
	set frame [$tframe getframe]
	set irow 0
	foreach item $Results_Prbdata {
	    if { [lindex $item 4] == "ransol" } {
		set name [lindex $item 0]
		set c_$name [checkbutton $frame.c_$name -text "[lindex $item 1] " \
		        -variable prbdatwin::$name]
		grid [eval set temp \$c_$name] -row [incr irow] -column 0 -sticky nw
	    }
	}
	grid $tframe -row 1 -column 0 -sticky ewsn -pady 4 -padx 4
	grid rowconfigure $frame $irow -weight 1
    }

    if { $show_heatrans == 1 } {
	# Title Frame HEATRANS
	set tframe [TitleFrame $sframe.heatrans -relief ridge -text [= {HEATRANS Results}]]
	set frame [$tframe getframe]
	set irow 0
	foreach item $Results_Prbdata {
	    if { [lindex $item 4] == "heatrans" } {
		set name [lindex $item 0]
		set c_$name [checkbutton $frame.c_$name -text "[lindex $item 1] " \
		        -variable prbdatwin::$name]
		grid [eval set temp \$c_$name] -row [incr irow] -column 0 -sticky nw
	    }
	}
	grid $tframe -row 1 -column 1 -sticky ewsn -pady 4 -padx 4
	grid rowconfigure $frame $irow -weight 1
    }

    if { $show_advect == 1 } {
	# Title Frame ADVECT
	set tframe [TitleFrame $sframe.advect -relief ridge -text [= {ADVECT Results}]]
	set frame [$tframe getframe]
	set irow 0
	foreach item $Results_Prbdata {
	    if { [lindex $item 4] == "advect" } {
		set name [lindex $item 0]
		set c_$name [checkbutton $frame.c_$name -text "[lindex $item 1] " \
		        -variable prbdatwin::$name]
		grid [eval set temp \$c_$name] -row [incr irow] -column 0 -sticky nw
	    }
	}
	grid $tframe -row 1 -column 2 -sticky ewsn -pady 4 -padx 4
	grid rowconfigure $frame $irow -weight 1
    }

    # Title Frame URSOLVER
    set tframe [TitleFrame $sframe.ursolver -relief ridge -text [= {URSOLVER Results}]]
    set frame [$tframe getframe]
    if { $show_ursolver == 1 } {
	set c_phi [checkbutton $frame.c_phi -text [= {Phi Variable }] \
		-variable prbdatwin::VariableResult]
    }
    if { $show_fluid } {
	set ln_udf1 [Label $frame.ln_udf1 -text [= {Name }]]
	set en_udf1 [entry $frame.en_udf1 -textvariable prbdatwin::FluidFunction1_Name]
	set lf_udf1 [Label $frame.lf_udf1 -text [= {Function }]]
	set ef_udf1 [entry $frame.ef_udf1 -textvariable prbdatwin::FluidFunction1]
	set c_udf1 [checkbutton $frame.c_udf1 -text [= {Fluid Function #1 }] \
		-variable prbdatwin::UserDefinedF1]
	set cmd "HideShow \${prbdatwin::UserDefinedF1} \[list $ln_udf1 $en_udf1 $lf_udf1 $ef_udf1\]"
	append cmd "; prbdatwin::managedependencies $frame $c_udf1 \"ursrf1\" prbdatwin::UserDefinedF1"
	append cmd "; prbdatwin::managedependencies $frame \"\" \"ursrall\" \"\""
	$c_udf1 configure -command $cmd
	
	set ln_udf2 [Label $frame.ln_udf2 -text [= {Name }]]
	set en_udf2 [entry $frame.en_udf2 -textvariable prbdatwin::FluidFunction2_Name]
	set lf_udf2 [Label $frame.lf_udf2 -text [= {Function }]]
	set ef_udf2 [entry $frame.ef_udf2 -textvariable prbdatwin::FluidFunction2]
	set c_udf2 [checkbutton $frame.c_udf2 -text [= {Fluid Function #2 }] \
		-variable prbdatwin::UserDefinedF2]
	set cmd "HideShow \${prbdatwin::UserDefinedF2} \[list $ln_udf2 $en_udf2 $lf_udf2 $ef_udf2\]"
	append cmd "; prbdatwin::managedependencies $frame $c_udf2 \"ursrf2\" prbdatwin::UserDefinedF2"
	append cmd "; prbdatwin::managedependencies $frame \"\" \"ursrall\" \"\""
	$c_udf2 configure -command $cmd
	
	set ln_udf3 [Label $frame.ln_udf3 -text [= {Name }]]
	set en_udf3 [entry $frame.en_udf3 -textvariable prbdatwin::FluidFunction3_Name]
	set lf_udf3 [Label $frame.lf_udf3 -text [= {Function }]]
	set ef_udf3 [entry $frame.ef_udf3 -textvariable prbdatwin::FluidFunction3]
	set c_udf3 [checkbutton $frame.c_udf3 -text [= {Fluid Function #3 }] \
		-variable prbdatwin::UserDefinedF3]
	set cmd "HideShow \${prbdatwin::UserDefinedF3} \[list $ln_udf3 $en_udf3 $lf_udf3 $ef_udf3\]"
	append cmd "; prbdatwin::managedependencies $frame $c_udf3 \"ursrf3\" prbdatwin::UserDefinedF3"
	append cmd "; prbdatwin::managedependencies $frame \"\" \"ursrall\" \"\""
	$c_udf3 configure -command $cmd
    }
    if { $show_solid } {
	set ln_uds1 [Label $frame.ln_uds1 -text [= {Name }]]
	set en_uds1 [entry $frame.en_uds1 -textvariable prbdatwin::SolidFunction1_Name]
	set lf_uds1 [Label $frame.lf_uds1 -text [= {Function }]]
	set ef_uds1 [entry $frame.ef_uds1 -textvariable prbdatwin::SolidFunction1]
	set c_uds1 [checkbutton $frame.c_uds1 -text [= {Solid Function #1 }] \
		-variable prbdatwin::UserDefinedS1]
	set cmd "HideShow \${prbdatwin::UserDefinedS1} \[list $ln_uds1 $en_uds1 $lf_uds1 $ef_uds1\]"
	append cmd "; prbdatwin::managedependencies $frame $c_uds1 \"ursrs1\" prbdatwin::UserDefinedS1"
	append cmd "; prbdatwin::managedependencies $frame \"\" \"ursrall\" \"\""
	$c_uds1 configure -command $cmd
	
	set ln_uds2 [Label $frame.ln_uds2 -text [= {Name }]]
	set en_uds2 [entry $frame.en_uds2 -textvariable prbdatwin::SolidFunction2_Name]
	set lf_uds2 [Label $frame.lf_uds2 -text [= {Function }]]
	set ef_uds2 [entry $frame.ef_uds2 -textvariable prbdatwin::SolidFunction2]
	set c_uds2 [checkbutton $frame.c_uds2 -text [= {Solid Function #2 }] \
		-variable prbdatwin::UserDefinedS2]
	set cmd "HideShow \${prbdatwin::UserDefinedS2} \[list $ln_uds2 $en_uds2 $lf_uds2 $ef_uds2\]"
	append cmd "; prbdatwin::managedependencies $frame $c_uds2 \"ursrs2\" prbdatwin::UserDefinedS2"
	append cmd "; prbdatwin::managedependencies $frame \"\" \"ursrall\" \"\""
	$c_uds2 configure -command $cmd
	
	set ln_uds3 [Label $frame.ln_uds3 -text [= {Name }]]
	set en_uds3 [entry $frame.en_uds3 -textvariable prbdatwin::SolidFunction3_Name]
	set lf_uds3 [Label $frame.lf_uds3 -text [= {Function }]]
	set ef_uds3 [entry $frame.ef_uds3 -textvariable prbdatwin::SolidFunction3]
	set c_uds3 [checkbutton $frame.c_uds3 -text [= {Solid Function #3 }] \
		-variable prbdatwin::UserDefinedS3]
	set cmd "HideShow \${prbdatwin::UserDefinedS3} \[list $ln_uds3 $en_uds3 $lf_uds3 $ef_uds3\]"
	append cmd "; prbdatwin::managedependencies $frame $c_uds3 \"ursrs3\" prbdatwin::UserDefinedS3"
	append cmd "; prbdatwin::managedependencies $frame \"\" \"ursrall\" \"\""
	$c_uds3 configure -command $cmd
    }
    GidHelpRecursive $scrwindow "[= {Select results to be written in the output file and visualised in the postprocessing part}]."
    
    # Buttons frame
    set bf [frame $frame.bf -relief raised -takefocus 1]
    # Editor button
    if { $show_fluid & $show_solid } {
	set btn_functions [Button $bf.btn_func -underline 0 \
		-command "FEditor::init $page \"$predefined_ff\" \"\" \"SELECT FIELD\" \"\" \"\$prbdatwin::results_ursolver_ff\" \"\"" \
		-image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]
    } elseif { $show_fluid } {
	set btn_functions [Button $bf.btn_func -underline 0 \
		-command "FEditor::init $page \"$predefined_ff\" \"\" \"SELECT FIELD\" \"\" \"\$prbdatwin::results_fursolver_ff\" \"\"" \
		-image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]
    } else {
	set btn_functions [Button $bf.btn_func -underline 0 \
		-command "FEditor::init $page \"$predefined_ff\" \"\" \"SELECT FIELD\" \"\" \"\$prbdatwin::results_sursolver_ff\" \"\"" \
		-image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]
    }
    GidHelp $btn_functions $help_btn_func

    set irow 0
    if { $show_ursolver == 1 } {
	grid $c_phi -row $irow -column 0 -sticky nw -columnspan 2
    }
    if { $show_fluid } {
	grid $c_udf1 -row [incr irow] -column 0 -sticky nw -columnspan 2
	grid $ln_udf1 -row [incr irow] -column 0 -sticky nw
	grid $en_udf1 -row $irow -column 1 -sticky nw
	grid $lf_udf1 -row [incr irow] -column 0 -sticky nw
	grid $ef_udf1 -row $irow -column 1 -sticky nw
	grid $c_udf2 -row [incr irow] -column 0 -sticky nw -columnspan 2
	grid $ln_udf2 -row [incr irow] -column 0 -sticky nw
	grid $en_udf2 -row $irow -column 1 -sticky nw
	grid $lf_udf2 -row [incr irow] -column 0 -sticky nw
	grid $ef_udf2 -row $irow -column 1 -sticky nw
	grid $c_udf3 -row [incr irow] -column 0 -sticky nw -columnspan 2
	grid $ln_udf3 -row [incr irow] -column 0 -sticky nw
	grid $en_udf3 -row $irow -column 1 -sticky nw
	grid $lf_udf3 -row [incr irow] -column 0 -sticky nw
	grid $ef_udf3 -row $irow -column 1 -sticky nw
	HideShow ${prbdatwin::UserDefinedF1} [list $ln_udf1 $en_udf1 $lf_udf1 $ef_udf1]
	HideShow ${prbdatwin::UserDefinedF2} [list $ln_udf2 $en_udf2 $lf_udf2 $ef_udf2]
	HideShow ${prbdatwin::UserDefinedF3} [list $ln_udf3 $en_udf3 $lf_udf3 $ef_udf3]
	prbdatwin::managedependencies $frame $c_udf1 "ursrf1" prbdatwin::UserDefinedF1
	prbdatwin::managedependencies $frame $c_udf2 "ursrf2" prbdatwin::UserDefinedF2
	prbdatwin::managedependencies $frame $c_udf3 "ursrf3" prbdatwin::UserDefinedF3
	bind $ef_udf1 <ButtonPress-3> \
	    "prbdatwin::popupmenu $page prbdatwin::FluidFunction1 \"Fluid Function #1\" \"\" 1 %X %Y"
	bind $ef_udf2 <ButtonPress-3> \
	    "prbdatwin::popupmenu $page prbdatwin::FluidFunction2 \"Fluid Function #2\" \"\" 1 %X %Y"
	bind $ef_udf3 <ButtonPress-3> \
	    "prbdatwin::popupmenu $page prbdatwin::FluidFunction3 \"Fluid Function #3\" \"\" 1 %X %Y"
    }
    if { $show_solid } {
	grid $c_uds1 -row [incr irow] -column 0 -sticky nw -columnspan 2
	grid $ln_uds1 -row [incr irow] -column 0 -sticky nw
	grid $en_uds1 -row $irow -column 1 -sticky nw
	grid $lf_uds1 -row [incr irow] -column 0 -sticky nw
	grid $ef_uds1 -row $irow -column 1 -sticky nw
	grid $c_uds2 -row [incr irow] -column 0 -sticky nw -columnspan 2
	grid $ln_uds2 -row [incr irow] -column 0 -sticky nw
	grid $en_uds2 -row $irow -column 1 -sticky nw
	grid $lf_uds2 -row [incr irow] -column 0 -sticky nw
	grid $ef_uds2 -row $irow -column 1 -sticky nw
	grid $c_uds3 -row [incr irow] -column 0 -sticky nw -columnspan 2
	grid $ln_uds3 -row [incr irow] -column 0 -sticky nw
	grid $en_uds3 -row $irow -column 1 -sticky nw
	grid $lf_uds3 -row [incr irow] -column 0 -sticky nw
	grid $ef_uds3 -row $irow -column 1 -sticky nw
	HideShow ${prbdatwin::UserDefinedS1} [list $ln_uds1 $en_uds1 $lf_uds1 $ef_uds1]
	HideShow ${prbdatwin::UserDefinedS2} [list $ln_uds2 $en_uds2 $lf_uds2 $ef_uds2]
	HideShow ${prbdatwin::UserDefinedS3} [list $ln_uds3 $en_uds3 $lf_uds3 $ef_uds3]
	prbdatwin::managedependencies $frame $c_uds1 "ursrs1" prbdatwin::UserDefinedS1
	prbdatwin::managedependencies $frame $c_uds2 "ursrs2" prbdatwin::UserDefinedS2
	prbdatwin::managedependencies $frame $c_uds3 "ursrs3" prbdatwin::UserDefinedS3
	bind $ef_uds1 <ButtonPress-3> \
	    "prbdatwin::popupmenu $page prbdatwin::SolidFunction1 \"Solid Function #1\" \"\" 1 %X %Y"
	bind $ef_uds2 <ButtonPress-3> \
	    "prbdatwin::popupmenu $page prbdatwin::SolidFunction2 \"Solid Function #2\" \"\" 1 %X %Y"
	bind $ef_uds3 <ButtonPress-3> \
	    "prbdatwin::popupmenu $page prbdatwin::SolidFunction3 \"Solid Function #3\" \"\" 1 %X %Y"
    }
    # Buttons Frame
    grid $bf -row 100 -column 0 -sticky nws
    grid rowconfigure $bf 0 -weight 1
    # Function Editor Button
    grid $btn_functions -row 0 -column 0 -sticky wn -pady 3 -padx 2
    
    grid $tframe -row 1 -column 3 -sticky ewsn -pady 4 -padx 4
    grid rowconfigure $frame 100 -weight 1
    
    # Configure Function Editor variables list and hide/show functions button.
    prbdatwin::managedependencies $frame "" "ursrall" ""
    
     if { $show_alemesh == 1 } {
	# Title Frame ALEMESH
	set tframe [TitleFrame $sframe.alemesh -relief ridge -text [= {ALEMESH Results}]]
	set frame [$tframe getframe]
	set irow 0
	foreach item $Results_Prbdata {
	    if { [lindex $item 4] == "alemesh" } {
		set name [lindex $item 0]
		set c_$name [checkbutton $frame.c_$name -text "[lindex $item 1] " \
		        -variable prbdatwin::$name]
		grid [eval set temp \$c_$name] -row [incr irow] -column 0 -sticky nw
	    }
	}
	grid $tframe -row 1 -column 4 -sticky ewsn -pady 4 -padx 4
	grid rowconfigure $frame $irow -weight 1
    }

    if { $show_naval == 1 } {
	# Title Frame NAVAL
	set tframe [TitleFrame $sframe.naval -relief ridge -text [= {NAVAL Results}]]
	set frame [$tframe getframe]
	set irow 0
	foreach item $Results_Prbdata {
	    if { [lindex $item 4] == "naval" } {
		set name [lindex $item 0]
		set c_$name [checkbutton $frame.c_$name -text "[lindex $item 1] " \
		        -variable prbdatwin::$name]
		grid [eval set temp \$c_$name] -row [incr irow] -column 0 -sticky nw
	    }
	}
	grid $tframe -row 1 -column 5 -sticky ewsn -pady 4 -padx 4
	grid rowconfigure $frame $irow -weight 1
    }
}

proc HideShow { value hslist } {

    if { $value == 1 || $value == "Yes" || $value == "yes" } {
	foreach item $hslist {
	    grid $item
	}
    } else {
	 foreach item $hslist {
	    grid remove $item
	}
    }

    return 1
}

proc prbdatwin::managedependencies { parent manpath man tag } {

    variable results_ursolver_ff
    variable Results_Prbdata

    set itposf 0
    set itpos 0

    switch $man {
	"ursrf1" {
	    eval set value $$tag
	    foreach item $Results_Prbdata {
		if { [lindex $item 0] == "FluidFunction1" } {
		    set itposf 1
		    break
		}
		incr itpos
	    }
	    if { $value == 1 || $value == "Yes" || $value == "yes" } {
		if { [lsearch -exact $results_ursolver_ff "prbdatwin::FluidFunction1"] == -1 } {
		    set results_ursolver_ff \
		            [linsert $results_ursolver_ff end \
		            "prbdatwin::FluidFunction1" "Fluid Function #1"]
		}
		if { $itposf == 1 } {
		    set Results_Prbdata [lreplace $Results_Prbdata $itpos $itpos \
		            [lreplace [lindex $Results_Prbdata $itpos] 3 3 1]]
		}
	    } else {
		set pos [lsearch -exact $results_ursolver_ff "prbdatwin::FluidFunction1"]
		if { $pos != -1 } {
		    set results_ursolver_ff [lreplace $results_ursolver_ff $pos [expr $pos + 1]]
		}
		if { $itposf == 1 } {
		    set Results_Prbdata [lreplace $Results_Prbdata $itpos $itpos \
		            [lreplace [lindex $Results_Prbdata $itpos] 3 3 0]]
		}
	    }
	}
	"ursrf2" {
	    eval set value $$tag
	    foreach item $Results_Prbdata {
		if { [lindex $item 0] == "FluidFunction2" } {
		    set itposf 1
		    break
		}
		incr itpos
	    }
	    if { $value == 1 || $value == "Yes" || $value == "yes" } {
		if { [lsearch -exact $results_ursolver_ff "prbdatwin::FluidFunction2"] == -1 } {
		    set results_ursolver_ff \
		            [linsert $results_ursolver_ff end \
		            "prbdatwin::FluidFunction2" "Fluid Function #2"]
		}
		if { $itposf == 1 } {
		    set Results_Prbdata [lreplace $Results_Prbdata $itpos $itpos \
		            [lreplace [lindex $Results_Prbdata $itpos] 3 3 1]]
		}
	    } else {
		set pos [lsearch -exact $results_ursolver_ff "prbdatwin::FluidFunction2"]
		if { $pos != -1 } {
		    set results_ursolver_ff [lreplace $results_ursolver_ff $pos [expr $pos + 1]]
		}
		if { $itposf == 1 } {
		    set Results_Prbdata [lreplace $Results_Prbdata $itpos $itpos \
		            [lreplace [lindex $Results_Prbdata $itpos] 3 3 0]]
		}
	    }
	}
	"ursrf3" {
	    eval set value $$tag
	    foreach item $Results_Prbdata {
		if { [lindex $item 0] == "FluidFunction3" } {
		    set itposf 1
		    break
		}
		incr itpos
	    }
	    if { $value == 1 || $value == "Yes" || $value == "yes" } {
		if { [lsearch -exact $results_ursolver_ff "prbdatwin::FluidFunction2"] == -1 } {
		    set results_ursolver_ff \
		            [linsert $results_ursolver_ff end \
		            "prbdatwin::FluidFunction3" "Fluid Function #3"]
		}
		if { $itposf == 1 } {
		    set Results_Prbdata [lreplace $Results_Prbdata $itpos $itpos \
		            [lreplace [lindex $Results_Prbdata $itpos] 3 3 1]]
		}
	    } else {
		set pos [lsearch -exact $results_ursolver_ff "prbdatwin::FluidFunction3"]
		if { $pos != -1 } {
		    set results_ursolver_ff [lreplace $results_ursolver_ff $pos [expr $pos + 1]]
		}
		if { $itposf == 1 } {
		    set Results_Prbdata [lreplace $Results_Prbdata $itpos $itpos \
		            [lreplace [lindex $Results_Prbdata $itpos] 3 3 0]]
		}
	    }
	}
	"ursrs1" {
	    foreach item $Results_Prbdata {
		if { [lindex $item 0] == "SolidFunction1" } {
		    set itposf 1
		    break
		}
		incr itpos
	    }
	    eval set value $$tag
	    if { $value == 1 || $value == "Yes" || $value == "yes" } {
		if { [lsearch -exact $results_ursolver_ff "prbdatwin::SolidFunction1"] == -1 } {
		    set results_ursolver_ff \
		            [linsert $results_ursolver_ff end \
		            "prbdatwin::SolidFunction1" "Solid Function #1"]
		}
		if { $itposf == 1 } {
		    set Results_Prbdata [lreplace $Results_Prbdata $itpos $itpos \
		            [lreplace [lindex $Results_Prbdata $itpos] 3 3 1]]
		}
	    } else {
		set pos [lsearch -exact $results_ursolver_ff "prbdatwin::SolidFunction1"]
		if { $pos != -1 } {
		    set results_ursolver_ff [lreplace $results_ursolver_ff $pos [expr $pos + 1]]
		}
		if { $itposf == 1 } {
		    set Results_Prbdata [lreplace $Results_Prbdata $itpos $itpos \
		            [lreplace [lindex $Results_Prbdata $itpos] 3 3 0]]
		}
	    }
	}
	"ursrs2" {
	    foreach item $Results_Prbdata {
		if { [lindex $item 0] == "SolidFunction2" } {
		    set itposf 1
		    break
		}
		incr itpos
	    }
	    eval set value $$tag
	    if { $value == 1 || $value == "Yes" || $value == "yes" } {
		if { [lsearch -exact $results_ursolver_ff "prbdatwin::SolidFunction2"] == -1 } {
		    set results_ursolver_ff \
		            [linsert $results_ursolver_ff end \
		            "prbdatwin::SolidFunction2" "Solid Function #2"]
		}
		if { $itposf == 1 } {
		    set Results_Prbdata [lreplace $Results_Prbdata $itpos $itpos \
		            [lreplace [lindex $Results_Prbdata $itpos] 3 3 1]]
		}
	    } else {
		set pos [lsearch -exact $results_ursolver_ff "prbdatwin::SolidFunction2"]
		if { $pos != -1 } {
		    set results_ursolver_ff [lreplace $results_ursolver_ff $pos [expr $pos + 1]]
		}
		if { $itposf == 1 } {
		    set Results_Prbdata [lreplace $Results_Prbdata $itpos $itpos \
		            [lreplace [lindex $Results_Prbdata $itpos] 3 3 0]]
		}
	    }
	}
	"ursrs3" {
	    foreach item $Results_Prbdata {
		if { [lindex $item 0] == "SolidFunction3" } {
		    set itposf 1
		    break
		}
		incr itpos
	    }
	    eval set value $$tag
	    if { $value == 1 || $value == "Yes" || $value == "yes" } {
		if { [lsearch -exact $results_ursolver_ff "prbdatwin::SolidFunction3"] == -1 } {
		    set results_ursolver_ff \
		            [linsert $results_ursolver_ff end \
		            "prbdatwin::SolidFunction3" "Solid Function #3"]
		}
		if { $itposf == 1 } {
		    set Results_Prbdata [lreplace $Results_Prbdata $itpos $itpos \
		            [lreplace [lindex $Results_Prbdata $itpos] 3 3 1]]
		}
	    } else {
		set pos [lsearch -exact $results_ursolver_ff "prbdatwin::SolidFunction3"]
		if { $pos != -1 } {
		    set results_ursolver_ff [lreplace $results_ursolver_ff $pos [expr $pos + 1]]
		}
		if { $itposf == 1 } {
		    set Results_Prbdata [lreplace $Results_Prbdata $itpos $itpos \
		            [lreplace [lindex $Results_Prbdata $itpos] 3 3 0]]
		}
	    }
	}
	"ursrall" {
	    # If no functions in URSOLVER Solver Data ara enabled, hide the Function Editor Button
	    if { \
		    $prbdatwin::UserDefinedF1 != 1 && $prbdatwin::UserDefinedF1 != "Yes" && $prbdatwin::UserDefinedF1 != "yes" && \
		    $prbdatwin::UserDefinedF2 != 1 && $prbdatwin::UserDefinedF2 != "Yes" && $prbdatwin::UserDefinedF2 != "yes" && \
		    $prbdatwin::UserDefinedF3 != 1 && $prbdatwin::UserDefinedF3 != "Yes" && $prbdatwin::UserDefinedF3 != "yes" && \
		    $prbdatwin::UserDefinedS1 != 1 && $prbdatwin::UserDefinedS1 != "Yes" && $prbdatwin::UserDefinedS1 != "yes" && \
		    $prbdatwin::UserDefinedS2 != 1 && $prbdatwin::UserDefinedS2 != "Yes" && $prbdatwin::UserDefinedS2 != "yes" && \
		    $prbdatwin::UserDefinedS3 != 1 && $prbdatwin::UserDefinedS3 != "Yes" && $prbdatwin::UserDefinedS3 != "yes" } {
		grid remove $parent.bf.btn_func
	    } else {
		grid $parent.bf.btn_func
	    }
	}
    }

    return 1
}

################################################################################
#
#   Other data
#
################################################################################

proc prbdatwin::other_data { page tags } {
 
    global ProgramName

    # Tdyn settings
    variable show_fluid
    variable show_solid
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_alemesh
    variable show_naval

    variable predefined_ff
    variable other_ff

    variable Other_Data
    foreach item $Other_Data {
	variable [lindex $item 0]
    }
    
    # Scrollable Frame
    set scrwindow [ScrolledWindow $page.g -relief ridge -bd 2]
    set scrframe [ScrollableFrame $scrwindow.f]
    $scrwindow setwidget $scrframe
    set sframe [$scrframe getframe]
    grid $scrwindow -row 0 -column 0 -sticky ewsn -pady 4
    grid rowconfigure $page 0 -weight 1

    if { $show_ransol == 1 } {
	# Title Frame RANSOL
	set tframe [TitleFrame $sframe.ransol -relief ridge -text [= {RANSOL Data}]]
	set frame [$tframe getframe]

	set c_ufdens [checkbutton $frame.c_ufdens -text "[= {Floatability by Density}] " \
		-variable prbdatwin::Float_By_Density -onvalue "Yes" -offvalue "No"]
	set c_utpres [checkbutton $frame.c_utpres -text "[= {Use Total Pressure}] "\
		-variable prbdatwin::Use_Total_Pressure -onvalue "Yes" -offvalue "No"]
	set ln_gopresx [Label $frame.ln_gopresx -text "[= {Pressure origin OX}] "]
	set en_gopresx [entry $frame.en_gopresx -textvariable prbdatwin::Pressure_Origin_OX]
	set ln_gopresy [Label $frame.ln_gopresy -text "[= {Pressure origin OY}] "]
	set en_gopresy [entry $frame.en_gopresy -textvariable prbdatwin::Pressure_Origin_OY]
	set ln_gopresz [Label $frame.ln_gopresz -text "[= {Pressure origin OZ}] "]
	set en_gopresz [entry $frame.en_gopresz -textvariable prbdatwin::Pressure_Origin_OZ]
	set c_gopres [checkbutton $frame.c_ugopres -text "[= {Pressure reference location}] " \
		-variable prbdatwin::Give_Pressure_Origin -onvalue "Yes" -offvalue "No"]
	
	set irow 0
	grid $c_ufdens -row [incr irow] -column 0 -sticky nw -columnspan 2
	grid $c_utpres -row [incr irow] -column 0 -sticky nw -columnspan 2
	grid $c_gopres -row [incr irow] -column 0 -sticky nw -columnspan 2
	grid $ln_gopresx -row [incr irow] -column 0 -sticky nw
	grid $en_gopresx -row $irow -column 1 -sticky nw
	grid $ln_gopresy -row [incr irow] -column 0 -sticky nw
	grid $en_gopresy -row $irow -column 1 -sticky nw
	
	if { $ProgramName == "Tdyn3D" } {
	    grid $ln_gopresz -row [incr irow] -column 0 -sticky nw
	    grid $en_gopresz -row $irow -column 1 -sticky nw
	    $c_gopres configure -command "HideShow \${prbdatwin::Give_Pressure_Origin} \
		    \[list $ln_gopresx $ln_gopresy $ln_gopresz $en_gopresx $en_gopresy $en_gopresz\]"
	    HideShow ${prbdatwin::Give_Pressure_Origin} \
		    [list $ln_gopresx $ln_gopresy $ln_gopresz $en_gopresx $en_gopresy $en_gopresz]
	} else {
	    $c_gopres configure -command "HideShow \${prbdatwin::Give_Pressure_Origin} \
		    \[list $ln_gopresx $ln_gopresy $en_gopresx $en_gopresy\]"
	    HideShow ${prbdatwin::Give_Pressure_Origin} \
		    [list $ln_gopresx $ln_gopresy $en_gopresx $en_gopresy]
	}

	set ln_xplsym [Label $frame.ln_xplsym -text [= {List of OX symmetry planes }]]
	set en_xplsym [entry $frame.en_xplsym -textvariable prbdatwin::Xplane_Symmetry_Position]
	set c_xplsym [checkbutton $frame.c_xplsym -text [= {Xplane Symmetry in Fluid }] \
		-variable prbdatwin::Xplane_Symmetry_in_Fluid -onvalue "Yes" -offvalue "No" \
		-command "HideShow \${prbdatwin::Xplane_Symmetry_in_Fluid} \[list $ln_xplsym $en_xplsym\]"]
	set ln_yplsym [Label $frame.ln_yplsym -text [= {List of OY symmetry planes }]]
	set en_yplsym [entry $frame.en_yplsym -textvariable prbdatwin::Yplane_Symmetry_Position]
	set c_yplsym [checkbutton $frame.c_yplsym -text [= {Yplane Symmetry in Fluid }] \
		-variable prbdatwin::Yplane_Symmetry_in_Fluid -onvalue "Yes" -offvalue "No" \
		-command "HideShow \${prbdatwin::Yplane_Symmetry_in_Fluid} \[list $ln_yplsym $en_yplsym\]"]
	set ln_zplsym [Label $frame.ln_zplsym -text [= {List of OZ symmetry planes }]]
	set en_zplsym [entry $frame.en_zplsym -textvariable prbdatwin::Zplane_Symmetry_Position]
	set c_zplsym [checkbutton $frame.c_zplsym -text [= {Zplane Symmetry in Fluid }] \
		-variable prbdatwin::Zplane_Symmetry_in_Fluid -onvalue "Yes" -offvalue "No" \
		-command "HideShow \${prbdatwin::Zplane_Symmetry_in_Fluid} \[list $ln_zplsym $en_zplsym\]"]
	grid $c_xplsym -row [incr irow] -column 0 -sticky nw -columnspan 2
	grid $ln_xplsym -row [incr irow] -column 0 -sticky nw
	grid $en_xplsym -row $irow -column 1 -sticky nw
	grid $c_yplsym -row [incr irow] -column 0 -sticky nw -columnspan 2
	grid $ln_yplsym -row [incr irow] -column 0 -sticky nw
	grid $en_yplsym -row $irow -column 1 -sticky nw
	HideShow ${prbdatwin::Xplane_Symmetry_in_Fluid} [list $ln_xplsym $en_xplsym]
	HideShow ${prbdatwin::Yplane_Symmetry_in_Fluid} [list $ln_yplsym $en_yplsym]
	if { $ProgramName == "Tdyn3D" } {
	    grid $c_zplsym -row [incr irow] -column 0 -sticky nw -columnspan 2
	    grid $ln_zplsym -row [incr irow] -column 0 -sticky nw
	    grid $en_zplsym -row $irow -column 1 -sticky nw
	    HideShow ${prbdatwin::Zplane_Symmetry_in_Fluid} [list $ln_zplsym $en_zplsym]
	}
	set ln_refntp [Label $frame.ln_refntp -text [= {Mesh refinement type }]]
	set en_refntp [ComboBox $frame.en_refntp -values [list None Residual] \
	    -editable 0 -width [TDYN_getcbxsize 10 [list None Residual]] \
	    -textvariable prbdatwin::RefineMesh]
	set ln_wlawtp [Label $frame.ln_wlawtp -text [= {Law of the wall type }]]
	set en_wlawtp [ComboBox $frame.en_wlawtp -values [list FixTau DepTau] \
	    -editable 0 -width [TDYN_getcbxsize 10 [list FixTau DepTau]] \
	    -textvariable prbdatwin::Wall_Law_Type]
	set ln_wlawfr [Label $frame.ln_wlawfr -text [= {Law of the wall vfor }]]
	set en_wlawfr [ComboBox $frame.en_wlawfr -values [list On Off] \
	    -editable 0 -width [TDYN_getcbxsize 10 [list On Off]] \
	    -textvariable prbdatwin::Wall_Law_VFor]

	grid $ln_refntp -row [incr irow] -column 0 -sticky nw
	grid $en_refntp -row $irow -column 1 -sticky nw
	grid $ln_wlawtp -row [incr irow] -column 0 -sticky nw
	grid $en_wlawtp -row $irow -column 1 -sticky nw
	grid $ln_wlawfr -row [incr irow] -column 0 -sticky nw
	grid $en_wlawfr -row $irow -column 1 -sticky nw

	grid $tframe -row 0 -column 0 -sticky ewsn -pady 4 -padx 4
	grid rowconfigure $frame $irow -weight 1
    }

    if { $show_ursolver == 1 } {

	set help_btn_func "[= {Custom Function Editor}].\n[= {Edit a function and transfer it automatically to a field}].\n[= {You can also RIGHT-CLICK a field to open the Function Editor}]."

	# Title Frame URSOLVER
	set tframe [TitleFrame $sframe.ursolver -relief ridge -text [= {URSOLVER Data}]]
	set frame [$tframe getframe]

	set irow 0
	if { $show_fluid == 1 } {
	    set ln_intf1 [Label $frame.ln_intf1 -text [= {Fluid user integral #1 }]]
	    set en_intf1 [entry $frame.en_intf1 -textvariable prbdatwin::UserIntegralF1]
	    set ln_intf2 [Label $frame.ln_intf2 -text [= {Fluid user integral #2 }]]
	    set en_intf2 [entry $frame.en_intf2 -textvariable prbdatwin::UserIntegralF2]
	    set ln_intf3 [Label $frame.ln_intf3 -text [= {Fluid user integral #3 }]]
	    set en_intf3 [entry $frame.en_intf3 -textvariable prbdatwin::UserIntegralF3]
	    grid $ln_intf1 -row [incr irow] -column 0 -sticky nw
	    grid $en_intf1 -row $irow -column 1 -sticky nw
	    grid $ln_intf2 -row [incr irow] -column 0 -sticky nw
	    grid $en_intf2 -row $irow -column 1 -sticky nw
	    grid $ln_intf3 -row [incr irow] -column 0 -sticky nw
	    grid $en_intf3 -row $irow -column 1 -sticky nw
	    bind $en_intf1 <ButtonPress-3> \
		    "prbdatwin::popupmenu $page prbdatwin::UserIntegralF1 \"Fluid user integral #1\" \"\" 1 %X %Y"
	    bind $en_intf2 <ButtonPress-3> \
		    "prbdatwin::popupmenu $page prbdatwin::UserIntegralF2 \"Fluid user integral #2\" \"\" 1 %X %Y"
	    bind $en_intf3 <ButtonPress-3> \
		    "prbdatwin::popupmenu $page prbdatwin::UserIntegralF3 \"Fluid user integral #3\" \"\" 1 %X %Y"
	} 
	if { $show_solid == 1 } {
	    set ln_ints1 [Label $frame.ln_ints1 -text [= {Solid user integral #1 }]]
	    set en_ints1 [entry $frame.en_ints1 -textvariable prbdatwin::UserIntegralS1]
	    set ln_ints2 [Label $frame.ln_ints2 -text [= {Solid user integral #2 }]]
	    set en_ints2 [entry $frame.en_ints2 -textvariable prbdatwin::UserIntegralS2]
	    set ln_ints3 [Label $frame.ln_ints3 -text [= {Solid user integral #3 }]]
	    set en_ints3 [entry $frame.en_ints3 -textvariable prbdatwin::UserIntegralS3]
	    grid $ln_ints1 -row [incr irow] -column 0 -sticky nw
	    grid $en_ints1 -row $irow -column 1 -sticky nw
	    grid $ln_ints2 -row [incr irow] -column 0 -sticky nw
	    grid $en_ints2 -row $irow -column 1 -sticky nw
	    grid $ln_ints3 -row [incr irow] -column 0 -sticky nw
	    grid $en_ints3 -row $irow -column 1 -sticky nw
	    bind $en_ints1 <ButtonPress-3> \
		    "prbdatwin::popupmenu $page prbdatwin::UserIntegralS1 \"Solid user integral #1\" \"\" 1 %X %Y"
	    bind $en_ints2 <ButtonPress-3> \
		    "prbdatwin::popupmenu $page prbdatwin::UserIntegralS2 \"Solid user integral #2\" \"\" 1 %X %Y"
	    bind $en_ints3 <ButtonPress-3> \
		    "prbdatwin::popupmenu $page prbdatwin::UserIntegralS3 \"Solid user integral #3\" \"\" 1 %X %Y"
	} 

	# Buttons frame
	set bf [frame $frame.bf -relief raised -takefocus 1]
	# Editor button
	set btn_functions [Button $bf.btn_func -underline 0 \
		-command "FEditor::init $page \"$predefined_ff\" \"\" \"SELECT FIELD\" \"\" \"$other_ff\" \"\"" \
		-image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]
	GidHelp $btn_functions $help_btn_func
	# GRIDS
	# Buttons Frame
	incr irow
	grid $bf -row $irow -column 1 -sticky nw
	# Function Editor Button
	grid $btn_functions -row 0 -column 0 -sticky wn -pady 3 -padx 2

	grid $tframe -row 0 -column 1 -sticky ewsn -pady 4 -padx 4
	grid rowconfigure $frame $irow -weight 1
    }

    if { $show_ransol == 1 } {
	# Title Frame MULTIPLE RUNS
	set tframe [TitleFrame $sframe.multruns -relief ridge -text [= {MULTIPLE Runs}]]
	set frame [$tframe getframe]

	set ln_mruns [Label $frame.ln_mruns -text [= {Multiple runs }]]
	set en_mruns [entry $frame.en_mruns -textvariable prbdatwin::Velocities_List]
	set ln_addls [Label $frame.ln_addls -text [= {Additional steps }]]
	set en_addls [entry $frame.en_addls -textvariable prbdatwin::Additional_Steps]

	set irow 0
	grid $ln_mruns -row [incr irow] -column 0 -sticky nw
	grid $en_mruns -row $irow -column 1 -sticky nw
	grid $ln_addls -row [incr irow] -column 0 -sticky nw
	grid $en_addls -row $irow -column 1 -sticky nw
	grid $tframe -row 0 -column 2 -sticky ewsn -pady 4 -padx 4
	grid rowconfigure $frame $irow -weight 1
    }
    # Title Frame SPECIAL Options
    set tframe [TitleFrame $sframe.spcoptions -relief ridge -text [= {SPECIAL Options}]]
    set frame [$tframe getframe]
    
    set ln_spops [Label $frame.ln_spops -text [= {Execution arguments}]]
    set en_spops [entry $frame.en_spops -textvariable prbdatwin::Execution_Arguments]
  
    set irow 0
    grid $ln_spops -row [incr irow] -column 0 -sticky nw
    grid $en_spops -row $irow -column 1 -sticky nw
    grid $tframe -row 0 -column 3 -sticky ewsn -pady 4 -padx 4
    grid rowconfigure $frame $irow -weight 1
}

################################################################################
#
#   Fluid Solver
#
################################################################################

proc prbdatwin::fluid_solver { page tags } {

    # FLUID SOLVER
    variable Fluid_Solver
    foreach item $Fluid_Solver {
	variable [lindex $item 0]
    }

    #####  HELP Text variables #####
    set help_FTime_Integration \
	    "[= {Scheme to be used in the time integration: Backward_Euler (1st order) or Crank Nicolson (2nd order)}]."
    set help_StabTauV_MinRatio \
	    "[= {Minimum admissible ratio (Tau/dt) for the stabilisation parameter tau used in the advection stabilisation}]."
    set help_StabTauP_MinRatio \
	    "[= {Minimum admissible ratio (Tau/dt) for the stabilisation parameter tau used in the pressure stabilisation}]."
    set help_FSolver_NonSymmetric \
	    "[= {Solver for fluid problem solution (unsymmetric linear systems)}]."
    set help_NS1_Kdim \
	    "[= {Dimension of internal direct solver used in GMRES}]."
    set help_NS1_Tolerance \
	    "[= {Tolerance of fluid solver (nonsymmetric linear systems). Recommended value < 1.0e-6}]."
    set help_NS1_MaxIter \
	   "[= {Maximum number of iterations of fluid solver (nonsymmetric linear systems)}]."
    set help_NS1_Preconditioner \
	    "[= {Preconditioner for the fluid solver (nonsymmetric linear systems)}].\n[= {In some cases using elements with high aspect ratio the diagonal preconditioner may work better.}]"
    set help_FSolver_Symmetric \
	    "[= {Solver for fluid problem solution (symmetric linear systems)}]."
    set help_NS2_Kdim \
	    "[= {Dimension of internal direct solver used in GMRES}]."
    set help_NS2_Tolerance \
	    "[= {Tolerance of fluid solver (symmetric linear systems). Recommended value < 1.0e-6}]."
    set help_NS2_MaxIter \
	    "[= {Maximum number of iterations of fluid solver (symmetric linear systems)}]."
    set help_NS2_Preconditioner \
	    "[= {Preconditioner for the fluid solver (symmetric linear systems)}]."
    set help_Advection_Norm \
	    "[= {Convergence norm used for recalculating advective terms. Recommended value < 1.0e-5}]."
    set help_Steady_State_Norm \
	    "[= {Norm used to detect the steady state}]."
    set help_Increment_Control \
	    "[= {This option activates a control that limits the variable increment every iteration}].\n[= {Enter a value greater than 0.0 to 1.0 (1.0 to deactivate)}]."

    # Combo boxes values
    lappend vals_FTime_Integration "Backward_Euler" "Crank_Nicolson" "Forward_Euler"
    lappend vals_FSolver_NonSymmetric \
	    "Bi_Conjugate_Gradient" "Stab_Bi_Conjugate_Gradient" "GMRes" "Squared_Conjugate_Gradient" "Gauss_Seidel"
    lappend vals_NS1_Preconditioner "ILU" "Diagonal" "None"
    lappend vals_FSolver_Symmetric \
	    "Conjugate_Gradient" "Bi_Conjugate_Gradient" "Stab_Bi_Conjugate_Gradient" "GMRes" "Squared_Conjugate_Gradient" "Gauss_Seidel"
    lappend vals_NS2_Preconditioner "ILU" "IC" "Diagonal" "None"
#    lappend vals_Increment_Control "None" "Low" "Medium" "High" "Extreme"

#    set frame [frame $page.f -relief flat]
    set tframe [TitleFrame $page.f -relief ridge -text [= {Solver Data}]]
    set frame [$tframe getframe]

    # Invisible size label
#    set sizelabel [label $frame.l_sizelabel \
#            -text "                                                         " -bd 0 ]
    
    # FTime Integration
    set l_FTime_Integration [Label $frame.l_ftimeintegration \
	    -text [= {Time Integration }] -helptext $help_FTime_Integration]
    set e_FTime_Integration [ComboBox $frame.cbx_ftimeintegration -values $vals_FTime_Integration \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_FTime_Integration] \
	    -textvariable prbdatwin::FTime_Integration]

    # DEPENDENCIES
    $e_FTime_Integration configure -modifycmd "prbdatwin::fluidsolverdep $page $e_FTime_Integration ftintg"

    # StabTauV MinRatio
    set l_StabTauV_MinRatio [Label $frame.l_stabtauvminratio -text "[= {StabTauV MinRatio}] " \
	    -helptext $help_StabTauV_MinRatio]
    set e_StabTauV_MinRatio [entry $frame.e_stabtauvminratio -textvariable prbdatwin::StabTauV_MinRatio]

    # StabTauP MinRatio
    set l_StabTauP_MinRatio [Label $frame.l_stabtaupminratio -text "[= {StabTauP MinRatio}] "\
	    -helptext $help_StabTauP_MinRatio]
    set e_StabTauP_MinRatio [entry $frame.e_stabtaupminratio -textvariable prbdatwin::StabTauP_MinRatio]

    # FSolver NonSymetric
    set l_FSolver_NonSymmetric [Label $frame.l_fsolvernonsymmetric \
	    -text [= {Solver NonSymmetric }] -helptext $help_FSolver_NonSymmetric]
    set e_FSolver_NonSymmetric [ComboBox $frame.cbx_fsolvernonsymmetric -values $vals_FSolver_NonSymmetric \
	    -editable false -width [TDYN_getcbxsize 10 $vals_FSolver_NonSymmetric] \
	    -textvariable prbdatwin::FSolver_NonSymmetric -takefocus 1]
    # DEPENDENCIES
    $e_FSolver_NonSymmetric configure -modifycmd \
	    "prbdatwin::fluidsolverdep $page $e_FSolver_NonSymmetric fsnonsym"
    if { [$e_FTime_Integration getvalue] == 2 } {
	$e_FSolver_NonSymmetric setvalue last
	$e_FSolver_NonSymmetric configure -state disabled
    } else {
	$e_FSolver_NonSymmetric configure -state normal
    }

    # NS1 Kdim
    set l_NS1_Kdim [Label $frame.l_ns1kdim -text [= {Krilov sp. dimension }] \
	    -helptext $help_NS1_Kdim]
    set e_NS1_Kdim [entry $frame.e_ns1kdim -textvariable prbdatwin::NS1_Kdim]

    # NS1 Tolerance
    set l_NS1_Tolerance [Label $frame.l_ns1tolerance -text [= {Tolerance }] \
	    -helptext $help_NS1_Tolerance]
    set e_NS1_Tolerance [entry $frame.e_ns1tolerance -textvariable prbdatwin::NS1_Tolerance]

    # NS1 MaxIter
    set l_NS1_MaxIter [Label $frame.l_ns1maxiter -text [= {Max. Iterations }] \
	    -helptext $help_NS1_MaxIter]
    set e_NS1_MaxIter [entry $frame.e_ns1maxiter -textvariable prbdatwin::NS1_MaxIter]

    # NS1 Preconditioner
    set l_NS1_Preconditioner [Label $frame.l_ns1preconditioner \
	    -text [= {Preconditioner }] -helptext $help_NS1_Preconditioner]
    set e_NS1_Preconditioner [ComboBox $frame.cbx_ns1preconditioner -values $vals_NS1_Preconditioner \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_NS1_Preconditioner] \
	    -textvariable prbdatwin::NS1_Preconditioner]
    # DEPENDENCIES
    if { [$e_FTime_Integration getvalue] == 2 || [$e_FSolver_NonSymmetric getvalue] == 4} {
	$e_NS1_Preconditioner setvalue last
	$e_NS1_Preconditioner configure -state disabled
    } else {
	$e_NS1_Preconditioner configure -state normal
    }

    # FSolver Symetric
    set l_FSolver_Symmetric [Label $frame.l_fsolversymmetric \
	    -text [= {Solver Symmetric }] -helptext $help_FSolver_Symmetric]
    set e_FSolver_Symmetric [ComboBox $frame.cbx_fsolversymmetric -values $vals_FSolver_Symmetric \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_FSolver_Symmetric] \
	    -textvariable prbdatwin::FSolver_Symmetric]
    # DEPENDENCIES
    $e_FSolver_Symmetric configure -modifycmd "prbdatwin::fluidsolverdep $page $e_FSolver_Symmetric fssym"

    # NS2 Kdim
    set l_NS2_Kdim [Label $frame.l_ns2kdim -text [= {Krilov sp. dimension }] \
	    -helptext $help_NS2_Kdim]
    set e_NS2_Kdim [entry $frame.e_ns2kdim -textvariable prbdatwin::NS2_Kdim]

    # NS2 Tolerance
    set l_NS2_Tolerance [Label $frame.l_ns2tolerance -text [= {Tolerance }] \
	    -helptext $help_NS2_Tolerance]
    set e_NS2_Tolerance [entry $frame.e_ns2tolerance -textvariable prbdatwin::NS2_Tolerance]

    # NS2 MaxIter
    set l_NS2_MaxIter [Label $frame.l_ns2maxiter -text [= {Max. Iterations }] \
	    -helptext $help_NS2_MaxIter]
    set e_NS2_MaxIter [entry $frame.e_ns2maxiter -textvariable prbdatwin::NS2_MaxIter]

    # NS2 Preconditioner
    set l_NS2_Preconditioner [Label $frame.l_ns2preconditioner \
	    -text [= {Preconditioner }] -helptext $help_NS2_Preconditioner]
    set e_NS2_Preconditioner [ComboBox $frame.cbx_ns2preconditioner -values $vals_NS2_Preconditioner \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_NS2_Preconditioner] \
	    -textvariable prbdatwin::NS2_Preconditioner]
    # DEPENDENCIES
    if { [$e_FSolver_Symmetric getvalue] == 5} {
	$e_NS2_Preconditioner setvalue last
	$e_NS2_Preconditioner configure -state disabled
    } else {
	$e_NS2_Preconditioner configure -state normal
    }

    # Advection Norm
    set l_Advection_Norm [Label $frame.l_advectionnorm -text [= {Advection Norm }] \
	    -helptext $help_Advection_Norm]
    set e_Advection_Norm [entry $frame.e_advectionnorm -textvariable prbdatwin::Advection_Norm]

    # Steady State Norm
    set l_FLUIDSOLVER_Steady_State_Norm [Label $frame.l_stesystatenorm -text [= {Steady State Norm }] \
	    -helptext $help_Steady_State_Norm]
    set e_FLUIDSOLVER_Steady_State_Norm [entry $frame.e_stesystatenorm \
	    -textvariable prbdatwin::FLUIDSOLVER_Steady_State_Norm]

    # S Preconditioner
    set l_FLUIDSOLVER_Increment_Control [Label $frame.l_incrementcontrol -text \
	    [= {Increment Control }] -helptext $help_Increment_Control]
    set e_FLUIDSOLVER_Increment_Control [entry $frame.e_incrementcontrol \
	    -textvariable prbdatwin::FLUIDSOLVER_Increment_Control]

    # GRIDS
    # SizeLabel
    grid $tframe -row 0 -column 0 -sticky ewn
#    grid $sizelabel -row 0 -column 0 -sticky wn
    set row 1
    foreach item $Fluid_Solver {
	set itt [lindex $item 0]
	set lvar "l_$itt"
	set evar "e_$itt"
	grid [eval set temp $$lvar] -row $row -column 0 -sticky en -pady 2
	grid [eval set temp $$evar] -row $row -column 1 -sticky wn -pady 2
	set help "help_$itt"
	if { [info exist $help] } {
	    GidHelp [eval set temp $$lvar] [eval set temp $$help]
	    GidHelp [eval set temp $$evar] [eval set temp $$help]
	}
	incr row
    }

    # DEPENDENCIES
    if { [$e_FSolver_NonSymmetric getvalue] != 2 } {
	grid remove $l_NS1_Kdim
	grid remove $e_NS1_Kdim
    }
    if { [$e_FSolver_Symmetric getvalue] != 3 } {
	grid remove $l_NS2_Kdim
	grid remove $e_NS2_Kdim
    }

    # BINDS
    bind $page <<forward-euler>> "$e_FSolver_NonSymmetric setvalue last"
    bind $page <<forward-euler>> "+ $e_FSolver_NonSymmetric configure -state disabled"
    bind $page <<forward-euler>> "+ $e_NS1_Preconditioner setvalue last"
    bind $page <<forward-euler>> "+ $e_NS1_Preconditioner configure -state disabled"
    bind $page <<forward-euler>> "+ prbdatwin::fluidsolverdep $page $e_FSolver_NonSymmetric fsnonsym"
    bind $page <<forward-euler-out>> "$e_FSolver_NonSymmetric configure -state normal"
    bind $page <<forward-euler-out>> "+ prbdatwin::fluidsolverdep $page $e_FSolver_NonSymmetric fsnonsym"
    bind $page <<nonsym-gaussseidel>> "$e_NS1_Preconditioner setvalue last"
    bind $page <<nonsym-gaussseidel>> "+ $e_NS1_Preconditioner configure -state disabled"
    bind $page <<nonsym-gaussseidel-out>> "$e_NS1_Preconditioner configure -state normal"
    bind $page <<sym-gaussseidel>> "$e_NS2_Preconditioner setvalue last"
    bind $page <<sym-gaussseidel>> "+ $e_NS2_Preconditioner configure -state disabled"
    bind $page <<sym-gaussseidel-out>> "$e_NS2_Preconditioner configure -state normal"
    bind $page <<nonsym-gmres>> "grid $l_NS1_Kdim"
    bind $page <<nonsym-gmres>> "+ grid $e_NS1_Kdim"
    bind $page <<nonsym-gmres-out>> "grid remove $l_NS1_Kdim"
    bind $page <<nonsym-gmres-out>> "+ grid remove $e_NS1_Kdim"
    bind $page <<sym-gmres>> "grid $l_NS2_Kdim"
    bind $page <<sym-gmres>> "+ grid $e_NS2_Kdim"
    bind $page <<sym-gmres-out>> "grid remove $l_NS2_Kdim"
    bind $page <<sym-gmres-out>> "+ grid remove $e_NS2_Kdim"
}

proc prbdatwin::fluidsolverdep { page wdg gen } {

    # FLUID SOLVER
    variable Fluid_Solver

    set valindex -1
    set valindex [$wdg getvalue]

    switch $gen {
	"ftintg" {
	    if { $valindex == 2 } {
		event generate $page <<forward-euler>>
	    } else {
		event generate $page <<forward-euler-out>>
	    }
	}
	"fsnonsym" {
	    if { $valindex == 4 } {
		event generate $page <<nonsym-gaussseidel>>
	    } else {
		event generate $page <<nonsym-gaussseidel-out>>
	    }
	    if { $valindex != 2 } {
		event generate $page <<nonsym-gmres-out>>
		set temp [lreplace [join [lrange $Fluid_Solver 4 4]] 3 3 0]
		set Fluid_Solver [lreplace $Fluid_Solver 4 4 $temp]
	    } else {
		event generate $page <<nonsym-gmres>>
		set temp [lreplace [join [lrange $Fluid_Solver 4 4]] 3 3 1]
		set Fluid_Solver [lreplace $Fluid_Solver 4 4 $temp]
	    }
	}
	"fssym" {
	    if { $valindex == 5 } {
		event generate $page <<sym-gaussseidel>>
	    } else {
		event generate $page <<sym-gaussseidel-out>>
	    }
	    if { $valindex != 3 } {
		event generate $page <<sym-gmres-out>>
		set temp [lreplace [join [lrange $Fluid_Solver 9 9]] 3 0]
		set Fluid_Solver [lreplace $Fluid_Solver 9 9 $temp]
	    } else {
		event generate $page <<sym-gmres>>
		set temp [lreplace [join [lrange $Fluid_Solver 9 9]] 3 1]
		set Fluid_Solver [lreplace $Fluid_Solver 9 9 $temp]
	    }
	}
    }
}

################################################################################
#
#   Solid Solver
#
################################################################################

proc prbdatwin::solid_solver { page tags } {

    variable show_ramsolid

    # Solid Solver variables
    variable Solid_Solver
    foreach item $Solid_Solver {
	variable [lindex $item 0]
    }

    #####  HELP Text variables #####
    set help_STime_Integration \
	    "[= {Scheme to be used in the time integration: Backward_Euler (1st order) or Crank Nicolson (2nd order)}]."
    set help_SSolver_Symmetric \
	    "[= {Solver for solid problem solution (symmetric linear systems)}]."
    set help_S_Kdim \
	    "[= {Dimension of internal direct solver used in GMRES}]."
    set help_S_Tolerance \
	    "[= {Tolerance of solid solver (symmetric linear systems). Recommended value < 1.0e-6}]."
    set help_S_MaxIter \
	    "[= {Maximum number of iterations of solid solver (symmetric linear systems)}]."
    set help_S_Preconditioner \
	    "[= {Preconditioner for the solid solver (symmetric linear systems)}]."
    set help_Steady_State_Norm \
	    "[= {Norm used to detect the steady state}]."
    set help_Increment_Control \
	    "[= {[= {This option activates a control that limits the variable increment every iteration}]}].\n[= {[= {Enter a value greater than 0.0 to 1.0 (1.0 to deactivate)}]}]."
    set help_Solver_type \
	    "[= {Allows to choose the solver to be used:}]\n[= {Automatic: Runs a direct solver for small\
	    problems and an iterative for big ones}].\n[= {SkyLine: Direct solver. It has no convergence\
	    problems but needs more RAM memory}].\n[= {Sparse: Iterative solver. they take much less\
	    memory but may not converge. User can choose desired parameters}]."
    set help_Solver_tolerance "[= {Tolerance accepted to finish iterations}]"
    set help_Solver_tolerance_minimum \
	    "[= {If solver arrives to Max iterations, then this tolerance is used to accept or not the result}]."
    set help_Solver_max_iterations \
	    "[= {Maximum number of iterations permmited to the solver}]."

    # Combo boxes values
    lappend vals_STime_Integration "Backward_Euler" "Crank_Nicolson" "Forward_Euler"
    lappend vals_SSolver_Symmetric \
	    "Conjugate_Gradient" "Bi_Conjugate_Gradient" "Stab_Bi_Conjugate_Gradient" "GMRes" "Squared_Conjugate_Gradient" "Gauss_Seidel"
    lappend vals_S_Preconditioner "ILU" "IC" "Diagonal" "None"
#    lappend vals_Increment_Control "None" "Low" "Medium" "High" "Extreme"

#    set frame [frame $page.f -relief flat]
    set tframe [TitleFrame $page.f -relief ridge -text [= {Solver Data}]]
    set frame [$tframe getframe]

    # Invisible size label
#    set sizelabel [label $frame.l_sizelabel \
#            -text "                                                         " -bd 0 ]
    
    # STime Integration
    set l_STime_Integration [Label $frame.l_stimeintegration -text [= {Time Integration }] -helptext $help_STime_Integration]
    set e_STime_Integration [ComboBox $frame.cbx_stimeintegration -values $vals_STime_Integration \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_STime_Integration] \
	    -textvariable prbdatwin::STime_Integration]
    # DEPENDENCIES
    $e_STime_Integration configure -modifycmd "prbdatwin::solidsolverdep $page $e_STime_Integration stintg"

    # SSolver Symetric
    set l_SSolver_Symmetric [Label $frame.l_ssolversymmetric -text [= {Solver Symmetric }] -helptext $help_SSolver_Symmetric]
    set e_SSolver_Symmetric [ComboBox $frame.cbx_ssolversymmetric -values $vals_SSolver_Symmetric \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_SSolver_Symmetric] \
	    -textvariable prbdatwin::SSolver_Symmetric]
    # DEPENDENCIES
    $e_SSolver_Symmetric configure -modifycmd "prbdatwin::solidsolverdep $page $e_SSolver_Symmetric sssym"

    # S Kdim
    set l_S_Kdim [Label $frame.l_skdim -text [= {Krilov sp. dimension }] \
	    -helptext $help_S_Kdim]
    set e_S_Kdim [entry $frame.e_skdim -textvariable prbdatwin::S_Kdim]

    # S Tolerance
    set l_S_Tolerance [Label $frame.l_stolerance -text [= {Tolerance }] \
	    -helptext $help_S_Tolerance]
    set e_S_Tolerance [entry $frame.e_stolerance -textvariable prbdatwin::S_Tolerance]

    # S MaxIter
    set l_S_MaxIter [Label $frame.l_smaxiter -text [= {Max. Iterations }] \
	    -helptext $help_S_MaxIter]
    set e_S_MaxIter [entry $frame.e_smaxiter -textvariable prbdatwin::S_MaxIter]

    # S Preconditioner
    set l_S_Preconditioner [Label $frame.l_spreconditioner -text [= {Preconditioner }] -helptext $help_S_Preconditioner]
    set e_S_Preconditioner [ComboBox $frame.cbx_spreconditioner -values $vals_S_Preconditioner \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_S_Preconditioner] \
	    -textvariable prbdatwin::S_Preconditioner]
    # DEPENDENCIES
    if { [$e_SSolver_Symmetric getvalue] == 5} {
	$e_S_Preconditioner setvalue last
	$e_S_Preconditioner configure -state disabled
    } else {
	$e_S_Preconditioner configure -state normal
    }

    # Steady State Norm
    set l_SOLIDSOLVER_Steady_State_Norm [Label $frame.l_stesystatenorm -text [= {Steady State Norm }] \
	    -helptext $help_Steady_State_Norm]
    set e_SOLIDSOLVER_Steady_State_Norm [entry $frame.e_stesystatenorm -textvariable prbdatwin::SOLIDSOLVER_Steady_State_Norm]

    # S Preconditioner
    set l_SOLIDSOLVER_Increment_Control [Label $frame.l_incrementcontrol -text [= {Increment Control }] -helptext $help_Increment_Control]
    set e_SOLIDSOLVER_Increment_Control [entry $frame.e_incrementcontrol -textvariable prbdatwin::SOLIDSOLVER_Increment_Control]

    if { $show_ramsolid == 1 } {
	set rframe [TitleFrame $page.r -relief ridge -text [= {RamSolid Solver Data}]]
	set frame [$rframe getframe] 
	
	# RamSolid Solver
	lappend vals_RamSolver "Automatic" "SkyLine" "Sparse"
	set l_Solver_type [Label $frame.l_rams -text [= {Solver type }] \
		-helptext $help_Solver_type]
	set e_Solver_type [ComboBox $frame.e_rams -values $vals_RamSolver \
		-editable 0 -width [TDYN_getcbxsize 10 $vals_RamSolver] \
		-textvariable prbdatwin::Solver_type]
	
	# DEPENDENCIES
	$e_Solver_type configure -modifycmd "prbdatwin::solidsolverdep $frame $e_Solver_type rams"
	
	set l_Solver_tolerance [Label $frame.l_ramtol -text [= {Solver tolerance }]]
	set e_Solver_tolerance [entry $frame.e_ramtol -textvariable prbdatwin::Solver_tolerance]
	set l_Solver_tolerance_minimum [Label $frame.l_minramtol -text [= {Solver tolerance minimum }]]
	set e_Solver_tolerance_minimum [entry $frame.e_minramtol -textvariable prbdatwin::Solver_tolerance_minimum]
	set l_Solver_max_iterations [Label $frame.l_ramiter -text [= {Solver max iterations }]]
	set e_Solver_max_iterations [entry $frame.e_ramiter -textvariable prbdatwin::Solver_max_iterations]
    }

    # GRIDS
    # SizeLabel
    grid $tframe -row 0 -column 0 -sticky ewn
    if { $show_ramsolid == 1 } {
	grid $rframe -row 1 -column 0 -sticky ewn
    }
    set row 1
    foreach item $Solid_Solver {
	set itt [lindex $item 0] 
	set lvar "l_$itt"
	set evar "e_$itt"
	if { [info exist $lvar] } {
	    grid [eval set temp $$lvar] -row $row -column 0 -sticky en -pady 2
	    grid [eval set temp $$evar] -row $row -column 1 -sticky wn -pady 2
	    set help "help_$itt"
	    if { [info exist $help] } {
		GidHelp [eval set temp $$lvar] [eval set temp $$help]
		GidHelp [eval set temp $$evar] [eval set temp $$help]
	    }
	}
	incr row
    }

    # DEPENDENCIES
    if { [$e_SSolver_Symmetric getvalue] != 3 } {
	grid remove $l_S_Kdim
	grid remove $e_S_Kdim
    }

    # BINDS
    bind $page <<sl-forward-euler>> "$e_SSolver_Symmetric setvalue last"
    bind $page <<sl-forward-euler>> "+ $e_SSolver_Symmetric configure -state disabled"
    bind $page <<sl-forward-euler>> "+ $e_S_Preconditioner setvalue last"
    bind $page <<sl-forward-euler>> "+ $e_S_Preconditioner configure -state disabled"
    bind $page <<sl-forward-euler>> "+ prbdatwin::solidsolverdep $page $e_SSolver_Symmetric sssym"
    bind $page <<sl-forward-euler-out>> "$e_SSolver_Symmetric configure -state normal"
    bind $page <<sl-forward-euler-out>> "+ prbdatwin::solidsolverdep $page $e_SSolver_Symmetric sssym"
    bind $page <<sl-sym-gaussseidel>> "$e_S_Preconditioner setvalue last"
    bind $page <<sl-sym-gaussseidel>> "+ $e_S_Preconditioner configure -state disabled"
    bind $page <<sl-sym-gaussseidel-out>> "$e_S_Preconditioner configure -state normal"
    bind $page <<sl-sym-gmres>> "grid $l_S_Kdim"
    bind $page <<sl-sym-gmres>> "+ grid $e_S_Kdim"
    bind $page <<sl-sym-gmres-out>> "grid remove $l_S_Kdim"
    bind $page <<sl-sym-gmres-out>> "+ grid remove $e_S_Kdim"
    if { $show_ramsolid == 1 } {
	solidsolverdep $frame $e_Solver_type rams
    }
}

proc prbdatwin::solidsolverdep { page wdg gen } {

    variable Solid_Solver

    set valindex -1
    set valindex [$wdg getvalue]

    switch $gen {
	"stintg" {
	    if { $valindex == 2 } {
		event generate $page <<sl-forward-euler>>
	    } else {
		event generate $page <<sl-forward-euler-out>>
	    }
	}
	"rams" {
	    set inflist [list l_ramtol e_ramtol l_minramtol e_minramtol l_ramiter e_ramiter]
	    if { $valindex == 2 } {
		foreach item $inflist {
		    grid $page.$item
		}
	    } else {
		foreach item $inflist {
		    grid remove $page.$item
		}
	    }
	}
	"sssym" {
	    if { $valindex == 5 } {
		event generate $page <<sl-sym-gaussseidel>>
	    } else {
		event generate $page <<sl-sym-gaussseidel-out>>
	    }
	    if { $valindex != 3 } {
		event generate $page <<sl-sym-gmres-out>>
		set temp [lreplace [join [lrange $Solid_Solver 2 2]] 3 3 0]
		set Solid_Solver [lreplace $Solid_Solver 2 2 $temp]
	    } else {
		event generate $page <<sl-sym-gmres>>
		set temp [lreplace [join [lrange $Solid_Solver 2 2]] 3 3 1]
		set Solid_Solver [lreplace $Solid_Solver 2 2 $temp]
	    }
	}
    }
}

################################################################################
#
#   PopUp Menus
#
################################################################################

proc prbdatwin::popupmenu { parent {field ""} {fieldname ""} tags content x y } {

    variable predefined_ff

    catch { 
	destroy $parent.menu
    }

    set menu [menu $parent.menu -type normal]

    switch $content {
	1 {
	    if { [string length $field] > 0 } {
		eval set fval $$field
	    }
	    $menu add command -label [= {Define Function}] \
		    -command "FEditor::init $parent \"$predefined_ff\" $field [list $fieldname] [list $fval] \"\" \"\""
	}
    }
    
    tk_popup $menu $x $y

    return 1
}

################################################################################
#
#   Get Values
#
################################################################################

proc prbdatwin::getvalues { } {

    set varlist [list Problem_Prbdata Analysis_Prbdata Results_Prbdata Fluid_Solver Solid_Solver Other_Data]
    set unilist [list Analysis_Unitsdata Other_Unitsdata]

    set gendata [.central.s info gendata]

    # Reading values
    for {set i 0} {$i < [llength $varlist]} {incr i} {
	set thisvar [lindex $varlist $i]
	variable $thisvar
	foreach item [eval set nothing $$thisvar] {
	    variable [lindex $item 0]
	}
	foreach item [eval set nothing $$thisvar] {
	    set itt [lindex $item 0]    
	    set $itt [TUI_readsinglefield gendata $itt]
	}
    }
    # Reading units
    for {set i 0} {$i < [llength $unilist]} {incr i} {
	set thisvar [lindex $unilist $i]
	variable $thisvar
	foreach item [eval set nothing $$thisvar] {
	    variable [lindex $item 0]
	}
	foreach item [eval set nothing $$thisvar] {
	    set itt [lindex $item 0]
	    set nitt [lindex $item 1]
	    set $itt [TUI_formatunits Nums2Unicode \
		    [DWUnder2Space [join [lindex $gendata [expr [lsearch -regexp $gendata \
		                        [eval set nothing ^${itt}(\$|\#CB)]] + 1]]]] 0]
	}
    }
}

proc prbdatwin::checkclose { win {dumpit 1} {askdump 1} {close 1} } {

    global tkPriv tcl_platform

    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver

    # Checking info 
    set valueschange 0
    set wtsave 0
    set usr_err ""
    set num_usr_err 0
    set uerrpg 0
    set varlist [list Problem_Prbdata Analysis_Prbdata Results_Prbdata Fluid_Solver Solid_Solver Other_Data]
    set unilist [list ""              Analysis_Unitsdata ""            ""           ""           ""]
    set paglist [list [= {PROBLEM}] [= {ANALYSIS}] [= {RESULTS}] [= {FLUID_SOLVER}] [= {SOLID_SOLVER}] [= {OTHER}]] 

    set gendata [.central.s info gendata]

    # Checking values
    for {set i 0} {$i < [llength $varlist]} {incr i} {
	set thisvar [lindex $varlist $i]
	set thispag [lindex $paglist $i]
	set uerrpg_$thispag 0
	if { $thisvar != "" } {
	    variable $thisvar
	    foreach item [eval set nothing $$thisvar] {
		variable [lindex $item 0]
	    }
	    foreach item [eval set nothing $$thisvar] {
		set itt [lindex $item 0]
		set $itt [string trim [eval set nothing $$itt]]
		set temp [TUI_readsinglefield gendata $itt]
		if { $temp != [eval set nothing $$itt] } {
		    set valueschange 1
		    if { [lindex $item 3] == 1} {
		        set errcheck [TUI_valuecheck "[eval set nothing $$itt]" [lindex $item 2] 0 ""]
		        if { $errcheck != "ok"} {
		            incr num_usr_err
		            if { [eval set temp \$uerrpg_$thispag] != 1 } {
		                append usr_err "\n[= {%s PAGE} $thispag]\n"
		                set uerrpg_$thispag 1
		            }
		            append usr_err "$num_usr_err. " [DWUnder2Space $itt] ": $errcheck\n"
		        }
		    }
		}
	    }
	}
    }
    # Checking units
    for {set i 0} {$i < [llength $unilist]} {incr i} {
	set thisuni [lindex $unilist $i]
	set thispag [lindex $paglist $i]
	if { $thisuni != "" } {
	    variable $thisuni
	    foreach item [eval set nothing $$thisuni] {
		variable [lindex $item 0]
	    }
	    foreach item [eval set nothing $$thisuni] {
		set itt [lindex $item 0]
		set jtt temp_$itt
		set $jtt [TUI_formatunits Unicode2Nums [eval set temp $$itt] 1]
		set temp [join [lindex $gendata [expr [lsearch -regexp $gendata \
		        [eval set nothing ^${itt}(\$|\#CB)]] + 1]]]
		if { [DWUnder2Space $temp] != [eval set nothing $$jtt] } {
		    set valueschange 1
		    if { [lindex $item 3] == 1} {
		        set errcheck [TUI_valuecheck "[eval set nothing $$jtt]" [lindex $item 2] 0 ""]
		        if { $errcheck != "ok"} {
		            incr num_usr_err
		            if { [eval set temp \$uerrpg_$thispag] != 1 } {
		                append usr_err "\n[= {%s PAGE} $thispag]\n"
		                set uerrpg_$thispag 1
		            }
		            append usr_err "$num_usr_err. " [DWUnder2Space $itt] ": $errcheck\n"
		        }
		    }
		}
	    }
	}
    }
    if { $valueschange == 1 } {
	if { $askdump == 0 } {
	    set answer 0
	} else {
	    set answer [tk_dialogRAM $win [= {Tdyn Problem and solver Data}] \
		    [= {Problem and solver data has changed}].\n[= {Do you want to save changes?}] question 0 Yes No]
	}

	if { $answer == 0 && $dumpit == 1} {
	    set wtsave 1
	    if { $num_usr_err > 0 } {
		if { $num_usr_err > 1 } {
		    set err_display [= "The following %s errors were found in the data input" $num_usr_err]:\n
		} else {
		    set err_display [= {The following error was found in the data input}]:\n
		}
		append err_display $usr_err
		WarnWin $err_display
		set close 0
	    } else {
		prbdatwin::dump
		FloatMessage $win.flm [= {Problem and solver Data were saved.}]
	    }
	}
    } else {
	if { $dumpit == 1 } {
	    FloatMessage $win.flm [= {No changes need to be saved.}]
	}
    }
    # Cierro la ventana si todo es correcto, en otro caso muestra un mensaje de error
    if { $close == 1 } {
	destroy $win
	return $valueschange
    } else {
	if { $num_usr_err == 0 } {
	    return $valueschange
	} else {
	    if { $wtsave == 1 } {
		return "dataerror"
	    } else {
		return "nosave.dataerror"
	    }
	}
    }
}

proc prbdatwin::dump { } {

    variable Problem_Prbdata
    variable Analysis_Prbdata
    variable Analysis_Unitsdata
    variable Results_Prbdata
    variable Fluid_Solver
    variable Solid_Solver
    variable Other_Data

    TUI_dumpsinglefields prbdatwin $Problem_Prbdata ProblemData

    TUI_dumpsinglefields prbdatwin $Analysis_Prbdata ProblemData

    TUI_dumpsingleunits prbdatwin $Analysis_Unitsdata ProblemData

    TUI_dumpsinglefields prbdatwin $Results_Prbdata ProblemData

    TUI_dumpsinglefields prbdatwin $Fluid_Solver ProblemData

    TUI_dumpsinglefields prbdatwin $Solid_Solver ProblemData
    
    TUI_dumpsinglefields prbdatwin $Other_Data ProblemData

    # Actualizamos la variable de control de cambios en GiD
    GIDModifiedFileFlag Set

    return 1
}
