namespace eval solvdatwin {

    global ProgramName
    global tkPriv tcl_platform

    # Tdyn settings
    variable show_fluid [IsVarOnTdynDefaults show_fluid 1]
    variable show_solid [IsVarOnTdynDefaults show_solid 1]
    variable show_ransol [IsVarOnTdynDefaults show_ransol 1]
    variable show_heatrans [IsVarOnTdynDefaults show_heatrans 1]
    variable show_advect [IsVarOnTdynDefaults show_advect 1]
    variable show_ursolver [IsVarOnTdynDefaults show_ursolver 1]
    variable show_alemesh [IsVarOnTdynDefaults show_alemesh 1]
    variable show_naval [IsVarOnTdynDefaults show_naval 1]
    variable show_ramsolid [IsVarOnTdynDefaults show_ramsolid 1]
    variable edit_units [IsVarOnTdynDefaults edit_units 1]

    # RANSOL
    if { $ProgramName == "Tdyn2D" } {
	variable Ransol_Solverdata [list \
		[list Velocity_Advect_Stabilisation "Velocity_Advect_Stabilisation#CB#" string 0 basic] \
		[list Velocity_Control_Level "Velocity_Control_Level#CB#" string 0 basic] \
		[list StabTauV_MinRatio "StabTauV_MinRatio" float 1 basic] \
		[list Velocity_Inner_Iterations "Velocity_Inner_Iterations" integer 1 basic] \
		[list Velocity_Norm "Velocity_Norm" float 1 basic] \
		[list Pressure_Stabilisation "Pressure_Stabilisation#CB#" string 0 basic] \
		[list StabTauP_MinRatio "StabTauP_MinRatio" float 1 basic] \
		[list Pressure_Inner_Iterations "Pressure_Inner_Iterations" integer 1 basic] \
		[list Pressure_Norm "Pressure_Norm" float 1 basic] \
		[list Initialise_Flow_Field "Initialise_Flow_Field" string 0 basic] \
		[list Turbulence_Model "Turbulence_Model#CB#" string 0 basic] \
		[list Turbulence_Advect_Stabilisation "Turbulence_Advect_Stabilisation#CB#" string 0 basic] \
		[list Turbulence_Control_Level "Turbulence_Control_Level#CB#" string 0 basic] \
		[list Turbulence_Inner_Iterations "Turbulence_Inner_Iterations" integer 1 basic] \
		[list Float_By_Density "Floatability by Density" yesno 0 basic] \
		[list GravityOX "Gravity OX" float 1 grav] \
		[list GravityOY "Gravity OY" float 1 grav] \
		[list Fix_Turbulence_On_Bodies "Fix_Turbulence_On_Bodies" string 0 advanced] \
		[list TVisco_Min_Ratio "TVisco_Min_Ratio" float 1 advanced] \
		[list TVisco_Max_Ratio "TVisco_Max_Ratio" float 1 advanced] \
		[list KEnergy_Min_Ratio "KEnergy_Min_Ratio" float 1 advanced] \
		[list KEnergy_Max_Ratio "KEnergy_Max_Ratio" float 1 advanced] \
		[list Epsilon_Min_Ratio "Epsilon_Min_Ratio" float 1 advanced] \
		[list Epsilon_Max_Ratio "Epsilon_Max_Ratio" float 1 advanced] \
		[list Omega_Min_Ratio "Omega_Min_Ratio" float 1 advanced] \
		[list Omega_Max_Ratio "Omega_Max_Ratio" float 1 advanced] \
		[list K_Tau_Min_Ratio "K_Tau_Min_Ratio" float 1 advanced] \
		[list K_Tau_Max_Ratio "K_Tau_Max_Ratio" float 1 advanced] \
		[list Advanced "Advanced#CB#" string 0 nogrid] \
		[list EddyKEnergy_Production_Limit "EddyKEnergy_Production_Limit" float 1 advanced] \
		[list Epsilon_Production_Limit "Epsilon_Production_Limit" float 1 advanced] \
		[list Epsilon_Reaction_Limit "Epsilon_Reaction_Limit" float 1 advanced] \
		[list Omega_Production_Limit "Omega_Production_Limit" float 1 advanced] \
		[list Omega_Reaction_Limit "Omega_Reaction_Limit" float 1 advanced] \
		[list EddyViscoT_Production_Limit "EddyViscoT_Production_Limit" float 1 advanced] \
		[list EddyViscoT_Reaction_Limit "EddyViscoT_Reaction_Limit" float 1 advanced] \
		]
    } elseif { $ProgramName == "Tdyn3D" } {
	variable Ransol_Solverdata [list \
		[list Velocity_Advect_Stabilisation "Velocity_Advect_Stabilisation#CB#" string 0 basic] \
		[list Velocity_Control_Level "Velocity_Control_Level#CB#" string 0 basic] \
		[list StabTauV_MinRatio "StabTauV_MinRatio" float 1 basic] \
		[list Velocity_Inner_Iterations "Velocity_Inner_Iterations" integer 1 basic] \
		[list Velocity_Norm "Velocity_Norm" float 1 basic] \
		[list Pressure_Stabilisation "Pressure_Stabilisation#CB#" string 0 basic] \
		[list StabTauP_MinRatio "StabTauP_MinRatio" float 1 basic] \
		[list Pressure_Inner_Iterations "Pressure_Inner_Iterations" integer 1 basic] \
		[list Pressure_Norm "Pressure_Norm" float 1 basic] \
		[list Initialise_Flow_Field "Initialise_Flow_Field" string 0 basic] \
		[list Turbulence_Model "Turbulence_Model#CB#" string 0 basic] \
		[list Turbulence_Advect_Stabilisation "Turbulence_Advect_Stabilisation#CB#" string 0 basic] \
		[list Turbulence_Control_Level "Turbulence_Control_Level#CB#" string 0 basic] \
		[list Turbulence_Inner_Iterations "Turbulence_Inner_Iterations" integer 1 basic] \
		[list Float_By_Density "Floatability by Density" yesno 0 basic] \
		[list GravityOX "Gravity OX" float 1 grav] \
		[list GravityOY "Gravity OY" float 1 grav] \
		[list GravityOZ "Gravity OZ" float 1 grav] \
		[list Fix_Turbulence_On_Bodies "Fix_Turbulence_On_Bodies" string 0 advanced] \
		[list TVisco_Min_Ratio "TVisco_Min_Ratio" float 1 advanced] \
		[list TVisco_Max_Ratio "TVisco_Max_Ratio" float 1 advanced] \
		[list KEnergy_Min_Ratio "KEnergy_Min_Ratio" float 1 advanced] \
		[list KEnergy_Max_Ratio "KEnergy_Max_Ratio" float 1 advanced] \
		[list Epsilon_Min_Ratio "Epsilon_Min_Ratio" float 1 advanced] \
		[list Epsilon_Max_Ratio "Epsilon_Max_Ratio" float 1 advanced] \
		[list Omega_Min_Ratio "Omega_Min_Ratio" float 1 advanced] \
		[list Omega_Max_Ratio "Omega_Max_Ratio" float 1 advanced] \
		[list K_Tau_Min_Ratio "K_Tau_Min_Ratio" float 1 advanced] \
		[list K_Tau_Max_Ratio "K_Tau_Max_Ratio" float 1 advanced] \
		[list Advanced "Advanced#CB#" string 0 nogrid] \
		[list EddyKEnergy_Production_Limit "EddyKEnergy_Production_Limit" float 1 advanced] \
		[list Epsilon_Production_Limit "Epsilon_Production_Limit" float 1 advanced] \
		[list Epsilon_Reaction_Limit "Epsilon_Reaction_Limit" float 1 advanced] \
		[list Omega_Production_Limit "Omega_Production_Limit" float 1 advanced] \
		[list Omega_Reaction_Limit "Omega_Reaction_Limit" float 1 advanced] \
		[list EddyViscoT_Production_Limit "EddyViscoT_Production_Limit" float 1 advanced] \
		[list EddyViscoT_Reaction_Limit "EddyViscoT_Reaction_Limit" float 1 advanced] \
		]
    }
    foreach item $Ransol_Solverdata {
	variable [lindex $item 0]
	if { [lindex $item 4] == "advanced" } {
	    set ransol_var "at_"
	    append ransol_var [lindex $item 0]
	    variable $ransol_var
	}
    }
    variable Ransol_UnitsRead [list \
	    [list Gravity_Units "Gravity_Units#CB#"] \
	    ]
    foreach item $Ransol_UnitsRead {
	variable [lindex $item 0]
    }

    # HEATRANS
    variable Heatrans_Solverdata [list \
	    [list Temperature_Advect_Stabilisation "Temperature_Advect_Stabilisation#CB#" string 0] \
	    [list Temperature_Control_Level "Temperature_Control_Level_#CB#" string 0] \
	    [list Temperature_Inner_Iterations "Temperature_Inner_Iterations" integer 1] \
	    [list Temperature_Norm "Temperature_Norm" float 1] \
	    [list Prandtl_Number "Prandtl_Number" float 1] \
	    ]
    foreach item $Heatrans_Solverdata {
	variable [lindex $item 0]
    }

    # ADVECT
    variable Advect_Solverdata
    variable Species_Names
    variable Species_Values
    variable Species_Valnames \
	    [list \
	    [list [= {Max limit}] ADVECT_MaxLimit float 1 entry "" "" general] \
	    [list [= {Min limit}] ADVECT_MinLimit float 1 entry "" "" general] \
	    [list [= {Schmidt number}] ADVECT_Schmidt float 1 entry "" "" turbulence] \
	    [list [= {Convergence norm}] ADVECT_Norm float 1 entry "" "" general] \
	    [list [= {Inner iterations}] ADVECT_Iterations integer 1 entry "" "" general] \
	    [list [= {Advect stabilisation}] ADVECT_Type string 0 combo [list "Auto" "4th_Order" "2nd_Order"] "" general] \
	    [list [= {Stability control}] ADVECT_Level integer 0 combo [list 0 1 2 3 4 5] "" general] \
	    [list [= {Volume conservation}] ADVECT_Conservation yesno 0 check [list 0 1] "" general] \
	    [list [= {Reference units}] ADVECT_Units unit 1 entry "" boundary general] \
	    ]
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set advect_var [lindex [lindex $Species_Valnames $i] 1]
	variable $advect_var
    }
    # Advect Species support variables
    variable spcdelerrwarn 0
    variable spcdellasterrwarn 0
    variable spcnlastsel -1
    variable snlist ""
    variable sname

    # URSOLVER
    variable URSolver_Solverdata
    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_Valnames \
	    [list \
	    [list [= {Max limit}] URSOLVER_MaxLimit float 1 entry "" "" general] \
	    [list [= {Min limit}] URSOLVER_MinLimit float 1 entry "" "" general] \
	    [list [= {Convergence norm}] URSOLVER_Norm float 1 entry "" "" general] \
	    [list [= {Inner iterations}] URSOLVER_Iterations integer 1 entry "" "" general] \
	    [list [= {Advect stabilisation}] URSOLVER_Type string 0 combo [list "Auto" "4th_Order" "2nd_Order"] "" general] \
	    [list [= {Stability control}] URSOLVER_Level integer 0 combo [list 0 1 2 3 4 5] "" general] \
	    [list [= {Volume conservation}] URSOLVER_Conservation yesno 0 check [list 0 1] "" general] \
	    [list [= {Reinitialisation}] URSOLVER_IterReinitialisation yesno 0 check [list 0 1] "" "" general] \
	    [list [= {Reference units}] URSOLVER_Units unit 1 entry "" boundary general] \
	    ]
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set ursolver_var [lindex [lindex $URVariables_Valnames $i] 1]
	variable $ursolver_var
    }
    # URSolver support variables
    variable ursdelerrwarn 0
    variable ursdellasterrwarn 0
    variable ursnlastsel -1
    variable ursnlist
    variable ursname ""

    # NAVAL
    variable Naval_Solverdata [list \
	      [list WaveElevation_Norm "WaveElevation_Norm" float 1 basic] \
	      ]
    foreach item $Naval_Solverdata {
	variable [lindex $item 0]
    }

    # ALEMESH
    switch $ProgramName {
	"Tdyn2D" {
	    variable Alemesh_Solverdata [list \
		    [list Fluid_Mesh_Deformation "Fluid_Mesh_Deformation#CB#" string 0 grid] \
		    [list FluidUpdateMeshEvery "FluidUpdateMeshEvery" integer 0 grid] \
		    [list Fluid_Deformation_X "Fluid_Deformation_X" func 1 grid] \
		    [list Fluid_Deformation_Y "Fluid_Deformation_Y" func 1 grid] \
		    [list Fluid_Deformation_Z "Fluid_Deformation_Z" func 1 nogrid] \
		    [list Solid_Mesh_Deformation "Solid_Mesh_Deformation#CB#" string 0 grid] \
		    [list SolidUpdateMeshEvery "SolidUpdateMeshEvery" integer 0 grid] \
		    [list Solid_Deformation_X "Solid_Deformation_X" func 1 grid] \
		    [list Solid_Deformation_Y "Solid_Deformation_Y" func 1 grid] \
		    [list Solid_Deformation_Z "Solid_Deformation_Z" func 1 nogrid] \
		    ]
	}
	"Tdyn3D" {
	    variable Alemesh_Solverdata [list \
		    [list Fluid_Mesh_Deformation "Fluid_Mesh_Deformation#CB#" string 0 grid] \
		    [list FluidUpdateMeshEvery "FluidUpdateMeshEvery" integer 0 grid] \
		    [list Fluid_Deformation_X "Fluid_Deformation_X" func 1 grid] \
		    [list Fluid_Deformation_Y "Fluid_Deformation_Y" func 1 grid] \
		    [list Fluid_Deformation_Z "Fluid_Deformation_Z" func 1 grid] \
		    [list Solid_Mesh_Deformation "Solid_Mesh_Deformation#CB#" string 0 grid] \
		    [list SolidUpdateMeshEvery "SolidUpdateMeshEvery" integer 0 grid] \
		    [list Solid_Deformation_X "Solid_Deformation_X" func 1 grid] \
		    [list Solid_Deformation_Y "Solid_Deformation_Y" func 1 grid] \
		    [list Solid_Deformation_Z "Solid_Deformation_Z" func 1 grid] \
		    ]
	}
    }
    foreach item $Alemesh_Solverdata {
	variable [lindex $item 0]
    }
    variable Alemesh_UnitsRead [list \
	    [list Geometry_Units "Geometry_Units#CB#"] \
	    ]
    foreach item $Alemesh_UnitsRead {
	variable [lindex $item 0]
    }
    # RAMSOLID
    switch $ProgramName {
	"Tdyn2D" {
	    variable Ramsolid_Solverdata ""
	    set show_ramsolid 0
	}
	"Tdyn3D" {
	    variable Ramsolid_Solverdata [list \
		    [list Smooth_per_material "Smooth per material" yesno 1] \
		    [list Coupling_Type "Coupling Type" string 0] \
		    [list Coupling_Step "Coupling Step" ineteger 1] \
		    [list Coupling_Start "Coupling Start" ineteger 1] \
		    [list Coupling_Variable "Coupling Variable" string 0] \
		    [list GravityOX "Gravity OX" float 1] \
		    [list GravityOY "Gravity OY" float 1] \
		    [list GravityOZ "Gravity OZ" float 1] \
		    ]
	}
    }
    foreach item $Ramsolid_Solverdata {
	variable [lindex $item 0]
    }
    variable Ramsolid_UnitsRead [list \
	    [list Gravity_Units "Gravity_Units#CB#"] \
	    ]
    foreach item $Ramsolid_UnitsRead {
	variable [lindex $item 0]
    }

    # Function Editor variables
    variable fluid_variables "x y z nx ny nz t it rand dt exp(1) pi vx vy vz pr tm\
	    vt v_ tau wc ds ke ep om kt pk dn bt sp#"
    variable example_fluid_variables "x y z nx ny nz t it rand dt exp(1)\
	    pi vx vy vz pr tm vt v_ tau wc ds ke ep om kt pk dn bt sp#"
    variable fluid_operators "+ - * / ^ mod div rmod rdiv max min Dx() Dy() Dz()\
	    ~ < <= > >= = != & |"
    variable predefined_ff [list $fluid_variables $example_fluid_variables $fluid_operators]
    switch $ProgramName {
	"Tdyn3D" {
	    variable alemesh_ff [ list \
		    {solvdatwin::Fluid_Deformation_X} {Fluid Deformation X} \
		    {solvdatwin::Fluid_Deformation_Y} {Fluid Deformation Y} \
		    {solvdatwin::Fluid_Deformation_Z} {Fluid Deformation Z} \
		    {solvdatwin::Solid_Deformation_X} {Solid Deformation X} \
		    {solvdatwin::Solid_Deformation_Y} {Solid Deformation Y} \
		    {solvdatwin::Solid_Deformation_Z} {Solid Deformation Z} \
		    ]
	}
	"Tdyn2D" {
	    variable alemesh_ff [ list \
		    {solvdatwin::Fluid_Deformation_X} {Fluid Deformation X} \
		    {solvdatwin::Fluid_Deformation_Y} {Fluid Deformation Y} \
		    {solvdatwin::Solid_Deformation_X} {Solid Deformation X} \
		    {solvdatwin::Solid_Deformation_Y} {Solid Deformation Y} \
		    ]
	}
    }
}

proc solvdatwin::init { parent {show "all"} {tags ""} } {

    global ProgramName
    global tkPriv tcl_platform

    # Tdyn settings
    variable show_fluid
    variable show_solid
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_naval
    variable show_alemesh
    variable show_ramsolid
    variable edit_units

    variable Species_Names
    variable snlist
    variable URVariables_Names
    variable ursnlist

    variable predefined_ff
    variable alemesh_ff

    set tdw $parent.tdw

    if { [TUI_closeotherwindows $tdw 1] == 1 } {

	InitWindow $tdw [= {Tdyn Modules Data}] PreTdynModulesDataWindowGeom ""

	set closecmd "solvdatwin::checkclose $tdw 1 1 1"
	set acceptcmd "solvdatwin::checkclose $tdw 1 0 0"
	wm protocol $tdw WM_DELETE_WINDOW "$closecmd"

	# Reading values from Problem Data
	solvdatwin::getvalues

	# Top frame
	set topf [frame $tdw.f -bg lightblue]
	# Picture Box
	set l_icon [label $topf.l_icon -image [imagefromtdyn solvers.gif] -bg lightblue]
	grid $topf -row 0 -column 0 -sticky nwe
	grid $l_icon -row 0 -column 0 -sticky nw
	grid columnconf $topf 1 -weight 1

	# Main Notebook
	set pages [NoteBook $tdw.pages -homogeneous 1 -arcradius 0]
	grid $pages -row 1 -column 0 -sticky nwes -pady 5

	grid columnconf $tdw 0 -weight 1
	grid rowconf $tdw 1 -weight 1

	set pnum 0
	set firstpage ""

	# Ransol Page
	if { $show_ransol == 1 } {
	    incr pnum
	    set pvar "pg_ransol"
	    if { [string length $firstpage] < 1 } { 
		set firstpage $pvar
	    }
	    set fpvar "fpg_ransol"
	    set $pvar [$pages insert $pnum $pvar -text [= {RANSOL}]]
	    set $fpvar [$pages getframe $pvar]
#            grid columnconf $fpg_ransol 10 -weight 1
#            grid rowconf $fpg_ransol 10 -weight 1
	    solvdatwin::ransol $pg_ransol $parent
	}

	# Heatrans Page
	if { $show_heatrans == 1 } {
	    incr pnum
	    set pvar "pg_heatrans"
	    if { [string length $firstpage] < 1 } { 
		set firstpage $pvar
	    }
	    set fpvar "fpg_heatrans"
	    set $pvar [$pages insert $pnum $pvar -text [= {HEATRANS}]]
	    set $fpvar [$pages getframe $pvar]
#            grid columnconf $fpg_heatrans 10 -weight 1
#            grid rowconf $fpg_heatrans 10 -weight 1
	    solvdatwin::heatrans $pg_heatrans $tags
	}

	# Advect Page
	if { $show_advect == 1 } {
	    incr pnum
	    set pvar "pg_advect"
	    if { [string length $firstpage] < 1 } { 
		set firstpage $pvar
	    }
	    set fpvar "fpg_advect"
	    set $pvar [$pages insert $pnum $pvar -text [= {ADVECT}]]
	    set $fpvar [$pages getframe $pvar]
	    solvdatwin::advect $pg_advect $tags
	}

	# URSolver Page
	if { $show_ursolver == 1 } {
	    incr pnum
	    set pvar "pg_ursolver"
	    if { [string length $firstpage] < 1 } { 
		set firstpage $pvar
	    }
	    set fpvar "fpg_ursolver"
	    set $pvar [$pages insert $pnum $pvar -text [= {URSOLVER}]]
	    set $fpvar [$pages getframe $pvar]
	    solvdatwin::ursolver $pg_ursolver $tags
	}

	# Naval Page
	if { $show_naval == 1 } {
		    incr pnum
		    set pvar "pg_naval"
		    if { [string length $firstpage] < 1 } { 
		            set firstpage $pvar
		        }
		    set fpvar "fpg_naval"
		    set $pvar [$pages insert $pnum $pvar -text [= {NAVAL}]]
		    set $fpvar [$pages getframe $pvar]
		    solvdatwin::naval $pg_naval $parent
	}

	# Alemesh Page
	if { $show_alemesh == 1 } {
	    incr pnum
	    set pvar "pg_alemesh"
	    if { [string length $firstpage] < 1 } { 
		set firstpage $pvar
	    }
	    set fpvar "fpg_alemesh"
	    set $pvar [$pages insert $pnum $pvar -text [= {ALEMESH}]]
	    set $fpvar [$pages getframe $pvar]
	    solvdatwin::alemesh $pg_alemesh $tdw
	}

	# RamSolid Page
	if { $show_ramsolid == 1 } {
	    incr pnum
	    set pvar "pg_ramsolid"
	    if { [string length $firstpage] < 1 } { 
		set firstpage $pvar
	    }
	    set fpvar "fpg_ramsolid"
	    set $pvar [$pages insert $pnum $pvar -text [= {RAMSOLID}]]
	    set $fpvar [$pages getframe $pvar]
	    solvdatwin::ramsolid $pg_ramsolid $tags
	}

	if { $show == "all" } {
	    $pages raise $firstpage
	} elseif { $show_ransol == 1 && $show == "ransol" } {
	    $pages raise pg_ransol
	} elseif { $show_heatrans == 1 && $show == "heatrans" } {
	    $pages raise pg_heatrans
	} elseif { $show_advect == 1 && $show == "advect" } {
	    $pages raise pg_advect
	} elseif { $show_ursolver == 1 && $show == "ursolver" } {
	    $pages raise pg_ursolver
	} elseif { $show_alemesh == 1 && $show == "alemesh" } {
	    $pages raise pg_alemesh
	} elseif { $show_ramsolid == 1 && $show == "ramsolid" } {
	    $pages raise pg_ramsolid
	} else {
	    $pages raise $firstpage
	}

	# Buttons frame
	set bf [frame $tdw.bf -relief raised -takefocus 1]
	# Accept button
	set btn_accept [button $bf.btn_accept -text [= {Accept Data}] -underline 0 -width 10 \
		-relief raised -bd 1 -highlightthickness 1 -takefocus 1 \
		-command "$acceptcmd"]
	# Close button
	set btn_close [button $bf.btn_close -text [= {Close}] -underline 0 -width 10 \
		-relief raised -bd 1 -highlightthickness 1 -takefocus 1 \
		-command "$closecmd"]

	# GRIDS
	grid $bf -row 2 -column 0 -sticky news
	grid $btn_accept -row 0 -column 1 -sticky ew -padx 5 -pady 5
	grid $btn_close -row 0 -column 2 -sticky ew -padx 5 -pady 5

	# BINDS
	bind $tdw <Escape> "tkButtonInvoke $btn_close"
	bind $tdw <Alt-c> "tkButtonInvoke $btn_close"
	bind $tdw <Alt-a> "tkButtonInvoke $btn_accept"
	$pages bindtabs <Button-1> "solvdatwin::selectpage"

	# Selecting Specie / Variable
	if { $show == "advect" || $show == "ursolver" || $firstpage == "pg_advect" || $firstpage == "pg_ursolver" } {
	    if { $show == "advect" || $firstpage == "pg_advect" } {
		set type_Names $Species_Names
		set type_nlist $snlist
		set type "advect"
	    } elseif { $show == "ursolver" || $firstpage == "pg_ursolver" } {
		set type_Names $URVariables_Names
		set type_nlist $ursnlist
		set type "ursolver"
	    }

	    if { $tags > -1 && $tags <= [llength $type_Names] } {
		set setsel $tags
	    } else {
		set setsel 0
	    }
	    solvdatwin::updatespcselection $type_nlist $setsel $type
	    solvdatwin::displayspecievalues $type_nlist $type
	}

	$pages compute_size

	focus $tdw

    }
}

proc solvdatwin::selectpage { page } {
    
    variable spcnlastsel
    variable ursnlastsel
    variable snlist
    variable ursnlist

    switch $page {
	"pg_advect" {
	    solvdatwin::valsavespecie $snlist "" "advect"
	    solvdatwin::updatespcselection $snlist $spcnlastsel "advect"
	    solvdatwin::displayspecievalues $snlist "advect"
	}
	"pg_ursolver" {
	    solvdatwin::valsavespecie $ursnlist "" "ursolver"
	    solvdatwin::updatespcselection $ursnlist $ursnlastsel "ursolver"
	    solvdatwin::displayspecievalues $ursnlist "ursolver"
	}
    }

    return 1
}

################################################################################
#
#   Ransol
#
################################################################################

proc solvdatwin::ransol { page tags } {

    # Tdyn Settings
    variable edit_units

    # Ransol variables
    variable Ransol_Solverdata
    foreach item $Ransol_Solverdata {
	variable [lindex $item 0]
    }
    variable Ransol_UnitsRead
    foreach item $Ransol_UnitsRead {
	variable [lindex $item 0]
    }

    #####  HELP Text variables #####
    # General
    set help_Velocity_Advect_Stabilisation \
	    "[= {Scheme to be used in the stabilisation of the advective terms of the Navier Stokes equations: Standard (2nd_Order) or Improved (4th order)}]."
    set help_Velocity_Control_Level \
	    "[= {Level of control of unstabilities (0 means Off). If unstabilities are found in the velocity field when using the 2nd_Order Advect_Stabilisation, first try to reduce Time_Increment, then to increase this value}].\n[= {Note that high values may cause over-diffusive results}]."
    set help_Velocity_Inner_Iterations \
	    "[= {Number of iterations of the inner nonlinear fluid flow momentum eq. solver (performed every external iteration)}]."
    set help_Velocity_Norm \
	    "[= {Velocity norm used to check convergence in the nonlinear iteration loop}]."
    set help_Pressure_Stabilisation \
	    "[= {Scheme to be used in the stabilisation of the Pressure solver of the Navier Stokes equations}]."
    set help_Pressure_Inner_Iterations \
	    "[= {Number of iterations of the inner nonlinear navier stokes pressure solver (performed every external iteration)}]."
    set help_Pressure_Norm \
	    "[= {Pressure norm used to check convergence in the nonlinear iteration loop}]."
    set help_Initialise_Flow_Field \
	    "[= {Select the type of initialisation of the velocity and pressure field}].\n[= {Initial\
	     values inserted in the \"Initial data window\" will be ignored}]."
    set help_StabTauV_MinRatio \
	    "[= {Minimum admissible ratio (Tau/dt) for the stabilisation parameter tau used in the advection stabilisation}]."
    set help_StabTauP_MinRatio \
	    "[= {Minimum admissible ratio (Tau/dt) for the stabilisation parameter tau used in the pressure stabilisation}]."
    set help_Float_By_Density "[= {Select to simulate floatability forces due to changes in density}]."
    set help_Turbulence_Advect_Stabilisation \
	    "[= {Scheme to be used in the stabilisation of the advective terms of the turbulence equations: Standard (2nd_Order) or Improved (4th order)}]."
    set help_Turbulence_Control_Level \
	    "[= {Level of control of unstabilities for turbulence (0 means Off)}].\n[= {If unstabilities are found in the eddy viscosity field when using the 2nd_Order Advect_Stabilisation, first try to reduce Time_Increment and refine the mesh when possible, then to increase this value}].\n[= {Note that high values may cause over-diffusive results}]."
    set help_Turbulence_Inner_Iterations \
	    "[= {Number of iterations of the inner nonlinear turbulence solver (performed every external iteration)}]."
    set help_WaveElevation_Norm \
	    "[= {Wave Elevation norm used to check convergence in the nonlinear iteration loop}]."
    # Turbulence
    set help_Turbulence_Model \
	    "[= {Select the turbulence model to be used in the fluid problem}]."

    # Advanced Button help
    set help_btn_advanced "[= {Show Advanced Turbulence Data}]."

    # Combo boxes values
    lappend vals_Velocity_Advect_Stabilisation "Auto" "4th_Order" "2nd_Order"
    lappend vals_Velocity_Control_Level "0" "1" "2" "3" "4" "5"
    lappend vals_Pressure_Stabilisation "4th_Order" "2nd_Order"
    lappend vals_Initialise_Flow_Field "None" "Potential_Flow" "Stokes_Flow"
    lappend vals_Turbulence_Advect_Stabilisation "Auto" "4th_Order" "2nd_Order"
    lappend vals_Turbulence_Control_Level "0" "1" "2" "3" "4" "5"
    lappend vals_Turbulence_Model "Laminar" "Mixing_Length" "Smagorinsky" "Kinetic_Energy" "K_Energy_Two_Layers" "K_E_High_Reynolds"\
	"K_E_Two_Layers" "K_E_Lam_Bremhorst" "K_E_Launder_Sharma" "K_Omega" "K_Omega_SST" "K_KT" "Spalart_Allmaras"
    lappend vals_Gravity_Units "m/s\u00b2" "G"

    ### RANSOL Solver Data - LEFT FRAME
    set tframe [TitleFrame $page.gen -relief ridge -text [= {General}]]
    set frame [$tframe getframe]

    # Velocity Advect Stabilisation
    set l_Velocity_Advect_Stabilisation [Label $frame.l_veladvstabil -text "[= {Velocity Advect Stabilisation}] " \
	    -helptext $help_Velocity_Advect_Stabilisation]
    set e_Velocity_Advect_Stabilisation [ComboBox $frame.cbx_veladvstabil -values $vals_Velocity_Advect_Stabilisation \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Velocity_Advect_Stabilisation] \
	    -textvariable solvdatwin::Velocity_Advect_Stabilisation]

    # Velocity Control Level
    set l_Velocity_Control_Level [Label $frame.l_velctrllevel -text "[= {Velocity Control Level}] " \
	    -helptext $help_Velocity_Control_Level]
    set e_Velocity_Control_Level [ComboBox $frame.cbx_velctrllevel -values $vals_Velocity_Control_Level \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Velocity_Control_Level] \
	    -textvariable solvdatwin::Velocity_Control_Level]

    # StabTauV MinRatio
    set l_StabTauV_MinRatio [Label $frame.l_stabtauvminratio -text "[= {StabTauV MinRatio}] " \
	    -helptext $help_StabTauV_MinRatio]
    set e_StabTauV_MinRatio [entry $frame.e_stabtauvminratio -textvariable solvdatwin::StabTauV_MinRatio]

    # Velocity Inner Iterations
    set l_Velocity_Inner_Iterations [Label $frame.l_velinneriter -text "[= {Velocity Inner Iterations}] " \
	    -helptext $help_Velocity_Inner_Iterations]
    set e_Velocity_Inner_Iterations [entry $frame.e_velinneriter -textvariable solvdatwin::Velocity_Inner_Iterations]
    
    # Velocity Norm
    set l_Velocity_Norm [Label $frame.l_velnorm -text "[= {Velocity Norm}] " \
	    -helptext $help_Velocity_Norm]
    set e_Velocity_Norm [entry $frame.e_velnorm -textvariable solvdatwin::Velocity_Norm]
    
    # Pressure Stabilization
    set l_Pressure_Stabilisation [Label $frame.l_pressstabil -text "[= {Pressure Stabilisation}] " \
	    -helptext $help_Pressure_Stabilisation]
    set e_Pressure_Stabilisation [ComboBox $frame.cbx_pressstabil -values $vals_Pressure_Stabilisation \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Pressure_Stabilisation] \
	    -textvariable solvdatwin::Pressure_Stabilisation]

    # StabTauP MinRatio
    set l_StabTauP_MinRatio [Label $frame.l_stabtaupminratio -text "[= {StabTauP MinRatio}] "\
	    -helptext $help_StabTauP_MinRatio]
    set e_StabTauP_MinRatio [entry $frame.e_stabtaupminratio -textvariable solvdatwin::StabTauP_MinRatio]

    # Pressure Inner Iterations
    set l_Pressure_Inner_Iterations [Label $frame.l_pressinneriter -text "[= {Pressure Inner Iterations}] " \
	    -helptext $help_Velocity_Norm]
    set e_Pressure_Inner_Iterations [entry $frame.e_pressinneriter -textvariable solvdatwin::Pressure_Inner_Iterations]
    
    # Pressure Norm
    set l_Pressure_Norm [Label $frame.l_pressnorm -text "[= {Pressure Norm}] " \
	    -helptext $help_Velocity_Norm]
    set e_Pressure_Norm [entry $frame.e_pressnorm -textvariable solvdatwin::Pressure_Norm]

    # Initialise Pressure & Velocity Field
    set l_Initialise_Flow_Field [Label $frame.l_initialisepv -text "[= {Initialise Flow Field}] " \
	    -helptext $help_Initialise_Flow_Field]
    set e_Initialise_Flow_Field [ComboBox $frame.cbx_initialisepv -values $vals_Initialise_Flow_Field \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Initialise_Flow_Field] \
	    -textvariable solvdatwin::Initialise_Flow_Field]

    # Floatability by density
    set l_Float_By_Density [Label $frame.l_ufdens -text "[= {Floatability by Density}] " \
	    -helptext $help_Float_By_Density]
    set e_Float_By_Density [checkbutton $frame.c_ufdens -text "" \
	    -variable solvdatwin::Float_By_Density -onvalue "Yes" -offvalue "No"]

    # Gravity
    set l_Gravity [Label $frame.gravl -text "[= {Gravity Vector}] "]
    set f_Gravity [frame $frame.gravf]
    set e_GravityOX [entry $f_Gravity.gravx -width 6 -textvariable solvdatwin::GravityOX]
    set e_GravityOY [entry $f_Gravity.gravy -width 6 -textvariable solvdatwin::GravityOY]
    set e_GravityOZ [entry $f_Gravity.gravz -width 6 -textvariable solvdatwin::GravityOZ]
    set e_Gravity_Units [ComboBox $frame.gravu -values $vals_Gravity_Units \
	    -editable $edit_units -width [TDYN_getcbxsize 10 $vals_Gravity_Units 0] \
	    -textvariable solvdatwin::Gravity_Units]

    ### RANSOL Solver Data - RIGHT FRAME
    set sframe [TitleFrame $page.adv -relief ridge -text [= {Turbulence}]]
    set frame [$sframe getframe]

    # Turbulence Model
    set l_Turbulence_Model [Label $frame.l_turbmodel -text "[= {Turbulence Model}] " \
	    -helptext $help_Turbulence_Model]
    set e_Turbulence_Model [ComboBox $frame.cbx_surbmodel -values $vals_Turbulence_Model \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Turbulence_Model] \
	    -textvariable solvdatwin::Turbulence_Model]

    # Turbulence Advect Stabilisation
    set l_Turbulence_Advect_Stabilisation [Label $frame.l_turadvstabil \
	    -text "Turbulence Advect Stabilisation " \
	    -helptext $help_Turbulence_Advect_Stabilisation]
    set e_Turbulence_Advect_Stabilisation [ComboBox $frame.cbx_turadvstabil \
	    -values $vals_Turbulence_Advect_Stabilisation \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Turbulence_Advect_Stabilisation] \
	    -textvariable solvdatwin::Turbulence_Advect_Stabilisation]

    # Turbulence Control Level
    set l_Turbulence_Control_Level [Label $frame.l_turctrllevel -text "[= {Turbulence Control Level}] " \
	    -helptext $help_Turbulence_Control_Level]
    set e_Turbulence_Control_Level [ComboBox $frame.cbx_turctrllevel -values $vals_Turbulence_Control_Level \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Turbulence_Control_Level] \
	    -textvariable solvdatwin::Turbulence_Control_Level]

    # Turbulence Inner Iterations
    set l_Turbulence_Inner_Iterations [Label $frame.l_turinneriter -text "[= {Turbulence Inner Iterations}] " \
	    -helptext $help_Velocity_Norm]
    set e_Turbulence_Inner_Iterations [entry $frame.e_turinneriter \
	    -textvariable solvdatwin::Turbulence_Inner_Iterations]

    # Advanced Turbulence Data button
    set btn_adv [Button $frame.btn_adv -underline 0 -helptext $help_btn_advanced\
	    -command "solvdatwin::ransoladvturbulence $tags" \
	    -text "[= {More}]..." -takefocus 1]
    
    # GRIDS
    # SizeLabel
    grid $tframe -row 0 -column 0 -padx 7 -pady 3 -sticky wne
    grid $sframe -row 1 -column 0 -padx 7 -pady 3 -sticky wne
 
    set row 0 
    set col 0
    foreach item $Ransol_Solverdata {
	if { [lindex $item 4] == "basic" } {
	    set itt [lindex $item 0]
	    set lvar "l_$itt"
	    set evar "e_$itt"
	    grid [eval set temp $$lvar] -row $row -column 0 -sticky en -pady 2
	    grid [eval set temp $$evar] -row $row -column 1 -sticky wn -pady 2 -padx 5
	    set help "help_$itt"
	    if { [info exist $help] } {
		GidHelp [eval set temp $$lvar] [eval set temp $$help]
		GidHelp [eval set temp $$evar] [eval set temp $$help]
	    }
	    incr row
	} elseif { [lindex $item 4] == "grav" } {
	    if { $col == 0 } {
		grid $l_Gravity -row $row -column $col -sticky en -pady 2 -padx 5
		incr col
		grid $f_Gravity -row $row -column $col -sticky ewn -pady 2 -padx 3
		incr col
		grid $e_Gravity_Units -row $row -column $col -sticky en -pady 2
		set grow $row
		grid columnconf $f_Gravity 10 -weight 1
	    }
	    set itt [lindex $item 0]
	    set evar "e_$itt"
	    grid [eval set temp $$evar] -row $grow -column $col -sticky wn -pady 2 -padx 2
	    incr col
	    set help "help_$itt"
	    if { [info exist $help] } {
		GidHelp [eval set temp $$evar] [eval set temp $$help]
	    }
	}
    }
    grid columnconfigure $page 0 -weight 1
    grid rowconfigure $page 2 -weight 1
 
    grid $btn_adv -row $row -column 0 -sticky en -pady 2 -padx 1
}

proc solvdatwin::ransoladvturbulence { parent } {

    # Ransol variables
    variable Ransol_Solverdata
    foreach item $Ransol_Solverdata {
	variable [lindex $item 0]
	if { [lindex $item 4] == "advanced" } {
	    set itt [lindex $item 0]
	    set var "at_"
	    append var $itt
	    variable $var
	    set $var [eval set nothing $$itt]
	}
    }

    # Combo boxes values
    lappend vals_Fix_Turbulence_On_Bodies "Yes" "No" "OnlyK"

    set w $parent.sdadvturb
    InitWindow $w [= {Advanced Turbulence Data}] PreTdynSolvdatAdvTurbWindowGeom ""
    set closecmd "solvdatwin::ransoladvturbulencecheckclose $w 1 1 1"
    wm protocol $w WM_DELETE_WINDOW "$closecmd"

    #####  HELP Text variables #####
    set help_Fix_Turbulence_On_Bodies \
	    [= {Select yes if you want the value of Epsilon or Omega on Bodies to be fixed automatically}]
    set help_EddyKEnergy_Production_Limit \
	    "[= "Maximum ratio between the Eddy kinetic energy production and reaction term.\nThis limiter may prevent the unrealistic buildup of eddy\nviscosity in the stagnation region of the bodies.\nRecommended value is 20.0"]."
    set help_Epsilon_Production_Limit \
	    "[= {Maximum ratio between the Epsilon production and reaction term}]."
    set help_Epsilon_Reaction_Limit \
	    "[= {Maximum ratio between the Epsilon reaction and production term}]."
    set help_Omega_Production_Limit \
	    "[= {Maximum ratio between the Omega production and reaction term}]."
    set help_Omega_Reaction_Limit \
	    "[= {Maximum ratio between the Omega reaction and production term}]."
    set help_EddyViscoT_Production_Limit \
	    "[= {Maximum ratio between the Spallart-Almarax model production and reaction term}]."
    set help_EddyViscoT_Reaction_Limit \
	    "[= {Maximum ratio between the Spallart-Almarax model reaction and production term}]."
    set help_TVisco_Min_Ratio \
	    "[= {Eddy viscosity ratio taken used to calculate the minimum admissible value}].\n[= {Reference value is the maximum physical viscosity of the problem.}]"    
    set help_TVisco_Max_Ratio \
	    "[= {Eddy viscosity ratio taken used to calculate the maximum admissible value}]\n[= {Reference value is the maximum physical viscosity of the problem.}]"
    set help_KEnergy_Min_Ratio \
	    "[= {Eddy Kinetic Energy ratio taken used to calculate the minimum admissible value}].\n[= {Reference value is the maximum initial kinetic energy of the problem.}]"
    set help_KEnergy_Max_Ratio \
	    "[= {Eddy Kinetic Energy ratio taken used to calculate the maximum admissible value}]\n[= {Reference value is the maximum initial kinetic energy of the problem.}]"
    set help_Epsilon_Min_Ratio \
	    "[= {Epsilon ratio taken used to calculate the minimum admissible value}].\n[= {Reference value is the maximum initial epsilon of the problem.}]"
    set help_Epsilon_Max_Ratio \
	    "[= {Epsilon ratio taken used to calculate the maximum admissible value}].\n[= {Reference value is the maximum initial epsilon of the problem.}]"
    set help_Omega_Min_Ratio \
	    "[= {Omega ratio taken used to calculate the minimum admissible value}].\n[= {Reference value is the maximum initial omega of the problem.}]"
    set help_Omega_Max_Ratio \
	    "[= {Omega ratio taken used to calculate the maximum admissible value}].\n[= {Reference value is the maximum initial omega of the problem.}]"
    set help_K_Tau_Min_Ratio \
	    "[= {K_Tau ratio taken used to calculate the minimum admissible value}].\n[= {Reference value is the maximum initial ktau  of the problem.}]"
    set help_K_Tau_Max_Ratio \
	    "[= {K_Tau ratio taken used to calculate the maximum admissible value}].\n[= {Reference value is the maximum initial ktau  of the problem.}]"

    ### RANSOL Solver Data - ADVANCED TURBULENCE
    set frame [frame $w.f -relief flat]

    # Fix_Turbulence_On_Bodies
    set l_Fix_Turbulence_On_Bodies [Label $frame.l_fixturbod -text "[= {Fix Turbulence On Bodies}] " \
	    -helptext $help_Fix_Turbulence_On_Bodies]
    set e_Fix_Turbulence_On_Bodies [ComboBox $frame.cbx_ftimeintegration \
	    -values $vals_Fix_Turbulence_On_Bodies -width 16 \
	    -editable 0 -textvariable solvdatwin::at_Fix_Turbulence_On_Bodies]

    # TVisco Min Ratio
    set l_TVisco_Min_Ratio [Label $frame.l_tvisminrat -text "[= {TVisco Min Ratio}] " \
	    -helptext $help_TVisco_Min_Ratio]
    set e_TVisco_Min_Ratio [entry $frame.e_tvisminrat -textvariable solvdatwin::at_TVisco_Min_Ratio]

    # TVisco Max Ratio
    set l_TVisco_Max_Ratio [Label $frame.l_tvismaxrat -text "[= {TVisco Max Ratio}] " \
	    -helptext $help_TVisco_Max_Ratio]
    set e_TVisco_Max_Ratio [entry $frame.e_tvismaxrat -textvariable solvdatwin::at_TVisco_Max_Ratio]

    # KEnergy Min Ratio
    set l_KEnergy_Min_Ratio [Label $frame.l_kensminrat -text "[= {KEnergy Min Ratio}] " \
	    -helptext $help_KEnergy_Min_Ratio]
    set e_KEnergy_Min_Ratio [entry $frame.e_kensminrat -textvariable solvdatwin::at_KEnergy_Min_Ratio]

    # KEnergy Max Ratio
    set l_KEnergy_Max_Ratio [Label $frame.l_kensmaxrat -text "[= {KEnergy Max Ratio}] " \
	    -helptext $help_KEnergy_Max_Ratio]
    set e_KEnergy_Max_Ratio [entry $frame.e_kensmaxrat -textvariable solvdatwin::at_KEnergy_Max_Ratio]

    # Epsilon Min Ratio
    set l_Epsilon_Min_Ratio [Label $frame.l_epssminrat -text "[= {Epsilon Min Ratio}] " \
	    -helptext $help_Epsilon_Min_Ratio]
    set e_Epsilon_Min_Ratio [entry $frame.e_epssminrat -textvariable solvdatwin::at_Epsilon_Min_Ratio]

    # Epsilon Max Ratio
    set l_Epsilon_Max_Ratio [Label $frame.l_epssmaxrat -text "[= {Epsilon Max Ratio}] " \
	    -helptext $help_Epsilon_Max_Ratio]
    set e_Epsilon_Max_Ratio [entry $frame.e_epssmaxrat -textvariable solvdatwin::at_Epsilon_Max_Ratio]

    # Omega Min Ratio
    set l_Omega_Min_Ratio [Label $frame.l_omgsminrat -text "[= {Omega Min Ratio}] " \
	    -helptext $help_Omega_Min_Ratio]
    set e_Omega_Min_Ratio [entry $frame.e_omgsminrat -textvariable solvdatwin::at_Omega_Min_Ratio]

    # Omega Max Ratio
    set l_Omega_Max_Ratio [Label $frame.l_omgsmaxrat -text "[= {Omega Max Ratio}] " \
	    -helptext $help_Omega_Max_Ratio]
    set e_Omega_Max_Ratio [entry $frame.e_omgsmaxrat -textvariable solvdatwin::at_Omega_Max_Ratio]

    # K_Tau Min Ratio
    set l_K_Tau_Min_Ratio [Label $frame.l_ktausminrat -text "[= {K_Tau Min Ratio}] " \
	    -helptext $help_K_Tau_Min_Ratio]
    set e_K_Tau_Min_Ratio [entry $frame.e_ktausminrat -textvariable solvdatwin::at_K_Tau_Min_Ratio]

    # K_Tau Max Ratio
    set l_K_Tau_Max_Ratio [Label $frame.l_ktausmaxrat -text "[= {K_Tau Max Ratio}] " \
	    -helptext $help_K_Tau_Max_Ratio]
    set e_K_Tau_Max_Ratio [entry $frame.e_ktausmaxrat -textvariable solvdatwin::at_K_Tau_Max_Ratio]

    # EddyKEnergy Production Limit
    set l_EddyKEnergy_Production_Limit [Label $frame.l_ekeprodlim -text "[= {EddyKEnergy Production Limit}] " \
	    -helptext $help_EddyKEnergy_Production_Limit]
    set e_EddyKEnergy_Production_Limit [entry $frame.e_ekeprodlim -textvariable solvdatwin::at_EddyKEnergy_Production_Limit]

    # Epsilon Production Limit
    set l_Epsilon_Production_Limit [Label $frame.l_epsprodlim -text "[= {Epsilon Production Limit}] " \
	    -helptext $help_Epsilon_Production_Limit]
    set e_Epsilon_Production_Limit [entry $frame.e_epsprodlim -textvariable solvdatwin::at_Epsilon_Production_Limit]

    # Epsilon Reaction Limit
    set l_Epsilon_Reaction_Limit [Label $frame.l_epsreaclim -text "[= {Epsilon Reaction Limit}] " \
	    -helptext $help_Epsilon_Reaction_Limit]
    set e_Epsilon_Reaction_Limit [entry $frame.e_epsreaclim -textvariable solvdatwin::at_Epsilon_Reaction_Limit]

    # Omega Production Limit
    set l_Omega_Production_Limit [Label $frame.l_omgprodlim -text "[= {Omega Production Limit}] " \
	    -helptext $help_Omega_Production_Limit]
    set e_Omega_Production_Limit [entry $frame.e_omgprodlim -textvariable solvdatwin::at_Omega_Production_Limit]

    # Omega Reaction Limit
    set l_Omega_Reaction_Limit [Label $frame.l_omgreaclim -text "[= {Omega Reaction Limit}] " \
	    -helptext $help_Omega_Reaction_Limit]
    set e_Omega_Reaction_Limit [entry $frame.e_omgreaclim -textvariable solvdatwin::at_Omega_Reaction_Limit]

    # EddyViscoT Production Limit
    set l_EddyViscoT_Production_Limit [Label $frame.l_edvtprodlim -text "[= {EddyViscoT Production Limit}] " \
	    -helptext $help_EddyViscoT_Production_Limit]
    set e_EddyViscoT_Production_Limit [entry $frame.e_edvtprodlim -textvariable solvdatwin::at_EddyViscoT_Production_Limit]

    # EddyViscoT Reaction Limit
    set l_EddyViscoT_Reaction_Limit [Label $frame.l_edvtreaclim -text "[= {EddyViscoT Reaction Limit}] " \
	    -helptext $help_EddyViscoT_Reaction_Limit]
    set e_EddyViscoT_Reaction_Limit [entry $frame.e_edvtreaclim -textvariable solvdatwin::at_EddyViscoT_Reaction_Limit]

    # Buttons Frame
    set bf [frame $w.bf -relief raised -takefocus 1]

    # Accept button
    set btn_accept [button $bf.btn_accept -text [= {Accept Data}] -underline 0 -relief raised \
	    -bd 1 -highlightthickness 1 -bg lightblue -takefocus 1 \
	    -command "solvdatwin::ransoladvturbulencecheckclose $w 1 0 0"]

    # Close button
    set btn_close [button $bf.btn_close -text [= {Close}] -underline 0 -relief raised \
	    -bd 1 -highlightthickness 1 -bg lightblue -takefocus 1 \
	    -command "$closecmd"]


    # GRIDS
    # SizeLabel
    grid $frame -row 0 -column 0 -padx 7 -sticky wn
    set row 1
    foreach item $Ransol_Solverdata {
	if { [lindex $item 4] == "advanced" } {
	    set itt [lindex $item 0]
	    set lvar "l_$itt"
	    set evar "e_$itt"
	    grid [eval set temp $$lvar] -row $row -column 0 -sticky en -pady 2
	    grid [eval set temp $$evar] -row $row -column 1 -sticky wn -pady 2 -padx 5
	    set help "help_$itt"
	    if { [info exist $help] } {
		GidHelp [eval set temp $$lvar] [eval set temp $$help]
		GidHelp [eval set temp $$evar] [eval set temp $$help]
	    }
	    incr row
	}
    }
    grid $bf -row 1 -column 0 -sticky ne -padx 10 -pady 7
    grid $btn_accept -row 0 -column 0 -sticky e -pady 1
    grid $btn_close -row 0 -column 1 -sticky e -pady 1

    grid rowconf $w 3 -weight 1
    grid columnconf $w 1 -weight 1

    # BINDS
    bind $w <Escape> "tkButtonInvoke $btn_close"
    bind $w <Alt-c> "tkButtonInvoke $btn_close"
    bind $w <Alt-a> "tkButtonInvoke $btn_accept"

    focus $w

    return 1
}

proc solvdatwin::ransoladvturbulencecheckclose { win {dumpit 1} {askdump 1} {close 1} } {

    # Ransol variables
    variable Ransol_Solverdata
    foreach item $Ransol_Solverdata {
	variable [lindex $item 0]
	if { [lindex $item 4] == "advanced" } {
	    set var "at_"
	    append var [lindex $item 0]
	    variable $var
	}
    }

    set valueschange 0
    set usr_err ""
    set num_usr_err 0

    # Checking RANSOL Advanced Turbulence Data
    # If no errors are detected and parameter dumpit == 1, data will be copied 
    # to Ransol Solver Data variables.
    foreach item $Ransol_Solverdata {
	if { [lindex $item 4] == "advanced" } {
	    set exitt [lindex $item 0]
	    set itt "at_$exitt"
	    if { [eval set nothing $$exitt] != [eval set nothing $$itt] } {
		set valueschange 1
		if { [lindex $item 3] == 1} {
		    set errcheck [TUI_valuecheck [DWSpace2Under [eval set nothing $$itt]] \
		            [lindex $item 2] 0 ""]
		    if { $errcheck != "ok"} {
		        incr num_usr_err
		        append usr_err "$num_usr_err. " [DWUnder2Space $exitt] ": $errcheck\n"
		    }
		}
	    }
	}
    }

    if { $valueschange == 1 } {
	if { $askdump == 0 } {
	    set answer 0
	} else {
	    set answer [tk_dialogRAM $win [= {Advanced Turbulence Data}] \
		    [= {Advanced Turbulence Data has changed}].\n[= {Do you want to save changes?}] question 0 Yes No]
	}

	if { $answer == 0 && $dumpit == 1} {
	    set wtsave 1
	    if { $num_usr_err > 0 } {
		if { $num_usr_err > 1 } {
		    set err_display "[= {The following %s errors were found in the data input} $num_usr_err]:\n"
		} else {
		    set err_display "[= {The following error was found in the data input}]:\n"
		}
		append err_display $usr_err
		WarnWin $err_display
		set close 0
	    } else {
		solvdatwin::ransoladvturbulencedump
		FloatMessage $win.flm "[= {Advanced Turbulence Data was saved}]."
	    }
	}
    } else {
	if { $dumpit == 1 } {
	    FloatMessage $win.flm "[= {No changes need to be saved}]."
	}
    }

    if { $close == 1 } {
	destroy $win
    } else {
	focus $win
	if { $num_usr_err == 0 } {
	    return $valueschange
	} else {
	    if { $wtsave == 1 } {
		return "dataerror"
	    } else {
		return "nosave.dataerror"
	    }
	}
    }
}

proc solvdatwin::ransoladvturbulencedump { } {

    # Ransol variables
    variable Ransol_Solverdata
    foreach item $Ransol_Solverdata {
	variable [lindex $item 0]
	if { [lindex $item 4] == "advanced" } {
	    set var "at_"
	    append var [lindex $item 0]
	    variable $var
	}
    }

    # Save Ransol Advanced Turbulence Data
    foreach item $Ransol_Solverdata {
	if { [lindex $item 4] == "advanced" } {
	    set exitt [lindex $item 0]
	    set itt "at_$exitt"
	    set vname [lindex $item 1]
	    set val [DWSpace2Under [eval set nothing $$itt]]
	    set $exitt $val
	    .central.s process escape escape escape escape Data \
		    ProblemData -SingleField- "$vname" "\"$val\""
	    .central.s process escape escape escape escape
	}
    }
}

################################################################################
#
#   Heatrans
#
################################################################################

proc solvdatwin::heatrans { page tags } {

    # Heatrans variables
    variable Heatrans_Solverdata
    foreach item $Heatrans_Solverdata {
	variable [lindex $item 0]
    }

    #####  HELP Text variables #####
    set help_Temperature_Advect_Stabilisation \
	    "[= {Scheme to be used in the stabilisation of the advective terms of the temperature equations: Standard (2nd_Order) or Improved (4th order)}]."
    set help_Temperature_Control_Level \
	    "[= {Level of homogeneous diffusion control (0 means Off)}]. [= {If unstabilities are found in the temperature field, increase this value}]. [= {Note that high values may cause over-diffusive results}]."
    set help_Temperature_Inner_Iterations \
	    "[= {Number of iterations of the inner nonlinear temperature solver (performed every external iteration)}]."
    set help_Temperature_Norm \
	    "[= {Temperature norm used to check convergence in the nonlinear iteration loop}]."
    set help_Prandtl_Number \
	    "[= {Turbulent Prandtl number (kt=Cp.Mut/Prt)}]."

    # Combo boxes values
    lappend vals_Temperature_Advect_Stabilisation "Auto" "4th_Order" "2nd_Order"
    lappend vals_Temperature_Control_Level "0" "1" "2" "3" "4" "5"

    ## General Frame
    set tframe [TitleFrame $page.f -relief ridge -text [= {General}]]
    set frame [$tframe getframe]

    # Invisible size label
#    set sizelabel [label $frame.l_sizelabel \
#            -text "                                                         " -bd 0 ]

    # Temperature Advect Stabilisation
    set l_Temperature_Advect_Stabilisation [Label $frame.l_tempadvstabil -text "[= {Temp. Advect Stabilisation}] " \
	    -helptext $help_Temperature_Advect_Stabilisation]
    set e_Temperature_Advect_Stabilisation [ComboBox $frame.cbx_tempadvstabil -values $vals_Temperature_Advect_Stabilisation \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Temperature_Advect_Stabilisation] \
	    -textvariable solvdatwin::Temperature_Advect_Stabilisation]

     # Temperature Control Level
    set l_Temperature_Control_Level [Label $frame.l_tempctrllevel -text "[= {Temp. Control Level}] " \
	    -helptext $help_Temperature_Control_Level]
    set e_Temperature_Control_Level [ComboBox $frame.cbx_tempctrllevel -values $vals_Temperature_Control_Level \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Temperature_Control_Level] \
	    -textvariable solvdatwin::Temperature_Control_Level]

    # Temperature Inner Iterations
    set l_Temperature_Inner_Iterations [Label $frame.l_tempinneriter -text "[= {Temp. Inner Iterations}] " \
	    -helptext $help_Temperature_Inner_Iterations]
    set e_Temperature_Inner_Iterations [entry $frame.e_tempinneriter -textvariable solvdatwin::Temperature_Inner_Iterations]
    
    # Temperature Norm
    set l_Temperature_Norm [Label $frame.l_tempnorm -text "[= {Temperature Norm}] " \
	    -helptext $help_Temperature_Norm]
    set e_Temperature_Norm [entry $frame.e_tempnorm -textvariable solvdatwin::Temperature_Norm]

    ## Turbulence Frame
    set sframe [TitleFrame $page.tur -relief ridge -text "[= {Turbulence}] "]
    set frame [$sframe getframe]

    # Prandtl Number
    set l_Prandtl_Number [Label $frame.l_prandtl -text "[= {Prandtl Number}] " \
	    -helptext $help_Prandtl_Number]
    set e_Prandtl_Number [entry $frame.e_prandtl -textvariable solvdatwin::Prandtl_Number]

    # GRIDS
    # SizeLabel
    grid $tframe -row 0 -column 0 -padx 7 -pady 3 -sticky wen
    grid $sframe -row 1 -column 0 -padx 7 -pady 3 -sticky wen

    set row 0
    foreach item $Heatrans_Solverdata {
	set itt [lindex $item 0]
	set lvar "l_$itt"
	set evar "e_$itt"
	grid [eval set temp $$lvar] -row $row -column 0 -sticky en -pady 2
	grid [eval set temp $$evar] -row $row -column 1 -sticky wn -pady 2
	set help "help_$itt"
	if { [info exist $help] } {
	    GidHelp [eval set temp $$lvar] [eval set temp $$help]
	    GidHelp [eval set temp $$evar] [eval set temp $$help]
	}
	incr row
    }
    grid columnconfigure $page 0 -weight 1
    grid rowconfigure $page 2 -weight 1
}

################################################################################
#
#   Advect
#
################################################################################

proc solvdatwin::advect { page tags } {

    # Advect variables
    variable Species_Names
    variable Species_Values
    variable Species_Valnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    # Advect Species support variables
    variable spcdelerrwarn 0
    variable spcdellasterrwarn 0
    variable spcnlastsel -1
    variable snlist
    variable sname

    set frame [frame $page.f -relief flat]

    # Paned window
    set pw [PanedWindow $frame.pw]
    set pane1 [$pw add -weight 1]
    set pane2 [$pw add -weight 1]

    # Species Names in scrolled window
    set spc_scrw [ScrolledWindow $pane1.spc_scrw -scrollbar both]
    set snlist [listbox $spc_scrw.snlist -selectbackground lightblue -selectforeground black \
		-selectborderwidth 1 -selectmode extended -height 5 -bg white -width 10]
    $spc_scrw setwidget $snlist

    # Selected Specie values frames for general and turbulence data
    set gframe [TitleFrame $pane2.f -relief ridge -text [= {General}]]
    set sglist [$gframe getframe]
    set tframe [TitleFrame $pane2.t -relief ridge -text [= {Turbulence}]]
    set stlist [$tframe getframe]

    # GRIDS
    grid $frame -row 0 -column 0 -sticky wnes
    grid $pw -row 0 -column 0 -sticky wnes
    grid $spc_scrw -row 0 -column 0 -sticky wnes
    grid $gframe -row 0 -column 0 -padx 7 -pady 3 -sticky wen
    grid $tframe -row 1 -column 0 -padx 7 -pady 3 -sticky wen
    grid columnconfigure $page 0 -weight 1
    grid rowconfigure $page 0 -weight 1
    grid columnconf $frame 0 -weight 1
    grid rowconf $frame 0 -weight 1
    grid columnconf $pw 0 -weight 1
    grid rowconf $pw 0 -weight 1
    grid columnconf $pane1 0 -weight 1
    grid rowconf $pane1 0 -weight 1
    grid columnconf $pane2 0 -weight 1
    grid rowconf $pane2 10 -weight 1
    grid columnconf $snlist 0 -weight 1
    grid rowconf $snlist 0 -weight 1
    grid columnconf $tframe 0 -weight 1

    # BINDS 
    bind $snlist <<ListboxSelect>> ";
    solvdatwin::valsavespecie $snlist \"last\" \"advect\"; 
    solvdatwin::displayspecievalues $snlist \"advect\";
    solvdatwin::displayspeciesnames $snlist \"advect\";
    "

    # Insert Species Names to listbox
    solvdatwin::displayspeciesnames $snlist "advect"
    # Create Species Values widgets
    solvdatwin::makespecie $snlist $sglist $stlist "advect"
    # Put specie values into entries
    solvdatwin::displayspecievalues $snlist "advect"
}

################################################################################
#
#   URSolver
#
################################################################################

proc solvdatwin::ursolver { page tags } {

    # URSolver Species variables
    variable URSolver_Solverdata
    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_UValues
    # URSolver Species variables
    variable URVariables_Valnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    # URSolver Species support variables
    variable ursdelerrwarn 0
    variable ursdellasterrwarn 0
    variable ursnlastsel -1
    variable ursnlist
    variable ursname

    set frame [frame $page.f -relief flat]

    # Paned window
    set upw [PanedWindow $frame.pw]
    set upane1 [$upw add -weight 1]
    set upane2 [$upw add -weight 1]

    # Variables Names in scrolled window
    set ursv_scrw [ScrolledWindow $upane1.ursv_scrw -scrollbar both]
    set ursnlist [listbox $ursv_scrw.ursnlist -selectbackground lightblue -selectforeground black \
	    -selectborderwidth 1 -selectmode extended -height 5 -bg white -width 10]
    $ursv_scrw setwidget $ursnlist

    # Selected Specie values frame
    set tframe [TitleFrame $upane2.f -relief ridge -text [= {General}]]
    set ursvlist [$tframe getframe]
#    set ursvlist [frame $upane2.ursvlist -relief flat]

    # GRIDS
    grid $frame -row 0 -column 0 -sticky wnes
    grid $upw -row 0 -column 0 -sticky wnes
    grid $ursv_scrw -row 0 -column 0 -sticky wnes
    grid $tframe -row 0 -column 0 -sticky wen
    grid columnconfigure $page 0 -weight 1
    grid rowconfigure $page 0 -weight 1
    grid columnconf $frame 0 -weight 1
    grid rowconf $frame 0 -weight 1
    grid columnconf $upw 0 -weight 1
    grid rowconf $upw 0 -weight 1
    grid columnconf $upane1 0 -weight 1
    grid rowconf $upane1 0 -weight 1
    grid columnconf $upane2 0 -weight 1
    grid rowconf $upane2 0 -weight 1
#    grid columnconf $ursv_scrw 0 -weight 1
#    grid rowconf $ursv_scrw 0 -weight 1
    grid columnconf $ursnlist 0 -weight 1
    grid rowconf $ursnlist 0 -weight 1
    grid columnconf $tframe 0 -weight 1

    # BINDS 
    bind $ursnlist <<ListboxSelect>> ";
    solvdatwin::valsavespecie $ursnlist \"last\" \"ursolver\"; 
    solvdatwin::displayspecievalues $ursnlist \"ursolver\";
    solvdatwin::displayspeciesnames $ursnlist \"ursolver\";
    "

    # Insert Species Names to listbox
    solvdatwin::displayspeciesnames $ursnlist "ursolver"
    # Selecting first Specie
    if { $tags > -1 && $tags <= [llength $URVariables_Names] } {
	set setsel $tags
    } else {
	set setsel 0
    }
    solvdatwin::updatespcselection $ursnlist $setsel "ursolver"
    # Create Species Values widgets
    solvdatwin::makespecie $ursnlist $ursvlist $ursvlist "ursolver"
    # Put specie values into entries
    solvdatwin::displayspecievalues $ursnlist "ursolver"
}

################################################################################
#
#   Species Manipulation
#   The following functions are used to manipulate the ADVECT Solver Data
#   as well as the URSolver Solver Data.
#
################################################################################

proc solvdatwin::makespecie { nlist vframe wframe type } {
 
    # Tdyn Settings
    variable edit_units

    # Advect Variables
    variable Species_Values
    variable Species_Names
    variable Species_Valnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }

    # URSolver Variables
    variable URVariables_Values
    variable URVariables_Names
    variable URVariables_Valnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }

    # Grid Values Frame
    switch $type {
	"advect" {
	    # Specie Name
	    set l_sname [Label $vframe.l_sname -text "[= {Species Name}] : "]
	    set e_sname [Entry $vframe.e_sname -width 21 -textvariable solvdatwin::sname \
		    -editable 0 -background [$vframe cget -background] -relief flat]
	}
	"ursolver" {
	    # Variable Name
	    set l_sname [Label $vframe.l_vname -text "[= {Variable Name}] : "]
	    set e_sname [Entry $vframe.e_vname -width 21 -textvariable solvdatwin::ursname \
		    -editable 0 -background [$vframe cget -background] -relief flat]
	}
    }

    # GRIDS
    # Label
    grid $l_sname -row 0 -column 0 -sticky wn -pady 5
    # Entry
    grid $e_sname -row 0 -column 1 -columnspan 2 -sticky wn -pady 5

    switch $type {
	"advect" {
	    set type_Valnames $Species_Valnames
	}
	"ursolver" {
	    set type_Valnames $URVariables_Valnames
	}
    }
    # Creating widgets
    for { set i 0 } { $i < [llength $type_Valnames] } { incr i } {
	set tvar [lindex [lindex $type_Valnames $i] 1]
	set vtype [lindex [lindex $type_Valnames $i] 2]
	set tname [lindex [lindex $type_Valnames $i] 0]
	set etype [lindex [lindex $type_Valnames $i] 4]
	set cbx_vals [lindex [lindex $type_Valnames $i] 5]
	set frame $vframe
	if { [lindex [lindex $type_Valnames $i] 7]!="general" } { set frame $wframe }
	# Defining a Label
	set lvar l_$tvar
	set $lvar [Label $frame.$lvar -text "$tname "]
	# Defining an Entry     
	set evar e_$tvar
	if { $vtype == "unit"} {
	    set edbl $edit_units
	} else {
	    if { $etype == "entry" } {
		set edbl 1
	    } else {
		set edbl 0
	    }
	}
	if { $etype == "entry" } {
	    set $evar [Entry $frame.$evar -width 11 -editable $edbl -textvariable solvdatwin::$tvar]
	} elseif { $etype == "combo" } {
	    set $evar [ComboBox $frame.$evar -values $cbx_vals -editable $edbl \
		    -width [TDYN_getcbxsize 9 $cbx_vals] -textvariable solvdatwin::$tvar -takefocus 1]
	} elseif { $etype == "check" } {
	    set $evar [checkbutton $frame.$evar -variable solvdatwin::$tvar \
		-offvalue [lindex $cbx_vals 0] -onvalue [lindex $cbx_vals 1]]
	}
	# GRIDS
	# Label
	grid [set $lvar] -row [expr $i+1] -column 0 -sticky wn -pady 1
	# Entry
	grid [set $evar] -row [expr $i+1] -column 1 -sticky wn -pady 1

	# BINDS
	bind [set $evar] <Return> ";
	solvdatwin::valsavespecie $nlist \"actual\" \"$type\";
	solvdatwin::displayspeciesnames $nlist \"$type\";
	"
    }

    return 1
}

proc solvdatwin::displayspecievalues { nlist type } {

    # Advect Variables
    variable Species_Values
    variable Species_Names
    variable Species_Valnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    variable spcnlastsel
    variable sname

    # URSolver Variables
    variable URVariables_Values
    variable URVariables_Names
    variable URVariables_Valnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    variable ursnlastsel
    variable ursname

    if { [lindex [$nlist curselection] 0] > -1 } {
	set sel [lindex [$nlist curselection] 0]
    } else {
	solvdatwin::updatespcselection $nlist 0 $type
	set sel [lindex [$nlist curselection] 0]
    }

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	    set type_Values $Species_Values
	    set type_Valnames $Species_Valnames
	    set vartype_name "sname"
	    set vartype_lastsel "spcnlastsel"
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	    set type_Values $URVariables_Values
	    set type_Valnames $URVariables_Valnames
	    set vartype_name "ursname"
	    set vartype_lastsel "ursnlastsel"
	}
    }

    # Display Specie / Variable name and set last selection
    set $vartype_name [DWUnder2Space [lindex $type_Names $sel]]
    set $vartype_lastsel $sel

    set currvals [lindex $type_Values $sel]
    for { set i 0 } { $i < [llength $type_Valnames] } { incr i } {
	# Entries Values
	set tvar [lindex [lindex $type_Valnames $i] 1]
	set $tvar [join [DWUnder2Space [lindex $currvals $i]]]
    }

    return 1
}

proc solvdatwin::displayspeciesnames { nlist type } {

    variable Species_Names
    variable URVariables_Names

    switch $type {
	"advect" {
	    set type_Names $Species_Names
	}
	"ursolver" {
	    set type_Names $URVariables_Names
	}
    }

    if { [lindex [$nlist curselection] 0] > -1 } {
	set savesel [lindex [$nlist curselection] 0]
    } else {
	set savesel ""
    }
    set p 0
    $nlist delete 0 end
    foreach n $type_Names {
	$nlist insert $p $n
	incr p
    }

    if { $savesel > -1 } {
	$nlist selection clear 0 end
	$nlist selection set $savesel $savesel
    }

    return 1
}

proc solvdatwin::updatespcselection { nlist setsel type } {

    # Tdyn Settings
    variable show_advect
    variable show_ursolver

    variable Species_Names
    variable URVariables_Names
    variable spcnlastsel
    variable ursnlastsel
    variable sname
    variable ursname

    if { [string length $nlist] > 0 } {
	switch $type {
	    "advect" {
		set type_Names $Species_Names
	    }
	    "ursolver" {
		set type_Names $URVariables_Names
	    }
	}

	if { $setsel < 0 || $setsel > [expr [llength $type_Names] -1] } {
	    set setsel "end"
	}

	$nlist selection clear 0 end
	$nlist selection set $setsel $setsel

	switch $type {
	    "advect" {
		if { $show_advect == 1 } {
		    set spcnlastsel $setsel
		    set sname [lindex $type_Names $setsel]
		}
	    }
	    "ursolver" {
		if { $show_ursolver == 1 } {
		    set ursnlastsel $setsel
		    set ursname [lindex $type_Names $setsel]
		}
	    }
	}
    }

    return 1
}

proc solvdatwin::valsavespecie { nlist sel type } {

    # Tdyn Settings
    variable show_advect
    variable show_ursolver

    # Advect Variables
    variable Species_Values
    variable Species_Names
    variable Species_Valnames
    for { set i 0 } { $i < [llength $Species_Valnames] } { incr i } {
	set tvar [lindex [lindex $Species_Valnames $i] 1]
	variable $tvar
    }
    variable spcnlastsel
    variable sname

    # URSolver Variables
    variable URVariables_Values
    variable URVariables_Names
    variable URVariables_Valnames
    for { set i 0 } { $i < [llength $URVariables_Valnames] } { incr i } {
	set tvar [lindex [lindex $URVariables_Valnames $i] 1]
	variable $tvar
    }
    variable ursnlastsel
    variable ursname

    if { [string length $nlist] > 0 } {
	if { $sel == "actual" && [string length [$nlist curselection]] > 0 } {
	    set sel [lindex [$nlist curselection] 0]
	} else {
	    switch $type {
		"advect" {
		    if { $show_advect == 1 } {
		        set sel $spcnlastsel
		    }
		}
		"ursolver" {
		    if { $show_ursolver == 1 } {
		        set sel $ursnlastsel
		    }
		}
	    }
	}

	switch $type {
	    "advect" {
		set type_Names $Species_Names
		set vartype_Names "Species_Names"
		set type_Values $Species_Values
		set vartype_Values "Species_Values"
		set type_Valnames $Species_Valnames
		set type_name $sname
	    }
	    "ursolver" {
		set type_Names $URVariables_Names
		set vartype_Names "URVariables_Names"
		set type_Values $URVariables_Values
		set vartype_Values "URVariables_Values"
		set type_Valnames $URVariables_Valnames
		set type_name $ursname
	    }
	}

	if { $sel > -1 && !($sel > [expr [llength $type_Values] -1]) && [string length $nlist] > 0 } {
	  
	    # Saving Specie / UR Variable Name
	    set $vartype_Names [lreplace $type_Names $sel $sel [string trim [DWSpace2Under $type_name]]]
	    
	    # Saving Specie / UR Variable values
	    set newvals ""
	    for { set i 0 } { $i < [llength $type_Valnames] } { incr i } {
		set tvar [lindex [lindex $type_Valnames $i] 1]
		set type [lindex [lindex $type_Valnames $i] 2]
		lappend newvals [TUI_cleanvalue [eval set temp $$tvar] $type]
		#if { [lindex [lindex $type_Valnames $i] 2] == "func" } {
		#    regsub -all { } [eval set temp $$tvar] {} ttv
		#    lappend newvals $ttv
		#} else {
		#    lappend newvals [DWSpace2Under [eval set temp $$tvar]]
		#}
	    }
	    set $vartype_Values [lreplace $type_Values $sel $sel $newvals]
	}
    }

    return 1
}

proc solvdatwin::formatvalues { way } {

    # ADVECT Variables
    variable Advect_Solverdata
    variable Species_Names
    variable Species_Values
    variable Species_Valnames
    # URSolver Variables
    variable URSolver_Solverdata
    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_Valnames

    switch $way {
	"saving" {
	    # ADVECT Species values
	    set Advect_Solverdata [TUI_formatspeciesvalues List2String $Species_Valnames $Species_Values]
	    #set tn [expr [llength $Species_Valnames] * [llength $Species_Values]]
	    #set Advect_Solverdata "#N# $tn"
	    #foreach sv $Species_Values {
	    #    foreach svv $sv {
	    #        append Advect_Solverdata " " [string trim $svv]
	    #    }
	    #}
	    #set Advect_Solverdata [string trim $Advect_Solverdata]
	    # URSOLVER Species values
	    set URSolver_Solverdata [TUI_formatspeciesvalues List2String $URVariables_Valnames $URVariables_Values]
	    #set tn [expr [llength $URVariables_Valnames] * [llength $URVariables_Values]]
	    #set URSolver_Solverdata "#N# $tn"
	    #foreach sv $URVariables_Values {
	    #    foreach svv $sv {
	    #        append URSolver_Solverdata " " [string trim $svv]
	    #    }
	    #}
	    #set URSolver_Solverdata [string trim $URSolver_Solverdata]
	}
	"retrieving" {
	    # ADVECT Species values
	    set Species_Values [TUI_formatspeciesvalues String2List $Species_Valnames $Advect_Solverdata]
	    #set valstr [lreplace $Advect_Solverdata 0 1]
	    #set Species_Values ""
	    #for { set i 0 } { $i < [expr [llength $valstr] / [llength $Species_Valnames]] } { incr i } {
	    #    set aa [lrange $valstr [expr $i * [llength $Species_Valnames]] \
	    #            [expr [expr ($i+1) * [llength $Species_Valnames]] -1]]
	    #    lappend Species_Values $aa
	    #}
	    # URSOLVER Species values
	    set URVariables_Values [TUI_formatspeciesvalues String2List $URVariables_Valnames $URSolver_Solverdata]
	    #set valstr [lreplace $URSolver_Solverdata 0 1]
	    #set URVariables_Values ""
	    #for { set i 0 } { $i < [expr [llength $valstr] / [llength $URVariables_Valnames]] } { incr i } {
	    #    set aa [lrange $valstr [expr $i * [llength $URVariables_Valnames]] \
	    #            [expr [expr ($i+1) * [llength $URVariables_Valnames]] -1]]
	    #    lappend URVariables_Values $aa
	    #}
	}
    }
}

################################################################################
#
#   Naval
#
################################################################################

proc solvdatwin::naval { page tags } {

    # Naval variables
    variable Naval_Solverdata
    variable WaveElevation_Norm


    #####  HELP Text variables #####
    set help_WaveElevation_Norm \
	    "[= {Wave Elevation norm used to check convergence in the nonlinear iteration loop}]."

    set frame [frame $page.f -relief ridge -bd 2 -padx 5 -pady 5]

    # Wave Elevation Norm
    set l_WaveElevation_Norm [Label $frame.l_waveelnorm -text "[= {Wave Elevation Norm}] " \
	    -helptext $help_WaveElevation_Norm]
    set e_WaveElevation_Norm [entry $frame.e_waveelnorm -textvariable solvdatwin::WaveElevation_Norm]

    # GRIDS
    # SizeLabel
    grid $frame -row 0 -column 0 -sticky wen
#    grid $sizelabel -row 0 -column 0 -sticky wn
    set row 1
    foreach item $Naval_Solverdata {
	set itt [lindex $item 0]
	set lvar "l_$itt"
	set evar "e_$itt"
	grid [eval set temp $$lvar] -row $row -column 0 -sticky en -pady 2
	grid [eval set temp $$evar] -row $row -column 1 -sticky wn -pady 2
	set help "help_$itt"
	if { [info exist $help] } {
	    GidHelp [eval set temp $$lvar] [eval set temp $$help]
	    GidHelp [eval set temp $$evar] [eval set temp $$help]
	}
	incr row
    }
    grid columnconfigure $page 0 -weight 1
    grid rowconfigure $page 2 -weight 1
}


################################################################################
#
#   Alemesh
#
################################################################################

proc solvdatwin::alemesh { page tags } {

    global ProgramName

    # Alemesh variables
    variable Alemesh_Solverdata
    foreach item $Alemesh_Solverdata {
	variable [lindex $item 0]
    }
    variable Alemesh_UnitsRead
    foreach item $Alemesh_UnitsRead {
	variable [lindex $item 0]
    }
    variable predefined_ff
    variable alemesh_ff

    #####  HELP Text variables #####
    # Function Editor button
    set help_btn_func "[= {Custom Function Editor}].\n[= {Edit a function and transfer it automatically to a field}].\n[= {You can also RIGHT-CLICK a field to open the Function Editor}]."
    set help_Fluid_Mesh_Deformation \
	    "[= {Type of mesh deformation:}]\n\t[= {ByFunctions -> Mesh is deformed \
	    following functions data}]\n\t[= {ByOtherData -> Mesh is deformed following \
	    boundary conditions and other data}].\n\t[= {ByBodies -> Mesh is deformed following \
	    bodies movement}]."
    set help_Fluid_Deformation \
	    "[= {Insert the functions to define fluid mesh deformation}].\n[= {Functions\
	    must define the deformation increment for every time step}]."
    set help_Solid_Mesh_Deformation \
	    "[= {Type of mesh deformation:}]\n\t[= {ByFunctions -> Mesh is deformed \
	    following functions data}]\n\t[= {ByOtherData -> Mesh is deformed following \
	    boundary conditions and other data}].\n\t[= {ByBodies -> Mesh is deformed following \
	    bodies movement}]."
    set help_Solid_Deformation \
	    "[= {Insert the functions to define solid mesh deformation}].\n[= {Functions\
	    must define the deformation increment for every time step}]."

    # Combo boxes values
    lappend vals_Fluid_Mesh_Deformation "ByFunctions" "ByBodies" "ByBoundaries" "ByAllData"
    lappend vals_Solid_Mesh_Deformation "ByFunctions" "ByBodies" "ByAllData"

    set tframe [TitleFrame $page.f -relief ridge -text [= {General}]]
    set frame [$tframe getframe]

    # Invisible size label
    set sizelabel [label $frame.l_sizelabel \
	    -text "                                                         " -bd 0 ]

     # Fluid Mesh Deformation
    set l_Fluid_Mesh_Deformation [Label $frame.l_fldmeshdef -text "[= {Fluid Mesh Deformation}] " \
	    -helptext $help_Fluid_Mesh_Deformation]
    set e_Fluid_Mesh_Deformation [ComboBox $frame.cbx_fldmeshdef -values $vals_Fluid_Mesh_Deformation \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Fluid_Mesh_Deformation] \
	    -textvariable solvdatwin::Fluid_Mesh_Deformation]
    set l_Fluid_Update [Label $frame.l_fldupdate -text [= {Update fluid mesh every (steps)}]]
    set e_Fluid_Update [Entry $frame.e_fldupdate -textvariable solvdatwin::FluidUpdateMeshEvery]

    # Solid Mesh Deformation
    set l_Solid_Mesh_Deformation [Label $frame.l_sldmeshdef -text "[= {Solid Mesh Deformation}] " \
	    -helptext $help_Solid_Mesh_Deformation]
    set e_Solid_Mesh_Deformation [ComboBox $frame.cbx_sldmeshdef -values $vals_Solid_Mesh_Deformation \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Solid_Mesh_Deformation] \
	    -textvariable solvdatwin::Solid_Mesh_Deformation]
    set l_Solid_Update [Label $frame.l_sldupdate -text [= {Update solid mesh every (steps)}]]
    set e_Solid_Update [Entry $frame.e_sldupdate -textvariable solvdatwin::SolidUpdateMeshEvery]

    # Fluid Mesh Deformation
    switch $ProgramName {
	"Tdyn2D" { 
	    set l_Fluid_Deformation [Label $frame.l_fldmshdef -text [= {Fluid Deformation Increment (OX OY)}] \
		    -helptext $help_Fluid_Deformation]
	    set l_Solid_Deformation [Label $frame.l_sldmshdef -text [= {Solid Deformation Increment (OX OY)}] \
		    -helptext $help_Solid_Deformation]
	}
	"Tdyn3D" {
	    set l_Fluid_Deformation [Label $frame.l_fldmshdef -text [= {Fluid Deformation Increment (OX OY OZ)}] \
		    -helptext $help_Fluid_Deformation]
	    set l_Solid_Deformation [Label $frame.l_sldmshdef -text [= {Solid Deformation Increment (OX OY OZ)}] \
		    -helptext $help_Solid_Deformation]
	}
    }
    
    set fdf [frame $frame.fdf -relief flat]
    set sdf [frame $frame.sdf -relief flat]

    set e_Fluid_Deformation_X [entry $fdf.e_fldmshdefx -width 6 -textvariable solvdatwin::Fluid_Deformation_X]
    bind $e_Fluid_Deformation_X <ButtonPress-3> \
	    "solvdatwin::popupmenu $page solvdatwin::Fluid_Deformation_X \"Fluid Deformation X\" \"\" 1 %X %Y"
    set e_Fluid_Deformation_Y [entry $fdf.e_fldmshdefy -width 6 -textvariable solvdatwin::Fluid_Deformation_Y]
    bind $e_Fluid_Deformation_Y <ButtonPress-3> \
	    "solvdatwin::popupmenu $page solvdatwin::Fluid_Deformation_Y \"Fluid Deformation Y\" \"\" 1 %X %Y"
    set e_Solid_Deformation_X [entry $sdf.e_sldmshdefx -width 6 -textvariable solvdatwin::Solid_Deformation_X]
    bind $e_Solid_Deformation_X <ButtonPress-3> \
	    "solvdatwin::popupmenu $page solvdatwin::Solid_Deformation_X \"Solid Deformation X\" \"\" 1 %X %Y"
    set e_Solid_Deformation_Y [entry $sdf.e_sldmshdefy -width 6 -textvariable solvdatwin::Solid_Deformation_Y]
    bind $e_Solid_Deformation_Y <ButtonPress-3> \
	    "solvdatwin::popupmenu $page solvdatwin::Solid_Deformation_Y \"Solid Deformation Y\" \"\" 1 %X %Y"
    if { $ProgramName == "Tdyn3D" } {
	set e_Fluid_Deformation_Z [entry $fdf.e_fldmshdefz -width 6 -textvariable solvdatwin::Fluid_Deformation_Z]
	bind $e_Fluid_Deformation_Z <ButtonPress-3> \
		"solvdatwin::popupmenu $page solvdatwin::Fluid_Deformation_Z \"Fluid Deformation Z\" \"\" 1 %X %Y"
	set e_Solid_Deformation_Z [entry $sdf.e_sldmshdefz -width 6 -textvariable solvdatwin::Solid_Deformation_Z]
	bind $e_Solid_Deformation_Z <ButtonPress-3> \
		"solvdatwin::popupmenu $page solvdatwin::Solid_Deformation_Z \"Solid Deformation Z\" \"\" 1 %X %Y"
    }
    set l_Fluid_Geometry_Units [Label $fdf.l_geomunt -text "$Geometry_Units"]
    set l_Solid_Geometry_Units [Label $sdf.l_geomunt -text "$Geometry_Units"]
    
    # Buttons frame
    set btn_frame [frame $frame.btn_frame]

    # Function Editor Button
    set btn_functions [Button $btn_frame.btn_func -justify left -underline 0 \
	    -command "FEditor::init $tags \"$predefined_ff\" \"\" \"SELECT FIELD\" \"\" \"$alemesh_ff\" \"\"" \
	    -image $buttons::ibtn_func -helptext $help_btn_func -takefocus 1]
    GidHelp $btn_functions $help_btn_func

    # GRIDS
    grid $tframe -row 0 -column 0 -sticky wen
    # Fluid Deformation
    grid $l_Fluid_Mesh_Deformation -row 1 -column 0 -sticky en -pady 2
    grid $e_Fluid_Mesh_Deformation -row 1 -column 1 -sticky wn -pady 2
    grid $l_Fluid_Update -row 2 -column 0 -sticky en -pady 2
    grid $e_Fluid_Update -row 2 -column 1 -sticky wn -pady 2
    grid $l_Fluid_Deformation -row 3 -column 0 -sticky en -pady 2
    grid $l_Fluid_Deformation -row 3 -column 0 -sticky en -pady 2
    grid $fdf -row 3 -column 1 -sticky wn -pady 2
    grid $e_Fluid_Deformation_X -row 0 -column 0 -sticky wn -padx 1
    grid $e_Fluid_Deformation_Y -row 0 -column 1 -sticky wn -padx 1
    if { $ProgramName == "Tdyn3D" } {
	grid $e_Fluid_Deformation_Z -row 0 -column 2 -sticky wn -padx 1
    }
    grid $l_Fluid_Geometry_Units -row 0 -column 3 -sticky wn -padx 1

    # Solid Deformation
    grid $l_Solid_Mesh_Deformation -row 4 -column 0 -sticky en -pady 2
    grid $e_Solid_Mesh_Deformation -row 4 -column 1 -sticky wn -pady 2
    grid $l_Solid_Update -row 5 -column 0 -sticky en -pady 2
    grid $e_Solid_Update -row 5 -column 1 -sticky wn -pady 2
    grid $l_Solid_Deformation -row 6 -column 0 -sticky en -pady 2
    grid $sdf -row 6 -column 1 -sticky wn -pady 2
    grid $e_Solid_Deformation_X -row 0 -column 0 -sticky wn -padx 1
    grid $e_Solid_Deformation_Y -row 0 -column 1 -sticky wn -padx 1
    if { $ProgramName == "Tdyn3D" } {
	grid $e_Solid_Deformation_Z -row 0 -column 2 -sticky wn -padx 1
    }
    grid $l_Solid_Geometry_Units -row 0 -column 3 -sticky wn -padx 1

    grid columnconfigure $page 0 -weight 1
    grid rowconfigure $page 2 -weight 1

    # Buttons frame
    grid $btn_frame -row 7 -column 1 -columnspan 2 -sticky wn

    # Function Editor Button
    grid $btn_functions -row 0 -column 0 -sticky en -pady 2 -padx 1
}

################################################################################
#
#   Ramsolid
#
################################################################################

proc solvdatwin::ramsolid { page tags } {

    global ProgramName

    # RamSolid variables
    variable Ramsolid_Solverdata
    foreach item $Ramsolid_Solverdata {
	variable [lindex $item 0]
    }
    variable Ramsolid_UnitsRead
    foreach item $Ramsolid_UnitsRead {
	variable [lindex $item 0]
    }
    # Combo boxes values
#    lappend vals_Results_Units "N-m" "N-mm" "Kp-cm" "kN-m-Mpa"
    lappend vals_Coupling_Type "Step By Step" "Steady State" "None"
    lappend vals_Coupling_Variable "Temperature"
 
    set gframe [TitleFrame $page.g -relief ridge -text [= {General}]]
    set frame [$gframe getframe]

#    set l_ResUnits [Label $frame.l_runits -text "[= {Results units}] "]
#    set e_ResUnits [ComboBox $frame.e_runits -values $vals_Results_Units \
#            -editable 0 -width [TDYN_getcbxsize 10 $vals_Results_Units] \
#            -textvariable solvdatwin::Results_units]
    set c_ResSmooth [checkbutton $frame.sres -text "[= {Smooth results per material}] " \
		-variable solvdatwin::Smooth_per_material -offvalue 0 -onvalue 1]
    set l_Gravity [Label $frame.gravl -text "[= {Gravity Vector}] "]
    set f_Gravity [frame $frame.gravf]
    set e_GravityOX [Entry $f_Gravity.gravx -width 6 -textvariable solvdatwin::GravityOX]
    set e_GravityOY [Entry $f_Gravity.gravy -width 6 -textvariable solvdatwin::GravityOY]
    set e_GravityOZ [Entry $f_Gravity.gravz -width 6 -textvariable solvdatwin::GravityOZ]
    set u_Gravity   [Entry $frame.gravu -editable 0 -background [$f_Gravity cget -background] \
	    -relief flat -textvariable solvdatwin::Gravity_Units]
    
    set tframe [TitleFrame $page.f -relief ridge -text [= {Coupling}]]
    set frame [$tframe getframe]

    set l_Coupling_Type [Label $frame.l_ctype -text "[= {Coupling type}] "]
    set e_Coupling_Type [ComboBox $frame.e_ctype -values $vals_Coupling_Type \
	    -editable 0 -width [TDYN_getcbxsize 10 $vals_Coupling_Type] \
	    -textvariable solvdatwin::Coupling_Type]
    set l_Coupling_Step [Label $frame.l_cstep -text "[= {Coupling every (steps)}] "]
    set e_Coupling_Step [entry $frame.e_cstep -textvariable solvdatwin::Coupling_Step]
    set l_Coupling_Start [Label $frame.l_cstart -text "[= {Coupling start (step)}] "]
    set e_Coupling_Start [entry $frame.e_cstart -textvariable solvdatwin::Coupling_Start]

#    set l_Coupling_Variable [Label $frame.l_cvar -text "[= {Coupling variable}] "]
#    set e_Coupling_Variable [ComboBox $frame.e_cvar -values $vals_Coupling_Variable \
#            -editable 0 -width [TDYN_getcbxsize 10 $vals_Coupling_Variable] \
#            -textvariable solvdatwin::Coupling_Variable]

    # GRIDS
    grid $gframe -row 0 -column 0 -sticky wen

#    grid $l_ResUnits -row 0 -column 0 -sticky en -pady 2
#    grid $e_ResUnits -row 0 -column 1 -sticky ewn -pady 2
    grid $c_ResSmooth -row 1 -column 0 -sticky en -pady 2 -columnspan 2
    grid $l_Gravity -row 4 -column 0 -sticky en -pady 2 -padx 5
    grid $f_Gravity -row 4 -column 1 -sticky ewn -pady 2 -padx 3
    grid $e_GravityOX -row 0 -column 0 -sticky en -pady 2 -padx 2
    grid $e_GravityOY -row 0 -column 1 -sticky en -pady 2 -padx 2
    grid $e_GravityOZ -row 0 -column 2 -sticky en -pady 2 -padx 2
    grid $u_Gravity -row 4 -column 2 -sticky en -pady 2 -padx 2

    grid $tframe -row 1 -column 0 -sticky wen

    grid $l_Coupling_Type -row 0 -column 0 -sticky en -pady 2
    grid $e_Coupling_Type -row 0 -column 1 -sticky wn -pady 2
    grid $l_Coupling_Step -row 1 -column 0 -sticky en -pady 2
    grid $e_Coupling_Step -row 1 -column 1 -sticky wn -pady 2
    grid $l_Coupling_Start -row 2 -column 0 -sticky en -pady 2
    grid $e_Coupling_Start -row 2 -column 1 -sticky wn -pady 2
#    grid $l_Coupling_Variable -row 2 -column 0 -sticky en -pady 2
#    grid $e_Coupling_Variable -row 2 -column 1 -sticky wn -pady 2

    grid columnconfigure $page 0 -weight 1
    grid rowconfigure $page 2 -weight 1
}

################################################################################
#
#   PopUp Menus
#
################################################################################

proc solvdatwin::popupmenu { parent {field ""} {fieldname ""} tags content x y } {

    variable predefined_ff

    catch { 
	destroy $parent.menu
    }

    set menu [menu $parent.menu -type normal]

    switch $content {
	1 {
	    if { [string length $field] > 0 } {
		eval set fval $$field
	    }
	    $menu add command -label [= {Define Function}] \
		    -command "FEditor::init $parent \"$predefined_ff\" $field [list $fieldname] [list $fval] \"\" \"\""
	}
    }
    
    tk_popup $menu $x $y

    return 1
}

################################################################################
#
#   Get Values
#
################################################################################

proc solvdatwin::getvalues { } {

    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_naval
    variable show_alemesh
    variable show_ramsolid

    set varlist ""
    set unilist ""
    set paglist ""
    if { $show_ransol == 1 } {
	lappend varlist Ransol_Solverdata
	lappend unilist Ransol_UnitsRead
	lappend paglist RANSOL
    } 
    if { $show_heatrans == 1 } {
	lappend varlist Heatrans_Solverdata
	lappend unilist ""
	lappend paglist HEATRANS
    } 
    if { $show_naval == 1 } {
	lappend varlist Naval_Solverdata
	lappend unilist ""
	lappend paglist NAVAL
    } 
    if { $show_alemesh == 1 } {
	lappend varlist Alemesh_Solverdata
	lappend unilist Alemesh_UnitsRead
	lappend paglist ALEMESH
    } 
    if { $show_ramsolid == 1 } {
	lappend varlist Ramsolid_Solverdata
	lappend unilist Ramsolid_UnitsRead
	lappend paglist RAMSOLID
    } 
    set gendata [.central.s info gendata]

    # Reading values
    for {set i 0} {$i < [llength $varlist]} {incr i} {
	set thisvar [lindex $varlist $i]
	if { $thisvar != "" } {
	    variable $thisvar
	    foreach item [eval set nothing $$thisvar] {
		set itt [lindex $item 0]
		variable $itt
		set $itt [TUI_readsinglefield gendata $itt]
	    }
	}
    }
    # Reading units
    for {set i 0} {$i < [llength $unilist]} {incr i} {
	set thisvar [lindex $unilist $i]
	if { $thisvar != "" } {
	    variable $thisvar
	    foreach item [eval set nothing $$thisvar] {
		variable [lindex $item 0]
	    }
	    foreach item [eval set nothing $$thisvar] {
		set itt [lindex $item 0]
		set nitt [lindex $item 1]
		set $itt [TUI_formatunits Nums2Unicode \
		        [DWUnder2Space [join [lindex $gendata [expr [lsearch -regexp $gendata \
		        [eval set nothing ^${itt}(\$|\#CB)]] + 1]]]] 0]
	    }
	}
    }

    # Advect variables
    variable Species_Names
    variable Advect_Solverdata
    # URSolver variables
    variable URVariables_Names
    variable URSolver_Solverdata

    # Advect & Ursolver
    set varlist [list "Species_Names" "URVariables_Names"]
    foreach item $varlist {
	set temp "[lindex $gendata [expr [lsearch -regexp $gendata \
		            [eval set nothing ^${item}\:]] + 1]]"
	set $item [TUI_formatlistvalues String2List $temp]
    }
    set varlist [list "Advect_Solverdata" "URSolver_Solverdata"]
    foreach item $varlist {
	#set temp "[lindex $gendata [expr [lsearch -regexp $gendata \
	#                    [eval set nothing ^${item}\:]] + 1]]"
	#set $item [TUI_formatlistvalues String2List $temp]
	set $item "[lindex $gendata [expr [lsearch -regexp $gendata \
		        [eval set nothing ^${item}\:]] + 1]]"
    }

    solvdatwin::formatvalues retrieving

}

proc solvdatwin::checkclose { win {dumpit 1} {askdump 1} {close 1} } {

    global tkPriv tcl_platform
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_naval
    variable show_alemesh
    variable show_ramsolid

    # Checking info 
    set valueschange 0
    set wtsave 0
    set usr_err ""
    set num_usr_err 0 
    
    set varlist ""
    set unilist ""
    set paglist ""
    if { $show_ransol == 1 } {
	lappend varlist Ransol_Solverdata
	lappend unilist Ransol_UnitsRead
	lappend paglist RANSOL
    } 
    if { $show_heatrans == 1 } {
	lappend varlist Heatrans_Solverdata
	lappend unilist ""
	lappend paglist HEATRANS
    } 
    if { $show_naval == 1 } {
	lappend varlist Naval_Solverdata
	lappend unilist ""
	lappend paglist NAVAL
    } 
    if { $show_alemesh == 1 } {
	lappend varlist Alemesh_Solverdata
	lappend unilist Alemesh_UnitsRead
	lappend paglist ALEMESH
    } 
    if { $show_ramsolid == 1 } {
	lappend varlist Ramsolid_Solverdata
	lappend unilist Ramsolid_UnitsRead
	lappend paglist RAMSOLID
    } 

    set gendata [.central.s info gendata]

    # Checking values
    for {set i 0} {$i < [llength $varlist]} {incr i} {
	set thisvar [lindex $varlist $i]
	set thispag [lindex $paglist $i]
	set uerrpg_$thispag 0
	if { $thisvar != "" } {
	    variable $thisvar
	    foreach item [eval set nothing $$thisvar] {

		set itt [lindex $item 0]
		variable $itt
		set temp [TUI_readsinglefield gendata $itt]
		
		if { $temp != [eval set nothing $$itt] } {
		    set valueschange 1
		    if { [lindex $item 3] == 1} {
		        set errcheck [TUI_valuecheck [DWSpace2Under [eval set nothing $$itt]] \
		                [lindex $item 2] 0 ""]
		        if { $errcheck != "ok"} {
		            incr num_usr_err
		            if { [eval set temp \$uerrpg_$thispag] != 1 } {
		                append usr_err "\n[= {%s PAGE} $thispag]\n"
		                set uerrpg_$thispag 1
		            }
		            append usr_err "$num_usr_err. " [DWUnder2Space $itt] ": $errcheck\n"
		        }
		    }
		}
	    }
	}
    }
    # Checking units
    for {set i 0} {$i < [llength $unilist]} {incr i} {
	set thisuni [lindex $unilist $i]
	set thispag [lindex $paglist $i]
	if { $thisuni != "" } {
	    variable $thisuni
	    foreach item [eval set nothing $$thisuni] {
		variable [lindex $item 0]
	    }
	    foreach item [eval set nothing $$thisuni] {
		set itt [lindex $item 0]
		set jtt temp_$itt
		set $jtt [TUI_formatunits Unicode2Nums [eval set temp $$itt] 1]
		set temp [join [lindex $gendata [expr [lsearch -regexp $gendata \
		        [eval set nothing ^${itt}(\$|\#CB)]] + 1]]]
		if { [DWUnder2Space $temp] != [eval set nothing $$jtt] } {
		    set valueschange 1
		    if { [lindex $item 3] == 1} {
		        set errcheck [TUI_valuecheck [DWSpace2Under [eval set nothing $$jtt]] \
		                [lindex $item 2] 0 ""]
		        if { $errcheck != "ok"} {
		            incr num_usr_err
		            if { [eval set temp \$uerrpg_$thispag] != 1 } {
		                append usr_err "\n[= {%s PAGE} $thispag]\n"
		            set uerrpg_$thispag 1
		            }
		            append usr_err "$num_usr_err. " [DWUnder2Space $itt] ": $errcheck\n"
		        }
		    }
		}
	    }
	}
    }

    # Advect variables
    variable Advect_Solverdata
    variable Species_Names
    variable Species_Values
    variable Species_Valnames
    variable snlist
    # URSolver variables
    variable URSolver_Solverdata
    variable URVariables_Names
    variable URVariables_Values
    variable URVariables_Valnames
    variable ursnlist

    # Last unsaved changes of Species Values - save them
    if { $show_advect == 1 } {
	 solvdatwin::valsavespecie $snlist "actual" "advect"
    }
    if { $show_ursolver == 1 } {
	solvdatwin::valsavespecie $ursnlist "actual" "ursolver"
    }
  
    solvdatwin::formatvalues "saving"

    # Checking ADVECT values
    if { $show_advect == 1 } {
	set temp [join [lindex $gendata [expr [lsearch -regexp $gendata Advect_Solverdata\:] + 1]]]

	set uerrpg_adv 0
	if { $temp != $Advect_Solverdata } {
	    set valueschange 1
	    set spc_pos 0
	    foreach item $Species_Values {
		set tspn [lindex $Species_Names $spc_pos]
		incr spc_pos
		set valnamepos 0
		foreach itt $item {
		    set valname [lindex $Species_Valnames $valnamepos]
		    incr valnamepos
		    set errcheck [TUI_valuecheck [DWSpace2Under $itt] [lindex $valname 2] 0 [lindex $valname 6]]
		    if { $errcheck != "ok" && [lindex $valname 3] == 1} {
		    incr num_usr_err
		        if { $uerrpg_adv != 1 } {
		            append usr_err "\n[= {ADVECT PAGE}]\n"
		            set uerrpg_adv 1
		        }
		        append usr_err "$num_usr_err. " "$tspn; " [lindex $valname 0] ": $errcheck\n"
		    }
		}
	    }
	}
    }

    # Checking URSOLVER values 
    if { $show_ursolver == 1 } {
	set temp [join [lindex $gendata [expr [lsearch -regexp $gendata URSolver_Solverdata\:] + 1]]]
	
	set uerrpg_urs 0
	if { $temp != $URSolver_Solverdata } {
	    set valueschange 1
	    set spc_pos 0
	    foreach item $URVariables_Values {
		set tspn [lindex $URVariables_Names $spc_pos]
		incr spc_pos
		set valnamepos 0
		foreach itt $item {
		    set valname [lindex $URVariables_Valnames $valnamepos]
		    incr valnamepos
		    set errcheck [TUI_valuecheck [DWSpace2Under $itt] [lindex $valname 2] 0 [lindex $valname 6]]
		    if { $errcheck != "ok" && [lindex $valname 3] == 1} {
		        incr num_usr_err
		        if { $uerrpg_urs != 1 } {
		        append usr_err "\n[= {URSOLVER PAGE}]\n"
		            set uerrpg_urs 1
		        }
		        append usr_err "$num_usr_err. " "$tspn; " [lindex $valname 0] ": $errcheck\n"
		    }
		}
	    }
	}
    }

    if { $valueschange == 1 } {
	if { $askdump == 0 } {
	    set answer 0
	} else {
	    set answer [tk_dialogRAM $win "[= {Tdyn Modules Data}] " \
		    [= {Modules data has changed}].\n[= {Do you want to save changes?}] question 0 Yes No]
	}

	if { $answer == 0 && $dumpit == 1} {
	    set wtsave 1
	    if { $num_usr_err > 0 } {
		if { $num_usr_err > 1 } {
		    set err_display "[= {The following %s errors were found in the data input} $num_usr_err]:\n"
		} else {
		    set err_display "[= {The following error was found in the data input}]:\n"
		}
		append err_display $usr_err
		WarnWin $err_display
		set close 0
	    } else {
		solvdatwin::dump
		FloatMessage $win.flm "[= {Modules Data were saved}]."
	    }
	}
    } else {
	if { $dumpit == 1 } {
	    FloatMessage $win.flm "[= {No changes need to be saved}]."
	}
    }

    if { $close == 1 } {
	destroy $win
	return $valueschange
    } else {
	if { $num_usr_err == 0 } {
	    return $valueschange
	} else {
	    if { $wtsave == 1 } {
		return "dataerror"
	    } else {
		return "nosave.dataerror"
	    }
	}
    }
}

proc solvdatwin::dump { } {

    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_naval
    variable show_alemesh
    variable show_ramsolid

    variable Ransol_Solverdata
    variable Ransol_UnitsRead
    variable Heatrans_Solverdata
    variable Advect_Solverdata
    variable URSolver_Solverdata
    variable Naval_Solverdata
    variable Alemesh_Solverdata
    variable Ramsolid_Solverdata

    if { $show_ransol==1 } {
	TUI_dumpsinglefields solvdatwin $Ransol_Solverdata ProblemData
	TUI_dumpsingleunits solvdatwin $Ransol_UnitsRead ProblemData
    }
    if { $show_heatrans==1 } {
	TUI_dumpsinglefields solvdatwin $Heatrans_Solverdata ProblemData
    }
    if { $show_advect==1 } {
	GiD_AccessValue set gendata "Advect_Solverdata:" $Advect_Solverdata
    }
    if { $show_ursolver==1 } {
	GiD_AccessValue set gendata "URSolver_Solverdata:" $URSolver_Solverdata
    }
    if { $show_naval==1 } {
	TUI_dumpsinglefields solvdatwin $Naval_Solverdata ProblemData
    }
    if { $show_alemesh==1 } {
	TUI_dumpsinglefields solvdatwin $Alemesh_Solverdata ProblemData
    }
    if { $show_ramsolid==1 } {
	TUI_dumpsinglefields solvdatwin $Ramsolid_Solverdata ProblemData
    }

    # Actualizamos la variable de control de cambios en GiD
    GIDModifiedFileFlag Set
    return 1
}
