namespace eval processdatwin {

    global ProgramName
    global tkPriv tcl_platform

    # Window settings
    variable bookname

    # Tdyn settings
    variable show_fluid [IsVarOnTdynDefaults show_fluid 1]
    variable show_solid [IsVarOnTdynDefaults show_solid 1]
    variable show_ursolver [IsVarOnTdynDefaults show_ursolver 1]
    variable show_alemesh [IsVarOnTdynDefaults show_alemesh 1]
    variable show_ransol [IsVarOnTdynDefaults show_ransol 1]
    variable show_heatrans [IsVarOnTdynDefaults show_heatrans 1]
    variable show_advect [IsVarOnTdynDefaults show_advect 1]
    variable show_naval [IsVarOnTdynDefaults show_naval 1]

    # Timing Data (time)
    variable Timing_Data_Units s
    variable Timing_Types [list Timing_Data_BAndB Timing_Data_62 Timing_Data_NNPB]
    variable Timing_Data_NNPB [list \
	    [list TimeGobLoad "[= {Gob Load}] " float 1 forming] \
	    [list TimeBaffleOn "[= {Baffle On}] " float 1 forming] \
	    [list TimePlungerUp "[= {Plunger Up}] " float 1 forming] \
	    [list TimePlungerUpOff "[= {Plunger Up Off}] " float 1 forming] \
	    [list TimePlungerDown "[= {Plunger Down}] " float 1 forming] \
	    [list TimeBaffleOff "[= {Baffle Off}] " float 1 forming] \
	    [list TimeBlankOpen "[= {Blank Open}] " float 1 forming] \
	    [list TimeBlankCoolingOn "[= {Blank Cooling On}] " float 1 cooling] \
	    [list TimeBlankCoolingOff "[= {Blank Cooling Off}] " float 1 cooling] \
	    [list TimeInvertOn "[= {Invert On}] " float 1 forming] \
	    [list TimeInvertArrived "[= {Invert Arrived}] " float 1 forming] \
	    [list TimeMoldPhysicalClose "[= {Mold Physical Close}] " float 1 forming] \
	    [list TimeFinalCoolingOn "[= {Final Cooling On}] " float 1 cooling] \
	    [list TimeMoldVacuumOn "[= {Mold Vacuum On}] " float 1 forming] \
	    [list TimeFinalBlowOn "[= {Final Blow On}] " float 1 forming] \
	    [list TimeFinalBlowOff "[= {Final Blow Off}] " float 1 forming] \
	    [list TimeFinalCoolingOff "[= {Final Cooling Off}] " float 1 cooling] \
	    [list TimeMoldVacuumOff "[= {Mold Vacuum Off}] " float 1 forming] \
	    [list TimeMoldOpenOn "[= {Mold Open On}] " float 1 forming] \
	    [list TimeBottomPlateCoolingOn "[= {Bot.Plate Cooling On}] " float 1 cooling] \
	    [list TimeBottomPlateCoolingOff "[= {Bot.Plate Cooling Off}] " float 1 cooling] \
	    ]
#            [list TimeNROpen "[= {NR Open}] " float 1]
    foreach item $Timing_Data_NNPB {
	variable [lindex $item 0]
    }   
    variable Timing_Data_62 $Timing_Data_NNPB
    foreach item $Timing_Data_62 {
	variable [lindex $item 0]
    }  
    variable Timing_Data_BAndB [list \
	    [list TimeGobLoad "[= {Gob Load}] " float 1 forming] \
	    [list TimeSettleBlowOn "[= {Settle Blow On}] " float 1 forming] \
	    [list TimeBaffleOn "[= {Baffle On}] " float 1 forming] \
	    [list TimeBaffle1Off "[= {Baffle 1 Off}] " float 1 forming] \
	    [list TimeSettleBlowOff "[= {Settle Blow Off}] " float 1 forming] \
	    [list TimePlungerUpOff "[= {Plunger Up Off}] " float 1 forming] \
	    [list TimeCounterBlowOn "[= {Counter Blow On}] " float 1 forming] \
	    [list TimeCounterBlowOff "[= {Counter Blow Off}] " float 1 forming] \
	    [list TimeBaffle2Off "[= {Baffle 2 Off}] " float 1 forming] \
	    [list TimeBlankOpen "[= {Blank Open}] " float 1 forming] \
	    [list TimeBlankCoolingOn "[= {Blank Cooling On}] " float 1 cooling] \
	    [list TimeBlankCoolingOff "[= {Blank Cooling Off}] " float 1 cooling] \
	    [list TimeCounterBlowLowOn "[= {Counter Blow Low On}] " float 1 forming] \
	    [list TimeCounterBlowLowOff "[= {Counter Blow Low Off}] " float 1 forming] \
	    [list TimeInvertOn "[= {Invert On}] " float 1 forming] \
	    [list TimeInvertArrived "[= {Invert Arrived}] " float 1 forming] \
	    [list TimeMoldPhysicalClose "[= {Mold Physical Close}] " float 1 forming] \
	    [list TimeFinalCoolingOn "[= {Final Cooling On}] " float 1 cooling] \
	    [list TimeFinalCoolingOff "[= {Final Cooling Off}] " float 1 cooling] \
	    [list TimeMoldVacuumOn "[= {Mold Vacuum On}] " float 1 forming] \
	    [list TimeFinalBlowOn "[= {Final Blow On}] " float 1 forming] \
	    [list TimeFinalBlowOff "[= {Final Blow Off}] " float 1 forming] \
	    [list TimeMoldVacuumOff "[= {Mold Vacuum Off}] " float 1 forming] \
	    [list TimeMoldOpenOn "[= {Mold Open On}] " float 1 forming] \
	    [list TimeBaffleCoolingOn "[= {Baffle Cooling On}] " float 1 cooling] \
	    [list TimeBaffleCoolingOff "[= {Baffle Cooling Off}] " float 1 cooling] \
	    [list TimeCounterBlowPuffOn "[= {Counter Blow Puff On}] " float 1 cooling] \
	    [list TimeCounterBlowPuffOff "[= {Counter Blow Puff Off}] " float 1 cooling] \
	    ]
#            [list TimeNROpen "[= {NR Open}] " float 1]
    foreach item $Timing_Data_BAndB {
	variable [lindex $item 0]
    }   
    variable TimePeriod 

    # Timing Data (angle) - By defaulf value is given at the end
    variable Angle_Types [list Angle_Data_BAndB Angle_Data_62 Angle_Data_NNPB]
    variable Angle_Data_NNPB [list \
	    [list AngleGobLoad "[= {Gob Load}] " float 1 35] \
	    [list AngleBaffleOn "[= {Baffle On}] " float 1 51] \
	    [list AnglePlungerUp "[= {Plunger Up}] " float 1 70] \
	    [list AnglePlungerUpOff "[= {Plunger Up Off}] " float 1 162] \
	    [list AnglePlungerDown "[= {Plunger Down}] " float 1 164] \
	    [list AngleBaffleOff "[= {Baffle Off}] " float 1 165] \
	    [list AngleBlankOpen "[= {Blank Open}] " float 1 167] \
	    [list AngleBlankCoolingOn "[= {Blank Cooling On}] " float 1 210] \
	    [list AngleBlankCoolingOff "[= {Blank Cooling Off}] " float 1 340] \
	    [list AngleInvertOn "[= {Invert On}] " float 1 205] \
	    [list AngleInvertArrived "[= {Invert Arrived}] " float 1 261] \
	    [list AngleMoldPhysicalClose "[= {Mold Physical Close}] " float 1 282] \
	    [list AngleFinalCoolingOn "[= {Final Cooling On}] " float 1 0] \
	    [list AngleMoldVacuumOn "[= {Mold Vacuum On}] " float 1 60] \
	    [list AngleFinalBlowOn "[= {Final Blow On}] " float 1 65] \
	    [list AngleFinalBlowOff "[= {Final Blow Off}] " float 1 178] \
	    [list AngleFinalCoolingOff "[= {Final Cooling Off}] " float 1 359] \
	    [list AngleMoldVacuumOff "[= {Mold Vacuum Off}] " float 1 196] \
	    [list AngleMoldOpenOn "[= {Mold Open On}] " float 1 206] \
	    [list AngleBottomPlateCoolingOn "[= {Bot.Plate Cooling On}] " float 1 0] \
	    [list AngleBottomPlateCoolingOff "[= {Bot.Plate Cooling Off}] " float 1 0] \
	   ]
#           [list AngleNROpen "[= {NR Open}] " float 1 303]
    foreach item $Angle_Data_NNPB {
	variable [lindex $item 0]
    }   
    variable Angle_Data_62 [list \
	    [list AngleGobLoad "[= {Gob Load}] " float 1 35] \
	    [list AngleBaffleOn "[= {Baffle On}] " float 1 51] \
	    [list AnglePlungerUp "[= {Plunger Up}] " float 1 57] \
	    [list AnglePlungerUpOff "[= {Plunger Up Off}] " float 1 173] \
	    [list AnglePlungerDown "[= {Plunger Down}] " float 1 175] \
	    [list AngleBaffleOff "[= {Baffle Off}] " float 1 177] \
	    [list AngleBlankOpen "[= {Blank Open}] " float 1 180] \
	    [list AngleBlankCoolingOn "[= {Blank Cooling On}] " float 1 250] \
	    [list AngleBlankCoolingOff "[= {Blank Cooling Off}] " float 1 340] \
	    [list AngleInvertOn "[= {Invert On}] " float 1 225] \
	    [list AngleInvertArrived "[= {Invert Arrived}] " float 1 264] \
	    [list AngleMoldPhysicalClose "[= {Mold Physical Close}] " float 1 282] \
	    [list AngleFinalCoolingOn "[= {Final Cooling On}] " float 1 60] \
	    [list AngleMoldVacuumOn "[= {Mold Vacuum On}] " float 1 60] \
	    [list AngleFinalBlowOn "[= {Final Blow On}] " float 1 30] \
	    [list AngleFinalBlowOff "[= {Final Blow Off}] " float 1 173] \
	    [list AngleFinalCoolingOff "[= {Final Cooling Off}] " float 1 178] \
	    [list AngleMoldVacuumOff "[= {Mold Vacuum Off}] " float 1 180] \
	    [list AngleMoldOpenOn "[= {Mold Open On}] " float 1 180] \
	    [list AngleBottomPlateCoolingOn "[= {Bot.Plate Cooling On}] " float 1 60] \
	    [list AngleBottomPlateCoolingOff "[= {Bot.Plate Cooling Off}] " float 1 100] \
	    ]
#            [list AngleNROpen "[= {NR Open}] " float 1 303]
    foreach item $Angle_Data_62 {
	variable [lindex $item 0]
    }  
    variable Angle_Data_BAndB [list \
	    [list AngleGobLoad "[= {Gob Load}] " float 1 20] \
	    [list AngleSettleBlowOn "[= {Settle Blow On}] " float 1 30] \
	    [list AngleBaffleOn "[= {Baffle On}] " float 1 51] \
	    [list AngleBaffle1Off "[= {Baffle 1 Off}] " float 1 66] \
	    [list AngleSettleBlowOff "[= {Settle Blow Off}] " float 1 70] \
	    [list AnglePlungerUpOff "[= {Plunger Up Off}] " float 1 70] \
	    [list AngleCounterBlowOn "[= {Counter Blow On}] " float 1 110] \
	    [list AngleCounterBlowOff "[= {Counter Blow Off}] " float 1 160] \
	    [list AngleBaffle2Off "[= {Baffle 2 Off}] " float 1 163] \
	    [list AngleBlankOpen "[= {Blank Open}] " float 1 166] \
	    [list AngleBlankCoolingOn "[= {Blank Cooling On}] " float 1 250] \
	    [list AngleBlankCoolingOff "[= {Blank Cooling Off}] " float 1 340] \
	    [list AngleCounterBlowLowOn "[= {Counter Blow Low On}] " float 1 195] \
	    [list AngleCounterBlowLowOff "[= {Counter Blow Low Off}] " float 1 201] \
	    [list AngleInvertOn "[= {Invert On}] " float 1 200] \
	    [list AngleInvertArrived "[= {Invert Arrived}] " float 1 264] \
	    [list AngleMoldPhysicalClose "[= {Mold Physical Close}] " float 1 282] \
	    [list AngleFinalCoolingOn "[= {Final Cooling On}] " float 1 35] \
	    [list AngleMoldVacuumOn "[= {Mold Vacuum On}] " float 1 30] \
	    [list AngleFinalBlowOn "[= {Final Blow On}] " float 1 35] \
	    [list AngleFinalBlowOff "[= {Final Blow Off}] " float 1 35] \
	    [list AngleFinalCoolingOff "[= {Final Cooling Off}] " float 1 155] \
	    [list AngleMoldVacuumOff "[= {Mold Vacuum Off}] " float 1 155] \
	    [list AngleMoldOpenOn "[= {Mold Open On}] " float 1 165] \
	    [list AngleBaffleCoolingOn "[= {Baffle Cooling On}] " float 1 180] \
	    [list AngleBaffleCoolingOff "[= {Baffle Cooling Off}] " float 1 220] \
	    [list AngleCounterBlowPuffOn "[= {Counter Blow Puff On}] " float 1 220] \
	    [list AngleCounterBlowPuffOff "[= {Counter Blow Puff Off}] " float 1 260] \
	    ]
#           [list AngleNROpen "[= {NR Open}] " float 1 303]
    foreach item $Angle_Data_BAndB {
	variable [lindex $item 0]
    }

    # Process Data
    variable Process_Data [list \
	    [list ProcessType [list [= {Process Type}] [= {Blow & Blow}] [= {62}] [= {NNPB}]] integer 1] \
	    [list CoolingSystem [list [= {Cooling System}] [= {Axial}]  [= {Vertiflow}] [= {Shell}] [= {Liquid}] [= {Stack}]] integer 1] \
	    [list MachineType [list [= {Machine Type}] [= {Single Gob}] [= {4.25 in}] [= {5 in}] [= {5.5 in}] [= {6 in}] [= {6.25 in}] [= {7 in}] [= {8.5 in}] [= {9.25 in}] [= {10 in}] [= {Quad}]] integer 1] \
	    ]
    foreach item $Process_Data {  
	variable [lindex $item 0]
    }

    # Analysis Data
    variable AnalysisType
    variable RestartType
    variable CommStepRatio 1.0
    variable TimeStepRatio 400
    variable Geometry_Units \[cm\]
    variable Temperature_Units \[Gt\]
#    variable Plunger_Volume
    variable Process_Parameters [list \
	    [list NumberOfCycles [= {Number of Cycles}] integer analysis undimensional [list BAndB NNPB 62]] \
	    [list TimeStepRatio [= {Steps per Cycle}] integer analysis undimensional [list BAndB NNPB 62]] \
	    [list CavityRate [= {Cavity Rate}] float analysis cpm [list BAndB NNPB 62]] \
	    [list Blk_Mold_Flow_Rate [= {Blk.Mold Fluid Flow Rate}] float cooling flow [list liquid]] \
	    [list Inlet_BlkCooling_Tm [= {Blk.Mold Fluid Inlet Temperature}] float cooling temperature [list axial vertiflow shell liquid stack]] \
	    [list Blk_Mold_Fluid_Inlet_Pressure [= {Blk.Mold Fluid Inlet Pressure}] float cooling watercolumn [list axial vertiflow shell stack]] \
	    [list Fnl_Mold_Flow_Rate [= {Fnl.Mold Fluid Flow Rate}] float cooling flow [list liquid]] \
	    [list Inlet_FnlCooling_Tm [= {Fnl.Mold Fluid Inlet Temperature}] float cooling temperature [list axial vertiflow shell liquid stack]] \
	    [list Fnl_Mold_Fluid_Inlet_Pressure [= {Fnl.Mold Fluid Inlet Pressure}] float cooling watercolumn [list axial vertiflow shell stack]] \
	    [list Glycol_Concentration [= {Glycol Concentration}] float cooling concentration [list liquid]] \
	    [list Settle_Blow_Pressure [= {Settle Blow Pressure}] float forming pressure [list BAndB]] \
	    [list Settle_Blow_Vacuum [= {Settle Blow Vacuum}] float forming pressure [list BAndB]] \
	    [list Counter_Blow_Pressure [= {Counter Blow Pressure}] float forming pressure [list BAndB]] \
	    [list Plng_Loading_Position [= {Plunger Load Height}] float forming length [list NNPB 62]] \
	    [list Final_Blow_Pressure [= {Final Blow Pressure}] float forming pressure [list BAndB NNPB 62]] \
	    [list Final_Blow_Vacuum [= {Final Blow Vacuum}] float forming pressure [list BAndB NNPB 62]] \
	    [list Gob_Weight [= {Gob Weight}] float forming mass [list BAndB]] \
	    [list Finish_Volume [= {Finish Volume}] float forming volume [list BAndB NNPB 62]] \
	    [list Gob_Load_Height [= {Gob Load Height}] float forming length [list BAndB NNPB 62]] \
	    [list Initial_Glass_Tm [= {Gob Temperature}] float initial temperature [list BAndB NNPB 62]] \
	    [list Initial_Plunger_Tm [= {Plunger temperature}] float initial temperature [list BAndB NNPB 62]] \
	    [list Initial_Blank_Mold_Tm [= {Blank Mold Temperature}] float initial temperature [list BAndB NNPB 62]] \
	    [list Initial_Final_Mold_Tm [= {Final Mold Temperature}] float initial temperature [list BAndB NNPB 62]] \
	    [list Initial_Baffle_Tm [= {Baffle Temperature}] float initial temperature [list BAndB NNPB 62]] \
	   ]
    foreach item $Process_Parameters {
	variable [lindex $item 0]
    }

    # Additional variables + initializations
    variable Initial_FnlVacuum_Tm 70.0
    variable External_Blank_Mold_Tm 350.0
    variable External_Final_Mold_Tm 350.0
    set Inlet_FnlCooling_Tm 35.0
    set Inlet_BlkCooling_Tm 35.0
    set CavityRate 10.0

    # Units Data
    variable Process_Units [list \
	    Geometry_Units \
	    Boundary_Time_Units \
	    Boundary_Temperature_Units \
	    Boundary_Angle_Units]

    # Function Editor variables
    variable fluid_variables "x y z nx ny nz t it rand dt exp(1) pi vx vy vz pr tm\
	    vt v_ tau wc ds ke ep om kt pk dn bt sp#"
    variable example_fluid_variables "x y z nx ny nz t it rand dt exp(1)\
	    pi vx vy vz pr tm vt v_ tau wc ds ke ep om kt pk dn bt sp#"
    variable fluid_operators "+ - * / ^ mod div rmod rdiv max min Dx() Dy() Dz()\
	    ~ < <= > >= = != & |"
    variable predefined_ff [list $fluid_variables $example_fluid_variables $fluid_operators]
}

proc processdatwin::init { parent {show "all"} {tags ""} } {

    global ProgramName
    global tkPriv tcl_platform

    # Window settings
    variable bookname

    # Tdyn settings
    variable show_fluid
    variable show_solid
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_naval
    variable show_alemesh

    # Timing settings
    variable Timing_Types
    variable Angle_Types

    set unw $parent.prc

    if { [TUI_closeotherwindows $unw 1] == 1 } {

	InitWindow $unw [= {Process Data}] PreProcessDataWindowGeom ""

	set closecmd "processdatwin::checkclose $unw 1 1 1"
	set acceptcmd "processdatwin::checkclose $unw 1 0 0"
	set resetcmd "processdatwin::resetdata"
	wm protocol $unw WM_DELETE_WINDOW "$closecmd"

	# Reading values from xml database
	processdatwin::getvalues

	# Top frame
	set topf [frame $unw.f -bg lightblue]
	# Picture Box
	set l_icon [label $topf.l_icon -image [imagefromtdyn prdata.gif] -bg lightblue]
	grid $topf -row 0 -column 0 -sticky nwe
	grid $l_icon -row 0 -column 0 -sticky nw
	grid columnconf $topf 1 -weight 1

	# Main Notebook
	set pages [NoteBook $unw.pages -homogeneous 1 -arcradius 0]
	grid $pages -row 1 -column 0 -sticky nwes -pady 5

	set bookname $pages

	grid columnconf $unw 0 -weight 1
	grid rowconf $unw 1 -weight 1

	set pnum 0
	set firstpage ""

	# Process Page
	incr pnum
	set pvar "pg_process"
	if { [string length $firstpage] < 1 } { 
	    set firstpage $pvar
	}
	set fpvar "fpg_process"
	set $pvar [$pages insert $pnum $pvar -text [= {PROCESS}]]
	set $fpvar [$pages getframe $pvar]
	processdatwin::process_data $pg_process
	$pages raise $pvar

	# Timing Page
	foreach Timing_Type $Timing_Types Angle_Type $Angle_Types {
	    incr pnum
	    set pvar p_$Timing_Type
	    if { [string length $firstpage] < 1 } { 
		set firstpage $pvar
	    }
	    set fpvar fp_$Timing_Type
	    set $pvar [$pages insert $pnum $pvar -text [= {TIMING}]]
	    set $fpvar [$pages getframe $pvar]
	    
	    processdatwin::timing_data $Timing_Type $Angle_Type $fpvar          
	}

	# Analysis Page
	incr pnum
	set pvar "an_process"
	if { [string length $firstpage] < 1 } { 
	    set firstpage $pvar
	}
	set fpvar "fan_process"
	set $pvar [$pages insert $pnum $pvar -text [= {ANALYSIS}]]
	set $fpvar [$pages getframe $pvar]
	
	processdatwin::analysis_data $an_process
	
	# Buttons frame
	set bf [frame $unw.bf -relief raised -takefocus 1]
	# Accept button
	set btn_accept [button $bf.btn_accept -text [= {Accept Data}] -underline 0 -relief raised \
		-bd 1 -highlightthickness 1 -bg lightblue -takefocus 1 \
		-command "$acceptcmd"]
	# Close button
	set btn_close [button $bf.btn_close -text [= {Close}] -underline 0 -relief raised \
		-bd 1 -highlightthickness 1 -bg lightblue -takefocus 1 \
		-command "$closecmd"]
	# Close button
	set btn_reset [button $bf.btn_reset -text [= {Reset}] -underline 0 -relief raised \
		-bd 1 -highlightthickness 1 -bg lightblue -takefocus 1 \
		-command "$resetcmd"]
	
	# GRIDS
	grid $bf -row 2 -column 0 -sticky ne
	grid $btn_reset -row 0 -column 0 -sticky e -pady 1
	grid $btn_accept -row 0 -column 1 -sticky e -pady 1
	grid $btn_close -row 0 -column 2 -sticky e -pady 1
	
	# BINDS
	bind $unw <Escape> "tkButtonInvoke $btn_close"
	bind $unw <Alt-c> "tkButtonInvoke $btn_close"
	bind $unw <Alt-a> "tkButtonInvoke $btn_accept"

	$pages compute_size
	processdatwin::select_timing
	focus $unw
    }
}

################################################################################
#
#   Analysis
#
################################################################################
proc processdatwin::analysis_data { page { tags new } } {

    # Analisis data
    variable AnalysisType
    variable RestartType
    variable Process_Parameters
    foreach item $Process_Parameters {
	variable [lindex $item 0]
    }
    # Process data
    variable Process_Data
    foreach item $Process_Data {
	variable [lindex $item 0]
    }
    # Timing data
    variable ProcessType
    variable Timing_Types
    variable Angle_Types
    set timetype [lindex $Timing_Types [expr $ProcessType-1]]
    variable $timetype
    set angletype [lindex $Angle_Types [expr $ProcessType-1]]
    variable $angletype
    # Units Data
    variable Process_Units
    foreach ivar $Process_Units {
	variable $ivar
    }
    set length [TUI_formatunits Nums2Unicode $Geometry_Units]
    set temperature [TUI_formatunits Nums2Unicode $Boundary_Temperature_Units]
    set time [TUI_formatunits Nums2Unicode $Boundary_Time_Units]
    set angle [TUI_formatunits Nums2Unicode $Boundary_Angle_Units]
    set concentration [TUI_formatunits Nums2Unicode {[%]}]
    set cpm [TUI_formatunits Nums2Unicode {[cpm]}]
    set mass [TUI_formatunits Nums2Unicode {[g]}]
    set flow [TUI_formatunits Nums2Unicode {[kg/min]}]
    set pressure [TUI_formatunits Nums2Unicode {[kPa]}]
    set watercolumn {mmH2O}
    set volume [TUI_formatunits Nums2Unicode {[cc]}]
    if { [TUI_formatunits NumsToPlain $Geometry_Units] == "in" } {
	set volume [TUI_formatunits Nums2Unicode {[in3]}]
	set mass [TUI_formatunits Nums2Unicode {[oz]}]
	set flow [TUI_formatunits Nums2Unicode {[lb/min]}]
	set pressure [TUI_formatunits Nums2Unicode {[psi]}]
	set watercolumn {inH2O}
    }
    # Scrolled Window
    if { $tags == "new" } {
	set scrwindow [ScrolledWindow $page.f]
	set scrframe [ScrollableFrame $scrwindow.f]
	$scrwindow setwidget $scrframe
	grid $scrwindow -row 0 -column 0 -sticky ewns
	grid rowconfigure $page 0 -weight 1
	grid columnconfigure $page 0 -weight 1
	# Title Frame (Analysis)
	set tframe [TitleFrame [$scrframe getframe].a -relief ridge -text [= {Analysis Data}]]
	set aframe [$tframe getframe]
	grid $tframe -row 0 -column 0 -sticky ewn
	GidHelp $aframe [= {Enter analysis data}] 
	# Title Frame (Forming)
	set tframe [TitleFrame [$scrframe getframe].f -relief ridge -text [= {Forming Data}]]
	set fframe [$tframe getframe]
	grid $tframe -row 1 -column 0 -sticky ewn
	GidHelp $fframe [= {Enter forming data}] 
	# Title Frame (Cooling)
	set tframe [TitleFrame [$scrframe getframe].c -relief ridge -text [= {Cooling Data}]]
	set cframe [$tframe getframe]
	grid $tframe -row 0 -column 1 -sticky ewn
	GidHelp $cframe [= {Enter cooling data}] 
	# Title Frame (Initial)
	set tframe [TitleFrame [$scrframe getframe].i -relief ridge -text [= {Initial Data}]]
	set iframe [$tframe getframe]
	grid $tframe -row 1 -column 1 -sticky ewn
	GidHelp $cframe [= {Enter initial data}] 
	
	# Analysis type field
	set analysisopt [list [= "Blank Mold & Bottle Thickness"] [= "Final Mold"]]
	set help [= {Select analysis type}]
	set l_anal [Label $aframe.l_anal -text "[= {Analysis type}] " -helptext $help]
	set cbx_anal [ComboBox $aframe.lb_anal -values $analysisopt -editable 0 -width 10]
	$cbx_anal configure -modifycmd "set processdatwin::AnalysisType \[$cbx_anal getvalue\]" 
	if { [catch { $cbx_anal setvalue @$processdatwin::AnalysisType }] } {
	    $cbx_anal setvalue first
	    set processdatwin::AnalysisType [$cbx_anal getvalue]
	}
	grid $l_anal -row 0 -column 0 -sticky en -pady 2
	grid $cbx_anal -row 0 -column 1 -sticky wn -pady 2
	GidHelp $l_anal $help
	GidHelp $cbx_anal $help
	
	# Restart type field
	set processdatwin::RestartType [GiD_AccessValue get gendata Restart]
	set help "[= {If marked Yes the restart file is used to define the initial\
		data}].\n[= {The Restart file used is}] \"ProblemName.flavia.rst\""
	set l_rest [Label $aframe.l_res -text [= {Restart }] -helptext $help]
	set e_rest [ComboBox $aframe.e_res -values [list Off On] -editable false \
		-width 10 -textvariable processdatwin::RestartType -takefocus 1]
	grid $l_rest -row 1 -column 0 -sticky en -pady 2
	grid $e_rest -row 1 -column 1 -sticky wn -pady 2
	GidHelp $l_rest $help
	GidHelp $e_rest $help
    } else {
	set frame [$page.f.f getframe]
	set fframe [$frame.f getframe]
	set cframe [$frame.c getframe]
	set aframe [$frame.a getframe]
	set iframe [$frame.i getframe]
    }

    set ianalrow 2
    set iformrow 0 
    set icoolrow 0 
    set iinitrow 0 
    set formtype [lindex [list BAndB 62 NNPB] [expr int($ProcessType-1)]]
    set cooltype [lindex [list axial vertiflow shell liquid stack] [expr int($CoolingSystem-1)]]
    foreach item $Process_Parameters {
	set name [lindex $item 0]
	set cool [lindex $item 5]
	set type [lindex $item 3]
	set show 1
	if { $type == "forming" } {
	    set frame $fframe
	    set irow $iformrow
	    incr iformrow
	    if { [lsearch [lindex $item 5] $formtype]==-1 } {
		set show 0
	    }
	} elseif { $type == "cooling" } {
	    set frame $cframe
	    set irow $icoolrow
	    incr icoolrow
	    if { [lsearch [lindex $item 5] $cooltype]==-1 } {
		set show 0
	    }
	}  elseif { $type == "initial" } {
	    set frame $iframe
	    set irow $iinitrow
	    incr iinitrow
	    if { [lsearch [lindex $item 5] $formtype]==-1 } {
		set show 0
	    }
	} else {
	    set frame $aframe
	    set irow $ianalrow
	    incr ianalrow
	    if { [lsearch [lindex $item 5] $formtype]==-1 } {
		set show 0
	    }
	}
	if { $tags == "new" } {
	    set l_$name [Label $frame.l_$name -text [fillspaces [lindex $item 1] 35]]
	    set e_$name [entry $frame.e_$name -width 7 -textvariable processdatwin::$name]
	} else {
	    set l_$name $frame.l_$name
	    set e_$name $frame.e_$name
	}
	grid [set l_$name] -row $irow -column 0 -sticky en -pady 2
	grid [set e_$name] -row $irow -column 1 -sticky wn -pady 2
	#if { $name == "NumberOfCycles" && $tags == "new" } {
	#    $cbx_anal configure -modifycmd "processdatwin::setAnalysisType \[$cbx_anal getvalue\] [set e_$name]"
	#    processdatwin::setAnalysisType [$cbx_anal getvalue] [set e_$name] 
	#}
	if { [info exists [lindex $item 4]] } {
	    if { $tags == "new" } {
		set u_$name [Label $frame.u_$name -text [set [lindex $item 4]]]
	    } else {
		set u_$name $frame.u_$name
	    }
	    grid [set u_$name] -row $irow -column 2 -sticky wn -pady 2
	}
	if { [info exists help_$name] } {
	    GidHelp [eval set temp \$l_$name] [eval set temp \$help_$name]
	}
	if { $show != 1 } {
	    grid remove [set l_$name] [set e_$name] 
	    if { [winfo exists [set u_$name]] } { grid remove [set u_$name] }
	}
    }
    bind $aframe.e_CavityRate <Return> "processdatwin::update_processtiming $timetype $angletype"
}

proc processdatwin::analysis_data_old { page { tags new } } {

    # Analisis data
    variable AnalysisType
    variable RestartType
    variable Process_Parameters
    foreach item $Process_Parameters {
	variable [lindex $item 0]
    }
    # Units Data
    variable Process_Units
    foreach ivar $Process_Units {
	variable $ivar
    }

    # Volume Data
    variable Finish_Volume
#    variable Plunger_Volume
    set Volume_Units {[cc]}
    if { [TUI_formatunits NumsToPlain $Geometry_Units] == "in" } {
	set Volume_Units {[in3]}
    }
    # Scrolled Window
    set scrwindow [ScrolledWindow $page.f]
    set scrframe [ScrollableFrame $scrwindow.f]
    $scrwindow setwidget $scrframe
    # Title Frame
    set tframe [TitleFrame [$scrframe getframe].f -relief ridge -text [= {Analysis data}]]
    set frame [$tframe getframe]
    grid $tframe -row 0 -column 0 -sticky ewn
#    grid columnconfigure $page 0 -weight 1
#    grid rowconfigure $page 2 -weight 1
    grid $scrwindow -row 0 -column 0 -sticky ewns
    grid rowconfigure $page 0 -weight 1
    grid columnconfigure $page 0 -weight 1
    GidHelp $scrwindow [= {Enter process data}] 

    set irow 0 
    
    # Analysis type field
    set analysisopt [list [= "Blank Mold & Bottle Thickness"] [= "Final Mold"]]
    set help [= {Select analysis type}]
    set l_anal [Label $frame.l_anal -text "[= {Analysis type}] " -helptext $help]
    set cbx_anal [ComboBox $frame.lb_anal -values $analysisopt -editable 0 -width 10]
    if { [catch { $cbx_anal setvalue @$processdatwin::AnalysisType }] } {
	$cbx_anal setvalue first
	set processdatwin::AnalysisType [$cbx_anal getvalue]
    }
    grid $l_anal -row $irow -column 0 -sticky en -pady 2
    grid $cbx_anal -row $irow -column 1 -sticky wn -pady 2
    GidHelp $l_anal $help
    GidHelp $cbx_anal $help

    incr irow

    set help [= {Enter number of cycles to be analysed}]
    set l_cycl [Label $frame.l_cycl -text "[= {Number of cycles}] " -helptext $help]
    set e_cycl [entry $frame.lb_cycl -width 12 -textvariable processdatwin::NumberOfCycles]
    grid $l_cycl -row $irow -column 0 -sticky en -pady 2
    grid $e_cycl -row $irow -column 1 -sticky wn -pady 2
    GidHelp $l_cycl $help
    GidHelp $e_cycl $help
    $cbx_anal configure -modifycmd "set processdatwin::AnalysisType \[$cbx_anal getvalue\]" 

    incr irow

    set processdatwin::RestartType [GiD_AccessValue get gendata Restart]
    set help "[= {If marked Yes the restart file is used to define the initial\
	    data}].\n[= {The Restart file used is}] 'ProblemName.flavia.rst'"
    set l_rest [Label $frame.l_res -text [= {Restart }] -helptext $help]
    set e_rest [ComboBox $frame.e_res -values [list Off On] -editable false \
	    -width 10 -textvariable processdatwin::RestartType -takefocus 1]
    grid $l_rest -row $irow -column 0 -sticky en -pady 2
    grid $e_rest -row $irow -column 1 -sticky wn -pady 2
    GidHelp $l_rest $help
    GidHelp $e_rest $help

    incr irow

    set help [= {Enter plunger loading position}]
    set l_plun [Label $frame.l_plun -text "[= {Plunger loading position}] " -helptext $help]
    set e_plun [entry $frame.e_plun -width 12 -textvariable processdatwin::Plng_Loading_Position]
    set u_plun [Label $frame.u_plun -text [TUI_formatunits Nums2Unicode $Geometry_Units] -helptext $help]
    grid $l_plun -row $irow -column 0 -sticky en -pady 2
    grid $e_plun -row $irow -column 1 -sticky wn -pady 2
    grid $u_plun -row $irow -column 2 -sticky wn
    GidHelp $l_plun $help
    GidHelp $e_plun $help
    GidHelp $u_plun $help

    incr irow

#    set help [= {Enter plunger volume}]
#    set l_pvol [Label $frame.l_pvol -text "[= {Plunger volume}] " -helptext $help]
#    set e_pvol [entry $frame.e_pvol -width 12 -textvariable processdatwin::Plunger_Volume]
#    set u_pvol [Label $frame.u_pvol -text [TUI_formatunits Nums2Unicode $Volume_Units] -helptext $help]
#    grid $l_pvol -row $irow -column 0 -sticky en -pady 2
#    grid $e_pvol -row $irow -column 1 -sticky wn -pady 2
#    grid $u_pvol -row $irow -column 2 -sticky wn
#    GidHelp $l_pvol $help
#    GidHelp $e_pvol $help
#    GidHelp $u_pvol $help

#    incr irow

    set help [= {Enter finish volume}]
    set l_fvol [Label $frame.l_fvol -text "[= {Finish volume}] " -helptext $help]
    set e_fvol [entry $frame.e_fvol -width 12 -textvariable processdatwin::Finish_Volume]
    set u_fvol [Label $frame.u_fvol -text [TUI_formatunits Nums2Unicode $Volume_Units] -helptext $help]
    grid $l_fvol -row $irow -column 0 -sticky en -pady 2
    grid $e_fvol -row $irow -column 1 -sticky wn -pady 2
    grid $u_fvol -row $irow -column 2 -sticky wn
    GidHelp $l_fvol $help
    GidHelp $e_fvol $help
    GidHelp $u_fvol $help

    incr irow

    set help [= {Enter gob temperature}]
    set l_gobt [Label $frame.l_gobt -text "[= {Gob temperature}] " -helptext $help]
    set e_gobt [entry $frame.lb_gobt -width 12 -textvariable processdatwin::Initial_Glass_Tm]
    set u_gobt [Label $frame.u_gobt -text [TUI_formatunits Nums2Unicode \
		$Boundary_Temperature_Units] -helptext $help]
    grid $l_gobt -row $irow -column 0 -sticky en -pady 2
    grid $e_gobt -row $irow -column 1 -sticky wn -pady 2
    grid $u_gobt -row $irow -column 2 -sticky wn
    GidHelp $l_gobt $help
    GidHelp $e_gobt $help
    GidHelp $u_gobt $help

    incr irow

    set help [= {Enter initial plunger temperature}]
    set l_plmv [Label $frame.l_plmv -text "[= {Plunger temperature}] " -helptext $help]
    set e_plmv [entry $frame.lb_plmv -width 12 -textvariable processdatwin::Initial_Plunger_Tm]
    set u_plmv [Label $frame.u_plmv -text [TUI_formatunits Nums2Unicode \
		$Boundary_Temperature_Units] -helptext $help]
    grid $l_plmv -row $irow -column 0 -sticky en -pady 2
    grid $e_plmv -row $irow -column 1 -sticky wn -pady 2
    grid $u_plmv -row $irow -column 2 -sticky wn
    GidHelp $l_plmv $help
    GidHelp $e_plmv $help
    GidHelp $u_plmv $help

    incr irow

    set help [= {Enter initial blank mold temperature}]
    set l_blkm [Label $frame.l_blkm -text "[= {Blank mold temperature}] " -helptext $help]
    set e_blkm [entry $frame.lb_blkm -width 12 -textvariable processdatwin::Initial_Blank_Mold_Tm]
    set u_blkm [Label $frame.u_blkm -text [TUI_formatunits Nums2Unicode \
		$Boundary_Temperature_Units] -helptext $help]
    grid $l_blkm -row $irow -column 0 -sticky en -pady 2
    grid $e_blkm -row $irow -column 1 -sticky wn -pady 2
    grid $u_blkm -row $irow -column 2 -sticky wn
    GidHelp $l_blkm $help
    GidHelp $e_blkm $help
    GidHelp $u_blkm $help

    incr irow

    set help [= {Enter initial temperature of the baffle}]
    set l_baff [Label $frame.l_baff -text "[= {Baffle temperature}] " -helptext $help]
    set e_baff [entry $frame.lb_baff -width 12 -textvariable processdatwin::Initial_Baffle_Tm]
    set u_baff [Label $frame.u_baff -text [TUI_formatunits Nums2Unicode \
		$Boundary_Temperature_Units] -helptext $help]
    grid $l_baff -row $irow -column 0 -sticky en -pady 2
    grid $e_baff -row $irow -column 1 -sticky wn -pady 2
    grid $u_baff -row $irow -column 2 -sticky wn
    GidHelp $l_baff $help
    GidHelp $e_baff $help
    GidHelp $u_baff $help

    incr irow

    set help [= {Enter initial temperature of the final mold}]
    set l_fnlm [Label $frame.l_fnlm -text "[= {Final mold temperature}] " -helptext $help]
    set e_fnlm [entry $frame.lb_fnlm -width 12 -textvariable processdatwin::Initial_Final_Mold_Tm]
    set u_fnlm [Label $frame.u_fnlm -text [TUI_formatunits Nums2Unicode \
		$Boundary_Temperature_Units] -helptext $help]
    grid $l_fnlm -row $irow -column 0 -sticky en -pady 2
    grid $e_fnlm -row $irow -column 1 -sticky wn -pady 2
    grid $u_fnlm -row $irow -column 2 -sticky wn
    GidHelp $l_fnlm $help
    GidHelp $e_fnlm $help
    GidHelp $u_fnlm $help

    grid $tframe -row 0 -column 0 -sticky ewn
    grid columnconfigure $page 0 -weight 1
    grid rowconfigure $page 2 -weight 1

#    GidHelpRecursive $tframe "" 
}

proc processdatwin::setAnalysisType { val { entry "" } } {
    variable AnalysisType
    variable NumberOfCycles

    set AnalysisType $val
    if { $AnalysisType == 1 } {
	set NumberOfCycles 1
	if { $entry != "" } {
	   $entry configure -state readonly
	}
    } else {
	if { $entry != "" } {
	   $entry configure -state normal
	}
    }
}

################################################################################
#
#   Timing
#
################################################################################
proc processdatwin::timing_data { type atype frame { tags new }  } {
    
    # Tdyn settings
    variable show_fluid
    variable show_solid
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_alemesh
    variable show_naval
    
    # Timing Data
    variable $type
    upvar 0 $type Timing_Data
    foreach item $Timing_Data {
	variable [lindex $item 0]
    }
    variable $atype
    upvar 0 $atype Angle_Data
    foreach item $Angle_Data {
	variable [lindex $item 0]
    }
    variable TimePeriod
    variable CavityRate

    upvar $frame page

    # Title Frame
#    set tframe [TitleFrame $page.f -relief ridge -text [= {Timing Data}]]
#    set frame [$tframe getframe]
#    grid $tframe -row 0 -column 0 -sticky ewn
#    grid rowconfigure $page 2 -weight 1
#    grid columnconfigure $page 0 -weight 1
#    GidHelp $tframe "Enter timing data" 

    # Scrolled Window
    set scrwindow [ScrolledWindow $page.f]
    set scrframe [ScrollableFrame $scrwindow.f]
    $scrwindow setwidget $scrframe
    grid $scrwindow -row 0 -column 0 -sticky ewns
    grid rowconfigure $page 0 -weight 1
    grid columnconfigure $page 0 -weight 1
    # Title Frame (Forming)
    set tframe [TitleFrame [$scrframe getframe].f -relief ridge -text [= {Forming Events}]]
    set fframe [$tframe getframe]
    grid $tframe -row 0 -column 0 -sticky ewn
    GidHelp $fframe [= {Enter forming timing data}] 
    # Title Frame (Cooling)
    set tframe [TitleFrame [$scrframe getframe].c -relief ridge -text [= {Cooling Events}]]
    set cframe [$tframe getframe]
    grid $tframe -row 0 -column 1 -sticky ewn
    GidHelp $cframe [= {Enter cooling timing data}] 

    set iformrow 0 
    set icoolrow 0 
    foreach item $Timing_Data atem $Angle_Data {
	set name [lindex $item 0]
	if { [lindex $item 4] == "forming" } {
	    set frame $fframe
	    set irow $iformrow
	    incr iformrow
	} else {
	    set frame $cframe
	    set irow $icoolrow
	    incr icoolrow
	}
	set l_$name [Label $frame.l_$name -text "[lindex $item 1] "]
	set e_$name [entry $frame.e_$name -width 7 -textvariable processdatwin::$name]
	set lb_$name [Label $frame.lb_$name -textvariable processdatwin::Timing_Data_Units]
	grid [eval set temp \$l_$name] -row $irow -column 0 -sticky en -pady 2
	grid [eval set temp \$e_$name] -row $irow -column 1 -sticky wn -pady 2
	grid [eval set temp \$lb_$name] -row $irow -column 2 -sticky wn -pady 2
	bind [eval set temp \$e_$name]  <Return> "processdatwin::update_processangle $type $atype"

	set aname [lindex $atem 0]
	set ea_$name [entry $frame.ea_$name -width 7 -textvariable processdatwin::$aname]
	set la_$name [Label $frame.la_$name  -text "\u2070"]
	grid [eval set temp \$ea_$name] -row $irow -column 3 -sticky wn -padx 5 -pady 2
	grid [eval set temp \$la_$name] -row $irow -column 4 -sticky wn -pady 2
	bind [eval set temp \$ea_$name]  <Return> "processdatwin::update_processtiming $type $atype"

	if { [info exists help_$name] } {
	    GidHelp [eval set temp \$l_$name] [eval set temp \$help_$name]
	}
    }
#    set frame2 [frame $frame.other]
#    set l_CavityRate [Label $frame2.l_CavityRate -text "[= {Cavity Rate}] "]
#    set e_CavityRate [entry $frame2.e_CavityRate -width 7 -textvariable processdatwin::CavityRate]
#    bind $e_CavityRate <Return> "processdatwin::update_processtiming $type $atype"
#    grid $l_CavityRate -row 0 -column 0 -sticky wn -padx 5 -pady 2
#    grid $e_CavityRate -row 0 -column 1 -sticky wn -pady 2
#    grid $frame2 -row $irow -column 0 -sticky ewns -columnspan 5
    
    processdatwin::update_processtiming $type $atype
}

proc processdatwin::update_processangle { type atype } {
    # Timing Data
    variable $type
    upvar 0 $type Timing_Data
    foreach item $Timing_Data {
	variable [lindex $item 0]
    }
    variable $atype
    upvar 0 $atype Angle_Data
    foreach item $Angle_Data {
	variable [lindex $item 0]
    }
    variable TimePeriod
    variable CavityRate

    set TimePeriod [expr 60.0/$CavityRate]

    foreach item $Timing_Data atem $Angle_Data {
	catch {
	    set name [lindex $item 0]
	    set aname [lindex $atem 0]
	    set $aname [format %.1f [expr double([eval set temp $$name])*360.0/double($TimePeriod)]]
	}
    }
}

proc processdatwin::update_processtiming { type atype } {
    # Timing Data
    variable $type
    upvar 0 $type Timing_Data
    foreach item $Timing_Data {
	variable [lindex $item 0]
    }
    variable $atype
    upvar 0 $atype Angle_Data
    foreach item $Angle_Data {
	variable [lindex $item 0]
    }
    variable TimePeriod
    variable CavityRate

    set TimePeriod [expr 60.0/$CavityRate]

    foreach item $Timing_Data atem $Angle_Data {
	catch {
	    set name [lindex $item 0]
	    set aname [lindex $atem 0]
	    set $name [format %.2f [expr double([eval set temp $$aname])/360.0*double($TimePeriod)]]
	}
    }
}

proc processdatwin::select_timing { } {
    # Process Data
    variable ProcessType
    # Timing Data
    variable Timing_Types
    # Window settings
    variable bookname

    for { set i 0 } { $i < [llength $Timing_Types] } { incr i } {
	set pname p_[lindex $Timing_Types $i]
	if { $i == [expr $ProcessType-1] } {
	    if { [$bookname index $pname] < 0 } {
		$bookname insert end-1 $pname -text [= {TIMING}]
	    }
	} else {
	    if { [$bookname index $pname] >= 0 } {
		$bookname delete $pname 0 
	    }
	}
    }
}

proc processdatwin::resetdata { } {
    # Process Data
    variable ProcessType
    # Timing Data
    variable Timing_Types
    variable Angle_Types

    if { ![info exists ProcessType] } { set ProcessType 3 }
    if { ![string is integer -strict $ProcessType] } { set ProcessType 3 }
    if { $ProcessType < 1 } { set ProcessType 3 }

    set type [lindex $Timing_Types [expr $ProcessType-1]]
    variable $type

    set atype [lindex $Angle_Types [expr $ProcessType-1]]
    variable $atype
    upvar 0 $atype Angle_Data
    foreach item $Angle_Data {
	variable [lindex $item 0]
	set [lindex $item 0] [lindex $item 4]
    }
    processdatwin::update_processtiming $type $atype
}

proc processdatwin::validatedata { } {
    # Process Data
    variable ProcessType
    # Timing Data
    variable Timing_Types
    variable Angle_Types

    set type [lindex $Timing_Types [expr $ProcessType-1]]

    set atype [lindex $Angle_Types [expr $ProcessType-1]]
    
    processdatwin::update_processtiming $type $atype
}

################################################################################
#
#   Process
#
################################################################################

proc processdatwin::process_data { page { tags new } } {
 
    # Tdyn settings
    variable show_fluid
    variable show_solid
    variable show_ransol
    variable show_heatrans
    variable show_advect
    variable show_ursolver
    variable show_alemesh
    variable show_naval

    variable Process_Data
    foreach item $Process_Data {
	variable [lindex $item 0]
    }

    # Scrolled Window
    set scrwindow [ScrolledWindow $page.f]
    set scrframe [ScrollableFrame $scrwindow.f]
    $scrwindow setwidget $scrframe
    set fpage [$scrframe getframe]
    grid $scrwindow -row 0 -column 0 -sticky ewns
    grid rowconfigure $page 0 -weight 1
    grid columnconfigure $page 0 -weight 1
    GidHelp $scrwindow [= {Enter process data}]  
    
    # Forming process Field
    set jcol 0
    foreach item $Process_Data {
	set var [lindex $item 0]
	variable $var
	set ltxt [lindex $item 1]
	set len [llength $ltxt]
	# Title Frame
	set tframe [TitleFrame $fpage.f$var -relief ridge -text [lindex $ltxt 0]]
	set frame [$tframe getframe]
	set jrow 0
	for { set i 1 } { $i < $len } { incr i } {
	    if { $var == "ProcessType" } {
		radiobutton $frame.f${var}$i -text [lindex $ltxt $i] -variable processdatwin::$var \
		    -value $i -command { processdatwin::select_windows }
	    } else {
# Warning!!!
# To be activated once design classifications are ready
		radiobutton $frame.f${var}$i -text [lindex $ltxt $i] -variable processdatwin::$var \
		    -value $i -state disabled
	    }
	    grid $frame.f${var}$i -row $i -sticky nw -pady 5
	}
	grid rowconf $frame [expr $len+1] -weight 1
	grid $tframe -row 0 -column $jcol -sticky nwes -padx 5 -pady 5
	grid columnconf $fpage $jcol -weight 1
	incr jcol
    }
    grid rowconf $page 0 -weight
    
    return
}

proc processdatwin::select_windows { } {
    # Process Data
    variable ProcessType
    # Timing Data
    variable Timing_Types
    # Window settings
    variable bookname

    # TIMING Page
    for { set i 0 } { $i < [llength $Timing_Types] } { incr i } {
	set pname p_[lindex $Timing_Types $i]
	if { $i == [expr $ProcessType-1] } {
	    if { [$bookname index $pname] < 0 } {
		$bookname insert end-1 $pname -text [= {TIMING}]
	    }
	} else {
	    if { [$bookname index $pname] >= 0 } {
		$bookname delete $pname 0 
	    }
	}
    }
    # ANALYSIS Page
    processdatwin::analysis_data [$bookname getframe an_process] update
}

################################################################################
#
#   Get Values
#
################################################################################

proc processdatwin::getvalues { } {
    # Process Data
    variable ProcessType
    # Timing Data
    variable Timing_Types
    variable Angle_Types
    variable TimePeriod
    variable CavityRate
    # Units Data
    variable Process_Units

    processxmlfile::getsvars gsdata/process processdatwin

    if { ![info exists ProcessType] } { set ProcessType 3 }
    if { ![string is integer -strict $ProcessType] } { set ProcessType 3 }
    if { $ProcessType < 1 } { set ProcessType 3 }
 
    set type [lindex $Timing_Types [expr $ProcessType-1]]
    variable $type

    set atype [lindex $Angle_Types [expr $ProcessType-1]]
    variable $atype

    processdatwin::update_processtiming $type $atype

    foreach ivar $Process_Units {
	variable $ivar
	set $ivar [GiD_AccessValue get gendata $ivar]
    }

    set TimePeriod [expr 60.0/$CavityRate]

    return
}

proc processdatwin::ImportSPDFile { } {
    global DefaultSearchDirectory

    if { ![info exists DefaultSearchDirectory] } {
	set DefaultSearchDirectory [pwd]
    }

    set file [tk_getOpenFile -defaultextension .bot -filetypes \
	    [list [list [= "SPD files"] [list ".spd" ".xml"]] \
		[list [= "All files"] [list "*"]]]  \
	    -initialdir $DefaultSearchDirectory -parent .gid -title [= "Import SPD file"]]
    if { $file == "" } { return }
    set DefaultSearchDirectory [file dirname $file]
    update

    # Initialise XML structure
    processxmlfile::initRead $file 1

    # Read info from spd file
    processdatwin::checkxmlfile
    processdatwin::getvalues

    # if mold creation windows are open, refresh them
    set dir [file dirname $file]
    gdutils::CreateWindow blank_mold $dir .gid revert
    gdutils::CreateWindow final_mold $dir .gid revert
}

################################################################################
#
#   Check Values
#
################################################################################

proc processdatwin::checkclose { win {dumpit 1} {askdump 1} {close 1} } {

    # Check List
    variable Process_Parameters
    variable ProcessType
    variable Angle_Types
    set angletype [lindex $Angle_Types [expr $ProcessType-1]]
    variable $angletype
    upvar 0 $angletype Angle_Data

    # Check & validate data
    processdatwin::validatedata
    # Creating a list of variables to check/save
    set varlist [processdatwin::mainvarslist]
    # See if something has changed
    set answer 0
    if { [processxmlfile::checkvars gsdata/process $varlist processdatwin] } {
	if { $askdump != 0 } {
	    set answer [tk_dialogRAM $win "[= {Process Data}] " \
		    [= {Data has changed}].\n[= {Do you want to save changes?}] question 0 Yes No]
	}
	# Checking values
	set usr_err ""
	set num_usr_err 0
	foreach item $Angle_Data {
	    set itt [lindex $item 0]
	    variable $itt
	    set errcheck [TUI_valuecheck [set $itt] [lindex $item 2] 2 ""]
	    if { $errcheck != "ok"} {
		incr num_usr_err
		append usr_err "$num_usr_err. " [DWUnder2Space $itt] ": $errcheck\n"
	    }
	}
	foreach item $Process_Parameters {
	    set itt [lindex $item 0]
	    variable $itt
	    set errcheck [TUI_valuecheck [set $itt] [lindex $item 2] 2 ""]
	    if { $errcheck != "ok"} {
		incr num_usr_err
		append usr_err "$num_usr_err. " [DWUnder2Space $itt] ": $errcheck\n"
	    }
	}
	if { $num_usr_err > 0 } {
	    if { $num_usr_err > 1 } {
		set err_display [= "The following %s errors were found in the data input" $num_usr_err]:\n
	    } else {
		set err_display [= {The following error was found in the data input}]:\n
	    }
	    append err_display $usr_err
	    WarnWin $err_display
	    return
	}
	# Dump data to XML database
	if { $answer == 0 && $dumpit == 1} {
	    # Just dump it! (xml database)
	    processxmlfile::putsvars gsdata/process $varlist processdatwin
	    # Update GiD's GenData info
	    processdatwin::assigngendata
	}
    } else {
	if { $close != 1} {
	    # Update GiD's GenData info (even if nothing is changed it updates info)
	    processdatwin::assigngendata
	}
    }
    # Destroy the window
    if { $close == 1 } {
	destroy $win
    }
    return
}

proc processdatwin::assigngendata { } {
    # Process data
    variable Process_Data
    variable ProcessType
    variable CoolingSystem
    variable MachineType
    # Timing Data
    variable Timing_Types
    set type [lindex $Timing_Types [expr $ProcessType-1]]
    variable $type
    upvar 0 $type Timing_Data
    foreach item $Timing_Data {
	variable [lindex $item 0]
    }
    # Analysis data
    variable TimePeriod 
    variable CommStepRatio
    variable TimeStepRatio
    # Analisis data
    variable AnalysisType
    variable RestartType
    variable Process_Parameters
    foreach item $Process_Parameters {
	variable [lindex $item 0]
    }
    # Units data
    variable Geometry_Units
    variable Temperature_Units

    # Apply changes in Tdyn GenData
    set ProjectInfo [.central.s info Project]
    # Time Increment
    if { $TimeStepRatio<1 } {
	WarnWin "[= {Wrong value of Steps per Cycle found}].\n[= {It will be set to 200}]." 
	set TimeStepRatio 200
    } elseif { $TimeStepRatio<100 } {
	WarnWin "[= {Steps per Cycle < 100 found}].\n[= {Values from 100 to 400 are recommended}]."
    }
# set dt [format %.5f [expr $TimePeriod/$TimeStepRatio]]
    set dt [expr $TimePeriod/$TimeStepRatio]
    if { $dt <= 0.0 } { 
	WarnWin "[= {Time increment too low found}].\n[= {It will be set to 0.05}]." 
	set dt 0.05 
    }
    catch { EditProblemData Time_Increment $dt }
    # Number of Time Steps
    catch { 
	# set ts [expr int(int($TimePeriod/$dt+.5)*$NumberOfCycles)]
	EditProblemData Number_of_Steps [expr $NumberOfCycles*$TimeStepRatio]
    }
    # Iterations
    catch { EditProblemData Max_Iterations 1 }
    # Initial Steps
    catch { EditProblemData Initial_Steps 0 }
    # Output Step
    catch { EditProblemData Output_Step 1 }
    # Output Start
    catch { 
	set os [expr int($TimePeriod/$dt*($NumberOfCycles-1))+1]
	EditProblemData Output_Start $os 
    }
    # Restart?
    catch { EditProblemData Restart $RestartType }
    # Units?
    catch { 
	set Geometry_Units [GiD_AccessValue get gendata Geometry_Units]
	set Temperature_Units [GiD_AccessValue get gendata Output_Temperature_Units]
    }
    # Initial and Conditional conditions for Blank Mold
    if { $AnalysisType == 0 } {
	set matname1 [lindex [TIU_getmaterialnames MATERIALS_(SOLID) Type BlkMold] 0]
	set matname2 [lindex [TIU_getmaterialnames MATERIALS_(SOLID) Type Baffle] 0]
	if { [catch { EditProblemData Initial_Temperature \
		"if(mat($matname1))then($Initial_Blank_Mold_Tm)elif(mat($matname2))then($Initial_Baffle_Tm)else($Initial_Final_Mold_Tm)endif" \
	    } errormsg] } {
	    WarnWin [= {Data error: Cannot define initial data}]
	}
	set time "dmod(t,$TimePeriod)"
	set itime [expr $TimeBaffleOn/$TimePeriod]
	if { [info exists TimeBaffle2Off] } {
	    set ftime [expr $TimeBaffle2Off/$TimePeriod]
	} else {
	    set ftime [expr $TimeBaffleOff/$TimePeriod]
	}
	set blkname [lindex [TIU_getmaterialnames MATERIALS_(SOLID) Type BlkMold] 0]
	if { $blkname == "" } {
	    EditProblemData Temperature_FuncCond \
		    "if(($time>$itime)&($time<$ftime))then(-1)else(1)endif"
	} else {
	    EditProblemData Temperature_FuncCond \
		    "if(($time>$itime)&($time<$ftime))then(-1)elif(mat($blkname)<1)then(1)else(0)endif"
	}
    } else {
	# Initial conditions for Final Mold
	set matname1 [lindex [TIU_getmaterialnames MATERIALS_(SOLID) Type FnlMold] 0]
	set matname2 [lindex [TIU_getmaterialnames MATERIALS_(SOLID) Type FnlMold_BottomPlate] 0]
	if { [catch { EditProblemData Initial_Temperature \
		"$Initial_Final_Mold_Tm" \
	    } errormsg] } {
	    WarnWin [= {Data error: Cannot define initial data}] 
	}
	if { [catch { EditProblemData Temperature_FuncCond 0 } errormsg] } {
	    WarnWin [= {Data error: Cannot define conditional data}] 
	}
    }
}

proc processdatwin::assignmaterials { } {
    # Process data
    variable Process_Data
    variable ProcessType
    variable CoolingSystem
    variable MachineType
    # Timing Data
    variable Timing_Types
    set type [lindex $Timing_Types [expr $ProcessType-1]]
    variable $type
    upvar 0 $type Timing_Data
    foreach item $Timing_Data {
	variable [lindex $item 0]
    }
    # Analysis data
    variable TimePeriod 
    variable CommStepRatio
    variable TimeStepRatio
    # Analisis data
    variable AnalysisType
    variable RestartType
    variable Process_Parameters
    foreach item $Process_Parameters {
	variable [lindex $item 0]
    }
    # Other Data
    variable Initial_FnlVacuum_Tm
    variable External_Blank_Mold_Tm
    variable External_Final_Mold_Tm

    set Geom_Units [GiD_AccessValue get gendata Geometry_Units]
    set Geom_IntUn [GiD_AccessValue get gendata Internal_Length_Units]

    # Check visualization status
    set MeshViewInfo [lindex [.central.s info Project] 4]
    if { $MeshViewInfo != "GEOMETRYUSE" } {
	.central.s process escape escape escape Meshing MeshView escape escape escape
    }
    ### Start the process 
    set err [ catch {
    ### Define Internal & OutPut Units 
    ### Internal Temperature units must be SI to communicate with Pbsim
    set unt [GiD_AccessValue get gendata OutPut_Temperature_Units]
    GiD_AccessValue set gendata Internal_Temperature_Units {[Gt]}
    GiD_AccessValue set gendata Boundary_Temperature_Units $unt
    set unt [GiD_AccessValue get gendata Geometry_Units]
    GiD_AccessValue set gendata Internal_Length_Units $unt
    GiD_AccessValue set gendata OutPut_Length_Units $unt
    GiD_AccessValue set gendata Boundary_Length_Units $unt
    ### Unassign Previous Materials
    .central.s process escape escape escape data materials unassign allmat yes escape escape escape
    ### Edit and Assign Material / Boundaries Properties
    ##### BLANK MOLD PROPERTIES ASSIGNMENT #####
    # Assign Materials (Blank Mold - BlkMold)
    set matname [lindex [TIU_getmaterialnames MATERIALS_(SOLID) Type BlkMold] 0]
    AssignMaterialToLayer blkmold $matname Volumes
    ## Process Blow & Blow, NNPB y 62 (Common to all the processes) ##
    # Assign Boundaries (glass contact surface for blkmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type BlkMold_Contact] 0]
    AssignMaterialToLayer blkmold_contact $matname Surfaces
    # Assign Boundaries (cooling tubes for blkmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type BlkMold_CoolingHoles] 0]
    if { $matname=="" && ![IsLayerEmpty blkmold_coolingholes Surfaces] } {
	CreateMaterial Solid_Body BlkMold_CoolingHoles [list Type] [list BlkMold_CoolingHoles]
	set matname BlkMold_CoolingHoles
    }
    if { $matname!=""} {
	# Axial cooling system
	set time "dmod(t,$TimePeriod)"
	set itime [expr $TimeBlankCoolingOn/$TimePeriod]
	set ftime [expr $TimeBlankCoolingOff/$TimePeriod]
	set uconv [TUI_exectdyntool [list -no_timetable \
		    -tool convert_units 1 $Geom_IntUn $Geom_Units Length]]
	set ymax [expr [LayerLength blkmold_coolingholes MAXY]*$uconv]
	set ymin [expr [LayerLength blkmold_coolingholes MINY]*$uconv]       
	set coef 0.0
	catch {
	    set coef [expr 100.0/($ymin-$ymax)]
	}
	set hfield "if(($time>$itime)&($time<$ftime))then(300*($Inlet_BlkCooling_Tm+($coef)*(y+($ymin))))else(10*($Inlet_BlkCooling_Tm+($coef)*(y+($ymin))))endif"
	set rfield "if(($time>$itime)&($time<$ftime))then(300)else(10)endif"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer blkmold_coolingholes $matname Surfaces
    }
    # Assign Boundaries (cooling stack (toberas) for blkmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type BlkMold_CoolingStack] 0]
    if { $matname=="" && ![IsLayerEmpty blkmold_coolingstack Surfaces] } {
	CreateMaterial Solid_Body BlkMold_CoolingStack [list Type] [list BlkMold_CoolingStack]
	set matname BlkMold_CoolingStack
    }
    if { $matname!=""} {
	# Stack cooling system
	set time "dmod(t,$TimePeriod)"
	set itime [expr $TimeBlankCoolingOn/$TimePeriod]
	set ftime [expr $TimeBlankCoolingOff/$TimePeriod]
	set coef 0.0
	catch {
	    set coef [expr 100.0/($ymin-$ymax)]
	}
	set hfield "if(($time>$itime)&($time<$ftime))then(180*$Inlet_BlkCooling_Tm)else(28*$Inlet_BlkCooling_Tm)endif"
	set rfield "if(($time>$itime)&($time<$ftime))then(180)else(28)endif"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer blkmold_coolingstack $matname Surfaces
    }
    # Assign Boundaries (cooling shell (aletas) for blkmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type BlkMold_CoolingShell] 0]
    if { $matname=="" && ![IsLayerEmpty blkmold_coolingshell Surfaces] } {
	CreateMaterial Solid_Body BlkMold_CoolingShell [list Type] [list BlkMold_CoolingShell]
	set matname BlkMold_CoolingShell
    }
    if { $matname!=""} {
	# Shell cooling system
	set time "dmod(t,$TimePeriod)"
	set itime [expr $TimeBlankCoolingOn/$TimePeriod]
	set ftime [expr $TimeBlankCoolingOff/$TimePeriod]
	set coef 0.0
	catch {
	    set coef [expr 100.0/($ymin-$ymax)]
	}
	set hfield "if(($time>$itime)&($time<$ftime))then(250*($Inlet_BlkCooling_Tm+($coef)*(y+($ymin))))else(10*($Inlet_BlkCooling_Tm+($coef)*(y+($ymin))))endif"
	set rfield "if(($time>$itime)&($time<$ftime))then(250)else(10)endif"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer blkmold_coolingshell $matname Surfaces
    }
    # Assign Boundaries (neckring for blkmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type BlkMold_NeckRing] 0]
    #if { $matname=="" && ![IsLayerEmpty blkmold_neckring Surfaces] } {
    #    CreateMaterial Solid_Body BlkMold_NeckRing [list Type] [list BlkMold_NeckRing]
    #    set matname BlkMold_NeckRing
    #}
    if { $matname!=""} {
	set time "dmod(t,$TimePeriod)"
	set itime 0.0
	set ftime [expr $TimeBlankOpen/$TimePeriod]
	set hfield "if(($time>$itime)&($time<$ftime))then(2500*(250))else(20*(35))endif"
	set rfield "if(($time>$itime)&($time<$ftime))then(2500)else(20)endif"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer blkmold_neckring $matname Surfaces
    } else {
	Warning "[= {Cannot find boundary properties for blank mold neckring}].\n\
	    [= {*.mat file may be corrupted}]."
    }
    # Assign Boundaries (holderarm for blkmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type BlkMold_HolderArm] 0]
    #if { $matname=="" && ![IsLayerEmpty blkmold_holderarm Surfaces] } {
    #    CreateMaterial Solid_Body BlkMold_HolderArm [list Type] [list BlkMold_HolderArm]
    #    set matname BlkMold_HolderArm
    #}
    if { $matname!=""} {
	# JGE 10/2004: Heat tranfer coefficient reduced from 2500 to 500
	set hfield "500*(120)"
	set rfield "500"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer blkmold_holderarm $matname Surfaces
    }
    # Assign Boundaries (external for blkmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type BlkMold_External] 0]
    if { $matname=="" && ![IsLayerEmpty blkmold_external Surfaces] } {
	CreateMaterial Solid_Body BlkMold_External [list Type] [list BlkMold_External]
	set matname BlkMold_External
    }
    if { $matname!=""} {
	set hfield "28*($External_Blank_Mold_Tm)"
	set rfield "28"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer blkmold_external $matname Surfaces
    }
    # Assign Boundaries (Baffle)
    #set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type BlkMold_Baffle] 0]
    #if { $matname!=""} {
    #    set time "dmod(t,$TimePeriod)"
    #    set hfield "28*50"
    #    set rfield "28"
    #    GiD_AccessValue set materials $matname Heat_Flux $hfield
    #    GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
    #    AssignMaterialToLayer blkmold_baffle $matname Surfaces
    #}
    ## Process Blow & Blow ## 
    if { $ProcessType == 0 } {
	# Assign Materials (Baffle - BlkMold_Baffle)
	set matname [lindex [TIU_getmaterialnames MATERIALS_(SOLID) Type Baffle] 0]
	if { $matname!=""} {
	    AssignMaterialToLayer blkmold_baffle $matname Volumes
	    .central.s process escape escape escape data conditions assigncond\
		Volume_Conditional_Temperature layer:blkmold_baffle escape escape escape
	} else {
	    Warning "[= {Cannot find volume for blank mold baffle}].\n\
		[= {Check layer blkmold_baffle definition}]."
	}
	# Assign Boundaries (funnel for blkmold)
	set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type BlkMold_Funnel] 0]
	if { $matname!=""} {
	    set time "dmod(t,$TimePeriod)"
	    # To be updated with FunnelOn y FunnelOff
	    set itime 0.0    
	    if { [info exists TimeBaffle2Off] } {
		set ftime [expr $TimeBaffle2Off/$TimePeriod]
	    } else {
		set ftime [expr $TimeBaffleOff/$TimePeriod]
	    }
	    set hfield "if(($time>$itime)&($time<$ftime))then(2500*(250))else(20*(35))endif"
	    set rfield "if(($time>$itime)&($time<$ftime))then(2500)else(20)endif"
	    GiD_AccessValue set materials $matname Heat_Flux $hfield
	    GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	    AssignMaterialToLayer blkmold_neckring $matname Surfaces
	} else {
	    if { $MeshViewInfo != "GEOMETRYUSE" } {
		.central.s process escape escape escape Meshing MeshView escape escape escape 
	    }
	    Warning "[= {Cannot find boundary properties for blank mold funnel}].\n\
		[= {*.mat file may be corrupted}]."
	}
    ## Process NNPB & 62   ## 
    } else {
	# Assign Materials and Conditions (Baffle - BlkMold_Baffle)
	set matname [lindex [TIU_getmaterialnames MATERIALS_(SOLID) Type Baffle] 0]
	if { $matname!=""} {
	    AssignMaterialToLayer blkmold_baffle $matname Volumes
	    set time "dmod(t,$TimePeriod)"
	    set itime [expr $TimeBaffleOn/$TimePeriod]
	    set ftime [expr $TimeBaffleOff/$TimePeriod]
	    set blkname [lindex [TIU_getmaterialnames MATERIALS_(SOLID) Type BlkMold] 0]
	    if { $blkname == "" } {
		EditProblemData Temperature_FuncCond \
		    "if(($time>$itime)&($time<$ftime))then(-1)else(1)endif"
	    } else {
		EditProblemData Temperature_FuncCond \
		    "if(($time>$itime)&($time<$ftime))then(-1)elif(mat($blkname)<1)then(1)else(0)endif"
	    }
	    .central.s process escape escape escape data conditions assigncond\
		Volume_Conditional_Temperature layer:blkmold_baffle escape escape escape
	} else {
	    Warning "[= {Cannot find volume for blank mold baffle}].\n\
		[= {Check layer blkmold_baffle definition}]."
	}
    }
    ##### FINAL MOLD PROPERTIES ASSIGNMENT #####
    ### Assign Materials (Final Mold - FnlMold) ###
    set matname [lindex [TIU_getmaterialnames MATERIALS_(SOLID) Type FnlMold] 0]
    AssignMaterialToLayer fnlmold $matname Volumes
    # Assign Boundaries (glass contact surface for fnlmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type FnlMold_Contact] 0]
    AssignMaterialToLayer fnlmold_contact $matname Surfaces
    # Assign Boundaries (cooling tubes for fnlmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type FnlMold_CoolingHoles] 0]
    if { $matname=="" && ![IsLayerEmpty fnlmold_coolingholes Surfaces] } {
	CreateMaterial Solid_Body FnlMold_CoolingHoles [list Type] [list FnlMold_CoolingHoles]
	set matname FnlMold_CoolingHoles
    }
    if { $matname!=""} {
	# Axial cooling system (Warning!!! Timmings are fixed to 0 and 360
	set time "dmod(t,$TimePeriod)"
	set itime 0.0
	set ftime $TimePeriod 
	set uconv [TUI_exectdyntool [list -no_timetable \
		    -tool convert_units 1 $Geom_IntUn $Geom_Units Length]]
	set ymax [expr [LayerLength fnlmold_coolingholes MAXY]*$uconv]
	set ymin [expr [LayerLength fnlmold_coolingholes MINY]*$uconv]
	set coef 0.0
	catch {
	    set coef [expr 100.0/($ymin-$ymax)]
	}
	set hfield "if(($time>$itime)&($time<$ftime))then(300*($Inlet_FnlCooling_Tm+($coef)*(($ymax)-y)))else(10*($Inlet_FnlCooling_Tm+($coef)*(($ymax)-y)))endif"
	set rfield "if(($time>$itime)&($time<$ftime))then(300)else(10)endif"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer fnlmold_coolingholes $matname Surfaces
    }
    # Assign Boundaries (cooling stack (toberas) for fnlmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type FnlMold_CoolingStack] 0]
    if { $matname=="" && ![IsLayerEmpty fnlmold_coolingstack Surfaces] } {
	CreateMaterial Solid_Body FnlMold_CoolingStack [list Type] [list FnlMold_CoolingStack]
	set matname FnlMold_CoolingStack
    }
    if { $matname!=""} {
	# Stack cooling system
	set time "dmod(t,$TimePeriod)"
	set itime [expr $TimeBlankCoolingOn/$TimePeriod]
	set ftime [expr $TimeBlankCoolingOff/$TimePeriod]
	set coef 0.0
	catch {
	    set coef [expr 100.0/($ymin-$ymax)]
	}
	set hfield "if(($time>$itime)&($time<$ftime))then(180*$Inlet_FnlCooling_Tm)else(28*$Inlet_FnlCooling_Tm)endif"
	set rfield "if(($time>$itime)&($time<$ftime))then(180)else(28)endif"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer fnlmold_coolingstack $matname Surfaces
    }
    # Assign Boundaries (cooling shell (aletas) for fnlmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type FnlMold_CoolingShell] 0]
    if { $matname=="" && ![IsLayerEmpty fnlmold_coolingshell Surfaces] } {
	CreateMaterial Solid_Body FnlMold_CoolingShell [list Type] [list FnlMold_CoolingShell]
	set matname FnlMold_CoolingShell
    }
    if { $matname!=""} {
	# Shell cooling system
	set time "dmod(t,$TimePeriod)"
	set itime [expr $TimeBlankCoolingOn/$TimePeriod]
	set ftime [expr $TimeBlankCoolingOff/$TimePeriod]
	set coef 0.0
	catch {
	    set coef [expr 100.0/($ymin-$ymax)]
	}
	set hfield "if(($time>$itime)&($time<$ftime))then(250*($Inlet_FnlCooling_Tm+($coef)*(y-($ymax))))else(10*($Inlet_FnlCooling_Tm+($coef)*(y-($ymax))))endif"
	set rfield "if(($time>$itime)&($time<$ftime))then(250)else(10)endif"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer fnlmold_coolingshell $matname Surfaces
    }
    # Assign Boundaries (vaccumholes for fnlmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type FnlMold_VacuumHoles] 0]
    if { $matname=="" && ![IsLayerEmpty fnlmold_vacuumholes Surfaces] } {
	CreateMaterial Solid_Body FnlMold_VacuumHoles [list Type] [list FnlMold_VacuumHoles]
	set matname FnlMold_VacuumHoles
    }
    if { $matname!=""} {
	set time "dmod(t,$TimePeriod)"
	set itime [expr ($TimeMoldVacuumOn+360.0-($TimeInvertOn+20.0))/$TimePeriod]
	set ftime [expr ($TimeMoldVacuumOff+360.0-($TimeInvertOn+20.0))/$TimePeriod]
	set uconv [TUI_exectdyntool [list -no_timetable \
		    -tool convert_units 1 $Geom_IntUn $Geom_Units Length]]
	set ymax [expr [LayerLength fnlmold_vacuumholes MAXY]*$uconv]
	set ymin [expr [LayerLength fnlmold_vacuumholes MINY]*$uconv]
	set coef 0.0
	catch {
	    set coef [expr 100.0/($ymin-$ymax)]
	}
	set hfield "if(($time>$itime)&($time<$itime+0.06))then(50*($Initial_FnlVacuum_Tm+($coef)*($ymax-y)))elif(($time>$itime+0.06)&($time<$ftime))then(1*($Initial_FnlVacuum_Tm+($coef)*($ymax-y)))else(10*($Initial_FnlVacuum_Tm+($coef)*($ymax-y)))endif"
	set rfield "if(($time>$itime)&($time<$itime+0.06))then(50)elif(($time>$itime+0.06)&($time<$ftime))then(1)else(10)endif"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer fnlmold_vacuumholes $matname Surfaces
    }
    # Assign Boundaries (bottomplate for fnlmold) and FnlMold for Volumen. To be clarified!!!
    set matname [lindex [TIU_getmaterialnames MATERIALS_(SOLID) Type FnlMold] 0]
    AssignMaterialToLayer fnlmold_bottomplate $matname Volumes
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type FnlMold_BottomPlate] 0]
    AssignMaterialToLayer fnlmold_bottomplate $matname Surfaces
    if { $matname!=""} {
	set time "dmod(t,$TimePeriod)"
	set itime [expr ($TimeMoldPhysicalClose-($TimeInvertOn+0.055556*$TimePeriod))/$TimePeriod]
	set ftime [expr ($TimeMoldOpenOn+$TimePeriod-($TimeInvertOn+0.055556*$TimePeriod))/$TimePeriod]
	set hfield "if(($time>$itime)&($time<$ftime))then(2500*(250))else(20*(35))endif"
	set rfield "if(($time>$itime)&($time<$ftime))then(2500)else(20)endif"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer blkmold_neckring $matname Surfaces
    } else {
	Warning "[= {Cannot find boundary properties for blank mold neckring}].\n\
	    [= {*.mat file may be corrupted}]."
    }
    # Assign Boundaries (insert for fnlmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type FnlMold_HolderArm] 0]
    AssignMaterialToLayer fnlmold_holderarm $matname Surfaces
    if { $matname!=""} {
	# JGE 10/2004: Heat tranfer coefficient reduced from 2500 to 500
	set hfield "500*(120)"
	set rfield "500"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer fnlmold_holderarm $matname Surfaces
    } else {
#        Warning "[= {Cannot find boundary properties for final mold holderarm}].\n\
#            [= {*.mat file may be corrupted}]."
    }
    # Assign Boundaries (external for fnlmold)
    set matname [lindex [TIU_getmaterialnames BOUNDARIES_(SOLID) Type FnlMold_External] 0]
    if { $matname=="" && ![IsLayerEmpty fnlmold_external Surfaces] } {
	CreateMaterial Solid_Body FnlMold_External [list Type] [list FnlMold_External]
	set matname FnlMold_External
    }
    if { $matname!=""} {
	set hfield "28*($External_Final_Mold_Tm)"
	set rfield "28"
	GiD_AccessValue set materials $matname Heat_Flux $hfield
	GiD_AccessValue set materials $matname Reactive_Heat_Flux $rfield
	AssignMaterialToLayer fnlmold_external $matname Surfaces
    }
    # Restore GiD View
    if { $MeshViewInfo != "GEOMETRYUSE" } {
	.central.s process escape escape escape Meshing MeshView escape escape escape 
    }
    } errstring ]
    ### Show error if any
    if { $errstring!="" } {
	GraphicsON  
	WarnWin "$errstring"
    }
}

proc processdatwin::mainvarslist { } {
    # Creating a list of variables to be saved/checked/...
    set ret ""
    foreach item $processdatwin::Process_Data {  
	set ret [linsert $ret end [lindex $item 0]]
    }
    foreach item $processdatwin::Angle_Data_NNPB {
	set ret [linsert $ret end [lindex $item 0]]
    }
    foreach item $processdatwin::Angle_Data_BAndB {
	if { [lsearch $ret $item] < 0 } {
	    set ret [linsert $ret end [lindex $item 0]]
	}
    }
    set ret [linsert $ret end  AnalysisType]
    set ret [linsert $ret end  RestartType]
    variable Process_Parameters
    foreach item $Process_Parameters {
	set ret [linsert $ret end  [lindex $item 0]]
    }
    set ret [linsert $ret end Geometry_Units]
    set ret [linsert $ret end Temperature_Units]

    return $ret
}

################################################################################
#
#   Save XML (SPD) file
#
################################################################################

proc processdatwin::ExportSPDFile { } {
    global DefaultSearchDirectory

    if { ![info exists DefaultSearchDirectory] } {
	set DefaultSearchDirectory [pwd]
    }

    set file [tk_getSaveFile -defaultextension .bot -filetypes \
	    [list [list [= "SPD files"] [list ".spd" ".xml"]] \
		[list [= "All files"] [list "*"]]]  \
	    -initialdir $DefaultSearchDirectory -parent .gid -title [= "Export SPD file"]]
    if { $file == "" } { return }
    set DefaultSearchDirectory [file dirname $file]
    update

    # Save XML structure
    processdatwin::assigngendata
    processxmlfile::write $file
}

#    Initial Checkings
proc processdatwin::checkxmlfile { } {

    set xmlroot $processxmlfile::XmlRoot
    set xmldoc $processxmlfile::XmlDoc
    set rootname $processxmlfile::rootname

    foreach v [mainvarslist] {
	set xpath "gsdata/process/param\[@name='$v'\]"
	set paramNode [$xmlroot selectNodes $xpath]
	if { $paramNode != "" } {
	    set value [$paramNode text]
	    if { $value == "" } {
		.central.s OutPutPrintedMessages [= "Error found in *.spd file: Parameter '%s' is not correct" $v]
		# WarnWin [= "Error found in *.spd file: Parameter '%s' is not correct" $v]
		set value 1.0
		if { [info exists processdatwin::$v]} {
		    if { [set processdatwin::$v] != "" } {
		        set value [set processdatwin::$v]
		    } 
		}
	    }
	    set processdatwin::$v $value
	} else {
	    .central.s OutPutPrintedMessages [= "Error found in *.spd file: Parameter '%s' cannot be found." $v]
	    # WarnWin [= "Error found in *.spd file: Parameter '%s' cannot be found." $v]
	    set prcnode [$xmlroot selectNodes gsdata/process]
	    if { $prcnode == "" } {
		set prcnode [processxmlfile::createElement /$rootname/gsdata/process]
	    }
	    set newnode [$xmldoc createElement param]
	    $newnode setAttribute name $v
	    $newnode setAttribute c ""
	    $newnode setAttribute default 0.0
	    $newnode setAttribute units ""
	    $prcnode appendChild $newnode
	    set value 1.0
	    if { [info exists processdatwin::$v]} {
		if { [set processdatwin::$v] != "" } {
		    set value [set processdatwin::$v]
		} 
	    }
	    $newnode appendChild [$xmldoc createTextNode $value]
	    set processdatwin::$v $value
	}
    }
}

# Devuelve el valor de una variable (para uso en *.bas)
proc SpdData { var {ret 1} } {
    catch {
	set var processdatwin::$var
	set ret [eval set temp $$var]
    }
    return $ret
}

# Devuelve el valor de una variable (para uso en *.bas)
proc processdatwin::vardata { var } {
    set ret -1
    if { [catch { 
	variable $var
	set ret [eval set temp $$var]
    } errormsg] } {
	.central.s OutPutPrintedMessages "[= {Error found in writeinfo}]: $errormsg"
	#WarnWin "[= {Error found in writeinfo}]: $errormsg"
    }    
    return $ret
}

# Escribe informacin en formato pbsim
proc processdatwin::writegobinfo { } {

    set matname [lindex [TIU_getmaterialnames MATERIALS_(GOB) Type Gob] 0]
    set ret ""

    if { [catch {
	    set untT [GiD_AccessValue get gendata OutPut_Temperature_Units]
	    append ret "material data\n"
	    append ret "viscosity\n"
	    set val [TUI_getmatfieldvalue $matname Fluid_Viscosity]
	    regexp {exp\((.*)\+(.*)/\(Tm-(.*)\)\)} $val --> av bv cv
	    set unt [TUI_getmatfieldvalue $matname Fluid_Viscosity_Units]
	    set factor [TUI_exectdyntool [list -no_timetable \
		-tool convert_units 1.0 $unt \[Kg/m.s\] Viscosity]]
	    append ret "$av $bv $cv $factor\n"  
	    append ret "density\n"
	    regexp {interpolate\(\#(.*)\#Tm\)} [TUI_getmatfieldvalue $matname Density] -> val
	    set unt [TUI_getmatfieldvalue $matname Density_Units]
	    set factor [TUI_exectdyntool [list -no_timetable \
		        -tool convert_units 1 $unt \[Kg/m3\] Density]]
	    set vallist [split $val {,}]
	    foreach {t d} $vallist {
		set ft [TUI_exectdyntool [list -no_timetable \
		        -tool convert_units $t $untT \[Gt\] Temperature]]
		append ret "$ft [expr $d*$factor] "
	    }
	    append ret "\n"
	    append ret "heat capacity\n"
	    regexp {interpolate\(\#(.*)\#Tm\)} [TUI_getmatfieldvalue $matname Specific_Heat_C] -> val
	    set unt [TUI_getmatfieldvalue $matname C_Units]
	    set factor [TUI_exectdyntool [list -no_timetable \
		        -tool convert_units 1 $unt \[J/Kg.Gt\] SpecificHeat]]
	    set vallist [split $val {,}]
	    foreach {t d} $vallist {
		set ft [TUI_exectdyntool [list -no_timetable \
		        -tool convert_units $t $untT \[Gt\] Temperature]]
		append ret "$ft [expr $d*$factor] "
	    }
	    append ret "\n"
	    append ret "effective conductivity\n"
	    regexp {interpolate\(\#(.*)\#Tm\)} [TUI_getmatfieldvalue $matname Thermal_Conductivity_k11] -> val
	    set unt [TUI_getmatfieldvalue $matname k_Units]
	    set factor [TUI_exectdyntool [list -no_timetable \
		        -tool convert_units 1 $unt \[W/m.Gt\] HeatConductivity]]
	    set vallist [split $val {,}]
	    foreach {t d} $vallist {
		set ft [TUI_exectdyntool [list -no_timetable \
		        -tool convert_units $t $untT \[Gt\] Temperature]]
		append ret "$ft [expr $d*$factor] "
	    }
	} errormsg ] } {
	    .central.s OutPutPrintedMessages "[= {Error writting PBSIM data}]:\n$errormsg."
	    #WarnWin "[= {Error writting PBSIM data}]:\n$errormsg."
    }      

    return $ret
}

proc processdatwin::writepbsim { } {

    # Process data
    variable ProcessType
    # Analisis data
    variable AnalysisType
    variable RestartType
    variable CommStepRatio
    variable TimeStepRatio
    variable Process_Parameters
    foreach item $Process_Parameters {
	variable [lindex $item 0]
    }
    # Timing Data
    variable TimePeriod
    variable Timing_Types
    set type [lindex $Timing_Types [expr $ProcessType-1]]
    variable $type
    upvar 0 $type Timing_Data
    foreach item $Timing_Data {
	variable [lindex $item 0]
    }
    variable Angle_Types
    set type [lindex $Angle_Types [expr $ProcessType-1]]
    variable $type
    upvar 0 $type Angle_Data
    foreach item $Angle_Data {
	variable [lindex $item 0]
    }
    variable CavityRate

    # Units data
    set Geom_Units [GiD_AccessValue get gendata Geometry_Units]
    set Temp_Units [GiD_AccessValue get gendata Boundary_Temperature_Units]
    if { [catch {
	    set ret "communication time step\n"
	    append ret [expr [GiD_AccessValue get gendata Time_Increment]*$CommStepRatio]\n
	    append ret "analysis settings\n"
	    append ret [TUI_exectdyntool [list -no_timetable \
		        -tool convert_units $Initial_Glass_Tm $Temp_Units \[Gt\] Temperature]]\n
	    append ret [TUI_exectdyntool [list -no_timetable \
		        -tool convert_units $Initial_Plunger_Tm $Temp_Units \[Gt\] Temperature]]\n
	    append ret [TUI_exectdyntool [list -no_timetable \
		        -tool convert_units $Initial_Final_Mold_Tm $Temp_Units \[Gt\] Temperature]]\n
	    append ret $ProcessType\n
	    append ret $NumberOfCycles\n
	      append ret "analysis type\n"
	    append ret $AnalysisType\n
	    append ret "restart mode\n"
	    append ret $RestartType\n
	    append ret "timing settings\n"
	    foreach time $Timing_Data angle $Angle_Data {
		append ret "[lindex $time 0] [expr double([set temp $[lindex $angle 0]])/360.0*double($TimePeriod)]\n"
	    }
	    append ret "CavityRate $CavityRate\n"
	    append ret "plunger settings\n"
	    append ret [TUI_exectdyntool [list -no_timetable \
		        -tool convert_units $Plng_Loading_Position $Geom_Units \[m\] Length]]\n
#            append ret "plunger volume\n"
#            set Volume_Units {[cc]}
#            if { [TUI_formatunits NumsToPlain $Geom_Units] == "in" } {
#                set Volume_Units {[in3]}
#            }
#            append ret [TUI_exectdyntool [list -no_timetable \
#                    -tool convert_units $Plunger_Volume $Volume_Units \[m3\] Volume]]\n
	    append ret "finish volume\n"
	    set Volume_Units {[cc]}
	    if { [TUI_formatunits NumsToPlain $Geom_Units] == "in" } {
		set Volume_Units {[in3]}
	    }
	    append ret [TUI_exectdyntool [list -no_timetable \
		    -tool convert_units $Finish_Volume $Volume_Units \[m3\] Volume]]\n
	    append ret "other settings\n"
	    # set GeomOUnits [GiD_AccessValue get gendata Output_Length_Units]
	    # Makes no sense to use other geometry units for deformation
	    set GeomOUnits [GiD_AccessValue get gendata Geometry_Units]
	    if { [regexp {mm} $GeomOUnits] } {
		append ret "mm\n"
	    } elseif { [regexp {cm} $GeomOUnits] } {
		append ret "cm\n"
	    } elseif { [regexp {in} $GeomOUnits] } {
		append ret "in\n"
	    } elseif { [regexp {m} $GeomOUnits] } {
		append ret "m\n"
	    }
	    set TempOUnits [GiD_AccessValue get gendata Output_Temperature_Units]
	    if { [regexp {Gt} $TempOUnits] } {
		append ret "C\n"
	    } else {
		append ret "F\n"
	    }
	    set GeomIUnits [GiD_AccessValue get gendata Geometry_Units]
	    if { [regexp {mm} $GeomIUnits] } {
		append ret "mm\n"
	    } elseif { [regexp {cm} $GeomIUnits] } {
		append ret "cm\n"
	    } elseif { [regexp {in} $GeomIUnits] } {
		append ret "in\n"
	    } elseif { [regexp {m} $GeomIUnits] } {
		append ret "m\n"
	    }
	} errormsg ] } {
	    .central.s OutPutPrintedMessages "[= {Error writting PBSIM data}]:\n $errormsg."
	    #WarnWin "[= {Error writting PBSIM data}]:\n $errormsg."
    }
    return $ret
}
#
#   Glass Moulding Materials Database
#   Namespace for export/import materials from database
#
namespace eval ::GMMaterialsDatabase {
    variable CurrMaterials
    variable DataMaterials
    variable ModifiedCurrMaterials
    variable ModifiedDataMaterials
    # Configuraciones
    variable SortByBooks "No"
    variable HideBooks [list MATERIALS_(FLUID) BOUNDARIES_(FLUID) BOUNDARIES_(SOLID)]
}

# Evento DWImportExport --
#
# Argumentos:
#
# Resultados:
#
proc ::GMMaterialsDatabase::DWMatImportExport { w Book {initcmd ""} } {
    global DefaultSearchDirectoryP
    #set initialdir [GetDirectoryProblemType]
    set initialdir $DefaultSearchDirectoryP
    set filename [::tk::dialog::file:: open \
		      -title [= "Load Database"] \
		      -initialdir $initialdir \
		      -parent $w \
		      -filetypes [= "{{Materials} {.mat}}"]] 
    if { [string compare $filename ""] != 0 } {
	set DefaultSearchDirectoryP [file dirname $filename]
	::GMMaterialsDatabase::saveMaterialsWindow $filename $Book
    }
    catch {   
	tkwait window .saveMatWin
	eval $initcmd
    }
}

proc ::GMMaterialsDatabase::saveMaterialsWindow {filename Book {w .saveMatWin}} {
    
    InitWindow $w [= "Import/Export materials"] SaveMatWinWindowGeom

    frame $w.top -relief raised -bd 2

    # Show the current database materials  
    frame $w.top.finternal -relief raised -bd 2
    label $w.top.finternal.label -text [= "Internal materials"]
    set sw1 [ScrolledWindow $w.top.finternal.swinternmat -relief sunken -bd 2 -auto both]
    set tree1 [Tree $sw1.tree -relief flat -borderwidth 0 \
		             -highlightthickness 0 -selectbackground "darkblue" \
		             -highlightbackground yellow -width 30 -redraw 1]
    
    $sw1 setwidget $tree1
    frame $w.top.finternal.fbut -relief raised 
    button $w.top.finternal.fbut.rename -text [= "Rename"] \
	    -width 10 \
	    -command "::GMMaterialsDatabase::RenameSelMaterial $tree1 CurrMaterials"
#    button $w.top.finternal.fbut.delete -text [_ "Delete"] \
#        -width 10 \
#        -command "::GMMaterialsDatabase::RemoveSelNode $tree1 CurrMaterials"
    button $w.top.finternal.fbut.apply -text [= "Apply"] \
	-width 10 \
	-command [list ::GMMaterialsDatabase::UpdateGiDMaterials $w]

   
    # Show the external database materials  
    frame $w.top.fexternal -relief raised -bd 2
    label $w.top.fexternal.label -text [= "External materials"]
    set sw2 [ScrolledWindow $w.top.fexternal.swexternmat -relief sunken -bd 2 -auto both]
    set tree2 [Tree $sw2.tree -relief flat -borderwidth 0 \
		             -highlightthickness 0 -selectbackground "darkblue" \
		             -highlightbackground yellow -width 30 -redraw 1]
    
    $sw2 setwidget $tree2
    frame $w.top.fexternal.fbut
    button $w.top.fexternal.fbut.rename -text [= "Rename"] \
	-width 10 \
	-command "::GMMaterialsDatabase::RenameSelMaterial $tree2 DataMaterials"
    button $w.top.fexternal.fbut.delete -text [= "Delete"] \
	-width 10 \
	-command "::GMMaterialsDatabase::RemoveSelNode $tree2 DataMaterials"
    button $w.top.fexternal.fbut.save -text [= "Save"] \
	-width 10 \
	-command [list ::GMMaterialsDatabase::matSaveButton $filename $w]
    
    # Create the transfer buttons
    frame $w.top.fbut
    button $w.top.fbut.assign -text ">" -width "3"\
	    -command "::GMMaterialsDatabase::CopySelMaterial $tree1 $tree2 DataMaterials"
    button $w.top.fbut.assignall -text ">>" -width "3" \
	    -command "::GMMaterialsDatabase::CopyAllMaterials $tree1 $tree2 DataMaterials"
    button $w.top.fbut.deassign -text "<" -width "3" \
	    -command "::GMMaterialsDatabase::CopySelMaterialToSelMaterial $tree2 $tree1 CurrMaterials"
#    button $w.top.fbut.deassignall  -text "<<" -width "3" \
#            -command "::GMMaterialsDatabase::CopyAllMaterials $tree2 $tree1 CurrMaterials"

    
    set def_back [$w cget -background]
    frame $w.frmButtons -bg [CCColorActivo $def_back]
    button $w.frmButtons.btnclose -text [= "Close"] \
	    -command "destroy $w" \
	    -underline 0 -width 6    


    grid $w.top.fexternal.label -sticky nsew
    grid $sw2 -sticky nsew
    grid $w.top.fexternal.fbut.rename $w.top.fexternal.fbut.delete $w.top.fexternal.fbut.save -pady 5 -padx 5 -sticky ew
    grid $w.top.fexternal.fbut -sticky sew

    
    grid $w.top.fbut.assign -pady 5 -padx 5
    grid $w.top.fbut.assignall -pady 5 -padx 5
    grid $w.top.fbut.deassign -pady 5 -padx 5
#    grid $w.top.fbut.deassignall -pady 5 -padx 5

    grid $w.top.finternal.label -sticky nsew
    grid $sw1 -sticky nsew
#    grid $w.top.finternal.fbut.rename $w.top.finternal.fbut.delete $w.top.finternal.fbut.apply -pady 5 -padx 5 -sticky ew
    grid $w.top.finternal.fbut.rename $w.top.finternal.fbut.apply -pady 5 -padx 5 -sticky ew
    grid $w.top.finternal.fbut -sticky sew

    grid $w.top.finternal $w.top.fbut $w.top.fexternal -pady 5 -padx 6 -sticky nsew
    grid columnconfigure $w.top.finternal "0" -weight 1
    grid rowconfigure $w.top.finternal "1" -weight 1
    grid columnconfigure $w.top.fexternal "0" -weight 1
    grid rowconfigure $w.top.fexternal "1" -weight 1
    grid $w.top -sticky nsew

    grid $w.frmButtons -sticky ews -columnspan 7
    grid $w.frmButtons.btnclose -padx 5 -pady 6
    grid columnconfigure $w.top "0 2" -weight 1
    grid rowconfigure $w.top "0" -weight 1

    grid columnconfigure $w "0" -weight 1
    grid rowconfigure $w "0" -weight 1


    ::GMMaterialsDatabase::InitMaterials $filename $Book
    #UpdateMaterialsPrim $w.top.fassigned databaseMaterials $Book
    #UpdateMaterialsPrim $w.top.flayers currentMaterials $Book
    
    ::GMMaterialsDatabase::FillTreeMaterialsDatabase $tree1 CurrMaterials
    ::GMMaterialsDatabase::FillTreeMaterialsDatabase $tree2 DataMaterials

    bind $w <Alt-c> "tkButtonInvoke $w.frmButtons.btnclose"
    bind $w <Escape> "tkButtonInvoke $w.frmButtons.btnclose"
   
    #bind $tree2 <Delete> "::GMMaterialsDatabase::RemoveNode $tree2 DataMaterials"

    focus $w.frmButtons.btnclose
}

proc ::GMMaterialsDatabase::InitMaterials { filename Book } {
    ::GMMaterialsDatabase::ReadCurrMaterials $Book
    ::GMMaterialsDatabase::DWReadMatfile $filename
}

proc ::GMMaterialsDatabase::DWReadMatfile { filename } {
    variable DataMaterials
    variable ModifiedDataMaterials

    catch { unset DataMaterials }   
    set bookname ""
    set f [open $filename r]
    if { $f == "" } { 
	WarnWin [= "Error, cannot open file '%s'" $filename]
	return 
    }
    while { ![eof $f] } {
	gets $f aa
	if { $aa == "" || [string index $aa 0] == "#" } { 
	    continue
	} elseif { [regexp -nocase {BOOK:[ ]*([^ ]*)} $aa {} bookname] } {
	    if { ![info exists DataMaterials(MAT,bookslist)] || 
		[lsearch $DataMaterials(MAT,bookslist) $bookname] == -1 } {
		lappend DataMaterials(MAT,bookslist) $bookname
	    }
	} elseif { [regexp -nocase {[NUMBER:[ ]*([0-9]*)[ ]*]?MATERIAL:?[ ]*([^ ]*)} $aa {} matnum matname] } { 
	    lappend DataMaterials(MAT,nameslist) $matname
	    set DataMaterials(MAT,$matname,BOOK) $bookname
	    set inum 0
	    while { ![eof $f] } {
		gets $f aa
		if { $aa == "" || [string index $aa 0] == "#" } { continue }
		if { [regexp {^([^:]*):(.*)$} $aa {} field value] } {
		    set field [string trim $field]
		    set value [string trim $value]
		    if { $field == "QUESTION" } { incr inum }
		    if { $field == "DEPENDENCIES" } {
		        #can exists dependecies written with multiple lines
		        if { [info exists DataMaterials(MAT,$matname,$field,$inum)] } {
		            append DataMaterials(MAT,$matname,$field,$inum) $value
		        } else {
		            set DataMaterials(MAT,$matname,$field,$inum) $value                            
		        }                    
		    } else {
		        set DataMaterials(MAT,$matname,$field,$inum) $value
		    }
		} elseif { [regexp -nocase {^[ ]*END MATERIAL[ ]*$} $aa {}] } {
		    break
		} else {
		    WarnWin [= "Error reading material, bad line '%s'" $aa]
		    close $f
		    return
		}          
	    }
	} else {
	    WarnWin [= "Error reading material, bad line '%s'" $aa]
	    break 
	}
    }
    close $f

    foreach i [array names DataMaterials MAT,*,VALUE*] {
	if { [lindex $DataMaterials($i) 0] == "#N#" } {
	    set DataMaterials($i,0) [lindex $DataMaterials($i) 1]
	    for { set j 1 } { $j <= $DataMaterials($i,0) } { incr j } {
		set DataMaterials($i,$j) [lindex $DataMaterials($i) [expr $j+1]]
	    }
	}
    }
    set ModifiedDataMaterials 0
}

proc ::GMMaterialsDatabase::DWSaveMatfile { filename } {
    variable DataMaterials
    variable ModifiedDataMaterials
    set lastbookname ""
    set f [open $filename w]
    if { $f == "" } { 
	WarnWin [= "Error, cannot open file '%s'" $filename]
	return 
    }
    set otherfields "HELP STATE IMAGE DEPENDENCIES TKWIDGET TITLE"
    set matnum 1
    foreach matname $DataMaterials(MAT,nameslist) {
	if { [info exists DataMaterials(MAT,$matname,BOOK)] && $DataMaterials(MAT,$matname,BOOK) != "" } {
	    if { $DataMaterials(MAT,$matname,BOOK) != $lastbookname } {
		set lastbookname $DataMaterials(MAT,$matname,BOOK)
		puts $f "BOOK:$DataMaterials(MAT,$matname,BOOK)"
	    }
	}
	puts $f "NUMBER:$matnum MATERIAL:$matname"
	# Write fields
	#can exists title before any question
	set nquest 0
	set i "TITLE"
	if { [info exists CurrMaterials(MAT,$matname,$i,$nquest)] } {
	    puts $f "$i:$DataMaterials(MAT,$matname,$i,$nquest)"
	    set value $CurrMaterials(MAT,$matname,$i,$nquest)
	}
	set nquest 1
	while {[info exists DataMaterials(MAT,$matname,QUESTION,$nquest)]} {
	    puts $f "QUESTION:$DataMaterials(MAT,$matname,QUESTION,$nquest)"
	    puts $f "VALUE:$DataMaterials(MAT,$matname,VALUE,$nquest)"
	    foreach i $otherfields {
		if {[info exists DataMaterials(MAT,$matname,$i,$nquest)]} {
		    puts $f "$i:$DataMaterials(MAT,$matname,$i,$nquest)"
		}                
	    }
	    # Increase question
	    incr nquest
	}       
	puts $f "END MATERIAL"
    
	# Increase material number
	incr matnum
    }
    close $f
    set ModifiedDataMaterials 0
}


proc ::GMMaterialsDatabase::ReadCurrMaterials { Book } {
    
    variable CurrMaterials   
    variable ModifiedCurrMaterials 
    variable HideBooks
    # Obtain materials from GiD
    catch { unset CurrMaterials }
    
    foreach matname [.central.s info materials] {
	set bookname [.central.s info materials $matname BOOK]
	if { $bookname == "Default" } {
	    set bookname ""
	}
	if { [lsearch $HideBooks $bookname]==-1 } {
	#if { $bookname != $Book } continue
	    if { $bookname != "" && ( ![info exists CurrMaterials(MAT,bookslist)] || 
		 [lsearch $CurrMaterials(MAT,bookslist) $bookname] == -1 ) } { 
		lappend CurrMaterials(MAT,bookslist) $bookname
	    }

	    lappend CurrMaterials(MAT,nameslist) $matname
	    
	    set CurrMaterials(MAT,$matname,BOOK) $bookname
	    
	    set matparams [.central.s info materials $matname]
	    set matparams [lrange $matparams 1 end]
	    set inum  1
	    foreach "field value" $matparams {
		set CurrMaterials(MAT,$matname,QUESTION,$inum) $field            
		set CurrMaterials(MAT,$matname,VALUE,$inum) $value
		incr inum
	    }
	    set otherfields [.central.s info materials $matname OTHERFIELDS]
	    if { $otherfields != "" } {
		set otherfields [lrange $$otherfields 1 end]
		foreach "field value inum" $otherfields {                
		    set CurrMaterials(MAT,$matname,$field,$inum) $value 
		}
	    } 
	}        
    }

    foreach i [array names CurrMaterials MAT,*,VALUE*] {
	if { [lindex $CurrMaterials($i) 0] == "#N#" } {
	    set CurrMaterials($i,0) [lindex $CurrMaterials($i) 1]
	    for { set j 1 } { $j <= $CurrMaterials($i,0) } { incr j } {
		set CurrMaterials($i,$j) [lindex $CurrMaterials($i) [expr $j+1]]
	    }
	}
    }
    set ModifiedCurrMaterials 0
}

#dataname must be DataMaterials or CurrMaterials
proc ::GMMaterialsDatabase::FillTreeMaterialsDatabase { tree dataname } {
    variable HideBooks

    upvar #0 ::GMMaterialsDatabase::$dataname Data
    $tree delete [$tree nodes root]
    #materials without any book
    if { [info exists Data(MAT,nameslist)] } {
	foreach matname $Data(MAT,nameslist) {
	    if { ![info exists Data(MAT,$matname,BOOK)] || 
		$Data(MAT,$matname,BOOK) == "" } {
		if { [lsearch $HideBooks $bookname] == -1 } {
		    $tree insert end root "->$matname" -text $matname \
		        -image $TUI_images::i_point16   
		}         
	    }
	}
    }
    if { [info exists Data(MAT,bookslist) ] } {
	foreach bookname $Data(MAT,bookslist) {
	    if { [lsearch $HideBooks $bookname] == -1 } {
		$tree insert end root $bookname -text $bookname \
		    -image $TUI_images::i_folder
		foreach matname $Data(MAT,nameslist) {
		    if { [info exists Data(MAT,$matname,BOOK)] &&
		        $Data(MAT,$matname,BOOK) == $bookname } {
		        $tree insert end $bookname "$bookname->$matname" -text $matname \
		            -image $TUI_images::i_point16 
		    }
		}
	    }
	}
    }
}

proc ::GMMaterialsDatabase::matSaveButton { filename w } {
    variable ModifiedDataMaterials
    if { $ModifiedDataMaterials == "0" } return    

    if {[file writable $filename]==1} {
	set ret [tk_dialogRAM $w.tempwinw [= "Dialog window"] \
		[= "Are you sure to modify external materials file?"] \
		error 0 [= "OK"] [= "Cancel"]]
	if { $ret == 0 } {
	    ::GMMaterialsDatabase::DWSaveMatfile $filename
	}
    } else {
	WarnWin [= "The selected file is write protected"]
    }
}

proc ::GMMaterialsDatabase::UpdateGiDMaterials { w } {
    variable CurrMaterials
    variable ModifiedCurrMaterials
    variable HideBooks
    if { $ModifiedCurrMaterials == "0" } return

    set ret [tk_dialogRAM $w.tempwinw [= "Dialog window"] \
	    [= "Are you sure to modify the current materials?"] \
	    error 0 [= "OK"] [= "Cancel"]]
    if { $ret != 0 } {
	return
    }

    set otherfields "HELP STATE IMAGE DEPENDENCIES TKWIDGET TITLE"

    # Add/Remove materials loaded from database to GiD
    set memMaterials [.central.s info materials]    
    # Add materials
    foreach matname $CurrMaterials(MAT,nameslist) {        
	set found [lsearch $memMaterials $matname] 
	if {$found == -1} {        
	    # Add a new material to GiD
	    set cmd "Data Defaults BaseMaterial $matname"          
	    # Write fields
	    set cmd2 ""
	    if { [info exists CurrMaterials(MAT,$matname,BOOK)] } {
		set Book $CurrMaterials(MAT,$matname,BOOK)
	    }
	    set notherfields 0
	    set cmd3 ""
	    #can exists title before any question
	    set nquest 0
	    set i "TITLE"
	    if { [info exists CurrMaterials(MAT,$matname,$i,$nquest)] } {
		set value $CurrMaterials(MAT,$matname,$i,$nquest)
		set value [string map {{"} {\"}} $value]
		append cmd3 "$i \"$value\" [expr $nquest-1] "
		incr notherfields
	    }
	    set nquest 1
	    while {[info exists CurrMaterials(MAT,$matname,QUESTION,$nquest)]} {                
		set question $CurrMaterials(MAT,$matname,QUESTION,$nquest)
		set value $CurrMaterials(MAT,$matname,VALUE,$nquest)
		set value [string map {{"} {\"}} $value]
		append cmd2 "$question \"$value\" "        
		foreach i $otherfields {
		    if { [info exists CurrMaterials(MAT,$matname,$i,$nquest)] } {
		        set value $CurrMaterials(MAT,$matname,$i,$nquest)
		        set value [string map {{"} {\"}} $value]
		        append cmd3 "$i \"$value\" [expr $nquest-1] "
		        incr notherfields
		    }
		}
		incr nquest                
	    }
	    incr nquest -1
	    if { [info exists CurrMaterials(MAT,$matname,BOOK)] && 
		$CurrMaterials(MAT,$matname,BOOK) != "" } {
		set book $CurrMaterials(MAT,$matname,BOOK)
		if { $notherfields } {
		    set cmd "$cmd $nquest $cmd2 Book $book OtherFields $notherfields $cmd3 escape"
		} else {
		    set cmd "$cmd $nquest $cmd2 Book $book escape"
		}
	    } else {
		if { $notherfields } {
		    set cmd "$cmd $nquest $cmd2 OtherFields $notherfields $cmd3 escape"
		} else {
		    set cmd "$cmd $nquest $cmd2 escape"
		}
	    } 
	    .central.s process escape escape escape escape $cmd      
	}
    }
    # Remove materials
    foreach matname $memMaterials {  
	if { [lsearch $HideBooks [.central.s info materials $matname BOOK]]==-1 } {
	    set found [lsearch $CurrMaterials(MAT,nameslist) $matname]
	    if {$found == -1} {
		#remove material from GiD
		set cmd "Data Materials DeleteMaterial $matname escape" 
		.central.s process escape escape escape escape $cmd
	    }
	}
    }
}

#dataname must be DataMaterials or CurrMaterials
proc ::GMMaterialsDatabase::RemoveSelNode { tree dataname } {
    variable Modified$dataname
    upvar #0 ::GMMaterialsDatabase::$dataname Data

    set node [$tree selection get]
    if { [string equal $node ""] } return
    
    #set bookname [lindex [split $node "->"] 0]
    #set matname [lindex [split $node "->"] 2]
    set bookname ""
    set matname ""
    regexp {(.*)->(.*)} $node dummy bookname matname

    if { $bookname != "" && $matname == "" } {
	#delete all the book
	foreach node [$tree nodes $bookname] {
	    $tree delete $node            
	    #set matname [lindex [split $node "->"] 2]
	    set matname ""
	    regexp {(.*)->(.*)} $node dummy bookname matname
	    set pos [lsearch $Data(MAT,nameslist) $matname]
	    if { $pos != -1 } {
		set Data(MAT,nameslist) [lreplace $Data(MAT,nameslist) $pos $pos]
		array unset Data MAT,$matname,*
	    }            
	}
	$tree delete $bookname
	if { [info exists Data(MAT,bookslist)] } {
	    set pos [lsearch $Data(MAT,bookslist) $bookname]
	    if { $pos != -1 } {
		set Data(MAT,bookslist) [lreplace $Data(MAT,bookslist) $pos $pos]
	    }
	}
    } else {
	set parent [$tree parent $node]
	$tree delete $node
	if { ![llength [$tree nodes $parent]] } {
	    #delete void book
	    $tree delete $parent
	    set bookname $parent
	    if { [info exists Data(MAT,bookslist)] } {
		set pos [lsearch $Data(MAT,bookslist) $bookname]
		if { $pos != -1 } {
		    set Data(MAT,bookslist) [lreplace $Data(MAT,bookslist) $pos $pos]
		}
	    }
	}
	set pos [lsearch $Data(MAT,nameslist) $matname]
	if { $pos != -1 } {
	    set Data(MAT,nameslist) [lreplace $Data(MAT,nameslist) $pos $pos]
	    array unset Data MAT,$matname,*
	}
    }
    set Modified$dataname 1
}

#dataname must be DataMaterials or CurrMaterials
proc ::GMMaterialsDatabase::CreateBook { tree dataname bookname } {
    variable Modified$dataname
    upvar #0 ::GMMaterialsDatabase::$dataname Data
    if { ![$tree exists $bookname] } {    
	$tree insert end root $bookname -text $bookname \
	    -image $TUI_images::i_folder
    }
    if { ![info exists Data(MAT,bookslist)] || \
	    [lsearch $Data(MAT,bookslist) $bookname] == -1 } {
	lappend Data(MAT,bookslist) $bookname
    }
    set Modified$dataname 1
}

#dataname must be DataMaterials or CurrMaterials
proc ::GMMaterialsDatabase::CreateMaterial { tree dataname bookname matname } {
    variable Modified$dataname
    upvar #0 ::GMMaterialsDatabase::$dataname Data
    if { $dataname == "DataMaterials" } {
	upvar #0 ::GMMaterialsDatabase::CurrMaterials SourceData
    } else {
	upvar #0 ::GMMaterialsDatabase::DataMaterials SourceData
    }


    if { $bookname != "" && ![$tree exists $bookname] } {
	::GMMaterialsDatabase::CreateBook $tree $dataname $bookname
    }
    if { ![$tree exists "$bookname->$matname"] } {
	if { $bookname != "" } {
	    $tree insert end $bookname "$bookname->$matname" -text $matname \
		-image $TUI_images::i_point16 
	} else {
	    $tree insert end root "->$matname" -text $matname \
		-image $TUI_images::i_point16       
	}
    }
    if { [lsearch $Data(MAT,nameslist) $matname] == -1 } {
	lappend Data(MAT,nameslist) $matname
	foreach i [array names SourceData MAT,$matname,*] {
	    set Data($i) $SourceData($i)            
	}
    }
    set Modified$dataname 1
}

proc ::GMMaterialsDatabase::CopyMaterial { tree dataname bookname matname } {
  if { [$tree exists "$bookname->$matname"] } return
  if { $bookname != "" && ![$tree exists $bookname] } {
    CreateBook $tree $dataname $bookname
  }
  CreateMaterial $tree $dataname $bookname $matname
}

proc ::GMMaterialsDatabase::CopySelMaterial { treesrc treedst datanamedst } {
    set node [$treesrc selection get]
    if { $node == "" } return
#     set bookname [lindex [split $node "->"] 0]
#     set matname [lindex [split $node "->"] 2]
    set bookname ""
    set matname ""
    regexp {(.*)->(.*)} $node dummy bookname matname
    if { $bookname != "" && $matname == "" } {
	foreach node [$treesrc nodes $bookname] {
#             set matname [lindex [split $node "->"] 2]
	    set matname ""
	    regexp {(.*)->(.*)} $node dummy bookname matname
	    CopyMaterial $treedst $datanamedst $bookname $matname
	}
    } else {
	CopyMaterial $treedst $datanamedst $bookname $matname
    }
}

proc ::GMMaterialsDatabase::CopySelMaterialToSelMaterial { treesrc treedst datanamedst } {
    set nodesrc [$treesrc selection get]
    set nodedst [$treedst selection get]
    if { $nodesrc == "" || $nodedst == "" } {
	WarnWin [= {One material of the internal list and other of the external list must be selected}] 
	return
    }

    set booknamesrc ""
    set matnamesrc ""
    regexp {(.*)->(.*)} $nodesrc dummy booknamesrc matnamesrc
    set booknamedst ""
    set matnamedst ""
    regexp {(.*)->(.*)} $nodedst dummy booknamedst matnamedst

    if { $matnamedst == $matnamesrc } { 
	WarnWin [_ {Cannot copy a material with the same name than the original}]
    } else {
	::GMMaterialsDatabase::SubstituteMaterial $treesrc $treedst $datanamedst $matnamesrc $matnamedst
    }
}

# Sustituye un material del arbol treedst por uno del rbol treesrc
# datanamedst must be DataMaterials or CurrMaterials (usually CurrMaterials)
proc ::GMMaterialsDatabase::SubstituteMaterial { treesrc treedst datanamedst matnamesrc matnamedst} {
    variable Modified$datanamedst
    upvar #0 ::GMMaterialsDatabase::$datanamedst Data
    if { $datanamedst == "DataMaterials" } {
	upvar #0 ::GMMaterialsDatabase::CurrMaterials SourceData
    } else {
	upvar #0 ::GMMaterialsDatabase::DataMaterials SourceData
    }

    # Update mat fields
    set booknamedst $Data(MAT,$matnamedst,BOOK)
    set type $Data(MAT,$matnamedst,VALUE,1)
    if { $Data(MAT,$matnamedst,QUESTION,1) != "Type"} {
	WarnWin [= {Error: Cannot find Type of material %s} $matnamedst]
	return
    }
    if { [lsearch $Data(MAT,nameslist) $matnamesrc] == -1 &&
	 [lsearch $Data(MAT,nameslist) $matnamedst] != -1 } {
	set index [lsearch $Data(MAT,nameslist) $matnamedst]
	set Data(MAT,nameslist) [lreplace $Data(MAT,nameslist) $index $index $matnamesrc]
	foreach i [array names SourceData MAT,$matnamesrc,*] {
		set Data($i) $SourceData($i)
	}
    } else {
	return
    }
    set Data(MAT,$matnamesrc,VALUE,1) $type

    set index [$treedst index "$booknamedst->$matnamedst"]
    $treedst insert $index $booknamedst "$booknamedst->$matnamesrc" -text $matnamesrc \
	-image $TUI_images::i_point16 
    $treedst delete "$booknamedst->$matnamedst"

    set Modified$datanamedst 1
}

proc ::GMMaterialsDatabase::CopyAllMaterials { treesrc treedst datanamedst } {
    foreach bookname [$treesrc nodes root] {
#         set matname [lindex [split $bookname "->"] 2]        
	set matname ""
	regexp {(.*)->(.*)} $bookname dummy b matname
	if { $matname == "" } {
	    foreach node [$treesrc nodes $bookname] {
#                 set matname [lindex [split $node "->"] 2]
		set matname ""
		regexp {(.*)->(.*)} $node dummy b matname
		CopyMaterial $treedst $datanamedst $bookname $matname
	    }
	} else {
	    #matname without book
	    CopyMaterial $treedst $datanamedst "" $matname
	}
    }
}

proc ::GMMaterialsDatabase::RenameSelMaterial { tree dataname } {
    set node [$tree selection get]
    if { $node == "" } return
    #set bookname [lindex [split $node "->"] 0]
    #set matname [lindex [split $node "->"] 2]
    set matname ""
    regexp {(.*)->(.*)} $node dummy bookname matname
    if { $matname != "" } {
	set newname [tk_dialogEntryRAM .gid.renamemat [= "Material name"] \
		[= "Enter the new name of %s" $matname] gidquestionhead word $matname]
	if { $newname == "--CANCEL--" } {
	    return            
	}
	RenameMaterial $tree $dataname $matname $newname
    }    
}

proc ::GMMaterialsDatabase::RenameMaterial { tree dataname matname newname } {
    variable Modified$dataname
    upvar #0 ::GMMaterialsDatabase::$dataname Data
       
    set bookname $Data(MAT,$matname,BOOK)
    set node "$bookname->$matname"
    #$tree edit $node $newname 
    set pos [$tree index $node]
    $tree delete $node
    set node "$bookname->$newname"
    if { $bookname != "" } {
	$tree insert $pos $bookname $node -text $newname -image $TUI_images::i_point16 
    } else {
	$tree insert $pos root $node -text $newname -image $TUI_images::i_point16 
    }

    foreach i [array names Data MAT,$matname,*] {
	# this is bad: regsub ",$matname," $i ",$newname," newi
	set newi [string map [list $matname $newname] $i]
	set Data($newi) $Data($i)     
    }
    array unset Data MAT,$matname,*
    set pos [lsearch $Data(MAT,nameslist) $matname]
    if { $pos != -1 } {
	set Data(MAT,nameslist) [lreplace $Data(MAT,nameslist) $pos $pos $newname]
    }
    set Modified$dataname 1
}
